define(['EtherCalc/runtime/js/lib/jqueryExt',
        'EtherCalc/runtime/lang',
        'EtherCalc/runtime/js/lib/Chart.bundle.min'], function ($, lang, JPchart) {
    //'use strict';

    function EtherInit(id, $container, config, assetManager) {
        var dataToChart;
        var jpscript = [];

        Class = function (classDefinition, classWrapper) {
            if (!classDefinition) throw "Class requires a class definition string as its first argument";
            if (!classWrapper) throw "Class requires a class wrapper function as its second argument";

            if (!classDefinition.match(/^([\w\.]+)(?:\(\s*([\w\.]+)\s*\))?(?:\s+(.*?)\s*)?$/)) throw "Can't parse Class Definition: '" + classDefinition + "'";
            var className = RegExp.$1,
                baseClassName = RegExp.$2 || "",
                options = [];
            RegExp.$3 && (options = RegExp.$3.split(/\s+/));
            for (var incValues = [], strict = !0, i = 0, l = options.length; l > i; i++) {
                var option = options[i];
                "-nostrict" == option && (strict = !1), option.match(/^-inc=(.+)$/) && (incValues = RegExp.$1.split(","));
            }
            for (var parts = className.split("."), klass = Class.global, i = 0; i < parts.length; i++) klass[parts[i]] || (klass[parts[i]] = function () {
                try {
                    this.init();
                } catch (e) {}
            }), klass = klass[parts[i]];
            klass.className = className, klass.isa = function (baseName) {
                klass.baseClassName = baseName, baseName && (klass.prototype = eval("new " + baseName + "()"),
                    klass.prototype.superFunc = function (name) {
                        return eval(baseName).prototype[name];
                    });
            }, klass.isa(baseClassName), klass.global = Class.global, klass.addGlobal = function () {
                return this.newGlobals++, Class.global;
            }, klass.extend = function (e) {
                if ("object" != typeof e) throw "extend requires an object of name:value pairs";
                for (var t in e) klass.prototype[t] = e[t];
            };
            for (var ii = 0, ll = incValues.length; ll > ii; ii++) {
                var value = incValues[ii];
                incValues[ii] = "proto" == value ? klass.prototype : "this" == value ? klass : Class.global[value];
            }
            
            return strict ? Class.eval_strict(classWrapper, klass, incValues) : classWrapper.apply(klass, incValues),
                klass;
        };

        return EtherClassInit(id, $container, config, assetManager);

    };

    function EtherClassInit(id, $container, config, assetManager) {

        Class.global = this, Class.eval_strict = function (e, t, o) {
                var i, n = 0;
                for (var r in Class.global) n++, i = r;
                t.newGlobals = 0, e.apply(t, o);
                var a = 0;
                for (var r in Class.global) a++;
                if (n + t.newGlobals != a) throw "Class '" + t.className + "' defines " + (a - n) + " new global JavaScript variables without using this.addGlobal()";
                delete t.newGlobals;
            },
            Class("Document.Parser", function () {
                var proto = this.prototype;
                proto.className = "Document.Parser", proto.init = function () {}, proto.parse = function (e, t) {
                    return this.input = -1 == e.search(/\n$/) ? e + "\n" : e, t && (this.receiver = t),
                        this.receiver.init(), this.grammar = this.create_grammar(), this.parse_blocks("top"),
                        this.receiver.content();
                }, proto.create_grammar = function () {
                    throw "Please define create_grammar in a derived class of Document.Parser.";
                }, proto.parse_blocks = function (e) {
                    var t = this.grammar[e].blocks;
                    if (t)
                        for (; this.input.length;) {
                            for (var o = this.input.length, i = 0; i < t.length; i++) {
                                var n = t[i],
                                    r = this.find_match("matched_block", n);
                                if (r) {
                                    this.input = this.input.substr(r.end), this.handle_match(n, r);
                                    break;
                                }
                            }
                            if (this.input.length >= o) throw this.classname + ": Reduction error for:\n" + this.input + "\n" + JSON.stringify(this);
                        }
                }, proto.handle_match = function (e, t) {
                    var o = this.grammar[e],
                        i = o.blocks ? "parse_blocks" : "parse_phrases";
                    this.subparse(i, t, e, o.filter);
                }, proto.find_match = function (e, t) {
                    var o = this.grammar[t].match;
                    if (!o) throw "no regexp for type: " + t;
                    var i = this.input.match(o);
                    if (i) {
                        var n = this[e].call(this, i, this.grammar[t].lookbehind);
                        return n.type = this.grammar[t].type || t, n;
                    }
                }, proto.parse_phrases = function (e) {
                    var t = this.grammar[e].phrases;
                    if (!t) return void this.receiver.text_node(this.input || "");
                    for (; this.input.length;) {
                        for (var o = null, i = 0; i < t.length; i++) {
                            var n = t[i],
                                r = this.find_match("matched_phrase", n);
                            if (r && (!o || r.begin < o.begin) && (o = r, 0 == o.begin)) break;
                        }
                        if (!o) {
                            this.receiver.text_node(this.input || "");
                            break;
                        }
                        0 != o.begin && this.receiver.text_node(this.input.substr(0, o.begin) || ""), this.input = this.input.substr(o.end),
                            this.handle_match(o.type, o);
                    }
                }, proto.subparse = function (func, match, type, filter) {
                    match.type = this.grammar[type].type, null == match.type && (match.type = type);
                    var filtered_text = filter ? filter(match) : null;
                    match.type && this.receiver.begin_node(match);
                    var parser = eval("new " + this.className + "()");
                    parser.input = null == filtered_text ? match.text : filtered_text, parser.grammar = this.grammar,
                        parser.receiver = this.receiver.instantiate(), parser[func].call(parser, type),
                        this.receiver.insert(parser.receiver), match.type && this.receiver.end_node(match);
                }, proto.matched_block = function (e) {
                    return {
                        begin: e.index,
                        text: e[1],
                        end: e[0].length,
                        1: e[2],
                        2: e[3],
                        3: e[4]
                    };
                }, proto.matched_phrase = function (e, t) {
                    if (t) {
                        var o = e[2],
                            i = this.input.indexOf(e[1]);
                        return {
                            text: o,
                            begin: i,
                            end: i + e[1].length,
                            1: RegExp.$2,
                            2: RegExp.$3,
                            3: RegExp.$4
                        };
                    }
                    return {
                        begin: e.index,
                        text: e[1],
                        end: e.index + e[0].length,
                        1: e[2],
                        2: e[3],
                        3: e[4]
                    };
                };
            }), Class("Document.Parser.Wikitext(Document.Parser)", function () {
                var e = this.prototype;
                e.className = "Document.Parser.Wikitext", e.init = function () {}, e.create_grammar = function () {
                    var e = ["pre", "html", "hr", "hx", "waflparagraph", "ul", "ol", "blockquote", "p", "empty", "else"],
                        t = ["waflphrase", "asis", "wikilink", "wikilink2", "a", "im", "mail", "file", "tt", "b", "i", "del", "a"],
                        o = function (e, o) {
                            return o = "\\" + (o || e), e = "\\" + e, {
                                match: new RegExp("(?:^|[^" + e + "\\w])(" + e + "(?=\\S)(?!" + o + ")(.*?)" + o + "(?=[^" + o + "\\w]|$))"),
                                phrases: "\\`" == e ? null : t,
                                lookbehind: !0
                            };
                        },
                        i = {
                            yahoo: "yahoo",
                            ymsgr: "yahoo",
                            callto: "callto",
                            callme: "callto",
                            skype: "callto",
                            aim: "aim"
                        },
                        n = {
                            aim: "AIM: %1",
                            yahoo: "Yahoo: %1",
                            callto: "Skype: %1"
                        },
                        r = "(\\b(";
                    for (var a in i) r += a + "|";
                    r = r.replace(/\|$/, ")\\:([^\\s\\>\\)]+))");
                    var s = function (e, t) {
                        var o = new RegExp("(^|\n)" + t + " *", "g");
                        return {
                            match: new RegExp("^(" + e + "+ .*\n(?:[*-+#]+ .*\n)*)(?:s*\n)?"),
                            blocks: ["ul", "ol", "subl", "li"],
                            filter: function (e) {
                                return e.text.replace(o, "$1");
                            }
                        };
                    };
                    return {
                        _all_blocks: e,
                        _all_phrases: t,
                        top: {
                            blocks: e
                        },
                        ol: s("#", "[*#]"),
                        ul: s("[-+*]", "[-+*#]"),
                        blockquote: {
                            match: /^((?:>[^\n]*\n)+)(?:\s*\n)?/,
                            blocks: ["blockquote", "line"],
                            filter: function (e) {
                                return e.text.replace(/(^|\n)>\ ?/g, "$1");
                            }
                        },
                        line: {
                            match: /([^\n]*)\n/,
                            phrases: t
                        },
                        subl: {
                            type: "li",
                            match: /^(([^\n]*)\n[*#]+\ [^\n]*\n(?:[*#]+\ [^\n]*\n)*)(?:\s*\n)?/,
                            blocks: ["ul", "ol", "li2"]
                        },
                        li: {
                            match: /([^\n]*)\n/,
                            phrases: t
                        },
                        li2: {
                            type: "",
                            match: /([^\n]*)\n/,
                            phrases: t
                        },
                        html: {
                            match: /^(\.html\ *\n(?:[^\n]*\n)*?\.html)\ *\n(?:\s*\n)?/,
                            filter: function (e) {
                                return e._html = e.text, "";
                            }
                        },
                        pre: {
                            match: /^\.pre\ *\n((?:[^\n]*\n)*?)\.pre\ *\n(?:\s*\n)?/
                        },
                        hr: {
                            match: /^--+(?:\s*\n)?/
                        },
                        hx: {
                            match: /^((\^+) *([^\n]*?)(\s+=+)?\s*?\n+)/,
                            phrases: t,
                            filter: function (e) {
                                return e.type = "h" + e[1].length, e[2];
                            }
                        },
                        p: {
                            match: /^((?:(?!(?:(?:\^+|\#+|\*+|\-+) |\>|\.\w+\s*\n|\{[^\}]+\}\s*\n))[^\n]*\S[^\n]*\n)+(?:(?=^|\n)\s*\n)*)/,
                            phrases: t,
                            filter: function (e) {
                                return e.text.replace(/\n$/, "");
                            }
                        },
                        empty: {
                            match: /^(\s*\n)/,
                            filter: function (e) {
                                e.type = "";
                            }
                        },
                        "else": {
                            match: /^(([^\n]*)\n)/,
                            phrases: [],
                            filter: function (e) {
                                e.type = "p";
                            }
                        },
                        waflparagraph: {
                            match: /^\{(.*)\}[\ \t]*\n(?:\s*\n)?/,
                            filter: function (e) {
                                return e._wafl = e._label = e.text, "";
                            }
                        },
                        waflphrase: {
                            match: /(?:^|[\s\-])((?:"([^\n]+?)")?\{([\w-]+(?=[\:\ \}])(?:\s*:)?\s*[^\n]*?\s*)\}(?=[\W_]|$))/,
                            filter: function (e) {
                                return e._wafl = e[2], e._label = e[1] || e._wafl, "";
                            },
                            lookbehind: !0
                        },
                        asis: {
                            match: /(\{\{([^\n]*?)\}\}(\}*))/,
                            filter: function (e) {
                                return e.type = "", e[1] + e[2];
                            }
                        },
                        wikilink: {
                            match: /(?:^|[_\W])(\[()(?=[^\s\[\]])(.*?)\](?=[_\W]|$))/,
                            filter: function (e) {
                                return e._href = "?" + e[2], e.text || e[2];
                            },
                            lookbehind: !0
                        },
                        wikilink2: {
                            type: "wikilink",
                            match: /(?:"([^"]*)"\s*)(\[(?=[^\s\[\]])(.*?)\](?=[_\W]|$))/,
                            filter: function (e) {
                                return e._href = "?" + e[2], e[1] || e[2];
                            }
                        },
                        a: {
                            match: /((?:"([^"]*)"\s*)?<?((?:http|https|ftp|irc|file):(?:\/\/)?[\;\/\?\:\@\&\=\+\$\,\[\]\#A-Za-z0-9\-\_\.\!\~\*\'\(\)]+[A-Za-z0-9\/#])>?)/,
                            filter: function (e) {
                                return e._href = e[2], e[1] || e[2];
                            }
                        },
                        file: {
                            match: /((?:"([^"]*)")?<(\\\\[^\s\>\)]+)>)/,
                            filter: function (e) {
                                var t = e[2].replace(/^\\\\/, "");
                                return e._href = "file://" + t.replace(/\\/g, "/"), e[1] || t;
                            }
                        },
                        im: {
                            match: new RegExp(r),
                            filter: function (e) {
                                return e._wafl = e[1] + ": " + e[2], e._label = (n[i[e[1]]] || "%1").replace(/%1/g, e[2]),
                                    "";
                            }
                        },
                        mail: {
                            match: /([\w+%\-\.]+@(?:[\w\-]+\.)+[\w\-]+)/,
                            filter: function (e) {
                                e.type = "a", e._href = "mailto:" + e.text.replace(/%/g, "%25");
                            }
                        },
                        tt: o("`"),
                        b: o("*"),
                        i: o("_"),
                        del: o("-")
                    };
                };
            });

        
        var SuperT = EtherCore(window, $container, assetManager, config);
        return SuperT;
    }


    function EtherCore(e, $container, assetManager, config) {
        var t;
        t || (t = {}), t.Constants = {
            cellDataType: {
                v: "value",
                n: "value",
                t: "text",
                f: "formula",
                c: "constant"
            },
            textdatadefaulttype: "t",
            s_BrowserNotSupported: "Browser not supported.",
            s_InternalError: "Internal SocialCalc error (probably an internal bug): ",
            s_pssUnknownColType: "Unknown col type item",
            s_pssUnknownRowType: "Unknown row type item",
            s_pssUnknownLineType: "Unknown line type",
            s_cfspUnknownCellType: "Unknown cell type item",
            doCanonicalizeSheet: !0,
            s_escUnknownSheetCmd: "Unknown sheet command: ",
            s_escUnknownSetCoordCmd: "Unknown set coord command: ",
            s_escUnknownCmd: "Unknown command: ",
            s_caccCircRef: "Circular reference to ",
            defaultRowNameWidth: "30",
            defaultAssumedRowHeight: 15,
            defaultCellIDPrefix: "cell_",
            defaultCellLayout: "padding:2px 2px 1px 2px;vertical-align:top;",
            defaultCellFontStyle: "normal normal",
            defaultCellFontSize: "small",
            defaultCellFontFamily: "Verdana,Arial,Helvetica,sans-serif",
            defaultPaneDividerWidth: "3",
            defaultPaneDividerHeight: "3",
            defaultGridCSS: "1px solid #C0C0C0;",
            defaultCommentClass: "",
            //defaultCommentStyle: "background-repeat:no-repeat;background-position:top right;background-image:url(images/sc-commentbg.gif);",
            defaultCommentStyle: "background-repeat:no-repeat;background-position:top right;background-image:url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_commentbg.gif') + ");",
            defaultCommentNoGridClass: "",
            defaultCommentNoGridStyle: "",
            defaultReadonlyClass: "",
            //defaultReadonlyStyle: "background-repeat:no-repeat;background-position:top right;background-image:url(images/sc-lockbg.gif);",
            defaultReadonlyStyle: "background-repeat:no-repeat;background-position:top right;background-image:url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_lockbg.gif') + ");",
            defaultReadonlyNoGridClass: "",
            defaultReadonlyNoGridStyle: "",
            defaultReadonlyComment: "Locked cell",
            defaultColWidth: "80",
            defaultMinimumColWidth: 10,
            defaultHighlightTypeCursorClass: "",
            defaultHighlightTypeCursorStyle: "color:#FFF;backgroundColor:#e0e0e0;",
            defaultHighlightTypeRangeClass: "",
            defaultHighlightTypeRangeStyle: "color:#000;backgroundColor:#E5E5E5;",
            defaultColnameClass: "topCol",
            defaultColnameStyle: "overflow:visible;font-size:small;text-align:center;color:#808080;background-color:#f4f4f4;",
            defaultSelectedColnameClass: "activTopCol",
            defaultSelectedColnameStyle: "overflow:visible;font-size:small;text-align:center;color:#808080;background-color:#e0e0e0;",
            defaultRownameClass: "topRow",
            defaultRownameStyle: "position:relative;overflow:visible;font-size:small;text-align:right;color:#808080;background-color:#f4f4f4;",
            defaultSelectedRownameClass: "activTopRow",
            defaultSelectedRownameStyle: "position:relative;overflow:visible;font-size:small;text-align:right;color:#808080;background-color:#e0e0e0;",
            defaultUpperLeftClass: "",
            defaultUpperLeftStyle: "font-size:small;",
            defaultSkippedCellClass: "",
            defaultSkippedCellStyle: "font-size:small;background-color:#CCC",
            defaultPaneDividerClass: "",
            defaultPaneDividerStyle: "font-size:small;background-color:#C0C0C0;padding:0px;",
            defaultUnhideLeftClass: "",
            //defaultUnhideLeftStyle: "float:right;width:9px;height:12px;cursor:pointer;background-image:url(images/sc-unhideleft.gif);padding:0;",
            defaultUnhideLeftStyle: "float:right;width:9px;height:12px;cursor:pointer;background-image:url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_unhideleft.gif') + "); padding:0;",
            defaultUnhideRightClass: "",
            //defaultUnhideRightStyle: "float:left;width:9px;height:12px;cursor:pointer;background-image:url(images/sc-unhideright.gif);padding:0;",
            defaultUnhideRightStyle: "float:left;width:9px;height:12px;cursor:pointer;background-image:url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_unhideright.gif') + ");padding:0;",
            defaultUnhideTopClass: "",
            //defaultUnhideTopStyle: "float:left;left:1px;position:absolute;bottom:-4px;width:12px;height:9px;cursor:pointer;background-image:url(images/sc-unhidetop.gif);padding:0;",
            defaultUnhideTopStyle: "float:left;left:1px;position:absolute;bottom:-4px;width:12px;height:9px;cursor:pointer;background-image:url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_unhidetop.gif') + ");padding:0;",
            defaultUnhideBottomClass: "",
            //defaultUnhideBottomStyle: "float:left;width:12px;height:9px;cursor:pointer;background-image:url(images/sc-unhidebottom.gif);padding:0;",
            defaultUnhideBottomStyle: "float:left;width:12px;height:9px;cursor:pointer;background-image:url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_unhidebottom.gif') + ");padding:0;",
            defaultColResizeBarClass: "kol-resize-bar",
            defaultRowResizeBarClass: "row-resize-bar",
            s_rcMissingSheet: "Render Context must have a sheet object",
            defaultLinkFormatString: '<span style="font-size:smaller;text-decoration:none !important;background-color:#66B;color:#FFF;">Link</span>',
            defaultPageLinkFormatString: '<span style="font-size:smaller;text-decoration:none !important;background-color:#66B;color:#FFF;">Page</span>',
            defaultFormatp: "#,##0.0%",
            defaultFormatc: "[$$]#,##0.00",
            defaultFormatdt: "d-mmm-yyyy h:mm:ss",
            defaultFormatd: "d-mmm-yyyy",
            defaultFormatt: "[h]:mm:ss",
            defaultDisplayTRUE: "TRUE",
            defaultDisplayFALSE: "FALSE",
            defaultImagePrefix: "EtherCalc/runtime/assets/sc_", //JP Hack Pas suffisant chercher %img en bas !
            defaultTableEditorIDPrefix: "te_",
            defaultPageUpDnAmount: 15,
            AllowCtrlS: !0,
            defaultTableControlThickness: 20,
            cteGriddivClass: "",
            s_statusline_executing: "Executing...",
            s_statusline_displaying: "Displaying...",
            s_statusline_ordering: "Ordering...",
            s_statusline_calculating: "Calculating...",
            s_statusline_calculatingls: "Calculating... Loading Sheet...",
            s_statusline_doingserverfunc: "doing server function ",
            s_statusline_incell: " in cell ",
            s_statusline_calcstart: "Calculation start...",
            s_statusline_sum: "SUM",
            s_statusline_recalcneeded: '<span style="color:#999;">(Recalc needed)</span>',
            s_statusline_circref: '<span style="color:red;">Circular reference: ',
            s_statusline_sendemail: "Sending Email ",
            s_inputboxdisplaymultilinetext: "[Multi-line text: Click icon on right to edit]",
            defaultInputEchoClass: "",
            defaultInputEchoStyle: "filter:alpha(opacity=90);opacity:.9;backgroundColor:#FFD;border:1px solid #884;fontSize:small;padding:2px 10px 1px 2px;cursor:default;",
            defaultInputEchoPromptClass: "",
            defaultInputEchoPromptStyle: "filter:alpha(opacity=90);opacity:.9;backgroundColor:#FFD;borderLeft:1px solid #884;borderRight:1px solid #884;borderBottom:1px solid #884;fontSize:small;fontStyle:italic;padding:2px 10px 1px 2px;cursor:default;",
            defaultInputEchoHintClass: "",
            defaultInputEchoHintStyle: "filter:alpha(opacity=80);opacity:.8;backgroundColor:#884;border:1px solid #884;fontSize:small;fontWeight:bold;padding:2px 2px 2px 2px;color:#FFF;position:absolute;top:-20px;cursor:default;",
            ietUnknownFunction: "Unknown function ",
            CH_radius1: 29,
            CH_radius2: 41,
            s_CHfillAllTooltip: "Fill Contents and Formats Down/Right",
            s_CHfillContentsTooltip: "Fill Contents Only Down/Right",
            s_CHmovePasteAllTooltip: "Move Contents and Formats",
            s_CHmovePasteContentsTooltip: "Move Contents Only",
            s_CHmoveInsertAllTooltip: "Slide Contents and Formats within Row/Col",
            s_CHmoveInsertContentsTooltip: "Slide Contents within Row/Col",
            s_CHindicatorOperationLookup: {
                Fill: "Fill",
                FillC: "Fill Contents",
                Move: "Move",
                MoveI: "Slide",
                MoveC: "Move Contents",
                MoveIC: "Slide Contents"
            },
            s_CHindicatorDirectionLookup: {
                Down: " Down",
                Right: " Right",
                Horizontal: " Horizontal",
                Vertical: " Vertical"
            },
            defaultTCSliderThickness: 9,
            defaultTCButtonThickness: 20,
            defaultTCThumbThickness: 15,
            TCmainStyle: "backgroundColor:#EEE;",
            TCmainClass: "",
            TCendcapStyle: "backgroundColor:#FFF;",
            TCendcapClass: "",
            TCpanesliderClass: "tc-paneslider",
            s_panesliderTooltiph: lang.synt428,
            s_panesliderTooltipv: lang.synt429,
            TClessbuttonStyle: "backgroundColor:#AAA;",
            TClessbuttonClass: "",
            TClessbuttonRepeatWait: 300,
            TClessbuttonRepeatInterval: 20,
            TCmorebuttonStyle: "backgroundColor:#AAA;",
            TCmorebuttonClass: "",
            TCmorebuttonRepeatWait: 300,
            TCmorebuttonRepeatInterval: 20,
            TCscrollareaStyle: "backgroundColor:#DDD;",
            TCscrollareaClass: "",
            TCscrollareaRepeatWait: 500,
            TCscrollareaRepeatInterval: 100,
            TCthumbClass: "",
            TCthumbStyle: "backgroundColor:#CCC;",
            TCPStrackinglineClass: "tracklingine",
            TCPStrackinglineStyle: "overflow:hidden;position:absolute;zIndex:100;",
            TCPStrackinglineThickness: "2px",
            TCTDFSthumbstatusvClass: "",
            TCTDFSthumbstatusvStyle: "height:20px;width:auto;border:3px solid #808080;overflow:hidden;backgroundColor:#FFF;fontSize:small;position:absolute;zIndex:100;",
            TCTDFSthumbstatushClass: "",
            TCTDFSthumbstatushStyle: "height:20px;width:auto;border:1px solid black;padding:2px;backgroundColor:#FFF;fontSize:small;position:absolute;zIndex:100;",
            TCTDFSthumbstatusrownumClass: "",
            TCTDFSthumbstatusrownumStyle: "color:#FFF;background-color:#808080;font-size:small;white-space:nowrap;padding:3px;",
            TCTDFStopOffsetv: 0,
            TCTDFSleftOffsetv: -80,
            s_TCTDFthumbstatusPrefixv: lang.synt430,
            TCTDFStopOffseth: -30,
            TCTDFSleftOffseth: 0,
            s_TCTDFthumbstatusPrefixh: lang.synt431,
            TooltipOffsetX: 2,
            TooltipOffsetY: 10,
            TDpopupElementClass: "",
            TDpopupElementStyle: "border:1px solid black;padding:1px 2px 2px 2px;textAlign:center;backgroundColor:#FFF;fontSize:7pt;fontFamily:Verdana,Arial,Helvetica,sans-serif;position:absolute;width:auto;zIndex:110;",
            SCToolbarbackground: "background-color:#ffffff;",
            SCTabbackground: "background-color:#CCC;",
            SCTabselectedCSS: "font-size:small;padding:6px 30px 6px 8px;color:#FFF;background-color:#404040;cursor:default;border-right:1px solid #CCC;",
            SCTabplainCSS: "font-size:small;padding:6px 30px 6px 8px;color:#FFF;background-color:#808080;cursor:default;border-right:1px solid #CCC;",
            SCToolbartext: "font-size:x-small;font-weight:bold;color:#888",
            SCFormulabarheight: 30,
            SCStatuslineheight: 20,
            SCStatuslineCSS: "font-size:10px;padding:3px 0px;",
            SCFormatNumberFormats: "[cancel]:|[break]:|%loc!Default!:|[custom]:|%loc!Automatic!:general|%loc!Auto w/ commas!:[,]General|[break]:|00:00|000:000|0000:0000|00000:00000|[break]:|%loc!Formula!:formula|%loc!Hidden!:hidden|[newcol]:1234:0|1,234:#,##0|1,234.5:#,##0.0|1,234.56:#,##0.00|1,234.567:#,##0.000|1,234.5678:#,##0.0000|[break]:|1,234%:#,##0%|1,234.5%:#,##0.0%|1,234.56%:#,##0.00%|[newcol]:|$1,234:$#,##0|$1,234.5:$#,##0.0|$1,234.56:$#,##0.00|[break]:|(1,234):#,##0_);(#,##0)|(1,234.5):#,##0.0_);(#,##0.0)|(1,234.56):#,##0.00_);(#,##0.00)|[break]:|($1,234):$#,##0_);($#,##0)|($1,234.5):$#,##0.0_);($#,##0.0)|($1,234.56):$#,##0.00_);($#,##0.00)|[newcol]:|1/4/06:m/d/yy|01/04/2006:mm/dd/yyyy|2006-01-04:yyyy-mm-dd|4-Jan-06:d-mmm-yy|04-Jan-2006:dd-mmm-yyyy|"+lang.synt382+":mmmm d, yyyy|[break]:|1\\c23:h:mm|1\\c23 PM:h:mm AM/PM|1\\c23\\c45:h:mm:ss|01\\c23\\c45:hh:mm:ss|26\\c23 (h\\cm):[hh]:mm|69\\c45 (m\\cs):[mm]:ss|69 (s):[ss]|[newcol]:|2006-01-04 01\\c23\\c45:yyyy-mm-dd hh:mm:ss|"+lang.synt382+":mmmm d, yyyy hh:mm:ss|Wed:ddd|Wednesday:dddd|",
            SCFormatTextFormats: "[cancel]:|[break]:|%loc!Default!:|[custom]:|%loc!Automatic!:general|%loc!Plain Text!:text-plain|HTML:text-html|%loc!Wikitext!:text-wiki|%loc!Link!:text-link|%loc!Formula!:formula|%loc!Hidden!:hidden|",
            SCFormatPadsizes: "[cancel]:|[break]:|%loc!Default!:|[custom]:|%loc!No padding!:0px|[newcol]:|1 pixel:1px|2 pixels:2px|3 pixels:3px|4 pixels:4px|5 pixels:5px|6 pixels:6px|7 pixels:7px|8 pixels:8px|[newcol]:|9 pixels:9px|10 pixels:10px|11 pixels:11px|12 pixels:12px|13 pixels:13px|14 pixels:14px|16 pixels:16px|18 pixels:18px|[newcol]:|20 pixels:20px|22 pixels:22px|24 pixels:24px|28 pixels:28px|36 pixels:36px|",
            SCFormatFontsizes: "[cancel]:|[break]:|%loc!Default!:|[custom]:|X-Small:x-small|Small:small|Medium:medium|Large:large|X-Large:x-large|[newcol]:|6pt:6pt|7pt:7pt|8pt:8pt|9pt:9pt|10pt:10pt|11pt:11pt|12pt:12pt|14pt:14pt|16pt:16pt|[newcol]:|18pt:18pt|20pt:20pt|22pt:22pt|24pt:24pt|28pt:28pt|36pt:36pt|48pt:48pt|72pt:72pt|[newcol]:|8 pixels:8px|9 pixels:9px|10 pixels:10px|11 pixels:11px|12 pixels:12px|13 pixels:13px|14 pixels:14px|[newcol]:|16 pixels:16px|18 pixels:18px|20 pixels:20px|22 pixels:22px|24 pixels:24px|28 pixels:28px|36 pixels:36px|",
            SCFormatFontfamilies: "[cancel]:|[break]:|%loc!Default!:|[custom]:|Verdana:Verdana,Arial,Helvetica,sans-serif|Arial:arial,helvetica,sans-serif|Courier:'Courier New',Courier,monospace|",
            SCFormatFontlook: "[cancel]:|[break]:|%loc!Default!:|%loc!Normal!:normal normal|%loc!Bold!:normal bold|%loc!Italic!:italic normal|%loc!Bold Italic!:italic bold",
            SCFormatTextAlignhoriz: "[cancel]:|[break]:|%loc!Default!:|%loc!Left!:left|%loc!Center!:center|%loc!Right!:right|",
            SCFormatNumberAlignhoriz: "[cancel]:|[break]:|%loc!Default!:|%loc!Left!:left|%loc!Center!:center|%loc!Right!:right|",
            SCFormatAlignVertical: "[cancel]:|[break]:|%loc!Default!:|%loc!Top!:top|%loc!Middle!:middle|%loc!Bottom!:bottom|",
            SCFormatColwidth: "[cancel]:|[break]:|%loc!Default!:|[custom]:|[newcol]:|20 pixels:20|40:40|60:60|80:80|100:100|120:120|140:140|160:160|[newcol]:|180 pixels:180|200:200|220:220|240:240|260:260|280:280|300:300|",
            SCFormatRecalc: "[cancel]:|[break]:|%loc!Auto!:|%loc!Manual!:off|",
            SCFormatUserMaxCol: "[cancel]:|[break]:|%loc!Default!:|[custom]:|[newcol]:|Unlimited:0|10:10|20:20|30:30|40:40|50:50|60:60|80:80|100:100|",
            SCFormatUserMaxRow: "[cancel]:|[break]:|%loc!Default!:|[custom]:|[newcol]:|Unlimited:0|10:10|20:20|30:30|40:40|50:50|60:60|80:80|100:100|",
            ISCButtonNormalBackground: lang.synt386,
            ISCButtonBorderNormal: lang.synt113,
            ISCButtonBorderHover: lang.synt113,
            ISCButtonBorderDown: lang.synt113,
            ISCButtonDownBackground: "#fff",
            s_PopupListCancel: lang.synt385,
            s_PopupListCustom: lang.synt74,
            s_loc_align_center: lang.synt24,
            s_loc_align_left: lang.synt23,
            s_loc_align_right: lang.synt25,
            s_loc_alignment: lang.synt53,
            s_loc_audit: lang.synt4,
            s_loc_audit_trail_this_session: lang.synt119,
            s_loc_auto: lang.synt168,
            s_loc_auto_sum: lang.synt45,
            s_loc_auto_wX_commas: lang.synt76,
            s_loc_automatic: lang.synt75,
            s_loc_background: lang.synt61,
            s_loc_bold: lang.synt387,
            s_loc_bold_XampX_italics: lang.synt58,
            s_loc_bold_italic: lang.synt58,
            s_loc_borders: lang.synt62,
            s_loc_borders_off: lang.synt27,
            s_loc_borders_on: lang.synt26,
            s_loc_bottom: lang.synt70,
            s_loc_bottom_border: lang.synt64,
            s_loc_cell_settings: lang.synt46,
            s_loc_csv_format: lang.synt130,
            s_loc_cancel: lang.synt72,
            s_loc_category: lang.synt173,
            s_loc_center: lang.synt175,
            s_loc_clear: lang.synt178,
            s_loc_clear_socialcalc_clipboard: lang.synt133,
            s_loc_clipboard: lang.synt7,
            s_loc_color: lang.synt60,// PROBLEME A VERIF
            s_loc_column_: lang.synt107,
            s_loc_comment: lang.synt5,
            s_loc_copy: lang.synt11,
            s_loc_custom: lang.synt74,
            s_loc_cut: lang.synt12,
            s_loc_default: lang.synt73,
            s_loc_default_alignment: lang.synt101,
            s_loc_default_column_width: lang.synt104,
            s_loc_default_font: lang.synt102,
            s_loc_default_format: lang.synt100,
            s_loc_default_padding: lang.synt103,
            s_loc_delete: lang.synt127,
            s_loc_delete_column: lang.synt33,
            s_loc_delete_contents: lang.synt14,
            s_loc_delete_row: lang.synt32,
            s_loc_description: lang.synt123,
            s_loc_display_clipboard_in: lang.synt128,
            s_loc_down: lang.synt116,
            s_loc_edit: lang.synt143,
            s_loc_existing_names: lang.synt121,
            s_loc_family: lang.synt57,
            s_loc_fill_down: lang.synt18,
            s_loc_fill_right: lang.synt19,
            s_loc_font: lang.synt56,
            s_loc_format: lang.synt50,
            s_loc_formula: lang.synt77,
            s_loc_function_list: lang.synt195,
            s_loc_functions: lang.synt43,
            s_loc_grid: lang.synt196,
            s_loc_hidden: lang.synt78,
            s_loc_hide_column: lang.synt35,
            s_loc_hide_row: lang.synt34,
            s_loc_horizontal: lang.synt54,
            s_loc_insert_column: lang.synt31,
            s_loc_insert_row: lang.synt30,
            s_loc_italic: lang.synt204,
            s_loc_last_sort: lang.synt205,
            s_loc_left: lang.synt71,
            s_loc_left_border: lang.synt66,
            s_loc_link: lang.synt86,
            s_loc_link_input_box: lang.synt206,
            s_loc_list: lang.synt207,
            s_loc_load_socialcalc_clipboard_with_this: lang.synt132,
            s_loc_lock_cell: lang.synt16,
            s_loc_major_sort: lang.synt112,
            s_loc_manual: lang.synt99,
            s_loc_merge_cells: lang.synt29,
            s_loc_middle: lang.synt87,
            s_loc_minor_sort: lang.synt117,
            s_loc_move_insert: lang.synt22,
            s_loc_move_paste: lang.synt21,
            s_loc_multiXline_input_box: lang.synt214,
            s_loc_name: lang.synt122,
            s_loc_names: lang.synt6,
            s_loc_no_padding: lang.synt97,
            s_loc_normal: lang.synt88,
            s_loc_number: lang.synt51,
            s_loc_number_horizontal: lang.synt215,
            s_loc_ok: lang.synt194,
            s_loc_padding: lang.synt67,
            s_loc_page_name: lang.synt220,
            s_loc_paste: lang.synt13,
            s_loc_paste_formats: lang.synt15,
            s_loc_plain_text: lang.synt83,
            s_loc_recalc: lang.synt222,
            s_loc_recalculation: lang.synt383,
            s_loc_redo: lang.synt10,
            s_loc_right: lang.synt69,
            s_loc_right_border: lang.synt64,
            s_loc_sheet_settings: lang.synt384,
            s_loc_save: lang.synt126,
            s_loc_save_to: lang.synt47,
            s_loc_set_cell_contents: lang.synt225,
            s_loc_set_cells_to_sort: lang.synt109,
            s_loc_set_value_to: lang.synt125,
            s_loc_set_to_link_format: lang.synt226,
            s_loc_setXclear_move_from: lang.synt20,
            s_loc_show_cell_settings: lang.synt444,
            s_loc_show_sheet_settings: lang.synt49,
            s_loc_show_in_new_browser_window: lang.synt231,
            s_loc_size: lang.synt59,
            s_loc_socialcalcXsave_format: lang.synt131,
            s_loc_sort: lang.synt3,
            s_loc_sort_: lang.synt388,
            s_loc_sort_cells: lang.synt235,
            s_loc_swap_colors: lang.synt28,
            s_loc_tabXdelimited_format: lang.synt129,
            s_loc_text: lang.synt52,
            s_loc_text_horizontal: lang.synt238,
            s_loc_this_is_aXbrXsample: lang.synt98,
            s_loc_top: lang.synt68,
            s_loc_top_border:lang.synt63,
            s_loc_undone_steps: lang.synt239,
            s_loc_url: lang.synt251,
            s_loc_undo: lang.synt9,
            s_loc_unlock_cell: lang.synt17,
            s_loc_unmerge_cells: lang.synt250,
            s_loc_up: lang.synt115,
            s_loc_value: lang.synt252,
            s_loc_vertical: lang.synt55,
            s_loc_wikitext: lang.synt85,
            s_loc_workspace: lang.synt253,
            s_loc_XnewX: lang.synt161,
            s_loc_XnoneX: lang.synt162,
            s_loc_Xselect_rangeX: lang.synt163,
            SVStatuslineheight: 20,
            SVStatuslineCSS: "font-size:10px;padding:3px 0px;",
            FormatNumber_separatorchar: ",",
            FormatNumber_decimalchar: ".",
            FormatNumber_defaultCurrency: "$",
            s_FormatNumber_daynames: lang.synt165,
            s_FormatNumber_daynames3: lang.synt164,
            s_FormatNumber_monthnames: lang.synt160,
            s_FormatNumber_monthnames3: lang.synt159,
            s_FormatNumber_am: lang.synt167,
            s_FormatNumber_am1: lang.synt166,
            s_FormatNumber_pm: lang.synt221,
            s_FormatNumber_pm1: lang.synt218,
            s_parseerrexponent: lang.synt197,
            s_parseerrchar: lang.synt240,
            s_parseerrstring: lang.synt199,
            s_parseerrspecialvalue: lang.synt198,
            s_parseerrtwoops: lang.synt184,
            s_parseerrmissingopenparen: lang.synt209,
            s_parseerrcloseparennoopen: lang.synt179,
            s_parseerrmissingcloseparen: lang.synt208,
            s_parseerrmissingoperand: lang.synt210,
            s_parseerrerrorinformula: lang.synt186,
            s_calcerrerrorvalueinformula: lang.synt187,
            s_parseerrerrorinformulabadval: lang.synt185,
            s_formularangeresult: lang.synt194,
            s_calcerrnumericnan: lang.synt193,
            s_calcerrnumericoverflow: lang.synt216,
            s_sheetunavailable: lang.synt229,
            s_calcerrcellrefmissing: lang.synt174,
            s_calcerrsheetnamemissing: lang.synt227,
            s_circularnameref: lang.synt176,
            s_calcerrunknownname: lang.synt246,
            s_calcerrincorrectargstofunction: lang.synt200,
            s_sheetfuncunknownfunction: lang.synt244,
            s_sheetfunclnarg: lang.synt257,
            s_sheetfunclog10arg: lang.synt258,
            s_sheetfunclogsecondarg: lang.synt259,
            s_sheetfunclogfirstarg: lang.synt260,
            s_sheetfuncroundsecondarg: lang.synt261,
            s_sheetfuncddblife: lang.synt262,
            s_sheetfuncslnlife: lang.synt263,
            s_fdef_ABS: lang.synt264,
            s_fdef_ACOS: lang.synt265,
            s_fdef_AND: lang.synt266,
            s_fdef_ASIN: lang.synt267,
            s_fdef_ATAN: lang.synt268,
            s_fdef_ATAN2: lang.synt269,
            s_fdef_AVERAGE: lang.synt270,
            s_fdef_CHOOSE: lang.synt271,
            s_fdef_COLUMNS: lang.synt272,
            s_fdef_COS: lang.synt273,
            s_fdef_CONCAT: lang.synt274,
            s_fdef_CONCATENATE: lang.synt275,
            s_fdef_COUNT: lang.synt276,
            s_fdef_COUNTA: lang.synt277,
            s_fdef_COUNTBLANK: lang.synt278,
            s_fdef_COUNTIF: lang.synt279,
            s_fdef_DATE: lang.synt280,
            s_fdef_DAVERAGE: lang.synt281,
            s_fdef_DAY: lang.synt282,
            s_fdef_DCOUNT: lang.synt283,
            s_fdef_DCOUNTA: lang.synt284,
            s_fdef_DDB: lang.synt285,
            s_fdef_DEGREES: lang.synt286,
            s_fdef_DGET: lang.synt287,
            s_fdef_DMAX: lang.synt288,
            s_fdef_DMIN: lang.synt289,
            s_fdef_DPRODUCT: lang.synt290,
            s_fdef_DSTDEV: lang.synt291,
            s_fdef_DSTDEVP: lang.synt292,
            s_fdef_DSUM: lang.synt293,
            s_fdef_DVAR: lang.synt294,
            s_fdef_DVARP: lang.synt295,
            s_fdef_EVEN: lang.synt296,
            s_fdef_EXACT: lang.synt297,
            s_fdef_EXP: lang.synt298,
            s_fdef_FACT: lang.synt299,
            s_fdef_FALSE: lang.synt300,
            s_fdef_FIND: lang.synt301,
            s_fdef_FV: lang.synt302,
            s_fdef_HLOOKUP: lang.synt303,
            s_fdef_HOUR: lang.synt304,
            s_fdef_IF: lang.synt305,
            s_fdef_INDEX: lang.synt306,
            s_fdef_INT: lang.synt307,
            s_fdef_IRR: lang.synt308,
            s_fdef_ISBLANK: lang.synt309,
            s_fdef_ISERR: lang.synt310,
            s_fdef_ISERROR: lang.synt311,
            s_fdef_ISLOGICAL: lang.synt312,
            s_fdef_ISNA: lang.synt313,
            s_fdef_ISNONTEXT: lang.synt314,
            s_fdef_ISNUMBER: lang.synt315,
            s_fdef_ISTEXT: lang.synt316,
            s_fdef_LEFT: lang.synt317,
            s_fdef_LEN: lang.synt318,
            s_fdef_LN: lang.synt319,
            s_fdef_LOG: lang.synt320,
            s_fdef_LOG10: lang.synt321,
            s_fdef_LOWER: lang.synt322,
            s_fdef_MATCH: lang.synt323,
            s_fdef_MAX: lang.synt324,
            s_fdef_MID: lang.synt325,
            s_fdef_MIN: lang.synt326,
            s_fdef_MINUTE: lang.synt327,
            s_fdef_MOD: lang.synt328,
            s_fdef_MONTH: lang.synt329,
            s_fdef_N: lang.synt330,
            s_fdef_NA: lang.synt331,
            s_fdef_NOT: lang.synt332,
            s_fdef_NOW: lang.synt333,
            s_fdef_NPER: lang.synt334,
            s_fdef_NPV: lang.synt335,
            s_fdef_ODD: lang.synt336,
            s_fdef_OR: lang.synt337,
            s_fdef_PI: lang.synt338,
            s_fdef_PMT: lang.synt339,
            s_fdef_POWER: lang.synt340,
            s_fdef_PRODUCT: lang.synt341,
            s_fdef_PROPER: lang.synt342,
            s_fdef_PV: lang.synt343,
            s_fdef_RADIANS: lang.synt344,
            s_fdef_RATE: lang.synt345,
            s_fdef_REPLACE: lang.synt346,
            s_fdef_REPT: lang.synt347,
            s_fdef_RIGHT: lang.synt348,
            s_fdef_ROUND: lang.synt349,
            s_fdef_ROWS: lang.synt350,
            s_fdef_SECOND: lang.synt351,
            s_fdef_SIN: lang.synt352,
            s_fdef_SLN: lang.synt353,
            s_fdef_SQRT: lang.synt354,
            s_fdef_STDEV: lang.synt355,
            s_fdef_STDEVP: lang.synt356,
            s_fdef_SUBSTITUTE: lang.synt357,
            s_fdef_SUM: lang.synt358,
            s_fdef_SUMIF: lang.synt359,
            s_fdef_SUMIFS: lang.synt360,
            s_fdef_SYD: lang.synt361,
            s_fdef_T: lang.synt362,
            s_fdef_TAN: lang.synt363,
            s_fdef_TIME: lang.synt364,
            s_fdef_TODAY: lang.synt365,
            s_fdef_TRIM: lang.synt366,
            s_fdef_TRUE: lang.synt367,
            s_fdef_TRUNC: lang.synt368,
            s_fdef_UPPER: lang.synt369,
            s_fdef_VALUE: lang.synt370,
            s_fdef_VAR: lang.synt371,
            s_fdef_VARP: lang.synt372,
            s_fdef_VLOOKUP: lang.synt373,
            s_fdef_WEEKDAY: lang.synt374,
            s_fdef_YEAR: lang.synt375,
            s_fdef_SUMPRODUCT: lang.synt376,
            s_fdef_CEILING: lang.synt377,
            s_fdef_FLOOR: lang.synt378,
            s_farg_v: lang.synt389,
            s_farg_vn: lang.synt390,
            s_farg_xy: lang.synt391,
            s_farg_choose: lang.synt392,
            s_farg_range: lang.synt393,
            s_farg_rangec: lang.synt394,
            s_farg_date: lang.synt395,
            s_farg_dfunc: lang.synt396,
            s_farg_ddb: lang.synt397,
            s_farg_find: lang.synt398,
            s_farg_fv: lang.synt399,
            s_farg_hlookup: lang.synt400,
            s_farg_iffunc: lang.synt401,
            s_farg_index: lang.synt402,
            s_farg_irr: lang.synt403,
            s_farg_tc: lang.synt404,
            s_farg_log: lang.synt405,
            s_farg_match: lang.synt406,
            s_farg_mid: lang.synt407,
            s_farg_nper: lang.synt408,
            s_farg_npv: lang.synt409,
            s_farg_pmt: lang.synt410,
            s_farg_pv: lang.synt411,
            s_farg_rate: lang.synt412,
            s_farg_replace: lang.synt413,
            s_farg_vp: lang.synt414,
            s_farg_valpre: lang.synt415,
            s_farg_csl: lang.synt416,
            s_farg_cslp: lang.synt417,
            s_farg_subs: lang.synt418,
            s_farg_sumif: lang.synt419,
            s_farg_hms: lang.synt420,
            s_farg_txt: lang.synt421,
            s_farg_vlookup: lang.synt422,
            s_farg_weekday: lang.synt423,
            s_farg_dt: lang.synt424,
            s_farg_rangen: lang.synt425,
            s_farg_vsig: lang.synt426,
            function_classlist: lang.synt427,
            s_fclass_all: lang.synt442,
            s_fclass_stat: lang.synt144,
            s_fclass_lookup: lang.synt145,
            s_fclass_datetime: lang.synt146,
            s_fclass_financial: lang.synt147,
            s_fclass_test: lang.synt148,
            s_fclass_math: lang.synt149,
            s_fclass_text: lang.synt150,
            s_fclass_action: lang.synt152,
            s_fclass_gui: lang.synt151,
            lastone: null
        }, t.ConstantsDefaultClasses = {
            defaultComment: "",
            defaultCommentNoGrid: "",
            defaultHighlightTypeCursor: "",
            defaultHighlightTypeRange: "",
            defaultColname: "",
            defaultSelectedColname: "",
            defaultRowname: "",
            defaultSelectedRowname: "",
            defaultUpperLeft: "",
            defaultSkippedCell: "",
            defaultPaneDivider: "",
            cteGriddiv: "",
            defaultInputEcho: {
                classname: "",
                style: "filter:alpha(opacity=90);opacity:.9;"
            },
            TCmain: "",
            TCendcap: "",
            TCpaneslider: "",
            TClessbutton: "",
            TCmorebutton: "",
            TCscrollarea: "",
            TCthumb: "",
            TCPStrackingline: "",
            TCTDFSthumbstatus: "",
            TDpopupElement: ""
        }, t.ConstantsSetClasses = function (e) {
            var o, i = t.ConstantsDefaultClasses,
                n = t.Constants;
            e = e || "";
            for (o in i) "string" == typeof i[o] ? (n[o + "Class"] = e + (i[o] || o), void 0 !== n[o + "Style"] && (n[o + "Style"] = "")) : "object" == typeof i[o] && (n[o + "Class"] = e + (i[o].classname || o),
                n[o + "Style"] = i[o].style);
        }, t.ConstantsSetImagePrefix = function (e) {
            var o = t.Constants;
            for (var i in o) "string" == typeof o[i] && (o[i] = o[i].replace(o.defaultImagePrefix, e));
            o.defaultImagePrefix = e;
        };

        var t;
        t || (t = {}), t.Callbacks = {
                expand_wiki: null,
                expand_markup: function (e, o, i) {
                    return t.default_expand_markup(e, o, i);
                },
                MakePageLink: null,
                NormalizeSheetName: null
            }, t.Cell = function (e) {
                this.coord = e, this.datavalue = "", this.datatype = null, this.formula = "", this.valuetype = "b",
                    this.readonly = !1;
            }, t.CellProperties = {
                coord: 1,
                datavalue: 1,
                datatype: 1,
                formula: 1,
                valuetype: 1,
                errors: 1,
                comment: 1,
                readonly: 1,
                bt: 2,
                br: 2,
                bb: 2,
                bl: 2,
                layout: 2,
                font: 2,
                color: 2,
                bgcolor: 2,
                cellformat: 2,
                nontextvalueformat: 2,
                textvalueformat: 2,
                colspan: 2,
                rowspan: 2,
                cssc: 2,
                csss: 2,
                mod: 2,
                displaystring: 3,
                parseinfo: 3,
                hcolspan: 3,
                hrowspan: 3
            }, t.CellPropertiesTable = {
                bt: "borderstyle",
                br: "borderstyle",
                bb: "borderstyle",
                bl: "borderstyle",
                layout: "layout",
                font: "font",
                color: "color",
                bgcolor: "color",
                cellformat: "cellformat",
                nontextvalueformat: "valueformat",
                textvalueformat: "valueformat"
            }, t.Sheet = function () {
                t.ResetSheet(this), this.statuscallback = null, this.statuscallbackparams = null;
            }, t.ResetSheet = function (e) {
                e.cells = {}, e.attribs = {
                        lastcol: 1,
                        lastrow: 1,
                        defaultlayout: 0,
                        usermaxcol: 0,
                        usermaxrow: 0
                    }, e.rowattribs = {
                        hide: {},
                        height: {}
                    }, e.colattribs = {
                        width: {},
                        hide: {}
                    }, e.names = {}, e.layouts = [], e.layouthash = {}, e.fonts = [], e.fonthash = {},
                    e.colors = [], e.colorhash = {}, e.borderstyles = [], e.borderstylehash = {}, e.cellformats = [],
                    e.cellformathash = {}, e.valueformats = [], e.valueformathash = {}, e.matched_cells = [],
                    e.selected_search_cell = void 0, e.copiedfrom = "", e.changes = new t.UndoStack(),
                    e.renderneeded = !1, e.changedrendervalues = !0, e.recalcchangedavalue = !1, e.hiddencolrow = "",
                    e.sci = new t.SheetCommandInfo(e), e.ioEventTree = {}, e.ioParameterList = {};
            }, t.Sheet.prototype.ResetSheet = function () {
                t.ResetSheet(this);
            }, t.Sheet.prototype.AddCell = function (e) {
                return this.cells[e.coord] = e;
            }, t.Sheet.prototype.LastCol = function () {
                var e = 1;
                for (var o in this.cells) {
                    var i = t.coordToCr(o);
                    i.col > e && (e = i.col);
                }
                return e;
            }, t.Sheet.prototype.LastRow = function () {
                var e = 1;
                for (var o in this.cells) {
                    var i = t.coordToCr(o);
                    i.row > e && (e = i.row);
                }
                return e;
            }, t.Sheet.prototype.GetAssuredCell = function (e) {
                return this.cells[e] || this.AddCell(new t.Cell(e));
            }, t.Sheet.prototype.ParseSheetSave = function (e) {
                t.ParseSheetSave(e, this);
            }, t.Sheet.prototype.CellFromStringParts = function (e, o, i) {
                return t.CellFromStringParts(this, e, o, i);
            }, t.Sheet.prototype.CreateSheetSave = function (e, o) {
                return t.CreateSheetSave(this, e, o);
            }, t.Sheet.prototype.CellToString = function (e) {
                return t.CellToString(this, e);
            }, t.Sheet.prototype.CanonicalizeSheet = function (e) {
                return t.CanonicalizeSheet(this, e);
            }, t.Sheet.prototype.EncodeCellAttributes = function (e) {
                return t.EncodeCellAttributes(this, e);
            }, t.Sheet.prototype.EncodeSheetAttributes = function () {
                return t.EncodeSheetAttributes(this);
            }, t.Sheet.prototype.DecodeCellAttributes = function (e, o, i) {
                return t.DecodeCellAttributes(this, e, o, i);
            }, t.Sheet.prototype.DecodeSheetAttributes = function (e) {
                return t.DecodeSheetAttributes(this, e);
            }, t.Sheet.prototype.ScheduleSheetCommands = function (e, o) {
                return t.ScheduleSheetCommands(this, e, o);
            }, t.Sheet.prototype.SheetUndo = function () {
                return t.SheetUndo(this);
            }, t.Sheet.prototype.SheetRedo = function () {
                return t.SheetRedo(this);
            }, t.Sheet.prototype.CreateAuditString = function () {
                return t.CreateAuditString(this);
            }, t.Sheet.prototype.GetStyleNum = function (e, o) {
                return t.GetStyleNum(this, e, o);
            }, t.Sheet.prototype.GetStyleString = function (e, o) {
                return t.GetStyleString(this, e, o);
            }, t.Sheet.prototype.RecalcSheet = function () {
                return t.RecalcSheet(this);
            }, t.ParseSheetSave = function (e, o) {
                var i, n, r, a, s, l, c, u, d, h = e.split(/\r\n|\n/),
                    p = [],
                    f = t.Constants;
                for (n = 0; n < h.length; n++) {
                    switch (i = h[n], p = i.split(":"), p[0]) {
                        case "cell":
                            c = o.GetAssuredCell(p[1]), r = 2, o.CellFromStringParts(c, p, r);
                            break;

                        case "col":
                            for (l = p[1], r = 2; a = p[r++];) switch (a) {
                                case "w":
                                    o.colattribs.width[l] = p[r++];
                                    break;

                                case "hide":
                                    o.colattribs.hide[l] = p[r++];
                                    break;

                                default:
                                    throw f.s_pssUnknownColType + " '" + a + "'";
                            }
                            break;

                        case "row":
                            for (l = p[1] - 0, r = 2; a = p[r++];) switch (a) {
                                case "h":
                                    o.rowattribs.height[l] = p[r++] - 0;
                                    break;

                                case "hide":
                                    o.rowattribs.hide[l] = p[r++];
                                    break;

                                default:
                                    throw f.s_pssUnknownRowType + " '" + a + "'";
                            }
                            break;

                        case "sheet":
                            for (u = o.attribs, r = 1; a = p[r++];) switch (a) {
                                case "c":
                                    u.lastcol = p[r++] - 0;
                                    break;

                                case "r":
                                    u.lastrow = p[r++] - 0;
                                    break;

                                case "w":
                                    u.defaultcolwidth = p[r++] + "";
                                    break;

                                case "h":
                                    u.defaultrowheight = p[r++] - 0;
                                    break;

                                case "tf":
                                    u.defaulttextformat = p[r++] - 0;
                                    break;

                                case "ntf":
                                    u.defaultnontextformat = p[r++] - 0;
                                    break;

                                case "layout":
                                    u.defaultlayout = p[r++] - 0;
                                    break;

                                case "font":
                                    u.defaultfont = p[r++] - 0;
                                    break;

                                case "tvf":
                                    u.defaulttextvalueformat = p[r++] - 0;
                                    break;

                                case "ntvf":
                                    u.defaultnontextvalueformat = p[r++] - 0;
                                    break;

                                case "color":
                                    u.defaultcolor = p[r++] - 0;
                                    break;

                                case "bgcolor":
                                    u.defaultbgcolor = p[r++] - 0;
                                    break;

                                case "circularreferencecell":
                                    u.circularreferencecell = p[r++];
                                    break;

                                case "recalc":
                                    u.recalc = p[r++];
                                    break;

                                case "needsrecalc":
                                    u.needsrecalc = p[r++];
                                    break;

                                case "usermaxcol":
                                    u.usermaxcol = p[r++] - 0;
                                    break;

                                case "usermaxrow":
                                    u.usermaxrow = p[r++] - 0;
                                    break;

                                default:
                                    r += 1;
                            }
                            break;

                        case "name":
                            d = t.decodeFromSave(p[1]).toUpperCase(), o.names[d] = {
                                desc: t.decodeFromSave(p[2])
                            }, o.names[d].definition = t.decodeFromSave(p[3]);
                            break;

                        case "layout":
                            p = h[n].match(/^layout\:(\d+)\:(.+)$/), o.layouts[p[1] - 0] = p[2], o.layouthash[p[2]] = p[1] - 0;
                            break;

                        case "font":
                            o.fonts[p[1] - 0] = p[2], o.fonthash[p[2]] = p[1] - 0;
                            break;

                        case "color":
                            o.colors[p[1] - 0] = p[2], o.colorhash[p[2]] = p[1] - 0;
                            break;

                        case "border":
                            o.borderstyles[p[1] - 0] = p[2], o.borderstylehash[p[2]] = p[1] - 0;
                            break;

                        case "cellformat":
                            s = t.decodeFromSave(p[2]), o.cellformats[p[1] - 0] = s, o.cellformathash[s] = p[1] - 0;
                            break;

                        case "valueformat":
                            s = t.decodeFromSave(p[2]), o.valueformats[p[1] - 0] = s, o.valueformathash[s] = p[1] - 0;
                            break;

                        case "version":
                            break;

                        case "copiedfrom":
                            o.copiedfrom = p[1] + ":" + p[2];
                            break;

                        case "clipboardrange":
                        case "clipboard":
                            break;

                        case "":
                            break;

                        default:
                            throw alert(f.s_pssUnknownLineType + " '" + p[0] + "'"), f.s_pssUnknownLineType + " '" + p[0] + "'";
                    }
                    p = null;
                }
            }, t.CellFromStringParts = function (e, o, i, n) {
                for (var o, r, a; r = i[n++];) switch (r) {
                    case "v":
                        o.datavalue = t.decodeFromSave(i[n++]) - 0, o.datatype = "v", o.valuetype = "n";
                        break;

                    case "t":
                        o.datavalue = t.decodeFromSave(i[n++]), o.datatype = "t", o.valuetype = t.Constants.textdatadefaulttype;
                        break;

                    case "vt":
                        a = i[n++], o.valuetype = a, "n" == a.charAt(0) ? (o.datatype = "v", o.datavalue = t.decodeFromSave(i[n++]) - 0) : (o.datatype = "t",
                            o.datavalue = t.decodeFromSave(i[n++]));
                        break;

                    case "vtf":
                        a = i[n++], o.valuetype = a, o.datavalue = "n" == a.charAt(0) ? t.decodeFromSave(i[n++]) - 0 : t.decodeFromSave(i[n++]),
                            o.formula = t.decodeFromSave(i[n++]), o.datatype = "f";
                        break;

                    case "vtc":
                        a = i[n++], o.valuetype = a, o.datavalue = "n" == a.charAt(0) ? t.decodeFromSave(i[n++]) - 0 : t.decodeFromSave(i[n++]),
                            o.formula = t.decodeFromSave(i[n++]), o.datatype = "c";
                        break;

                    case "ro":
                        ro = t.decodeFromSave(i[n++]), o.readonly = "yes" == ro.toLowerCase();
                        break;

                    case "e":
                        o.errors = t.decodeFromSave(i[n++]);
                        break;

                    case "b":
                        o.bt = i[n++] - 0, o.br = i[n++] - 0, o.bb = i[n++] - 0, o.bl = i[n++] - 0;
                        break;

                    case "l":
                        o.layout = i[n++] - 0;
                        break;

                    case "f":
                        o.font = i[n++] - 0;
                        break;

                    case "c":
                        o.color = i[n++] - 0;
                        break;

                    case "bg":
                        o.bgcolor = i[n++] - 0;
                        break;

                    case "cf":
                        o.cellformat = i[n++] - 0;
                        break;

                    case "ntvf":
                        o.nontextvalueformat = i[n++] - 0;
                        break;

                    case "tvf":
                        o.textvalueformat = i[n++] - 0;
                        break;

                    case "colspan":
                        o.colspan = i[n++] - 0;
                        break;

                    case "rowspan":
                        o.rowspan = i[n++] - 0;
                        break;

                    case "cssc":
                        o.cssc = i[n++];
                        break;

                    case "csss":
                        o.csss = t.decodeFromSave(i[n++]);
                        break;

                    case "mod":
                        n += 1;
                        break;

                    case "comment":
                        o.comment = t.decodeFromSave(i[n++]);
                        break;

                    default:
                        throw t.Constants.s_cfspUnknownCellType + " '" + r + "'";
                }
            }, t.sheetfields = ["defaultrowheight", "defaultcolwidth", "circularreferencecell", "recalc", "needsrecalc", "usermaxcol", "usermaxrow"],
            t.sheetfieldsshort = ["h", "w", "circularreferencecell", "recalc", "needsrecalc", "usermaxcol", "usermaxrow"],
            t.sheetfieldsxlat = ["defaulttextformat", "defaultnontextformat", "defaulttextvalueformat", "defaultnontextvalueformat", "defaultcolor", "defaultbgcolor", "defaultfont", "defaultlayout"],
            t.sheetfieldsxlatshort = ["tf", "ntf", "tvf", "ntvf", "color", "bgcolor", "font", "layout"],
            t.sheetfieldsxlatxlt = ["cellformat", "cellformat", "valueformat", "valueformat", "color", "color", "font", "layout"],
            t.CreateSheetSave = function (e, o, i) {
                var n, r, a, s, l, c, u, d, h, p, f, m = [];
                e.CanonicalizeSheet(i || t.Constants.doCanonicalizeSheet);
                var g = e.xlt;
                for (f = o ? t.ParseRange(o) : {
                        cr1: {
                            row: 1,
                            col: 1
                        },
                        cr2: {
                            row: g.maxrow,
                            col: g.maxcol
                        }
                    }, r = f.cr1, a = f.cr2, m.push("version:1.5"), s = r.row; s <= a.row; s++)
                    for (l = r.col; l <= a.col; l++) c = t.crToCoord(l, s),
                        n = e.cells[c], n && (u = e.CellToString(n), 0 != u.length && (u = "cell:" + c + u,
                            m.push(u)));
                for (l = 1; l <= g.maxcol; l++) c = t.rcColname(l), e.colattribs.width[c] && m.push("col:" + c + ":w:" + e.colattribs.width[c]),
                    e.colattribs.hide[c] && m.push("col:" + c + ":hide:" + e.colattribs.hide[c]);
                for (s = 1; s <= g.maxrow; s++) e.rowattribs.height[s] && m.push("row:" + s + ":h:" + e.rowattribs.height[s]),
                    e.rowattribs.hide[s] && m.push("row:" + s + ":hide:" + e.rowattribs.hide[s]);
                for (u = "sheet:c:" + g.maxcol + ":r:" + g.maxrow, h = 0; h < t.sheetfields.length; h++) d = t.encodeForSave(e.attribs[t.sheetfields[h]]),
                    d && (u += ":" + t.sheetfieldsshort[h] + ":" + d);
                for (h = 0; h < t.sheetfieldsxlat.length; h++) d = e.attribs[t.sheetfieldsxlat[h]],
                    d && (u += ":" + t.sheetfieldsxlatshort[h] + ":" + g[t.sheetfieldsxlatxlt[h] + "sxlat"][d]);
                for (m.push(u), h = 1; h < g.newborderstyles.length; h++) m.push("border:" + h + ":" + g.newborderstyles[h]);
                for (h = 1; h < g.newcellformats.length; h++) m.push("cellformat:" + h + ":" + t.encodeForSave(g.newcellformats[h]));
                for (h = 1; h < g.newcolors.length; h++) m.push("color:" + h + ":" + g.newcolors[h]);
                for (h = 1; h < g.newfonts.length; h++) m.push("font:" + h + ":" + g.newfonts[h]);
                for (h = 1; h < g.newlayouts.length; h++) m.push("layout:" + h + ":" + g.newlayouts[h]);
                for (h = 1; h < g.newvalueformats.length; h++) m.push("valueformat:" + h + ":" + t.encodeForSave(g.newvalueformats[h]));
                for (h = 0; h < g.namesorder.length; h++) p = g.namesorder[h], m.push("name:" + t.encodeForSave(p).toUpperCase() + ":" + t.encodeForSave(e.names[p].desc) + ":" + t.encodeForSave(e.names[p].definition));
                return o && m.push("copiedfrom:" + t.crToCoord(r.col, r.row) + ":" + t.crToCoord(a.col, a.row)),
                    m.push(""), delete e.xlt, m.join("\n");
            }, t.CellToString = function (e, o) {
                var o, i, n, r, a, s, l, c, u;
                return i = "", o ? (n = t.encodeForSave(o.datavalue), "v" == o.datatype ? i += "n" == o.valuetype ? ":v:" + n : ":vt:" + o.valuetype + ":" + n : "t" == o.datatype ? i += o.valuetype == t.Constants.textdatadefaulttype ? ":t:" + n : ":vt:" + o.valuetype + ":" + n : (r = t.encodeForSave(o.formula),
                        "f" == o.datatype ? i += ":vtf:" + o.valuetype + ":" + n + ":" + r : "c" == o.datatype && (i += ":vtc:" + o.valuetype + ":" + n + ":" + r)),
                    o.readonly && (i += ":ro:yes"), o.errors && (i += ":e:" + t.encodeForSave(o.errors)),
                    a = o.bt || "", s = o.br || "", l = o.bb || "", c = o.bl || "", e.xlt ? (u = e.xlt,
                        (a || s || l || c) && (i += ":b:" + u.borderstylesxlat[a || 0] + ":" + u.borderstylesxlat[s || 0] + ":" + u.borderstylesxlat[l || 0] + ":" + u.borderstylesxlat[c || 0]),
                        o.layout && (i += ":l:" + u.layoutsxlat[o.layout]), o.font && (i += ":f:" + u.fontsxlat[o.font]),
                        o.color && (i += ":c:" + u.colorsxlat[o.color]), o.bgcolor && (i += ":bg:" + u.colorsxlat[o.bgcolor]),
                        o.cellformat && (i += ":cf:" + u.cellformatsxlat[o.cellformat]), o.textvalueformat && (i += ":tvf:" + u.valueformatsxlat[o.textvalueformat]),
                        o.nontextvalueformat && (i += ":ntvf:" + u.valueformatsxlat[o.nontextvalueformat])) : ((a || s || l || c) && (i += ":b:" + a + ":" + s + ":" + l + ":" + c),
                        o.layout && (i += ":l:" + o.layout), o.font && (i += ":f:" + o.font), o.color && (i += ":c:" + o.color),
                        o.bgcolor && (i += ":bg:" + o.bgcolor), o.cellformat && (i += ":cf:" + o.cellformat),
                        o.textvalueformat && (i += ":tvf:" + o.textvalueformat), o.nontextvalueformat && (i += ":ntvf:" + o.nontextvalueformat)),
                    o.colspan && (i += ":colspan:" + o.colspan), o.rowspan && (i += ":rowspan:" + o.rowspan),
                    o.cssc && (i += ":cssc:" + o.cssc), o.csss && (i += ":csss:" + t.encodeForSave(o.csss)),
                    o.mod && (i += ":mod:" + o.mod), o.comment && (i += ":comment:" + t.encodeForSave(o.comment)),
                    i) : i;
            }, t.CanonicalizeSheet = function (e, o) {
                var i, n, r, a, s, l, c, u, d, h, p, f, m, g = 0,
                    v = 0,
                    b = ["borderstyle", "cellformat", "color", "font", "layout", "valueformat"],
                    y = {};
                y.namesorder = [];
                for (c in e.names) y.namesorder.push(c);
                if (y.namesorder.sort(), !t.Constants.doCanonicalizeSheet || !o) {
                    for (l = 0; l < b.length; l++) {
                        for (c = b[l], y["new" + c + "s"] = e[c + "s"], i = e[c + "s"].length, d = new Array(i),
                            d[0] = "", f = 1; i > f; f++) d[f] = f;
                        y[c + "sxlat"] = d;
                    }
                    return y.maxrow = e.attribs.lastrow, y.maxcol = e.attribs.lastcol, void(e.xlt = y);
                }
                for (l = 0; l < b.length; l++) c = b[l], y[c + "sUsed"] = {};
                var C = y.colorsUsed,
                    w = y.borderstylesUsed,
                    x = y.fontsUsed,
                    _ = y.layoutsUsed,
                    S = y.cellformatsUsed,
                    k = y.valueformatsUsed;
                for (n in e.cells) r = t.coordToCr(n), a = e.cells[n], s = !1, a.valuetype && "b" != a.valuetype && (s = !0),
                    a.color && (C[a.color] = 1, s = !0), a.bgcolor && (C[a.bgcolor] = 1, s = !0), a.bt && (w[a.bt] = 1,
                        s = !0), a.br && (w[a.br] = 1, s = !0), a.bb && (w[a.bb] = 1, s = !0), a.bl && (w[a.bl] = 1,
                        s = !0), a.layout && (_[a.layout] = 1, s = !0), a.font && (x[a.font] = 1, s = !0),
                    a.cellformat && (S[a.cellformat] = 1, s = !0), a.textvalueformat && (k[a.textvalueformat] = 1,
                        s = !0), a.nontextvalueformat && (k[a.nontextvalueformat] = 1, s = !0), s && (r.row > g && (g = r.row),
                        r.col > v && (v = r.col));
                for (f = 0; f < t.sheetfieldsxlat.length; f++) m = e.attribs[t.sheetfieldsxlat[f]],
                    m && (y[t.sheetfieldsxlatxlt[f] + "sUsed"][m] = 1);
                c = {
                    height: 1,
                    hide: 1
                };
                for (m in c)
                    for (r in e.rowattribs[m]) r > g && (g = r);
                c = {
                    hide: 1,
                    width: 1
                };
                for (m in c)
                    for (n in e.colattribs[m]) r = t.coordToCr(n + "1"), r.col > v && (v = r.col);
                for (l = 0; l < b.length; l++) {
                    c = b[l], u = [], h = y[c + "sUsed"];
                    for (m in h) u.push(e[c + "s"][m]);
                    for (u.sort(), u.unshift(""), d = [""], p = e[c + "hash"], f = 1; f < u.length; f++) d[p[u[f]]] = f;
                    y[c + "sxlat"] = d, y["new" + c + "s"] = u;
                }
                y.maxrow = g || 1, y.maxcol = v || 1, e.xlt = y;
            }, t.EncodeCellAttributes = function (e, t) {
                var o, i, n, r = {},
                    a = function (e) {
                        r[e] = {
                            def: !0,
                            val: ""
                        };
                    },
                    s = function (e) {
                        for (var t = 0; t < e.length; t++) a(e[t]);
                    },
                    l = function (e, t) {
                        r[e].def = !1, r[e].val = t || "";
                    },
                    c = function (e, t) {
                        "*" != t && (r[e].def = !1, r[e].val = t);
                    },
                    u = e.GetAssuredCell(t);
                for (a("alignhoriz"), u.cellformat && l("alignhoriz", e.cellformats[u.cellformat]),
                    s(["alignvert", "padtop", "padright", "padbottom", "padleft"]), u.layout && (parts = e.layouts[u.layout].match(/^padding:\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+);vertical-align:\s*(\S+);/),
                        c("padtop", parts[1]), c("padright", parts[2]), c("padbottom", parts[3]), c("padleft", parts[4]),
                        c("alignvert", parts[5])), s(["fontfamily", "fontlook", "fontsize"]), u.font && (parts = e.fonts[u.font].match(/^(\*|\S+? \S+?) (\S+?) (\S.*)$/),
                        c("fontfamily", parts[3]), c("fontsize", parts[2]), c("fontlook", parts[1])), a("textcolor"),
                    u.color && l("textcolor", e.colors[u.color]), a("bgcolor"), u.bgcolor && l("bgcolor", e.colors[u.bgcolor]),
                    s(["numberformat", "textformat"]), u.nontextvalueformat && l("numberformat", e.valueformats[u.nontextvalueformat]),
                    u.textvalueformat && l("textformat", e.valueformats[u.textvalueformat]), s(["colspan", "rowspan"]),
                    l("colspan", u.colspan || 1), l("rowspan", u.rowspan || 1), o = 0; 4 > o; o++) i = "trbl".charAt(o),
                    n = "b" + i, a(n), l(n, u[n] ? e.borderstyles[u[n]] : ""), a(n + "thickness"), a(n + "style"),
                    a(n + "color"), u[n] && (parts = e.borderstyles[u[n]].match(/(\S+)\s+(\S+)\s+(\S.+)/),
                        l(n + "thickness", parts[1]), l(n + "style", parts[2]), l(n + "color", parts[3]));
                return s(["cssc", "csss", "mod"]), l("cssc", u.cssc || ""), l("csss", u.csss || ""),
                    l("mod", u.mod || "n"), r;
            }, t.EncodeSheetAttributes = function (e) {
                var t, o = e.attribs,
                    i = {},
                    n = function (e) {
                        i[e] = {
                            def: !0,
                            val: ""
                        };
                    },
                    r = function (e) {
                        for (var t = 0; t < e.length; t++) n(e[t]);
                    },
                    a = function (e, o) {
                        i[e].def = !1, i[e].val = o || t;
                    },
                    s = function (e, t) {
                        "*" != t && (i[e].def = !1, i[e].val = t);
                    };
                return n("colwidth"), o.defaultcolwidth && a("colwidth", o.defaultcolwidth), n("rowheight"),
                    o.rowheight && a("rowheight", o.defaultrowheight), n("textalignhoriz"), o.defaulttextformat && a("textalignhoriz", e.cellformats[o.defaulttextformat]),
                    n("numberalignhoriz"), o.defaultnontextformat && a("numberalignhoriz", e.cellformats[o.defaultnontextformat]),
                    r(["alignvert", "padtop", "padright", "padbottom", "padleft"]), o.defaultlayout && (parts = e.layouts[o.defaultlayout].match(/^padding:\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+);vertical-align:\s*(\S+);/),
                        s("padtop", parts[1]), s("padright", parts[2]), s("padbottom", parts[3]), s("padleft", parts[4]),
                        s("alignvert", parts[5])), r(["fontfamily", "fontlook", "fontsize"]), o.defaultfont && (parts = e.fonts[o.defaultfont].match(/^(\*|\S+? \S+?) (\S+?) (\S.*)$/),
                        s("fontfamily", parts[3]), s("fontsize", parts[2]), s("fontlook", parts[1])), n("textcolor"),
                    o.defaultcolor && a("textcolor", e.colors[o.defaultcolor]), n("bgcolor"), o.defaultbgcolor && a("bgcolor", e.colors[o.defaultbgcolor]),
                    r(["numberformat", "textformat"]), o.defaultnontextvalueformat && a("numberformat", e.valueformats[o.defaultnontextvalueformat]),
                    o.defaulttextvalueformat && a("textformat", e.valueformats[o.defaulttextvalueformat]),
                    n("recalc"), o.recalc && a("recalc", o.recalc), n("usermaxcol"), o.usermaxcol && a("usermaxcol", o.usermaxcol),
                    n("usermaxrow"), o.usermaxrow && a("usermaxrow", o.usermaxrow), i;
            }, t.DecodeCellAttributes = function (e, t, o, n) {
                var r, a, s, l = e.GetAssuredCell(t),
                    c = !1,
                    u = function (e, t, i) {
                        var n;
                        o[e] && (n = o[e].def ? "" : o[e].val, n != (t || "") && h(i + " " + n));
                    },
                    d = "",
                    h = function (e) {
                        d && (d += "\n"), d += "set " + (n || t) + " " + e, c = !0;
                    };
                for (u("alignhoriz", e.cellformats[l.cellformat], "cellformat"), r = o.alignvert.def && o.padtop.def && o.padright.def && o.padbottom.def && o.padleft.def ? "" : "padding:" + (o.padtop.def ? "* " : o.padtop.val + " ") + (o.padright.def ? "* " : o.padright.val + " ") + (o.padbottom.def ? "* " : o.padbottom.val + " ") + (o.padleft.def ? "*" : o.padleft.val) + ";vertical-align:" + (o.alignvert.def ? "*;" : o.alignvert.val + ";"),
                    r != (e.layouts[l.layout] || "") && h("layout " + r), r = o.fontlook.def && o.fontsize.def && o.fontfamily.def ? "" : (o.fontlook.def ? "* " : o.fontlook.val + " ") + (o.fontsize.def ? "* " : o.fontsize.val + " ") + (o.fontfamily.def ? "*" : o.fontfamily.val),
                    r != (e.fonts[l.font] || "") && h("font " + r), u("textcolor", e.colors[l.color], "color"),
                    u("bgcolor", e.colors[l.bgcolor], "bgcolor"), u("numberformat", e.valueformats[l.nontextvalueformat], "nontextvalueformat"),
                    u("textformat", e.valueformats[l.textvalueformat], "textvalueformat"), i = 0; 4 > i; i++) a = "trbl".charAt(i),
                    s = "b" + a, u(s, e.borderstyles[l[s]], s);
                return u("cssc", l.cssc, "cssc"), u("csss", l.csss, "csss"), o.mod && (r = o.mod.def ? "n" : o.mod.val,
                    r != (l.mod || "n") && ("n" == r && (r = ""), h("mod " + r))), c ? d : null;
            }, t.DecodeSheetAttributes = function (e, t) {
                var o, i = e.attribs,
                    n = !1,
                    r = function (e, o, i) {
                        var n;
                        t[e] && (n = t[e].def ? "" : t[e].val, n != (o || "") && s(i + " " + n));
                    },
                    a = "",
                    s = function (e) {
                        a && (a += "\n"), a += "set sheet " + e, n = !0;
                    };
                return r("colwidth", i.defaultcolwidth, "defaultcolwidth"), r("rowheight", i.defaultrowheight, "defaultrowheight"),
                    r("textalignhoriz", e.cellformats[i.defaulttextformat], "defaulttextformat"), r("numberalignhoriz", e.cellformats[i.defaultnontextformat], "defaultnontextformat"),
                    o = t.alignvert.def && t.padtop.def && t.padright.def && t.padbottom.def && t.padleft.def ? "" : "padding:" + (t.padtop.def ? "* " : t.padtop.val + " ") + (t.padright.def ? "* " : t.padright.val + " ") + (t.padbottom.def ? "* " : t.padbottom.val + " ") + (t.padleft.def ? "*" : t.padleft.val) + ";vertical-align:" + (t.alignvert.def ? "*;" : t.alignvert.val + ";"),
                    o != (e.layouts[i.defaultlayout] || "") && s("defaultlayout " + o), o = t.fontlook.def && t.fontsize.def && t.fontfamily.def ? "" : (t.fontlook.def ? "* " : t.fontlook.val + " ") + (t.fontsize.def ? "* " : t.fontsize.val + " ") + (t.fontfamily.def ? "*" : t.fontfamily.val),
                    o != (e.fonts[i.defaultfont] || "") && s("defaultfont " + o), r("textcolor", e.colors[i.defaultcolor], "defaultcolor"),
                    r("bgcolor", e.colors[i.defaultbgcolor], "defaultbgcolor"), r("numberformat", e.valueformats[i.defaultnontextvalueformat], "defaultnontextvalueformat"),
                    r("textformat", e.valueformats[i.defaulttextvalueformat], "defaulttextvalueformat"),
                    r("recalc", e.attribs.recalc, "recalc"), r("usermaxcol", e.attribs.usermaxcol, "usermaxcol"),
                    r("usermaxrow", e.attribs.usermaxrow, "usermaxrow"), n ? a : null;
            }, t.SheetCommandInfo = function (e) {
                this.sheetobj = e, this.timerobj = null, this.firsttimerdelay = 50, this.timerdelay = 1,
                    this.maxtimeslice = 100, this.saveundo = !1, this.CmdExtensionCallbacks = {};
            }, t.ScheduleSheetCommands = function (o, i, n) {
                var r = o.sci,
                    a = new t.Parse(i);
                r.sheetobj.statuscallback && o.statuscallback(r, "cmdstart", "", r.sheetobj.statuscallbackparams),
                    n && r.sheetobj.changes.PushChange(""), r.timerobj = e.setTimeout(function () {
                        t.SheetCommandsTimerRoutine(r, a, n);
                    }, r.firsttimerdelay);
            }, t.SheetCommandsTimerRoutine = function (o, i, n) {
                var r, a = new Date();
                for (o.timerobj = null; !i.EOF();) {
                    try {
                        r = t.ExecuteSheetCommand(o.sheetobj, i, n);
                    } catch (s) {
                        r = s.message;
                    }
                    if (r && ("function" == typeof alert ? alert(r) : console.log(r)), i.NextLine(),
                        new Date() - a >= o.maxtimeslice) return void(o.timerobj = e.setTimeout(function () {
                        t.SheetCommandsTimerRoutine(o, i, n);
                    }, o.timerdelay));
                }
                o.sheetobj.statuscallback && o.sheetobj.statuscallback(o, "cmdend", "", o.sheetobj.statuscallbackparams);
            }, t.ExecuteSheetCommand = function (e, o, i) {
                function n(o) {
                    function i(e) {
                        return "v" == e || "c" == e;
                    }
                    var n = t.GetSpreadsheetControlObject().editor,
                        r = n.range2,
                        a = void 0;
                    if (r.hasrange) {
                        var s, l;
                        o && r.bottom - r.top == 1 && r.left == r.right ? (s = e.GetAssuredCell(t.crToCoord(r.left, r.top)),
                            l = e.GetAssuredCell(t.crToCoord(r.left, r.bottom)), i(s.datatype) && i(l.datatype) && (a = l.datavalue - s.datavalue)) : o || r.left == r.right || (s = e.GetAssuredCell(t.crToCoord(r.left, r.top)),
                            l = e.GetAssuredCell(t.crToCoord(r.right, r.top)), i(s.datatype) && i(l.datatype) && (a = l.datavalue - s.datavalue));
                    }
                    return n.Range2Remove(), a;
                }
                var r, a, s, l, c, u, d, h, p, f, m, g, v, b, y, C, w, x, _, S, k, T, F, E, D, P, A, I, M, R, N, L, O, z, H, B, U, j, V, W, G, $, Y, K, q, X, J, Z, Q, et, tt, ot, it, nt, rt, at, st, lt, ct, ut, dt, b, y, ht, pt, ft, mt = e.attribs,
                    gt = e.changes,
                    vt = t.CellProperties,
                    bt = t.Constants,
                    yt = !1,
                    Ct = function () {
                        var e = t.ParseRange(l);
                        g = e.cr1, v = e.cr2, v.col > mt.lastcol && (mt.lastcol = v.col), v.row > mt.lastrow && (mt.lastrow = v.row);
                    };

                function deleteConfigCells(cellToDel) {
                    for (let i = 0; i < config.cells.length; i++) {
                        if (config.cells[i].search("set " + cellToDel) == 0) {
                            config.cells.splice(i, 1);
                        }
                    }
                };

                /* function explicitType(type){
                    if(type =='n'){return 'numeric'}
                    else if (type == 'v') {return 'numeric'}
                    else if (type == 't') {return 'text'}
                    else if (type == 'f') {return 'formula'}
                    else if (type == 'c') {return 'constant'}

                } */
                switch (p = "", r = o.RestOfStringNoMove(), i && e.changes.AddDo(r), a = o.NextToken()) {
                    case "set":
                        if (l = o.NextToken(), c = o.NextToken(), s = o.RestOfString(), f = "set " + l + " " + c,
                            "sheet" == l) switch (e.renderneeded = !0, c) {
                                case "defaultcolwidth":
                                    i && gt.AddUndo(f, mt[c]), mt[c] = s;
                                    break;

                                case "defaultcolor":
                                case "defaultbgcolor":
                                    i && gt.AddUndo(f, e.GetStyleString("color", mt[c])), mt[c] = e.GetStyleNum("color", s);
                                    break;

                                case "defaultlayout":
                                    i && gt.AddUndo(f, e.GetStyleString("layout", mt[c])), mt[c] = e.GetStyleNum("layout", s);
                                    break;

                                case "defaultfont":
                                    i && gt.AddUndo(f, e.GetStyleString("font", mt[c])), "* * *" == s && (s = ""), mt[c] = e.GetStyleNum("font", s);
                                    break;

                                case "defaulttextformat":
                                case "defaultnontextformat":
                                    i && gt.AddUndo(f, e.GetStyleString("cellformat", mt[c])), mt[c] = e.GetStyleNum("cellformat", s);
                                    break;

                                case "defaulttextvalueformat":
                                case "defaultnontextvalueformat":
                                    i && gt.AddUndo(f, e.GetStyleString("valueformat", mt[c])), mt[c] = e.GetStyleNum("valueformat", s);
                                    for (C in e.cells) delete e.cells[C].displaystring;
                                    break;

                                case "lastcol":
                                case "lastrow":
                                    i && gt.AddUndo(f, mt[c] - 0), u = s - 0, "number" == typeof u && (mt[c] = u > 0 ? u : 1);
                                    break;

                                case "recalc":
                                    i && gt.AddUndo(f, mt[c]), "off" == s ? mt.recalc = s : delete mt.recalc;
                                    break;

                                case "usermaxcol":
                                case "usermaxrow":
                                    i && gt.AddUndo(f, mt[c] - 0), u = s - 0, "number" == typeof u && (mt[c] = u > 0 ? u : 0);
                                    break;

                                default:
                                    p = bt.s_escUnknownSheetCmd + r;
                            } else if (/^[a-z]{1,2}(:[a-z]{1,2})?$/i.test(l))
                                for (e.renderneeded = !0, l = l.toUpperCase(),
                                    d = l.indexOf(":"), d >= 0 ? (g = t.coordToCr(l.substring(0, d) + "1"), v = t.coordToCr(l.substring(d + 1) + "1")) : (g = t.coordToCr(l + "1"),
                                        v = g), b = g.col; b <= v.col; b++) "width" == c ? (C = t.rcColname(b), i && gt.AddUndo("set " + C + " width", e.colattribs.width[C]),
                                    s.length > 0 ? e.colattribs.width[C] = s : delete e.colattribs.width[C]) : "hide" == c && (e.hiddencolrow = "col",
                                    C = t.rcColname(b), i && gt.AddUndo("set " + C + " hide", e.colattribs.hide[C]),
                                    s.length > 0 ? e.colattribs.hide[C] = s : delete e.colattribs.hide[C]);
                            else if (/^\d+(:\d+)?$/i.test(l))
                            for (e.renderneeded = !0,
                                l = l.toUpperCase(), d = l.indexOf(":"), d >= 0 ? (g = t.coordToCr("A" + l.substring(0, d)),
                                    v = t.coordToCr("A" + l.substring(d + 1))) : (g = t.coordToCr("A" + l), v = g),
                                y = g.row; y <= v.row; y++) "height" == c ? (i && gt.AddUndo("set " + y + " height", e.rowattribs.height[y]),
                                s.length > 0 ? e.rowattribs.height[y] = s : delete e.rowattribs.height[y]) : "hide" == c && (e.hiddencolrow = "row",
                                i && gt.AddUndo("set " + y + " hide", e.rowattribs.hide[y]), s.length > 0 ? e.rowattribs.hide[y] = s : delete e.rowattribs.hide[y]);
                        else if (/^[a-z]{1,2}\d+(:[a-z]{1,2}\d+)?$/i.test(l))
                            for (yt = !0,
                                Ct(), g.row != v.row || g.col != v.col || e.celldisplayneeded || e.renderneeded ? (e.renderneeded = !0,
                                    e.celldisplayneeded = "") : e.celldisplayneeded = t.crToCoord(g.col, g.row), y = g.row; y <= v.row; y++)
                                for (b = g.col; b <= v.col; b++) C = t.crToCoord(b, y),
                                    w = e.GetAssuredCell(C), w.readonly && "readonly" != c || (i && gt.AddUndo("set " + C + " all", e.CellToString(w)),
                                        "value" == c ? (d = s.indexOf(" "), w.datavalue = s.substring(d + 1) - 0, delete w.errors,
                                            w.datatype = "v", w.valuetype = s.substring(0, d), delete w.displaystring, delete w.parseinfo,
                                            mt.needsrecalc = "yes") : "text" == c ? (d = s.indexOf(" "), w.datavalue = t.decodeFromSave(s.substring(d + 1)),
                                            delete w.errors, w.datatype = "t", w.valuetype = s.substring(0, d), delete w.displaystring,
                                            delete w.parseinfo, mt.needsrecalc = "yes") : "formula" == c ? (w.datavalue = 0,
                                            delete w.errors, w.datatype = "f", t._app && "e#N/A" != w.valuetype && (w.prevvaluetype = w.valuetype),
                                            w.valuetype = "e#N/A", w.formula = s, delete w.displaystring, delete w.parseinfo,
                                            mt.needsrecalc = "yes") : "constant" == c ? (d = s.indexOf(" "), h = s.substring(d + 1).indexOf(" "),
                                            w.datavalue = s.substring(d + 1, d + 1 + h) - 0, w.valuetype = s.substring(0, d),
                                            "e" == w.valuetype.charAt(0) ? w.errors = w.valuetype.substring(1) : delete w.errors,
                                            w.datatype = "c", w.formula = s.substring(d + h + 2), delete w.displaystring, delete w.parseinfo,
                                            mt.needsrecalc = "yes") : "empty" == c ? (w.datavalue = "", delete w.errors, w.datatype = null,
                                            w.formula = "", w.valuetype = "b", delete w.displaystring, delete w.parseinfo, mt.needsrecalc = "yes") : "all" == c ? (s.length > 0 ? (w = new t.Cell(C),
                                                e.CellFromStringParts(w, s.split(":"), 1), e.cells[C] = w) : delete e.cells[C],
                                            mt.needsrecalc = "yes") : /^b[trbl]$/.test(c) ? (w[c] = e.GetStyleNum("borderstyle", s),
                                            e.renderneeded = !0) : "color" == c || "bgcolor" == c ? w[c] = e.GetStyleNum("color", s) : "layout" == c || "cellformat" == c ? w[c] = e.GetStyleNum(c, s) : "font" == c ? ("* * *" == s && (s = ""),
                                            w[c] = e.GetStyleNum("font", s)) : "textvalueformat" == c || "nontextvalueformat" == c ? (w[c] = e.GetStyleNum("valueformat", s),
                                            delete w.displaystring) : "cssc" == c ? (s = s.replace(/[^a-zA-Z0-9\-]/g, ""), w.cssc = s) : "csss" == c ? (s = s.replace(/\n/g, ""),
                                            w.csss = s) : "mod" == c ? (s = s.replace(/[^yY]/g, "").toLowerCase(), w.mod = s) : "comment" == c ? w.comment = t.decodeFromSave(s) : "readonly" == c ? w.readonly = "yes" == s.toLowerCase() : p = bt.s_escUnknownSetCoordCmd + r);
                        break;

                    case "merge":
                        if (e.renderneeded = !0, l = o.NextToken(), s = o.RestOfString(), Ct(), w = e.GetAssuredCell(g.coord),
                            w.readonly) break;
                        for (y = g.row; y <= v.row; y++)
                            for (b = g.col; b <= v.col; b++)(y != g.row || b != g.col) && (quashedCellCoord = t.crToCoord(b, y),
                                quashedCell = e.GetAssuredCell(quashedCellCoord), i && gt.AddUndo("set " + quashedCellCoord + " all", e.CellToString(quashedCell)),
                                delete e.cells[quashedCellCoord]);
                        i && gt.AddUndo("unmerge " + g.coord), v.col > g.col ? w.colspan = v.col - g.col + 1 : delete w.colspan,
                            v.row > g.row ? w.rowspan = v.row - g.row + 1 : delete w.rowspan, e.changedrendervalues = !0;
                        break;

                    case "unmerge":
                        if (e.renderneeded = !0, l = o.NextToken(), s = o.RestOfString(), Ct(), w = e.GetAssuredCell(g.coord),
                            w.readonly) break;
                        i && gt.AddUndo("merge " + g.coord + ":" + t.crToCoord(g.col + (w.colspan || 1) - 1, g.row + (w.rowspan || 1) - 1)),
                            delete w.colspan, delete w.rowspan, e.changedrendervalues = !0;
                        break;

                    case "erase":
                    case "cut":
                        
                        for (e.renderneeded = !0, e.changedrendervalues = !0, l = o.NextToken(), s = o.RestOfString(),
                            Ct(), i && gt.AddUndo("changedrendervalues"), "cut" == a && (i && gt.AddUndo("loadclipboard", t.encodeForSave(t.Clipboard.clipboard)),
                                t.Clipboard.clipboard = t.CreateSheetSave(e, l)), y = g.row; y <= v.row; y++)
                            for (b = g.col; b <= v.col; b++) C = t.crToCoord(b, y),
                                
                                //deleteConfigCells(e.cells[C].coord),
                                w = e.GetAssuredCell(C), w.readonly || (i && gt.AddUndo("set " + C + " all", e.CellToString(w)),
                                    "all" == s ? delete e.cells[C] : "formulas" == s ? (w.datavalue = "", w.datatype = null,
                                        w.formula = "", w.valuetype = "b", delete w.errors, delete w.displaystring, delete w.parseinfo,
                                        w.comment && delete w.comment) : "formats" == s && (x = new t.Cell(C), x.datavalue = w.datavalue,
                                        x.datatype = w.datatype, x.formula = w.formula, x.valuetype = w.valuetype, w.comment && (x.comment = w.comment),
                                        e.cells[C] = x));
                        mt.needsrecalc = "yes";
                        break;

                    case "fillright":
                    case "filldown":
                        e.renderneeded = !0, e.changedrendervalues = !0, i && gt.AddUndo("changedrendervalues"),
                            l = o.NextToken(), s = o.RestOfString(), Ct();
                        var wt;
                        for ("fillright" == a ? (_ = !0, S = g.row, k = g.col + 1, wt = n(!1)) : (_ = !1,
                                S = g.row + 1, k = g.col, wt = n(!0)), y = S; y <= v.row; y++)
                            for (b = k; b <= v.col; b++)
                                if (C = t.crToCoord(b, y),
                                    w = e.GetAssuredCell(C), !w.readonly) {
                                    if (i && gt.AddUndo("set " + C + " all", e.CellToString(w)), _ ? (T = t.crToCoord(g.col, y),
                                            E = b - k + 1, F = 0) : (T = t.crToCoord(b, g.row), E = 0, F = y - S + 1), D = e.GetAssuredCell(T),
                                        "all" == s || "formats" == s)
                                        for (c in vt) 1 != vt[c] && (void 0 === typeof D[c] || 3 == vt[c] ? delete w[c] : w[c] = D[c]);
                                    ("all" == s || "formulas" == s) && (w.datavalue = void 0 !== wt ? D.datavalue + (_ ? E : F) * wt : D.datavalue,
                                        w.datatype = D.datatype, w.valuetype = D.valuetype, w.formula = "f" == w.datatype ? t.OffsetFormulaCoords(D.formula, E, F) : D.formula,
                                        delete w.parseinfo, w.errors = D.errors), delete w.displaystring;
                                }
                        mt.needsrecalc = "yes";
                        break;

                    case "copy":
                        l = o.NextToken(), s = o.RestOfString(), i && gt.AddUndo("loadclipboard", t.encodeForSave(t.Clipboard.clipboard)),
                            t.Clipboard.clipboard = t.CreateSheetSave(e, l);
                        break;

                    case "loadclipboard":
                        s = o.RestOfString(), i && gt.AddUndo("loadclipboard", t.encodeForSave(t.Clipboard.clipboard)),
                            t.Clipboard.clipboard = t.decodeFromSave(s);
                        
                        if (typeof s !== 'undefined') {
                            config.clipBoard.push(s)
                        };
                    
                        break;

                    case "clearclipboard":
                        i && gt.AddUndo("loadclipboard", t.encodeForSave(t.Clipboard.clipboard)), t.Clipboard.clipboard = "";
                        break;

                    case "paste":
                        if (e.renderneeded = !0, e.changedrendervalues = !0, i && gt.AddUndo("changedrendervalues"),
                            l = o.NextToken(), s = o.RestOfString(), Ct(), !t.Clipboard.clipboard) break;
                        for (P = new t.Sheet(), P.ParseSheetSave(t.Clipboard.clipboard), A = t.ParseRange(P.copiedfrom),
                            E = A.cr1.col, F = A.cr1.row, I = Math.max(v.col - g.col + 1, A.cr2.col - A.cr1.col + 1),
                            M = Math.max(v.row - g.row + 1, A.cr2.row - A.cr1.row + 1), g.col + I - 1 > mt.lastcol && (mt.lastcol = g.col + I - 1),
                            g.row + M - 1 > mt.lastrow && (mt.lastrow = g.row + M - 1), y = g.row; y < g.row + M; y++)
                            for (b = g.col; b < g.col + I; b++)
                                if (C = t.crToCoord(b, y),
                                    w = e.GetAssuredCell(C), !w.readonly) {
                                    if (i && gt.AddUndo("set " + C + " all", e.CellToString(w)), T = t.crToCoord(A.cr1.col + (b - g.col) % (A.cr2.col - A.cr1.col + 1), A.cr1.row + (y - g.row) % (A.cr2.row - A.cr1.row + 1)),
                                        D = P.GetAssuredCell(T), "all" == s || "formats" == s) {
                                        y == g.row && (sourceColname = t.rcColname(A.cr1.col + (b - g.col) % (A.cr2.col - A.cr1.col + 1)),
                                                colWidth = P.colattribs.width[sourceColname], colHide = P.colattribs.hide[sourceColname],
                                                null != colWidth && (e.colattribs.width[t.rcColname(b)] = colWidth), null != colHide && (e.colattribs.hide[t.rcColname(b)] = colHide)),
                                            b == g.col && (sourceRow = A.cr1.row + (y - g.row) % (A.cr2.row - A.cr1.row + 1),
                                                rowHide = P.rowattribs.hide[sourceRow], null != rowHide && (e.rowattribs.hide[y] = rowHide));
                                        for (c in vt) 1 != vt[c] && (void 0 === typeof D[c] || 3 == vt[c] ? delete w[c] : (R = t.CellPropertiesTable[c],
                                            w[c] = R && D[c] ? e.GetStyleNum(R, P.GetStyleString(R, D[c])) : D[c]));

                                    }
                                    ("all" == s || "formulas" == s) && (w.datavalue = D.datavalue, w.datatype = D.datatype,
                                        w.valuetype = D.valuetype, w.formula = "f" == w.datatype ? t.OffsetFormulaCoords(D.formula, b - E, y - F) : D.formula,
                                        delete w.parseinfo, w.errors = D.errors, D.comment ? w.comment = D.comment : w.comment && delete w.comment),
                                    delete w.displaystring;
                                    /*  var strcell;
                                     if (w.datatype == "n" || w.datatype == "t") {strcell = "set " + C +" "+ explicitType(w.datatype) +" "+ w.datatype +" "+ w.datavalue;}
                                     else if (w.datatype == "f"){strcell = "set " + C +" "+ explicitType(w.datatype) +" "+ w.formula;} */
                                    //if ($.isArray("config.cells")){config.cells.push(strcell);} // Control by function instead by command (line 10974 )
                                    //set C4 text t Premier

                                }
                        mt.needsrecalc = "yes";
                        break;

                    case "sort":
                        for (e.renderneeded = !0, e.changedrendervalues = !0, i && gt.AddUndo("changedrendervalues"),
                            l = o.NextToken(), Ct(), X = [], J = [], Z = 0, Q = 0; 3 >= Q; Q++) X[Q] = o.NextToken(),
                            J[Q] = o.NextToken(), X[Q] && (Z = Q);
                        for (tt = {}, et = [], ot = [], it = [], y = g.row; y <= v.row; y++) {
                            for (b = g.col; b <= v.col; b++) C = t.crToCoord(b, y), w = e.cells[C], w ? (tt[C] = e.CellToString(w),
                                i && gt.AddUndo("set " + C + " all", tt[C])) : i && gt.AddUndo("set " + C + " all");
                            for (et.push(et.length), ot.push([]), it.push([]), slast = it.length - 1, Q = 0; Z >= Q; Q++) C = X[Q] + y,
                                w = e.GetAssuredCell(C), m = w.datavalue, rt = w.valuetype.charAt(0) || "b", "t" == rt && (m = m.toLowerCase()),
                                ot[slast].push(m), it[slast].push(rt);
                        }
                        for (nt = function (e, t) {
                                var o, i, n, r, a;
                                for (o = 0; Z >= o; o++)
                                    if ("up" == J[o] ? (i = e, n = t) : (i = t, n = e), r = it[i][o],
                                        tb = it[n][o], "t" == r ? "t" == tb ? (i = ot[i][o], n = ot[n][o], a = i > n ? 1 : n > i ? -1 : 0) : "n" == tb ? a = 1 : "b" == tb ? a = "up" == J[o] ? -1 : 1 : "e" == tb && (a = -1) : "n" == r ? "t" == tb ? a = -1 : "n" == tb ? (i = ot[i][o] - 0,
                                            n = ot[n][o] - 0, a = i > n ? 1 : n > i ? -1 : 0) : "b" == tb ? a = "up" == J[o] ? -1 : 1 : "e" == tb && (a = -1) : "e" == r ? "e" == tb ? (i = ot[i][o],
                                            n = ot[n][o], a = i > n ? 1 : n > i ? -1 : 0) : a = "b" == tb && "up" == J[o] ? -1 : 1 : "b" == r && (a = "b" == tb ? 0 : "up" == J[o] ? 1 : -1),
                                        a) return a;
                                return a = e > t ? 1 : t > e ? -1 : 0;
                            }, et.sort(nt), y = g.row; y <= v.row; y++)
                            for (at = et[y - g.row], b = g.col; b <= v.col; b++) C = t.crToCoord(b, y),
                                st = t.crToCoord(b, at + g.row), tt[st] ? (w = new t.Cell(C), e.CellFromStringParts(w, tt[st].split(":"), 1),
                                    "f" == w.datatype && (w.formula = t.OffsetFormulaCoords(w.formula, 0, y - g.row - at)),
                                    e.cells[C] = w) : delete e.cells[C];
                        mt.needsrecalc = "yes";
                        break;

                    case "insertcol":
                    case "insertrow":
                        for (e.renderneeded = !0, e.changedrendervalues = !0, e.widgetsClean = !1, l = o.NextToken(),
                            s = o.RestOfString(), Ct(), "insertcol" == a ? (E = 1, N = g.col, F = 0, L = 1,
                                O = g.col, H = g.col, z = 1, B = mt.lastrow, i && gt.AddUndo("deletecol " + g.coord)) : (E = 0,
                                N = 1, F = 1, L = g.row, O = 1, H = mt.lastcol, z = g.row, B = g.row, i && gt.AddUndo("deleterow " + g.coord)),
                            y = mt.lastrow; y >= L; y--)
                            for (b = mt.lastcol; b >= N; b--) T = t.crToCoord(b, y),
                                C = t.crToCoord(b + E, y + F), e.cells[T] ? e.cells[C] = e.cells[T] : delete e.cells[C];
                        for (y = z; B >= y; y++)
                            for (b = O; H >= b; b++) {
                                C = t.crToCoord(b, y), w = new t.Cell(C), e.cells[C] = w, T = t.crToCoord(b - E, y - F),
                                    D = e.GetAssuredCell(T);
                                for (c in vt) 2 == vt[c] && (w[c] = D[c]);
                            }
                        for (C in e.cells) w = e.cells[C], w && "f" == w.datatype && (w.formula = t.AdjustFormulaCoords(w.formula, g.col, E, g.row, F)),
                            w && delete w.parseinfo;
                        for (lt in e.names) e.names[lt] && (ct = e.names[lt].definition, ut = "", "=" == ct.charAt(0) && (ut = "=",
                            ct = ct.substring(1)), e.names[lt].definition = ut + t.AdjustFormulaCoords(ct, g.col, E, g.row, F));
                        for (y = mt.lastrow; y >= L && "insertrow" == a; y--) {
                            U = y + F;
                            for (c in e.rowattribs) m = e.rowattribs[c][y], e.rowattribs[c][U] != m && (m ? e.rowattribs[c][U] = m : delete e.rowattribs[c][U]);
                        }
                        for (b = mt.lastcol; b >= N && "insertcol" == a; b--) {
                            V = t.rcColname(b), j = t.rcColname(b + E);
                            for (c in e.colattribs) m = e.colattribs[c][V], e.colattribs[c][j] != m && (m ? e.colattribs[c][j] = m : delete e.colattribs[c][j]);
                        }
                        var xt = new t.RenderContext(e);
                        xt.CalculateCellSkipData();
                        var _t = {};
                        for (var St in xt.cellskip) {
                            var kt = t.coordToCr(St),
                                Tt = xt.cellskip[St];
                            "insertcol" === a && kt.col === O && (_t[Tt] || (e.GetAssuredCell(Tt).colspan += E),
                                _t[Tt] = !0), "insertrow" === a && kt.row === z && (_t[Tt] || (e.GetAssuredCell(Tt).rowspan += F),
                                _t[Tt] = !0);
                        }
                        mt.lastcol += E, mt.lastrow += F, mt.needsrecalc = "yes";
                        break;

                    case "deletecol":
                    case "deleterow":
                        for (e.renderneeded = !0, e.changedrendervalues = !0, e.widgetsClean = !1, l = o.NextToken(),
                            s = o.RestOfString(), G = mt.lastcol, W = mt.lastrow, Ct(), "deletecol" == a ? (E = g.col - v.col - 1,
                                F = 0, k = v.col + 1, S = 1) : (E = 0, F = g.row - v.row - 1, k = 1, S = v.row + 1),
                            y = S; W - F >= y; y++)
                            for (b = k; G - E >= b; b++)
                                if (C = t.crToCoord(b + E, y + F),
                                    w = e.cells[C], w && w.readonly) return p = "Unable to remove " + ("deletecol" == a ? "column" : "row") + ", because cell " + w.coord + " is locked";
                        for (y = S; W - F >= y; y++)
                            for (b = k; G - E >= b; b++) C = t.crToCoord(b + E, y + F),
                                i && (S - F > y || k - E > b) && (w = e.cells[C], w ? gt.AddUndo("set " + C + " all", e.CellToString(w)) : gt.AddUndo("erase " + C + " all")),
                                T = t.crToCoord(b, y), w = e.cells[T], w ? e.cells[C] = w : delete e.cells[C];
                        for (C in e.cells) w = e.cells[C], w && ("f" == w.datatype ? (K = w.formula, w.formula = t.AdjustFormulaCoords(K, g.col, E, g.row, F),
                            w.formula != K && (delete w.parseinfo, i && -1 != w.formula.indexOf("#REF!") && (q = t.coordToCr(C),
                                gt.AddUndo("set " + t.rcColname(q.col - E) + (q.row - F) + " formula " + K)))) : delete w.parseinfo);
                        for (lt in e.names) e.names[lt] && (ct = e.names[lt].definition, ut = "", "=" == ct.charAt(0) && (ut = "=",
                            ct = ct.substring(1)), e.names[lt].definition = ut + t.AdjustFormulaCoords(ct, g.col, E, g.row, F));
                        for (y = S; W - F >= y && "deleterow" == a; y++) {
                            $ = y + F;
                            for (c in e.rowattribs) m = e.rowattribs[c][y], e.rowattribs[c][$] != m && (i && gt.AddUndo("set " + $ + " " + c, e.rowattribs[c][$]),
                                m ? e.rowattribs[c][$] = m : delete e.rowattribs[c][$]);
                        }
                        for (b = k; G - E >= b && "deletecol" == a; b++) {
                            V = t.rcColname(b), Y = t.rcColname(b + E);
                            for (c in e.colattribs) m = e.colattribs[c][V], e.colattribs[c][Y] != m && (i && gt.AddUndo("set " + Y + " " + c, e.colattribs[c][Y]),
                                m ? e.colattribs[c][Y] = m : delete e.colattribs[c][Y]);
                        }
                        var xt = new t.RenderContext(e);
                        xt.CalculateCellSkipData();
                        var Ft = {};
                        for (var St in xt.cellskip) {
                            var kt = t.coordToCr(St),
                                Tt = xt.cellskip[St],
                                Et = xt.coordToCR[Tt];
                            "deletecol" === a && kt.col === k + E && Et.col < kt.col && (Ft[Tt] || (e.GetAssuredCell(Tt).colspan += E),
                                Ft[Tt] = !0), "deleterow" === a && kt.row === S + F && Et.row < kt.row && (Ft[Tt] || (e.GetAssuredCell(Tt).rowspan += F),
                                Ft[Tt] = !0);
                        }
                        if (i)
                            if ("deletecol" == a)
                                for (b = g.col; b <= v.col; b++) gt.AddUndo("insertcol " + t.rcColname(g.col));
                            else
                                for (y = g.row; y <= v.row; y++) gt.AddUndo("insertrow " + g.row);
                        "deletecol" == a ? g.col <= G && (v.col <= G ? mt.lastcol += E : mt.lastcol = g.col - 1) : g.row <= W && (v.row <= W ? mt.lastrow += F : mt.lastrow = g.row - 1),
                            mt.needsrecalc = "yes";
                        break;

                    case "movepaste":
                    case "moveinsert":
                        var Dt, Pt, At, It, Mt, Rt, Nt;
                        for (e.renderneeded = !0, e.changedrendervalues = !0, i && gt.AddUndo("changedrendervalues"),
                            l = o.NextToken(), Pt = o.NextToken(), s = o.RestOfString(), "" == s && (s = "all"),
                            Ct(), At = t.coordToCr(Pt), E = At.col - g.col, F = At.row - g.row, I = v.col - g.col + 1,
                            M = v.row - g.row + 1, Dt = {}, y = g.row; y <= v.row; y++)
                            for (b = g.col; b <= v.col; b++)
                                if (C = t.crToCoord(b, y),
                                    w = e.GetAssuredCell(C), !w.readonly && (i && gt.AddUndo("set " + C + " all", e.CellToString(w)),
                                        e.cells[C])) {
                                    Dt[C] = new t.Cell(C);
                                    for (c in vt) void 0 !== typeof w[c] && (Dt[C][c] = w[c], "all" == s && delete w[c],
                                        "formulas" == s && (1 == vt[c] || 3 == vt[c]) && delete w[c], "formats" == s && 2 == vt[c] && delete w[c]);
                                    "formulas" == s && (w.datavalue = "", w.datatype = null, w.formula = "", w.valuetype = "b"),
                                        "all" == s && delete e.cells[C];
                                }
                        if ("moveinsert" == a && (It = !1, Mt = !1, 0 == F && (At.col < g.col || At.col > v.col) ? At.col < g.col ? (Rt = g.col - At.col,
                                It = -1) : (At.col -= 1, E = At.col - v.col, Rt = At.col - v.col, It = 1) : 0 == E && (At.row < g.row || At.row > v.row) ? At.row < g.row ? (Rt = g.row - At.row,
                                Mt = -1) : (At.row -= 1, F = At.row - v.row, Rt = At.row - v.row, Mt = 1) : a = "movepaste"),
                            Nt = {}, Mt)
                            for (y = 0; Rt > y; y++)
                                for (b = g.col; b <= v.col; b++) {
                                    if (0 > Mt ? (T = t.crToCoord(b, At.row + Rt - y - 1), C = t.crToCoord(b, v.row - y)) : (T = t.crToCoord(b, At.row - Rt + y + 1),
                                            C = t.crToCoord(b, g.row + y)), D = e.GetAssuredCell(T), i && gt.AddUndo("set " + T + " all", e.CellToString(D)),
                                        w = e.GetAssuredCell(C), "all" == s || "formats" == s)
                                        for (c in vt) 1 != vt[c] && (void 0 === typeof D[c] || 3 == vt[c] ? delete w[c] : w[c] = D[c]);
                                    ("all" == s || "formulas" == s) && (w.datavalue = D.datavalue, w.datatype = D.datatype,
                                        w.valuetype = D.valuetype, w.formula = D.formula, delete w.parseinfo, w.errors = D.errors),
                                    delete w.displaystring, Nt[T] = C;
                                }
                        if (It)
                            for (b = 0; Rt > b; b++)
                                for (y = g.row; y <= v.row; y++) {
                                    if (0 > It ? (T = t.crToCoord(At.col + Rt - b - 1, y), C = t.crToCoord(v.col - b, y)) : (T = t.crToCoord(At.col - Rt + b + 1, y),
                                            C = t.crToCoord(g.col + b, y)), D = e.GetAssuredCell(T), i && gt.AddUndo("set " + T + " all", e.CellToString(D)),
                                        w = e.GetAssuredCell(C), "all" == s || "formats" == s)
                                        for (c in vt) 1 != vt[c] && (void 0 === typeof D[c] || 3 == vt[c] ? delete w[c] : w[c] = D[c]);
                                    ("all" == s || "formulas" == s) && (w.datavalue = D.datavalue, w.datatype = D.datatype,
                                        w.valuetype = D.valuetype, w.formula = D.formula, delete w.parseinfo, w.errors = D.errors),
                                    delete w.displaystring, Nt[T] = C;
                                }
                        for (At.col + I - 1 > mt.lastcol && (mt.lastcol = At.col + I - 1), At.row + M - 1 > mt.lastrow && (mt.lastrow = At.row + M - 1),
                            y = g.row; y < g.row + M; y++)
                            for (b = g.col; b < g.col + I; b++)
                                if (C = t.crToCoord(b + E, y + F),
                                    w = e.GetAssuredCell(C), !w.readonly)
                                    if (i && gt.AddUndo("set " + C + " all", e.CellToString(w)),
                                        T = t.crToCoord(b, y), Nt[T] = C, "all" != s || Dt[T]) {
                                        if (D = Dt[T], D || (D = e.GetAssuredCell(T)), "all" == s || "formats" == s)
                                            for (c in vt) 1 != vt[c] && (void 0 === typeof D[c] || 3 == vt[c] ? delete w[c] : w[c] = D[c]);
                                        ("all" == s || "formulas" == s) && (w.datavalue = D.datavalue, w.datatype = D.datatype,
                                            w.valuetype = D.valuetype, w.formula = D.formula, delete w.parseinfo, w.errors = D.errors,
                                            D.comment ? w.comment = D.comment : w.comment && delete w.comment), delete w.displaystring;
                                    } else delete e.cells[C];
                        for (C in e.cells) w = e.cells[C], w && ("f" == w.datatype ? (K = w.formula, w.formula = t.ReplaceFormulaCoords(K, Nt),
                            w.formula != K && (delete w.parseinfo, i && !Nt[C] && gt.AddUndo("set " + C + " formula " + K))) : delete w.parseinfo);
                        for (lt in e.names) e.names[lt] && (ct = e.names[lt].definition, K = ct, ut = "",
                            "=" == ct.charAt(0) && (ut = "=", ct = ct.substring(1)), e.names[lt].definition = ut + t.ReplaceFormulaCoords(ct, Nt),
                            i && e.names[lt].definition != K && gt.AddUndo("name define " + lt + " " + K));
                        mt.needsrecalc = "yes";
                        break;

                    case "name":
                        if (l = o.NextToken(), lt = o.NextToken(), s = o.RestOfString(), lt = lt.toUpperCase().replace(/[^A-Z0-9_\.]/g, ""),
                            "" == lt) break;
                        if ("define" == l) {
                            if ("" == s) break;
                            e.names[lt] ? (i && gt.AddUndo("name define " + lt + " " + e.names[lt].definition),
                                e.names[lt].definition = s) : (i && gt.AddUndo("name delete " + lt), e.names[lt] = {
                                definition: s,
                                desc: ""
                            });
                        } else "desc" == l ? e.names[lt] && (i && gt.AddUndo("name desc " + lt + " " + e.names[lt].desc),
                            e.names[lt].desc = s) : "delete" == l && (i && (e.names[lt].desc && gt.AddUndo("name desc " + lt + " " + e.names[lt].desc),
                            gt.AddUndo("name define " + lt + " " + e.names[lt].definition)), delete e.names[lt]);
                        mt.needsrecalc = "yes";
                        break;

                    case "recalc":
                        mt.needsrecalc = "yes", e.recalconce = !0;
                        break;

                    case "redisplay":
                        e.renderneeded = !0;
                        break;

                    case "changedrendervalues":
                        e.changedrendervalues = !0;
                        break;

                    case "pane":
                        if (lt = o.NextToken().toUpperCase(), pt = 1, ht = t.GetSpreadsheetControlObject().editor,
                            "ROW" === lt.toUpperCase()) {
                            for (y = parseInt(o.NextToken(), 10), "undefined" != typeof ht.context.rowpanes[1] && "number" == typeof ht.context.rowpanes[1].first && (pt = ht.context.rowpanes[1].first),
                                i && gt.AddUndo("pane row " + pt);
                                "yes" == ht.context.sheetobj.rowattribs.hide[y];) y++;
                            (!y || y <= ht.context.rowpanes[0].first) && ht.context.rowpanes.length > 1 ? ht.context.rowpanes.length = 1 : ht.context.rowpanes.length - 1 && !ht.timeout ? (ht.context.SetRowPaneFirstLast(0, ht.context.rowpanes[0].first, y - 1),
                                ht.context.SetRowPaneFirstLast(1, y, y)) : (ht.context.SetRowPaneFirstLast(0, ht.context.rowpanes[0].first, y - 1),
                                ht.context.SetRowPaneFirstLast(1, y, y)), ht.griddiv && (ft = document.getElementById("trackingline-vertical"),
                                ft && (ht.griddiv.removeChild(ft), ht.FitToEditTable()));
                        } else {
                            for (b = parseInt(o.NextToken(), 10), "undefined" != typeof ht.context.colpanes[1] && "number" == typeof ht.context.colpanes[1].first && (pt = ht.context.colpanes[1].first),
                                i && gt.AddUndo("pane col " + pt);
                                "yes" == ht.context.sheetobj.colattribs.hide[t.rcColname(b)];) b++;
                            (!b || b <= ht.context.colpanes[0].first) && ht.context.colpanes.length > 1 ? ht.context.colpanes.length = 1 : ht.context.colpanes.length - 1 && !ht.timeout ? (ht.context.SetColPaneFirstLast(0, ht.context.colpanes[0].first, b - 1),
                                ht.context.SetColPaneFirstLast(1, b, b)) : (ht.context.SetColPaneFirstLast(0, ht.context.colpanes[0].first, b - 1),
                                ht.context.SetColPaneFirstLast(1, b, b)), ht.griddiv && (ft = document.getElementById("trackingline-horizon"),
                                ft && (ht.griddiv.removeChild(ft), ht.FitToEditTable()));
                        }
                        e.renderneeded = !0;
                        break;

                    case "startcmdextension":
                        lt = o.NextToken(), dt = e.sci.CmdExtensionCallbacks[lt], dt && dt.func(lt, dt.data, e, o, i);
                        break;

                    case "settimetrigger":
                    case "sendemail":
                    case "submitform":
                        break;

                    default:
                        p = bt.s_escUnknownCmd + r;
                }
                return t._app && (yt ? 1 == e.renderneeded && "value" != c && "text" != c && "formula" != c && "constant" != c && "empty" != c ? e.widgetsClean = !1 : "all" == c && (e.widgetsClean = !1) : 1 == e.renderneeded && (e.widgetsClean = !1)),
                    p;
            }, t.SheetUndo = function (e) {
                var t, o = e.changes.TOS(),
                    i = o ? o.undo.length - 1 : -1,
                    n = "";
                for (t = i; t >= 0; t--) n && (n += "\n"), n += o.undo[t];
                e.changes.Undo(), e.ScheduleSheetCommands(n, !1);
            }, t.SheetRedo = function (e) {
                var t, o, i = e.changes.Redo();
                if (!i) return void e.ScheduleSheetCommands("", !1);
                t = e.changes.TOS();
                var n = "";
                for (o = 0; t && o < t.command.length; o++) n && (n += "\n"), n += t.command[o];
                e.ScheduleSheetCommands(n, !1);
            }, t.CreateAuditString = function (e) {
                var t, o, i = "",
                    n = e.changes.stack,
                    r = e.changes.tos;
                for (t = 0; r >= t; t++)
                    for (o = 0; o < n[t].command.length; o++) i += n[t].command[o] + "\n";
                return i;
            }, t.GetStyleNum = function (e, t, o) {
                var i;
                return 0 == o.length ? 0 : (i = e[t + "hash"][o], i || (e[t + "s"].length < 1 && e[t + "s"].push(""),
                    i = e[t + "s"].push(o) - 1, e[t + "hash"][o] = i, e.changedrendervalues = !0), i);
            }, t.GetStyleString = function (e, t, o) {
                return o ? e[t + "s"][o] : null;
            }, t.OffsetFormulaCoords = function (e, o, i) {
                var n, r, a, s, l, c, u = "",
                    d = t.Formula;
                if (!d) return "Need SocialCalc.Formula";
                var h = d.TokenType,
                    p = h.op,
                    f = h.string,
                    m = h.coord,
                    g = d.TokenOpExpansion;
                for (n = d.ParseFormulaIntoTokens(e), s = 0; s < n.length; s++) a = n[s].type, r = n[s].text,
                    a == m ? (c = "", l = t.coordToCr(r), "$" != r.charAt(0) ? l.col += o : c += "$",
                        c += t.rcColname(l.col), -1 == r.indexOf("$", 1) ? l.row += i : c += "$", c += l.row,
                        (l.row < 1 || l.col < 1) && (c = "#REF!"), u += c) : u += a == f ? r.indexOf('"') >= 0 ? '"' + r.replace(/"/, '""') + '"' : '"' + r + '"' : a == p ? g[r] || r : r;
                return u;
            }, t.AdjustFormulaCoords = function (e, o, i, n, r) {
                var a, s, l, c, u = "",
                    d = !1,
                    h = t.Formula;
                if (!h) return "Need SocialCalc.Formula";
                var p = h.TokenType,
                    f = p.op,
                    m = p.string,
                    g = p.coord,
                    v = h.TokenOpExpansion;
                for (parseinfo = t.Formula.ParseFormulaIntoTokens(e), l = 0; l < parseinfo.length; l++) a = parseinfo[l].type,
                    s = parseinfo[l].text, a == f && ("!" == s ? d = !0 : ":" != s && (d = !1), s = v[s] || s),
                    a == g ? (cr = t.coordToCr(s), (0 > i && cr.col >= o && cr.col < o - i || 0 > r && cr.row >= n && cr.row < n - r) && (d || (cr.col = 0,
                            cr.row = 0)), d || (cr.col >= o && (cr.col += i), cr.row >= n && (cr.row += r)),
                        c = "$" == s.charAt(0) ? "$" + t.rcColname(cr.col) : t.rcColname(cr.col), c += -1 != s.indexOf("$", 1) ? "$" + cr.row : cr.row,
                        (cr.row < 1 || cr.col < 1) && (c = "#REF!"), s = c) : a == m && (s = s.indexOf('"') >= 0 ? '"' + s.replace(/"/, '""') + '"' : '"' + s + '"'),
                    u += s;
                return u;
            }, t.ReplaceFormulaCoords = function (e, o) {
                var i, n, r, a, s, l = "",
                    c = !1,
                    u = t.Formula;
                if (!u) return "Need SocialCalc.Formula";
                var d = u.TokenType,
                    h = d.op,
                    p = d.string,
                    f = d.coord,
                    m = u.TokenOpExpansion;
                for (parseinfo = t.Formula.ParseFormulaIntoTokens(e), r = 0; r < parseinfo.length; r++) i = parseinfo[r].type,
                    n = parseinfo[r].text, i == h && ("!" == n ? c = !0 : ":" != n && (c = !1), n = m[n] || n),
                    i == f ? (cr = t.coordToCr(n), s = t.crToCoord(cr.col, cr.row), o[s] && !c && (cr = t.coordToCr(o[s]),
                        a = "$" == n.charAt(0) ? "$" + t.rcColname(cr.col) : t.rcColname(cr.col), a += -1 != n.indexOf("$", 1) ? "$" + cr.row : cr.row,
                        n = a)) : i == p && (n = n.indexOf('"') >= 0 ? '"' + n.replace(/"/, '""') + '"' : '"' + n + '"'),
                    l += n;
                return l;
            }, t.RecalcInfo = {
                sheet: null,
                currentState: 0,
                state: {
                    idle: 0,
                    start_calc: 1,
                    order: 2,
                    calc: 3,
                    start_wait: 4,
                    done_wait: 5
                },
                recalctimer: null,
                maxtimeslice: 100,
                timeslicedelay: 1,
                starttime: 0,
                queue: [],
                LoadSheet: function () {
                    return !1;
                }
            }, t.RecalcData = function () {
                this.inrecalc = !0, this.celllist = [], this.celllistitem = 0, this.calclist = null,
                    this.calclistlength = 0, this.firstcalc = null, this.lastcalc = null, this.nextcalc = null,
                    this.count = 0, this.checkinfo = {};
            }, t.RecalcCheckInfo = function () {
                this.oldcoord = null, this.parsepos = 0, this.inrange = !1, this.inrangestart = !1,
                    this.cr1 = null, this.cr2 = null, this.c1 = null, this.c2 = null, this.r1 = null,
                    this.r2 = null, this.c = null, this.r = null;
            }, t.RecalcSheet = function (e) {
                var o = t.RecalcInfo;
                return o.currentState != o.state.idle ? void o.queue.push(e) : (delete e.attribs.circularreferencecell,
                    t.Formula.FreshnessInfoReset(), t.RecalcClearTimeout(), o.sheet = e, o.currentState = o.state.start_calc,
                    o.starttime = new Date(), e.statuscallback && e.statuscallback(o, "calcstart", null, e.statuscallbackparams),
                    void t.RecalcSetTimeout());
            }, t.RecalcSetTimeout = function () {
                var o = t.RecalcInfo;
                o.recalctimer = e.setTimeout(t.RecalcTimerRoutine, o.timeslicedelay);
            }, t.RecalcClearTimeout = function () {
                var o = t.RecalcInfo;
                o.recalctimer && (e.clearTimeout(o.recalctimer), o.recalctimer = null);
            }, t.RecalcLoadedSheet = function (e, o, i, n) {
                var r, a = t.RecalcInfo,
                    s = t.Formula;
                r = t.Formula.AddSheetToCache(e || s.SheetCache.waitingForLoading, o, n), i && r && "off" != r.attribs.recalc && (r.previousrecalcsheet = a.sheet,
                        a.sheet = r, a.currentState = a.state.start_calc), s.SheetCache.waitingForLoading = null,
                    t.RecalcSetTimeout();
            }, t.RecalcTimerRoutine = function () {
                var e, o, i, n, r, a = new Date(),
                    s = 0,
                    l = t.Formula;
                if (!l) return "Need SocialCalc.Formula";
                var c = t.RecalcInfo,
                    u = c.sheet;
                if (u) {
                    var d = u.recalcdata || (u.recalcdata = {}),
                        h = function (e, t) {
                            u.statuscallback && u.statuscallback(d, e, t, u.statuscallbackparams);
                        };
                    if (t.RecalcClearTimeout(), c.currentState == c.state.start_calc) {
                        d = new t.RecalcData(), u.recalcdata = d;
                        for (i in u.cells) i && d.celllist.push(i);
                        d.calclist = {}, c.currentState = c.state.order;
                    }
                    if (c.currentState == c.state.order) {
                        for (; d.celllistitem < d.celllist.length;)
                            if (i = d.celllist[d.celllistitem++],
                                n = t.RecalcCheckCell(u, i), new Date() - a >= c.maxtimeslice) return h("calcorder", {
                                coord: i,
                                total: d.celllist.length,
                                count: d.celllistitem
                            }), void t.RecalcSetTimeout();
                        return h("calccheckdone", d.calclistlength), d.nextcalc = d.firstcalc, c.currentState = c.state.calc,
                            void t.RecalcSetTimeout();
                    }
                    if (c.currentState == c.state.start_wait) {
                        if (c.currentState = c.state.done_wait, c.LoadSheet && (r = c.LoadSheet(l.SheetCache.waitingForLoading))) return;
                        return void t.RecalcLoadedSheet(null, "", !1);
                    }
                    if (c.currentState == c.state.done_wait) return c.currentState = c.state.calc, void t.RecalcSetTimeout();
                    for (c.currentState != c.state.calc && alert("Recalc state error: " + c.currentState + ". Error in SocialCalc code."),
                        i = u.recalcdata.nextcalc; i;) {
                        if (o = u.cells[i], o.parseinfo || (o.parseinfo = l.ParseFormulaIntoTokens(o.formula)),
                            o.parseinfo.coord = i, e = l.evaluate_parsed_formula(o.parseinfo, u, !1), l.SheetCache.waitingForLoading) {
                            if (1 != c.firstRenderScheduled) {
                                var p = t.GetSpreadsheetControlObject().editor;
                                p.ScheduleRender(!1), c.firstRenderScheduled = !0;
                            }
                            return d.nextcalc = i, d.count += s, h("calcloading", {
                                sheetname: l.SheetCache.waitingForLoading
                            }), c.currentState = c.state.start_wait, void t.RecalcSetTimeout();
                        }
                        if (l.RemoteFunctionInfo.waitingForServer) return d.nextcalc = i, d.count += s,
                            h("calcserverfunc", {
                                funcname: l.RemoteFunctionInfo.waitingForServer,
                                coord: i,
                                total: d.calclistlength,
                                count: d.count
                            }), void(c.currentState = c.state.done_wait);
                        if ((o.datavalue != e.value || o.valuetype != e.type) && (o.datavalue = e.value,
                                o.valuetype = e.type, delete o.displaystring, u.recalcchangedavalue = !0), e.error && (o.errors = e.error),
                            s++, i = u.recalcdata.calclist[i], new Date() - a >= c.maxtimeslice) return d.nextcalc = i,
                            d.count += s, h("calcstep", {
                                coord: i,
                                total: d.calclistlength,
                                count: d.count
                            }), void t.RecalcSetTimeout();
                    }
                    if (d.inrecalc = !1, u.reRenderCellList = u.recalcdata.celllist, delete u.recalcdata,
                        delete u.attribs.needsrecalc, c.sheet = u.previousrecalcsheet || null, c.sheet) return c.currentState = c.state.calc,
                        void t.RecalcSetTimeout();
                    l.FreshnessInfo.recalc_completed = !0, c.currentState = c.state.idle, h("calcfinished", new Date() - c.starttime),
                        c.queue.length > 0 && (u = c.queue.shift(), u.RecalcSheet());
                }
            }, t.RecalcCheckCell = function (e, o) {
                var i, n, r, a, s, l, c, u, d, h, p = t.Formula;
                if (!p) return "Need SocialCalc.Formula";
                var f = p.TokenType,
                    m = f.op,
                    g = f.name,
                    v = f.coord,
                    b = e.recalcdata,
                    y = b.checkinfo,
                    C = !1,
                    w = null,
                    x = o;
                e: for (; x;)
                    if (d = e.cells[x], h = y[x], !d || "f" != d.datatype || h && "object" != typeof h) x = w,
                        y[x] && (w = y[x].oldcoord);
                    else {
                        for (h || (h = new t.RecalcCheckInfo(), y[x] = h), d.errors && delete d.errors,
                            d.parseinfo || (d.parseinfo = p.ParseFormulaIntoTokens(d.formula)), i = d.parseinfo,
                            a = h.parsepos; a < i.length; a++) {
                            if (h.inrange) {
                                if (h.inrangestart && (h.cr1.col > h.cr2.col ? (h.c1 = h.cr2.col, h.c2 = h.cr1.col) : (h.c1 = h.cr1.col,
                                        h.c2 = h.cr2.col), h.c = h.c1 - 1, h.cr1.row > h.cr2.row ? (h.r1 = h.cr2.row, h.r2 = h.cr1.row) : (h.r1 = h.cr1.row,
                                        h.r2 = h.cr2.row), h.r = h.r1, h.inrangestart = !1), h.c += 1, h.c > h.c2) {
                                    if (h.r += 1, h.r > h.r2) {
                                        h.inrange = !1;
                                        continue;
                                    }
                                    h.c = h.c1;
                                }
                                if (s = t.crToCoord(h.c, h.r), h.parsepos = a, h.oldcoord = w, w = x, x = s, y[x] && "object" == typeof y[x]) return d.errors = t.Constants.s_caccCircRef + o,
                                    y[o] = !0, b.firstcalc ? b.calclist[b.lastcalc] = o : b.firstcalc = o, b.lastcalc = o,
                                    b.calclistlength++, e.attribs.circularreferencecell = x + "|" + w, d.errors;
                                continue e;
                            }
                            if (r = i[a].type, n = i[a].text, r == m && ("!" == n ? C = !0 : ":" != n && (C = !1)),
                                r == g)
                                if (l = p.LookupName(e, n), "range" == l.type) {
                                    if (c = l.value.indexOf("|"), -1 != c) {
                                        h.cr1 = t.coordToCr(l.value.substring(0, c)), u = l.value.indexOf("|", c + 1), h.cr2 = t.coordToCr(l.value.substring(c + 1, u)),
                                            h.inrange = !0, h.inrangestart = !0, a -= 1;
                                        continue;
                                    }
                                } else "coord" == l.type && (r = v, n = l.value);
                            if (r == v) {
                                if (a >= 2 && i[a - 1].type == m && ":" == i[a - 1].text && i[a - 2].type == v && !C) {
                                    h.cr1 = t.coordToCr(i[a - 2].text), h.cr2 = t.coordToCr(n), h.inrange = !0, h.inrangestart = !0,
                                        a -= 1;
                                    continue;
                                }
                                if (!C) {
                                    if (-1 != n.indexOf("$") && (n = n.replace(/\$/g, "")), h.parsepos = a + 1, h.oldcoord = w,
                                        w = x, x = n, y[x] && "object" == typeof y[x]) return d.errors = t.Constants.s_caccCircRef + o,
                                        y[o] = !0, b.firstcalc ? b.calclist[b.lastcalc] = o : b.firstcalc = o, b.lastcalc = o,
                                        b.calclistlength++, e.attribs.circularreferencecell = x + "|" + w, d.errors;
                                    continue e;
                                }
                            }
                        }
                        C = !1, y[x] = !0, b.firstcalc ? b.calclist[b.lastcalc] = x : b.firstcalc = x, b.lastcalc = x,
                            b.calclistlength++, x = w, w = y[x] ? y[x].oldcoord : null;
                    }
            }, t.Parse = function (e) {
                this.str = e, this.pos = 0, this.delimiter = " ", this.lineEnd = e.indexOf("\n"),
                    this.lineEnd < 0 && (this.lineEnd = e.length);
            }, t.Parse.prototype.NextToken = function () {
                if (this.pos < 0) return "";
                var e = this.str.indexOf(this.delimiter, this.pos),
                    t = this.pos;
                return e > this.lineEnd && (e = this.lineEnd), e >= 0 ? (this.pos = e + 1, this.str.substring(t, e)) : (this.pos = this.lineEnd,
                    this.str.substring(t, this.lineEnd));
            }, t.Parse.prototype.RestOfString = function () {
                var e = this.pos;
                return this.pos < 0 || this.pos >= this.lineEnd ? "" : (this.pos = this.lineEnd,
                    this.str.substring(e, this.lineEnd));
            }, t.Parse.prototype.RestOfStringNoMove = function () {
                return this.pos < 0 || this.pos >= this.lineEnd ? "" : this.str.substring(this.pos, this.lineEnd);
            }, t.Parse.prototype.NextLine = function () {
                this.pos = this.lineEnd + 1, this.lineEnd = this.str.indexOf("\n", this.pos), this.lineEnd < 0 && (this.lineEnd = this.str.length);
            }, t.Parse.prototype.EOF = function () {
                return this.pos < 0 || this.pos >= this.str.length ? !0 : !1;
            }, t.UndoStack = function () {
                this.stack = [], this.tos = -1, this.maxRedo = 0, this.maxUndo = 50;
            }, t.UndoStack.prototype.PushChange = function (e) {
                for (; this.stack.length > 0 && this.stack.length - 1 > this.tos;) this.stack.pop();
                this.stack.push({
                        command: [],
                        type: e,
                        undo: []
                    }),
                    config.script.push(this.stack),
                    this.maxRedo && this.stack.length > this.maxRedo && this.stack.shift(), this.maxUndo && this.stack.length > this.maxUndo && (this.stack[this.stack.length - this.maxUndo - 1].undo = []),
                    this.tos = this.stack.length - 1;
                if (config.script.length > 1) {
                    config.script.pop();
                }
            }, t.UndoStack.prototype.AddDo = function () {
                if (this.stack[this.stack.length - 1]) {
                    for (var e = [], t = 0; t < arguments.length; t++) null != arguments[t] && e.push(arguments[t]);
                    var o = e.join(" ");
                    this.stack[this.stack.length - 1].command.push(o);
                }
            }, t.UndoStack.prototype.AddUndo = function () {
                if (this.stack[this.stack.length - 1]) {
                    for (var e = [], t = 0; t < arguments.length; t++) null != arguments[t] && e.push(arguments[t]);
                    var o = e.join(" ");
                    this.stack[this.stack.length - 1].undo.push(o);
                }
            }, t.UndoStack.prototype.TOS = function () {
                return this.tos >= 0 ? this.stack[this.tos] : null;
            }, t.UndoStack.prototype.Undo = function () {
                return this.tos >= 0 && (!this.maxUndo || this.tos > this.stack.length - this.maxUndo - 1) ? (this.tos -= 1,
                    !0) : !1;
            }, t.UndoStack.prototype.Redo = function () {
                return this.tos < this.stack.length - 1 ? (this.tos += 1, !0) : !1;
            }, t.Clipboard = {
                clipboard: ""
            }, t.RenderContext = function (e) {
                var o = e.attribs,
                    i = t.Constants;
                if (this.sheetobj = e, this.hideRowsCols = !1, this.showGrid = !1, this.showRCHeaders = !1,
                    this.rownamewidth = i.defaultRowNameWidth, this.pixelsPerRow = i.defaultAssumedRowHeight,
                    this.cellskip = {}, this.coordToCR = {}, this.colwidth = [], this.rowheight = [],
                    this.totalwidth = 0, this.totalheight = 0, this.rowpanes = [], this.colpanes = [],
                    this.colunhideleft = [], this.colunhideright = [], this.rowunhidetop = [], this.rowunhidebottom = [],
                    this.maxcol = 0, this.maxrow = 0, this.highlights = {}, this.cursorsuffix = "",
                    this.highlightTypes = {
                        cursor: {
                            style: i.defaultHighlightTypeCursorStyle,
                            className: i.defaultHighlightTypeCursorClass
                        },
                        range: {
                            style: i.defaultHighlightTypeRangeStyle,
                            className: i.defaultHighlightTypeRangeClass
                        },
                        cursorinsertup: {
                            style: "color:#FFF;backgroundColor:#A6A6A6;backgroundRepeat:repeat-x;backgroundPosition:top left;backgroundImage:url(" + assetManager.resolve("EtherCalc/runtime/assets/sc_cursorinsertup.gif") + ");",
                            className: i.defaultHighlightTypeCursorClass
                        },
                        cursorinsertleft: {
                            style: "color:#FFF;backgroundColor:#A6A6A6;backgroundRepeat:repeat-y;backgroundPosition:top left;backgroundImage:url(" + assetManager.resolve("EtherCalc/runtime/assets/sc_cursorinsertleft.gif") + ");",
                            className: i.defaultHighlightTypeCursorClass
                        },
                        range2: {
                            style: "color:#000;backgroundColor:#FFF;backgroundImage:url(" + assetManager.resolve("EtherCalc/runtime/assets/sc_range2.gif") + ");",
                            className: ""
                        }
                    }, this.cellIDprefix = i.defaultCellIDPrefix, this.defaultlinkstyle = null, this.defaultHTMLlinkstyle = {
                        type: "html"
                    }, this.defaultfontstyle = i.defaultCellFontStyle, this.defaultfontsize = i.defaultCellFontSize,
                    this.defaultfontfamily = i.defaultCellFontFamily, this.defaultlayout = i.defaultCellLayout,
                    this.defaultpanedividerwidth = i.defaultPaneDividerWidth, this.defaultpanedividerheight = i.defaultPaneDividerHeight,
                    this.gridCSS = i.defaultGridCSS, this.commentClassName = i.defaultCommentClass,
                    this.commentCSS = i.defaultCommentStyle, this.commentNoGridClassName = i.defaultCommentNoGridClass,
                    this.commentNoGridCSS = i.defaultCommentNoGridStyle, this.readonlyClassName = i.defaultReadonlyClass,
                    this.readonlyCSS = i.defaultReadonlyStyle, this.readonlyNoGridClassName = i.defaultReadonlyNoGridClass,
                    this.readonlyNoGridCSS = i.defaultReadonlyNoGridStyle, this.readonlyComment = i.defaultReadonlyComment,
                    this.classnames = {
                        colname: i.defaultColnameClass,
                        rowname: i.defaultRownameClass,
                        selectedcolname: i.defaultSelectedColnameClass,
                        selectedrowname: i.defaultSelectedRownameClass,
                        upperleft: i.defaultUpperLeftClass,
                        skippedcell: i.defaultSkippedCellClass,
                        panedivider: i.defaultPaneDividerClass,
                        unhideleft: i.defaultUnhideLeftClass,
                        unhideright: i.defaultUnhideRightClass,
                        unhidetop: i.defaultUnhideTopClass,
                        unhidebottom: i.defaultUnhideBottomClass,
                        colresizebar: i.defaultColResizeBarClass,
                        rowresizebar: i.defaultRowResizeBarClass
                    }, this.explicitStyles = {
                        colname: i.defaultColnameStyle,
                        rowname: i.defaultRownameStyle,
                        selectedcolname: i.defaultSelectedColnameStyle,
                        selectedrowname: i.defaultSelectedRownameStyle,
                        upperleft: i.defaultUpperLeftStyle,
                        skippedcell: i.defaultSkippedCellStyle,
                        panedivider: i.defaultPaneDividerStyle,
                        unhideleft: i.defaultUnhideLeftStyle,
                        unhideright: i.defaultUnhideRightStyle,
                        unhidetop: i.defaultUnhideTopStyle,
                        unhidebottom: i.defaultUnhideBottomStyle
                    }, this.cellskip = null, this.needcellskip = !0, this.fonts = [], this.layouts = [],
                    this.needprecompute = !0, !o) throw i.s_rcMissingSheet;
                this.rowpanes[0] = {
                    first: 1,
                    last: o.lastrow
                }, this.colpanes[0] = {
                    first: 1,
                    last: o.lastcol
                }, this.usermaxcol = o.usermaxcol, this.usermaxrow = o.usermaxrow;
            }, t.RenderContext.prototype.PrecomputeSheetFontsAndLayouts = function () {
                t.PrecomputeSheetFontsAndLayouts(this);
            }, t.RenderContext.prototype.CalculateCellSkipData = function () {
                t.CalculateCellSkipData(this);
            }, t.RenderContext.prototype.CalculateColWidthData = function () {
                t.CalculateColWidthData(this);
            }, t.RenderContext.prototype.CalculateRowHeightData = function () {
                t.CalculateRowHeightData(this);
            }, t.RenderContext.prototype.SetRowPaneFirstLast = function (e, t, o) {
                this.rowpanes[e] = {
                    first: t,
                    last: o
                };
            }, t.RenderContext.prototype.SetColPaneFirstLast = function (e, t, o) {
                this.colpanes[e] = {
                    first: t,
                    last: o
                };
            }, t.RenderContext.prototype.CoordInPane = function (e, o, i) {
                return t.CoordInPane(this, e, o, i);
            }, t.RenderContext.prototype.CellInPane = function (e, o, i, n) {
                return t.CellInPane(this, e, o, i, n);
            }, t.RenderContext.prototype.InitializeTable = function (e) {
                t.InitializeTable(this, e);
            }, t.RenderContext.prototype.RenderSheet = function (e, o) {
                return t.RenderSheet(this, e, o);
            }, t.RenderContext.prototype.RenderColGroup = function () {
                return t.RenderColGroup(this);
            }, t.RenderContext.prototype.RenderColHeaders = function () {
                return t.RenderColHeaders(this);
            }, t.RenderContext.prototype.RenderSizingRow = function () {
                return t.RenderSizingRow(this);
            }, t.RenderContext.prototype.RenderRow = function (e, o, i) {
                return t.RenderRow(this, e, o, i);
            }, t.RenderContext.prototype.RenderSpacingRow = function () {
                return t.RenderSpacingRow(this);
            }, t.RenderContext.prototype.RenderCell = function (e, o, i, n, r, a) {
                return t.RenderCell(this, e, o, i, n, r, a);
            }, t.PrecomputeSheetFontsAndLayouts = function (e) {
                var o, i, n, r, a, s, l, c, u = e.sheetobj,
                    d = u.attribs;
                for (d.defaultfont && (o = u.fonts[d.defaultfont], o = o.replace(/^\*/, t.Constants.defaultCellFontStyle),
                        o = o.replace(/(.+)\*(.+)/, "$1" + t.Constants.defaultCellFontSize + "$2"), o = o.replace(/\*$/, t.Constants.defaultCellFontFamily),
                        i = o.match(/^(\S+? \S+?) (\S+?) (\S.*)$/), e.defaultfontstyle = i[1], e.defaultfontsize = i[2],
                        e.defaultfontfamily = i[3]), s = 1; s < u.fonts.length; s++) l = u.fonts[s], l = l.replace(/^\*/, e.defaultfontstyle),
                    l = l.replace(/(.+)\*(.+)/, "$1" + e.defaultfontsize + "$2"), l = l.replace(/\*$/, e.defaultfontfamily),
                    i = l.match(/^(\S+?) (\S+?) (\S+?) (\S.*)$/), i && (e.fonts[s] = {
                        style: i[1],
                        weight: i[2],
                        size: i[3],
                        family: i[4]
                    });
                for (n = /^padding:\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+);vertical-align:\s*(\S+);/, r = t.Constants.defaultCellLayout.match(n),
                    a = d.defaultlayout ? u.layouts[d.defaultlayout].match(n) : ["", "*", "*", "*", "*", "*"],
                    s = 1; s < u.layouts.length; s++)
                    if (l = u.layouts[s], i = l.match(n)) {
                        for (c = 1; 5 >= c; c++) "*" == i[c] && (i[c] = "*" != a[c] ? a[c] : r[c]);
                        e.layouts[s] = "padding:" + i[1] + " " + i[2] + " " + i[3] + " " + i[4] + ";vertical-align:" + i[5] + ";";
                    }
                e.needprecompute = !1;
            }, t.CalculateCellSkipData = function (e) {
                {
                    var o, i, n, r, a, s, l, c, u, d = e.sheetobj;
                    d.rowattribs, d.colattribs;
                }
                for (e.maxrow = 0, e.maxcol = 0, e.cellskip = {}, o = 1; o <= d.attribs.lastrow; o++)
                    for (i = 1; i <= d.attribs.lastcol; i++)
                        if (n = t.crToCoord(i, o),
                            r = d.cells[n], void 0 !== r && !e.cellskip[n] && (a = r.colspan || 1, s = r.rowspan || 1,
                                a > 1 || s > 1))
                            for (l = o; o + s > l; l++)
                                for (c = i; i + a > c; c++) u = t.crToCoord(c, l),
                                    u == n ? e.coordToCR[n] = {
                                        row: o,
                                        col: i
                                    } : e.cellskip[u] = n, l > e.maxrow && (maxrow = l), c > e.maxcol && (maxcol = c);
                e.needcellskip = !1;
            }, t.CalculateColWidthData = function (e) {
                {
                    var o, i, n, r, a = e.sheetobj;
                    a.colattribs;
                }
                for (r = e.showRCHeaders ? e.rownamewidth - 0 : 0, colpane = 0; colpane < e.colpanes.length; colpane++)
                    for (o = e.colpanes[colpane].first; o <= e.colpanes[colpane].last; o++) i = t.rcColname(o),
                        "yes" == a.colattribs.hide[i] ? e.colwidth[o] = 0 : (n = a.colattribs.width[i] || a.attribs.defaultcolwidth || t.Constants.defaultColWidth,
                            ("blank" == n || "auto" == n) && (n = ""), e.colwidth[o] = n + "", r += n && n - 0 > 0 ? n - 0 : 10);
                e.totalwidth = r;
            }, t.CalculateRowHeightData = function (e) {
                var o, i, n, r = e.sheetobj;
                for (n = e.showRCHeaders ? e.pixelsPerRow : 0, rowpane = 0; rowpane < e.rowpanes.length; rowpane++)
                    for (o = e.rowpanes[rowpane].first; o <= e.rowpanes[rowpane].last; o++) "yes" === r.rowattribs.hide[o] ? e.rowheight[o] = 0 : (i = r.rowattribs.height[o] || r.attribs.defaultrowheight || t.Constants.defaultAssumedRowHeight,
                        ("blank" === i || "auto" === i) && (i = ""), e.rowheight[o] = i + "", n += i && i - 0 > 0 ? i - 0 : 10);
                e.totalheight = n;
            }, t.InitializeTable = function (e, t) {
                t.style.borderCollapse = "collapse", t.cellSpacing = "0", t.cellPadding = "0", t.style.width = e.totalwidth + "px";
            }, t.RenderSheet = function (e, t, o) {
                var i, n, r, a, s, l;
                for (e.sheetobj.changedrendervalues && (e.needcellskip = !0, e.needprecompute = !0,
                        e.sheetobj.changedrendervalues = !1), e.needcellskip && e.CalculateCellSkipData(),
                    e.needprecompute && e.PrecomputeSheetFontsAndLayouts(), e.CalculateColWidthData(),
                    e.CalculateRowHeightData(), r = document.createElement("table"), e.InitializeTable(r),
                    a = e.RenderColGroup(), r.appendChild(a), s = document.createElement("tbody"), s.appendChild(e.RenderSizingRow()),
                    e.showRCHeaders && (i = e.RenderColHeaders(), i && s.appendChild(i)), n = 0; n < e.rowpanes.length; n++) {
                    for (rownum = e.rowpanes[n].first; rownum <= e.rowpanes[n].last; rownum++) i = e.RenderRow(rownum, n, o),
                        s.appendChild(i);
                    n < e.rowpanes.length - 1 && (i = e.RenderSpacingRow(), s.appendChild(i));
                }
                return r.appendChild(s), t && (l = t.parentNode, l && l.replaceChild(r, t)), r;
            }, t.RenderRow = function (e, o, i, n) {
                var r, a, s, l, c = e.sheetobj,
                    u = document.createElement("tr");
                if (e.showRCHeaders) {
                    if (a = document.createElement("td"), e.classnames && (a.className = e.classnames.rowname),
                        e.explicitStyles && (a.style.cssText = e.explicitStyles.rowname), a.width = e.rownamewidth,
                        a.height = e.rowheight[o], a.style.verticalAlign = "top", a.innerHTML = o + "",
                        o < e.rowpanes[e.rowpanes.length - 1].last && "yes" == c.rowattribs.hide[o + 1]) {
                        var d = document.createElement("div");
                        d.style.position = "relative";
                        var h = document.createElement("div");
                        e.classnames && (h.className = e.classnames.unhidetop), e.explicitStyles && (h.style.cssText = e.explicitStyles.unhidetop);
                        var p = e.rowheight[o] - 0 - t.Constants.defaultAssumedRowHeight;
                        p = 0 === p ? 4 : p, h.style.bottom = "-" + p + "px", e.rowunhidetop[o] = h, d.appendChild(h),
                            a.appendChild(d);
                    }
                    if (o > 1 && "yes" == c.rowattribs.hide[o - 1]) {
                        var h = document.createElement("div");
                        e.classnames && (h.className = e.classnames.unhidebottom), e.explicitStyles && (h.style.cssText = e.explicitStyles.unhidebottom),
                            e.rowunhidebottom[o] = h, a.appendChild(h);
                    }
                    var f = document.createElement("div");
                    f.className = e.classnames.rowresizebar, a.appendChild(f), u.appendChild(a);
                }
                for (s = 0; s < e.colpanes.length; s++) {
                    for (r = e.colpanes[s].first; r <= e.colpanes[s].last; r++) a = e.RenderCell(o, r, i, s, null, n),
                        a && u.appendChild(a);
                    s < e.colpanes.length - 1 && (a = document.createElement("td"), a.width = e.defaultpanedividerwidth,
                        e.classnames.panedivider && (a.className = e.classnames.panedivider), e.explicitStyles.panedivider && (a.style.cssText = e.explicitStyles.panedivider),
                        l = document.createElement("div"), l.style.width = e.defaultpanedividerwidth + "px",
                        l.style.overflow = "hidden", a.appendChild(l), u.appendChild(a));
                }
                return "yes" == c.rowattribs.hide[o] && (u.style.cssText += ";display:none"), u;
            }, t.RenderSpacingRow = function (e) {
                var t, o, i, n, r = (e.sheetobj, document.createElement("tr"));
                for (e.showRCHeaders && (o = document.createElement("td"), o.width = e.rownamewidth,
                        o.height = e.defaultpanedividerheight, e.classnames.panedivider && (o.className = e.classnames.panedivider),
                        e.explicitStyles.panedivider && (o.style.cssText = e.explicitStyles.panedivider),
                        r.appendChild(o)), i = 0; i < e.colpanes.length; i++) {
                    for (t = e.colpanes[i].first; t <= e.colpanes[i].last; t++) o = document.createElement("td"),
                        n = e.colwidth[t], n && (o.width = n), o.height = e.defaultpanedividerheight, e.classnames.panedivider && (o.className = e.classnames.panedivider),
                        e.explicitStyles.panedivider && (o.style.cssText = e.explicitStyles.panedivider),
                        o && r.appendChild(o);
                    i < e.colpanes.length - 1 && (o = document.createElement("td"), o.width = e.defaultpanedividerwidth,
                        o.height = e.defaultpanedividerheight, e.classnames.panedivider && (o.className = e.classnames.panedivider),
                        e.explicitStyles.panedivider && (o.style.cssText = e.explicitStyles.panedivider),
                        r.appendChild(o));
                }
                return r;
            }, t.RenderColHeaders = function (e) {
                var o, i, n = e.sheetobj,
                    r = document.createElement("tr");
                if (!e.showRCHeaders) return null;
                for (i = document.createElement("td"), e.classnames && (i.className = e.classnames.upperleft),
                    e.explicitStyles && (i.style.cssText = e.explicitStyles.upperleft), i.width = e.rownamewidth,
                    r.appendChild(i), colpane = 0; colpane < e.colpanes.length; colpane++) {
                    for (o = e.colpanes[colpane].first; o <= e.colpanes[colpane].last; o++) {
                        if (i = document.createElement("td"), e.classnames && (i.className = e.classnames.colname),
                            e.explicitStyles && (i.style.cssText = e.explicitStyles.colname), "yes" == n.colattribs.hide[t.rcColname(o)] && (i.style.cssText += ";display:none"),
                            i.innerHTML = t.rcColname(o), o < e.colpanes[e.colpanes.length - 1].last && "yes" == n.colattribs.hide[t.rcColname(o + 1)]) {
                            var a = document.createElement("div");
                            e.classnames && (a.className = e.classnames.unhideleft), e.explicitStyles && (a.style.cssText = e.explicitStyles.unhideleft),
                                e.colunhideleft[o] = a, i.appendChild(a);
                        }
                        o > 1 && "yes" == n.colattribs.hide[t.rcColname(o - 1)] && (a = document.createElement("div"),
                            e.classnames && (a.className = e.classnames.unhideright), e.explicitStyles && (a.style.cssText = e.explicitStyles.unhideright),
                            e.colunhideright[o] = a, i.appendChild(a));
                        var s = document.createElement("span");
                        s.style.height = t.Constants.defaultAssumedRowHeight + "px", s.className = e.classnames.colresizebar,
                            i.appendChild(s), r.appendChild(i);
                    }
                    colpane < e.colpanes.length - 1 && (i = document.createElement("td"), i.width = e.defaultpanedividerwidth,
                        e.classnames.panedivider && (i.className = e.classnames.panedivider), e.explicitStyles.panedivider && (i.style.cssText = e.explicitStyles.panedivider),
                        r.appendChild(i));
                }
                return r;
            }, t.RenderColGroup = function (e) {
                var o, i, n, r, a = e.sheetobj,
                    s = document.createElement("colgroup");
                for (e.showRCHeaders && (n = document.createElement("col"), n.width = e.rownamewidth,
                        s.appendChild(n)), o = 0; o < e.colpanes.length; o++) {
                    for (i = e.colpanes[o].first; i <= e.colpanes[o].last; i++) n = document.createElement("col"),
                        "yes" == a.colattribs.hide[t.rcColname(i)] ? n.width = "1" : (r = e.colwidth[i],
                            r && (n.width = r), s.appendChild(n));
                    o < e.colpanes.length - 1 && (n = document.createElement("col"), n.width = e.defaultpanedividerwidth,
                        s.appendChild(n));
                }
                return s;
            }, t.RenderSizingRow = function (e) {
                var o, i, n, r, a = e.sheetobj,
                    s = document.createElement("tr");
                for (e.showRCHeaders && (n = document.createElement("td"), n.style.width = e.rownamewidth + "px",
                        n.height = "1", s.appendChild(n)), o = 0; o < e.colpanes.length; o++) {
                    for (i = e.colpanes[o].first; i <= e.colpanes[o].last; i++) n = document.createElement("td"),
                        "yes" == a.colattribs.hide[t.rcColname(i)] ? n.width = "1" : (r = e.colwidth[i],
                            r && (n.width = r)), n.height = "1", s.appendChild(n);
                    o < e.colpanes.length - 1 && (n = document.createElement("td"), n.width = e.defaultpanedividerwidth,
                        n.height = "1", s.appendChild(n));
                }
                return s;
            }, t.RenderCell = function (e, o, i, n, r, a, s) {
                var l, c, u, d, h, p, f, m = e.sheetobj,
                    g = "";
                o -= 0, i -= 0;
                var v = t.crToCoord(i, o);
                if (e.cellskip[v]) return e.CoordInPane(e.cellskip[v], n, r) ? null : (u = a ? t.CreatePseudoElement() : document.createElement("td"),
                    e.classnames.skippedcell && (u.className = e.classnames.skippedcell), e.explicitStyles.skippedcell && (u.style.cssText = e.explicitStyles.skippedcell),
                    u.innerHTML = "&nbsp;", u);
                if (u = a ? t.CreatePseudoElement() : document.createElement("td"), e.cellIDprefix && (u.id = e.cellIDprefix + v),
                    h = m.cells[v], h || (h = new t.Cell(v)), f = m.attribs, scc = t.Constants, h.colspan > 1) {
                    for (d = 1, l = 1; l < h.colspan; l++) "yes" != m.colattribs.hide[t.rcColname(i + l)] && e.CellInPane(o, i + l, n, r) && d++;
                    u.colSpan = d;
                }
                if (h.rowspan > 1) {
                    for (d = 1, l = 1; l < h.rowspan; l++) "yes" != m.rowattribs.hide[o + l + ""] && e.CellInPane(o + l, i, n, r) && d++;
                    u.rowSpan = d;
                }
                return (void 0 == h.displaystring || 0 == m.widgetsClean) && (h.displaystring = t.FormatValueForDisplay(m, h.datavalue, v, s || e.defaultlinkstyle)),
                    u.innerHTML = h.displaystring, l = h.layout || f.defaultlayout, g += l && "undefined" != typeof e.layouts[l] ? e.layouts[l] : scc.defaultCellLayout,
                    l = h.font || f.defaultfont, l && "undefined" != typeof e.fonts[l] ? (c = e.fonts[l],
                        g += "font-style:" + c.style + ";font-weight:" + c.weight + ";font-size:" + c.size + ";font-family:" + c.family + ";") : (scc.defaultCellFontSize && (g += "font-size:" + scc.defaultCellFontSize + ";"),
                        scc.defaultCellFontFamily && (g += "font-family:" + scc.defaultCellFontFamily + ";")),
                    l = h.color || f.defaultcolor, l && "undefined" != typeof m.colors[l] && (g += "color:" + m.colors[l] + ";"),
                    l = h.bgcolor || f.defaultbgcolor, l && "undefined" != typeof m.colors[l] && (g += "background-color:" + m.colors[l] + ";"),
                    l = h.cellformat, l && "undefined" != typeof m.cellformats[l] ? g += "text-align:" + m.cellformats[l] + ";" : (c = h.valuetype.charAt(0),
                        "t" == c ? (l = f.defaulttextformat, l && "undefined" != typeof m.cellformats[l] && (g += "text-align:" + m.cellformats[l] + ";")) : "n" == c ? (l = f.defaultnontextformat,
                            g += l && "undefined" != typeof m.cellformats[l] ? "text-align:" + m.cellformats[l] + ";" : "text-align:right;") : g += "text-align:left;"),
                    (h.colspan > 1 || h.rowspan > 1) && (p = m.cells[t.crToCoord(i + (h.colspan || 1) - 1, o + (h.rowspan || 1) - 1)]),
                    l = h.bt, l && "undefined" != typeof m.borderstyles[l] && (g += "border-top:" + m.borderstyles[l] + ";"),
                    l = "undefined" != typeof p ? p.br : h.br, l && "undefined" != typeof m.borderstyles[l] ? g += "border-right:" + m.borderstyles[l] + ";" : e.showGrid && (c = e.CellInPane(o, i + (h.colspan || 1), n, r) ? t.crToCoord(i + (h.colspan || 1), o) : "nomatch",
                        e.cellskip[c] && (c = e.cellskip[c]), m.cells[c] && m.cells[c].bl || (g += "border-right:" + e.gridCSS)),
                    l = "undefined" != typeof p ? p.bb : h.bb, l && "undefined" != typeof m.borderstyles[l] ? g += "border-bottom:" + m.borderstyles[l] + ";" : e.showGrid && (c = e.CellInPane(o + (h.rowspan || 1), i, n, r) ? t.crToCoord(i, o + (h.rowspan || 1)) : "nomatch",
                        e.cellskip[c] && (c = e.cellskip[c]), m.cells[c] && m.cells[c].bt || (g += "border-bottom:" + e.gridCSS)),
                    l = h.bl, l && "undefined" != typeof m.borderstyles[l] && (g += "border-left:" + m.borderstyles[l] + ";"),
                    h.comment && (u.title = h.comment, e.showGrid ? (e.commentClassName && (u.className = (u.className ? u.className + " " : "") + e.commentClassName),
                        g += e.commentCSS) : (e.commentNoGridClassName && (u.className = (u.className ? u.className + " " : "") + e.commentNoGridClassName),
                        g += e.commentNoGridCSS)), h.readonly && (h.comment || (u.title = e.readonlyComment),
                        e.showGrid ? (e.readonlyClassName && (u.className = (u.className ? u.className + " " : "") + e.readonlyClassName),
                            g += e.readonlyCSS) : (e.readonlyNoGridClassName && (u.className = (u.className ? u.className + " " : "") + e.readonlyNoGridClassName),
                            g += e.readonlyNoGridCSS)), u.style.cssText = g, void 0 !== h.cssc && (a ? u.className = (u.className ? u.className + " " : "") + h.cssc : u.classList.add(h.cssc)),
                    c = e.highlights[v], c && ("cursor" == c && (c += e.cursorsuffix), e.highlightTypes[c].className && (u.className = (u.className ? u.className + " " : "") + e.highlightTypes[c].className),
                        t.setStyles(u, e.highlightTypes[c].style)), "yes" == m.colattribs.hide[t.rcColname(i)] && (u.style.cssText += ";display:none"),
                    "yes" == m.rowattribs.hide[o] && (u.style.cssText += ";display:none"), u;
            }, t.CoordInPane = function (e, t, o, i) {
                var n = e.coordToCR[t];
                if (!n || !n.row || !n.col) throw "Bad coordToCR for " + t;
                return e.CellInPane(n.row, n.col, o, i);
            }, t.CellInPane = function (e, t, o, i, n) {
                var r = e.rowpanes[i],
                    a = e.colpanes[n];
                if (!r || !a) throw "CellInPane called with unknown panes " + i + "/" + n;
                return t < r.first || t > r.last ? !1 : o < a.first || o > a.last ? !1 : !0;
            }, t.CreatePseudoElement = function () {
                return {
                    style: {
                        cssText: ""
                    },
                    innerHTML: "",
                    className: ""
                };
            }, t.rcColname = function (e) {
                e > 702 && (e = 702), 1 > e && (e = 1);
                var t = (e - 1) % 26 + 65,
                    o = Math.floor((e - 1) / 26);
                return o ? String.fromCharCode(o + 64) + String.fromCharCode(t) : String.fromCharCode(t);
            }, t.letters = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"],
            t.crToCoord = function (e, o) {
                var i;
                1 > e && (e = 1), e > 702 && (e = 702), 1 > o && (o = 1);
                var n = (e - 1) % 26,
                    r = Math.floor((e - 1) / 26);
                return i = r ? t.letters[r - 1] + t.letters[n] + o : t.letters[n] + o;
            }, t.coordToCol = {}, t.coordToRow = {}, t.coordToCr = function (e) {
                var o, i, n, r = t.coordToRow[e];
                if (r) return {
                    row: r,
                    col: t.coordToCol[e]
                };
                for (o = 0, r = 0, i = 0; i < e.length; i++) n = e.charCodeAt(i), 36 == n || (57 >= n ? r = 10 * r + n - 48 : n >= 97 ? o = 26 * o + n - 96 : n >= 65 && (o = 26 * o + n - 64));
                return t.coordToCol[e] = o, t.coordToRow[e] = r, {
                    row: r,
                    col: o
                };
            }, t.ParseRange = function (e) {
                var o, i, n, r;
                return e || (e = "A1:A1"), e = e.toUpperCase(), o = e.indexOf(":"), o >= 0 ? (i = e.substring(0, o),
                    n = t.coordToCr(i), n.coord = i, i = e.substring(o + 1), r = t.coordToCr(i), r.coord = i) : (n = t.coordToCr(e),
                    n.coord = e, r = t.coordToCr(e), r.coord = e), {
                    cr1: n,
                    cr2: r
                };
            }, t.decodeFromSave = function (e) {
                if ("string" != typeof e) return e;
                if (-1 == e.indexOf("\\")) return e;
                var t = e.replace(/\\c/g, ":");
                return t = t.replace(/\\n/g, "\n"), t.replace(/\\b/g, "\\");
            }, t.decodeFromAjax = function (e) {
                if ("string" != typeof e) return e;
                if (-1 == e.indexOf("\\")) return e;
                var t = e.replace(/\\c/g, ":");
                return t = t.replace(/\\n/g, "\n"), t = t.replace(/\\e/g, "]]"), t.replace(/\\b/g, "\\");
            }, t.encodeForSave = function (e) {
                return "string" != typeof e ? e : (-1 != e.indexOf("\\") && (e = e.replace(/\\/g, "\\b")),
                    -1 != e.indexOf(":") && (e = e.replace(/:/g, "\\c")), -1 != e.indexOf("\n") && (e = e.replace(/\n/g, "\\n")),
                    e);
            }, t.special_chars = function (e) {
                return /[&<>"]/.test(e) && (e = e.replace(/&/g, "&amp;"), e = e.replace(/</g, "&lt;"),
                    e = e.replace(/>/g, "&gt;"), e = e.replace(/"/g, "&quot;")), e;
            }, t.Lookup = function (e, t) {
                for (i = 0; i < t.length; i++)
                    if (t[i] > e) return i > 0 ? i - 1 : null;
                return t.length - 1;
            }, t.setStyles = function (e, t) {
                var o, i, n, r, a;
                if (t)
                    for (o = t.split(";"), i = 0; i < o.length; i++) n = o[i].indexOf(":"), -1 != n && (r = o[i].substring(0, n),
                        a = o[i].substring(n + 1), r && a && (e.style[r] = a));
            }, t.GetViewportInfo = function () {
                var t = {};
                return e.innerWidth ? (t.width = e.innerWidth, t.height = e.innerHeight, t.horizontalScroll = e.pageXOffset,
                    t.verticalScroll = e.pageYOffset) : document.documentElement && document.documentElement.clientWidth ? (t.width = document.documentElement.clientWidth,
                    t.height = document.documentElement.clientHeight, t.horizontalScroll = document.documentElement.scrollLeft,
                    t.verticalScroll = document.documentElement.scrollTop) : document.body.clientWidth && (t.width = document.body.clientWidth,
                    t.height = document.body.clientHeight, t.horizontalScroll = document.body.scrollLeft,
                    t.verticalScroll = document.body.scrollTop), t;
            }, t.GetElementPosition = function (e) {
                for (var o = 0, i = 0; e && "relative" != t.GetComputedStyle(e, "position");) o += e.offsetLeft,
                    i += e.offsetTop, e = e.offsetParent;
                return {
                    left: o,
                    top: i
                };
            }, t.GetElementPositionWithScroll = function (e) {
                var t = e.getBoundingClientRect();
                return {
                    left: t.left,
                    right: t.right,
                    top: t.top,
                    bottom: t.bottom,
                    width: t.width ? t.width : t.right - t.left,
                    height: t.height ? t.height : t.bottom - t.top
                };
            }, t.GetElementFixedParent = function (e) {
                for (; e && "HTML" != e.tagName;) {
                    if ("fixed" == t.GetComputedStyle(e, "position")) return e;
                    e = e.parentNode;
                }
                return !1;
            }, t.GetComputedStyle = function (e, t) {
                var o;
                return o = "undefined" != typeof e.currentStyle ? e.currentStyle : document.defaultView.getComputedStyle(e, null),
                    o[t];
            }, t.LookupElement = function (e, t) {
                var o;
                for (o = 0; o < t.length; o++)
                    if (t[o].element == e) return t[o];
                return null;
            }, t.AssignID = function (e, t, o) {
                e.idPrefix && (t.id = e.idPrefix + o);
            }, t.GetCellContents = function (e, t) {
                var o = "",
                    i = e.cells[t];
                if (i) switch (i.datatype) {
                    case "v":
                        o = i.datavalue + "";
                        break;

                    case "t":
                        o = "'" + i.datavalue;
                        break;

                    case "f":
                        o = "=" + i.formula;
                        break;

                    case "c":
                        o = i.formula;
                }
                return o;
            }, t.FormatValueForDisplay = function (e, o, i, n) {
                var r, a, s, l, c = e.attribs,
                    u = (t.Constants, e.cells[i]);
                u || (u = new t.Cell(i)), l = o, a = u.valuetype || "", s = a.substring(1), valueinputwidget = a.charAt(1);
                var d = a.substring(2),
                    h = null,
                    p = null;
                if (a = a.charAt(0), u.errors || "e" == a) return l = u.errors || s || "Error in cell";
                if ("t" == a) {
                    if (r = e.valueformats[u.textvalueformat - 0] || e.valueformats[c.defaulttextvalueformat - 0] || "",
                        "formula" == r) return l = "f" == u.datatype ? t.special_chars("=" + u.formula) || "&nbsp;" : "c" == u.datatype ? t.special_chars("'" + u.formula) || "&nbsp;" : t.special_chars("'" + l) || "&nbsp;";
                    var h = l;
                    l = t.format_text_for_display(l, u.valuetype, r, e, n, u.nontextvalueformat);
                    var p = l;
                } else if ("n" == a) {
                    if (r = u.nontextvalueformat, (null == r || "" == r) && (r = c.defaultnontextvalueformat),
                        r = e.valueformats[r - 0], (null == r || "none" == r) && (r = ""), "formula" == r) return l = "f" == u.datatype ? t.special_chars("=" + u.formula) || "&nbsp;" : "c" == u.datatype ? t.special_chars("'" + u.formula) || "&nbsp;" : t.special_chars("'" + l) || "&nbsp;";
                    if ("forcetext" == r) return l = "f" == u.datatype ? t.special_chars("=" + u.formula) || "&nbsp;" : "c" == u.datatype ? t.special_chars(u.formula) || "&nbsp;" : t.special_chars(l) || "&nbsp;";
                    var h = l;
                    l = t.format_number_for_display(l, u.valuetype, r);
                    var p = l;
                } else l = "&nbsp;";
                if ("i" == valueinputwidget && null != h && null != p) {
                    var f = e.ioParameterList[i],
                        m = t.Formula.FunctionList[d];
                    if (m) {
                        var g = m[5],
                            v = 0 == h ? "" : "checked";
                        g = g.replace(/<%=checked%>/g, v), g = g.replace(/<%=formated_value%>/g, p), g = g.replace(/<%=display_value%>/g, h);
                        var b;
                        if (f) {
                            for (var y = 0; y < f.length; y++) {
                                b = "coord" == f[y].type ? e.GetAssuredCell(f[y].value).datavalue : f[y].value;
                                var C = new RegExp("<%=parameter" + y + "_value%>", "g");
                                g = g.replace(C, b);
                            }
                            if (f.html)
                                for (var w = 0; w < f.html.length; w++) {
                                    var C = new RegExp("<%=html" + w + "_value%>", "g");
                                    g = g.replace(C, f.html[w]);
                                }
                            f.css && (g = g.replace(/^(<\w+)(\W)/, "$1 style='" + f.css + "'$2"));
                        }
                        return g.replace(/<%=cell_reference%>/g, i);
                    }
                    return "error:Widget HTML missing";
                }
                return l;
            }, t.format_text_for_display = function (e, o, i, n, r, a) {
                var i, s, l, c, u, d;
                return s = o.substring(1), d = e, ("none" == i || null == i) && (i = ""), /^(text-|custom|hidden)/.test(i) || (i = ""),
                    ("" == i || "General" == i) && ("h" == s && (i = "text-html"), ("w" == s || "r" == s) && (i = "text-wiki"),
                        "l" == s && (i = "text-link"), s || (i = "text-plain")), "text-html" == i || (t.Callbacks.expand_wiki && /^text-wiki/.test(i) ? d = t.Callbacks.expand_wiki(d, n, r, i) : "text-wiki" == i ? d = t.Callbacks.expand_markup && t.Callbacks.expand_markup(d, n, r) || t.special_chars("wiki-text:" + d) : "text-url" == i ? (l = t.special_chars(d),
                        c = encodeURI(d), d = '<a href="' + c + '">' + l + "</a>") : "text-link" == i ? d = t.expand_text_link(d, n, r, i) : "text-image" == i ? (c = encodeURI(d),
                        d = '<img src="' + c + '">') : "text-custom:" == i.substring(0, 12) ? (l = t.special_chars(d),
                        l = l.replace(/  /g, "&nbsp; "), l = l.replace(/\n/g, "<br>"), c = encodeURI(d),
                        u = {}, u.r = d, u.s = l, u.u = c, d = i.substring(12), d = d.replace(/@(r|s|u)/g, function (e, t) {
                            return u[t];
                        })) : "custom" == i.substring(0, 6) ? (d = t.special_chars(d), d = d.replace(/  /g, "&nbsp; "),
                        d = d.replace(/\n/g, "<br>"), d += " (custom format)") : "hidden" == i ? d = "&nbsp;" : null != a && "" != a && "none" != n.valueformats[a - 0] && "" != n.valueformats[a - 0] ? (i = n.valueformats[a],
                        d = t.format_number_for_display(e, o, i)) : (d = t.special_chars(d), d = d.replace(/  /g, "&nbsp; "),
                        d = d.replace(/\n/g, "<br>"))), d;
            }, t.format_number_for_display = function (e, o, i) {
                var n, r, a = t.Constants;
                return n = e - 0, r = o.substring(1), ("Auto" == i || "" == i) && (i = "%" == r ? a.defaultFormatp : "$" == r ? a.defaultFormatc : "dt" == r ? a.defaultFormatdt : "d" == r ? a.defaultFormatd : "t" == r ? a.defaultFormatt : "l" == r ? "logical" : "General"),
                    "logical" == i ? n ? a.defaultDisplayTRUE : a.defaultDisplayFALSE : "hidden" == i ? "&nbsp;" : t.FormatNumber.formatNumberWithFormat(e, i, "");
            }, t.DetermineValueType = function (e) {
                var o, i, n, r, a, s, l, c, u, d, h = e + "",
                    p = "t";
                return o = h.replace(/^\s+/, ""), o = o.replace(/\s+$/, ""), 0 == h.length ? p = "" : h.match(/^\s+$/) || (o.match(/^[-+]?\d*(?:\.)?\d*(?:[eE][-+]?\d+)?$/) ? (h = o - 0,
                    isNaN(h) ? h = e + "" : p = "n") : o.match(/^[-+]?\d*(?:\.)?\d*\s*%$/) ? (h = (o.slice(0, -1) - 0) / 100,
                    p = "n%") : o.match(/^[-+]?\$\s*\d*(?:\.)?\d*\s*$/) && o.match(/\d/) ? (h = o.replace(/\$/, "") - 0,
                    p = "n$") : o.match(/^[-+]?(\d*,\d*)+(?:\.)?\d*$/) ? (h = o.replace(/,/g, "") - 0,
                    p = "n") : o.match(/^[-+]?(\d*,\d*)+(?:\.)?\d*\s*%$/) ? (h = (o.replace(/[%,]/g, "") - 0) / 100,
                    p = "n%") : o.match(/^[-+]?\$\s*(\d*,\d*)+(?:\.)?\d*$/) && o.match(/\d/) ? (h = o.replace(/[\$,]/g, "") - 0,
                    p = "n$") : (i = h.match(/^(\d{1,2})[\/\-](\d{1,2})[\/\-](\d{1,4})\s*$/)) ? (n = i[3] - 0,
                    n = 1e3 > n ? n + 2e3 : n, h = 0 === navigator.language.indexOf("fr") ? t.FormatNumber.convert_date_gregorian_to_julian(n, i[2] - 0, i[1] - 0) - 2415019 : t.FormatNumber.convert_date_gregorian_to_julian(n, i[1] - 0, i[2] - 0) - 2415019,
                    p = "nd") : (i = h.match(/^(\d{4})[\/\-](\d{1,2})[\/\-](\d{1,2})\s*$/)) ? (n = i[1] - 0,
                    n = 1e3 > n ? n + 2e3 : n, h = t.FormatNumber.convert_date_gregorian_to_julian(n, i[2] - 0, i[3] - 0) - 2415019,
                    p = "nd") : (i = h.match(/^(\d{4})[\/\-](\d{1,2})[\/\-](\d{1,2}) (\d{1,2}):(\d{1,2})\s*$/)) ? (n = i[1] - 0,
                    n = 1e3 > n ? n + 2e3 : n, r = i[4] - 0, a = i[5] - 0, h = t.FormatNumber.convert_date_gregorian_to_julian(n, i[2] - 0, i[3] - 0) - 2415019,
                    p = "nd", 24 > r && 60 > a && (h += r / 24 + a / 1440, p = "ndt")) : (i = h.match(/^(\d{4})[\/\-](\d{1,2})[\/\-](\d{1,2}) (\d{1,2}):(\d{1,2}):(\d{1,2})\s*$/)) ? (n = i[1] - 0,
                    n = 1e3 > n ? n + 2e3 : n, r = i[4] - 0, a = i[5] - 0, s = i[6] - 0, h = t.FormatNumber.convert_date_gregorian_to_julian(n, i[2] - 0, i[3] - 0) - 2415019,
                    p = "nd", 24 > r && 60 > a && 60 > s && (h += r / 24 + a / 1440 + s / 86400, p = "ndt")) : (i = h.match(/^(\d{1,2}):(\d{1,2})\s*$/)) ? (r = i[1] - 0,
                    a = i[2] - 0, 24 > r && 60 > a && (h = r / 24 + a / 1440, p = "nt")) : (i = h.match(/^(\d{1,2}):(\d{1,2}):(\d{1,2})\s*$/)) ? (r = i[1] - 0,
                    a = i[2] - 0, s = i[3] - 0, 24 > r && 60 > a && 60 > s && (h = r / 24 + a / 1440 + s / 86400,
                        p = "nt")) : (i = h.match(/^\s*([-+]?\d+) (\d+)\/(\d+)\s*$/)) ? (u = i[1] - 0, c = i[2] - 0,
                    l = i[3] - 0, l && l > 0 && (h = u + (0 > u ? -c / l : c / l), p = "n")) : (d = t.InputConstants[h.toUpperCase()]) ? (c = d.indexOf(","),
                    h = d.substring(0, c) - 0, p = d.substring(c + 1)) : o.length > 7 && "http://" == o.substring(0, 7).toLowerCase() ? (h = o,
                    p = "tl") : o.match(/<([A-Z][A-Z0-9]*)\b[^>]*>[\s\S]*?<\/\1>/i) && (h = o, p = "th")), {
                    value: h,
                    type: p
                };
            }, t.InputConstants = {
                TRUE: "1,nl",
                FALSE: "0,nl",
                "#N/A": "0,e#N/A",
                "#NULL!": "0,e#NULL!",
                "#NUM!": "0,e#NUM!",
                "#DIV/0!": "0,e#DIV/0!",
                "#VALUE!": "0,e#VALUE!",
                "#REF!": "0,e#REF!",
                "#NAME?": "0,e#NAME?"
            }, t.default_expand_markup = function (e) {
                var o = e;
                return o = t.special_chars(o), o = o.replace(/  /g, "&nbsp; "), o = o.replace(/\n/g, "<br>");
            }, t.expand_text_link = function (e, o, i, n) {
                var r, a, s, l = t.Constants,
                    c = "",
                    u = t.ParseCellLinkText(e + "");
                return r = u.desc ? t.special_chars(u.desc) : u.pagename ? l.defaultPageLinkFormatString : l.defaultLinkFormatString,
                    e.length > 7 && "http://" == e.substring(0, 7).toLowerCase() && ">" != e.charAt(e.length - 1) && (r = r.substring(7)),
                    a = u.newwin || !i ? ' target="_blank"' : "", u.pagename ? t.Callbacks.MakePageLink && (c = t.Callbacks.MakePageLink(u.pagename, u.workspacename, i, n)) : c = encodeURI(u.url),
                    s = '<a href="' + c + '"' + a + ">" + r + "</a>";
            }, t.ParseCellLinkText = function (e) {
                var t = {
                        url: "",
                        desc: "",
                        newwin: !1,
                        pagename: "",
                        workspace: ""
                    },
                    o = !1,
                    i = e.length - 1,
                    n = 0,
                    r = e.lastIndexOf("<"),
                    a = e.lastIndexOf("["),
                    s = e.lastIndexOf("{"),
                    l = -1;
                return ">" == e.charAt(i) && -1 != r || "]" == e.charAt(i) && -1 != a || !("}" != e.charAt(i) || "]" != e.charAt(i - 1) || -1 == s || -1 == a || s > a) ? (">" == e.charAt(i) ? (l = r - 1,
                            r > 0 && "<" == e.charAt(l) && ">" == e.charAt(i - 1) && (l--, i--, t.newwin = !0)) : "]" == e.charAt(i) ? (l = a - 1,
                            o = !0, a > 0 && "[" == e.charAt(l) && "]" == e.charAt(i - 1) && (l--, i--, t.newwin = !0)) : "}" == e.charAt(i) && (l = s - 1,
                            o = !0, wsend = a, i--, a > 0 && "[" == e.charAt(a - 1) && "]" == e.charAt(i - 1) && (wsend = a - 1,
                                i--, t.newwin = !0), " " == e.charAt(wsend - 1) && wsend--, t.workspace = e.substring(s + 1, wsend) || ""),
                        " " == e.charAt(l) && l--, '"' == e.charAt(n) && '"' == e.charAt(l) && (n++, l--)) : (i++,
                        l = i), o ? t.pagename = e.substring(a + 1, i) || "" : t.url = e.substring(r + 1, i) || "",
                    l >= n && (t.desc = e.substring(n, l + 1)), t;
            }, t.ConvertSaveToOtherFormat = function (e, o, i) {
                var n, r, a, s, l, c, u, d, h, p, f = "";
                if ("scsave" == o) return e;
                if ("" == e) return "";
                if (n = new t.Sheet(), n.ParseSheetSave(e), i) throw "SocialCalc.ConvertSaveToOtherFormat: Not doing recalc.";
                if (a = n.copiedfrom ? t.ParseRange(n.copiedfrom) : {
                        cr1: {
                            row: 1,
                            col: 1
                        },
                        cr2: {
                            row: n.attribs.lastrow,
                            col: n.attribs.lastcol
                        }
                    }, "html" == o) return r = new t.RenderContext(n), n.copiedfrom && (r.rowpanes[0] = {
                        first: a.cr1.row,
                        last: a.cr2.row
                    }, r.colpanes[0] = {
                        first: a.cr1.col,
                        last: a.cr2.col
                    }), s = document.createElement("div"), l = r.RenderSheet(null, r.defaultHTMLlinkstyle),
                    s.appendChild(l), delete r, delete n, f = s.innerHTML, delete l, delete s, f;
                for (c = a.cr1.row; c <= a.cr2.row; c++) {
                    for (u = a.cr1.col; u <= a.cr2.col; u++) d = t.crToCoord(u, c), h = n.GetAssuredCell(d),
                        p = h.errors ? h.errors : h.datavalue + "", "csv" == o ? (-1 != p.indexOf('"') && (p = p.replace(/"/g, '""')),
                            /[, \n"]/.test(p) && (p = '"' + p + '"'), u > a.cr1.col && (p = "," + p)) : "tab" == o && (-1 != p.indexOf("\n") && (-1 != p.indexOf('"') && (p = p.replace(/"/g, '""')),
                            p = '"' + p + '"'), u > a.cr1.col && (p = "	" + p)), f += p;
                    f += "\n";
                }
                return f;
            }, t.ConvertOtherFormatToSave = function (e, o) {
                var i, n, r, a, s, l, c, u, d, h, p, f, m = "",
                    g = function () {
                        h++, h > f && (f = h), p = t.crToCoord(h, d), t.SetConvertedCell(i, p, s), s = "";
                    };
                if ("scsave" == o) return e;
                if (i = new t.Sheet(), n = e.split(/\r\n|\n/), f = 0, "csv" == o) {
                    for (d = 0, l = !1, r = 0; r < n.length && (r != n.length - 1 || "" != n[r]); r++)
                        for (l ? s += "\n" : (s = "",
                                d++, h = 0), a = n[r], c = 0; c < a.length; c++) u = a.charAt(c), '"' != u ? ("," != u || l ? s += u : g(),
                            c != a.length - 1 || l || g()) : l ? c < a.length - 1 && '"' == a.charAt(c + 1) ? (c++,
                            s += '"') : (l = !1, c == a.length - 1 && g()) : l = !0;
                    f > 0 && (i.attribs.lastrow = d, i.attribs.lastcol = f, m = i.CreateSheetSave("A1:" + t.crToCoord(f, d)));
                }
                if ("tab" == o) {
                    for (d = 0, l = !1, r = 0; r < n.length && (r != n.length - 1 || "" != n[r]); r++)
                        for (l ? s += "\n" : (s = "",
                                d++, h = 0), a = n[r], c = 0; c < a.length; c++) {
                            if (u = a.charAt(c), '"' == u) {
                                if (l) {
                                    c < a.length - 1 ? '"' == a.charAt(c + 1) ? (c++, s += '"') : "	" == a.charAt(c + 1) && (c++,
                                        l = !1, g()) : (l = !1, g());
                                    continue;
                                }
                                if ("" == s) {
                                    l = !0;
                                    continue;
                                }
                            }
                            "	" != u || l ? s += u : g(), c != a.length - 1 || l || g();
                        }
                    f > 0 && (i.attribs.lastrow = d, i.attribs.lastcol = f, m = i.CreateSheetSave("A1:" + t.crToCoord(f, d)));
                }
                return m;
            }, t.SetConvertedCell = function (e, o, i) {
                var n, r;
                n = e.GetAssuredCell(o), r = t.DetermineValueType(i), "n" == r.type && r.value == i ? (n.datatype = "v",
                    n.valuetype = "n", n.datavalue = r.value) : "t" == r.type.charAt(0) ? (n.datatype = "t",
                    n.valuetype = r.type, n.datavalue = r.value) : (n.datatype = "c", n.valuetype = r.type,
                    n.datavalue = r.value, n.formula = i);
            };
        var t;
        t || (t = {}), t.TableEditor = function (o) {
            t.Constants.defaultImagePrefix = "EtherCalc/runtime/assets/sc_";
            var i = t.Constants;
            this.context = o, this.toplevel = null, this.fullgrid = null, this.noEdit = !1,
                this.width = null, this.tablewidth = null, this.height = null, this.tableheight = null,
                this.inputBox = null, this.inputEcho = null, this.verticaltablecontrol = null, this.horizontaltablecontrol = null,
                this.logo = null, this.cellhandles = null, this.timeout = null, this.busy = !1,
                this.ensureecell = !1, this.deferredCommands = [], this.deferredEmailCommands = [],
                this.gridposition = null, this.headposition = null, this.firstscrollingrow = null,
                this.firstscrollingrowtop = null, this.lastnonscrollingrow = null, this.lastvisiblerow = null,
                this.firstscrollingcol = null, this.firstscrollingcolleft = null, this.lastnonscrollingcol = null,
                this.lastvisiblecol = null, this.rowpositions = [], this.colpositions = [], this.rowheight = [],
                this.colwidth = [], this.ecell = null, this.state = "start", this.workingvalues = {},
                this.imageprefix = i.defaultImagePrefix, this.idPrefix = i.defaultTableEditorIDPrefix,

                this.pageUpDnAmount = i.defaultPageUpDnAmount, this.recalcFunction = function (e) {
                    return e.context.sheetobj.RecalcSheet ? void e.context.sheetobj.RecalcSheet(t.EditorSheetStatusCallback, e) : null;
                }, this.ctrlkeyFunction = function (o, i) {
                    var n, r, a, s, l, c;
                    switch (i) {
                        case "[ctrl-a]":
                            return o.MoveECell("A1"), o.RangeAnchor("A1"), o.RangeExtend(t.crToCoord(o.context.sheetobj.attribs.lastcol, o.context.sheetobj.attribs.lastrow)),
                                !1;

                        case "[ctrl-c]":
                        case "[ctrl-x]":
                            return n = o.pasteTextarea, n.value = "", r = t.GetEditorCellElement(o, o.ecell.row, o.ecell.col),
                                r && (a = t.GetElementPosition(r.element), n.style.left = a.left - 1 + "px", n.style.top = a.top - 1 + "px"),
                                l = o.range.hasrange ? t.crToCoord(o.range.left, o.range.top) + ":" + t.crToCoord(o.range.right, o.range.bottom) : o.ecell.coord,
                                c = t.ConvertSaveToOtherFormat(t.CreateSheetSave(o.context.sheetobj, l), "tab"),
                                s = "[ctrl-c]" == i || o.noEdit || o.ECellReadonly() ? "copy " + l + " formulas" : "cut " + l + " formulas",
                                o.EditorScheduleSheetCommands(s, !0, !1), n.style.display = "block", n.value = c,
                                n.focus(), n.select(), e.setTimeout(function () {
                                    var e = o.pasteTextarea;
                                    e.blur(), e.style.display = "none", t.KeyboardFocus();
                                }, 200), !0;

                        case "[ctrl-v]":
                            return o.noEdit || o.ECellReadonly() ? !0 : (n = o.pasteTextarea, n.value = "",
                                r = t.GetEditorCellElement(o, o.ecell.row, o.ecell.col), r && (a = t.GetElementPosition(r.element),
                                    n.style.left = a.left - 1 + "px", n.style.top = a.top - 1 + "px"), n.style.display = "block",
                                n.value = "", n.focus(), e.setTimeout(function () {
                                    var e = o.pasteTextarea,
                                        i = e.value;
                                    e.blur(), e.style.display = "none";
                                    var n = "";
                                    if (o.pastescclipboard) o.pastescclipboard = !1;
                                    else {
                                        var r = t.ConvertSaveToOtherFormat(t.Clipboard.clipboard, "tab");
                                        i = i.replace(/\r\n/g, "\n"), i == r || i.length - r.length == 1 && i.substring(0, i.length - 1) == r || (n = "loadclipboard " + t.encodeForSave(t.ConvertOtherFormatToSave(i, "tab")) + "\n");
                                    }
                                    var a;
                                    if (o.range.hasrange) {
                                        var s = new t.Sheet();
                                        s.ParseSheetSave(t.Clipboard.clipboard);
                                        var l = s.copiedfrom.match(/(.+):(.+)/);
                                        a = null !== l && l[1] === l[2] ? t.crToCoord(o.range.left, o.range.top) + ":" + t.crToCoord(o.range.right, o.range.bottom) : t.crToCoord(o.range.left, o.range.top);
                                    } else a = o.ecell.coord;
                                    n += "paste " + a + " formulas", o.EditorScheduleSheetCommands(n, !0, !1), t.KeyboardFocus();
                                }, 200), !0);

                        case "[ctrl-z]":
                            return o.EditorScheduleSheetCommands("undo", !0, !1), !1;

                        case "[ctrl-s]":
                            if (!t.Constants.AllowCtrlS) break;
                            return e.setTimeout(function () {
                                var i = o.context.sheetobj,
                                    n = i.GetAssuredCell(o.ecell.coord),
                                    r = n.nontextvalueformat ? i.valueformats[n.nontextvalueformat - 0] || "" : "",
                                    a = e.prompt("Advanced Feature:\n\nCustom Numeric Format or Command", r);
                                if (null != a) {
                                    if (a.match(/^cmd:/)) s = a.substring(4);
                                    else {
                                        if (a.match(/^edit:/)) return s = a.substring(5), void(t.CtrlSEditor && t.CtrlSEditor(s));
                                        l = o.range.hasrange ? t.crToCoord(o.range.left, o.range.top) + ":" + t.crToCoord(o.range.right, o.range.bottom) : o.ecell.coord,
                                            s = "set " + l + " nontextvalueformat " + a;
                                    }
                                    o.EditorScheduleSheetCommands(s, !0, !1);
                                }
                            }, 200), !1;
                    }
                    return !0;
                }, o.sheetobj.statuscallback = t.EditorSheetStatusCallback, o.sheetobj.statuscallbackparams = this,
                this.StatusCallback = {}, this.MoveECellCallback = {}, this.RangeChangeCallback = {},
                this.SettingsCallbacks = {}, this.ecell = {
                    coord: "A1",
                    row: 1,
                    col: 1
                }, o.highlights[this.ecell.coord] = "cursor", this.range = {
                    hasrange: !1
                }, this.range2 = {
                    hasrange: !1
                };
        }, t.TableEditor.prototype.CreateTableEditor = function (e, o) {
            return t.CreateTableEditor(this, e, o);
        }, t.TableEditor.prototype.ResizeTableEditor = function (e, o) {
            return t.ResizeTableEditor(this, e, o);
        }, t.TableEditor.prototype.SaveEditorSettings = function () {
            return t.SaveEditorSettings(this);
        }, t.TableEditor.prototype.LoadEditorSettings = function (e, o) {
            return t.LoadEditorSettings(this, e, o);
        }, t.TableEditor.prototype.EditorRenderSheet = function () {
            t.EditorRenderSheet(this);
        }, t.TableEditor.prototype.EditorScheduleSheetCommands = function (e, o, i) {
            t.EditorScheduleSheetCommands(this, e, o, i);
        }, t.TableEditor.prototype.ScheduleSheetCommands = function (e, t) {
            this.context.sheetobj.ScheduleSheetCommands(e, t);
        }, t.TableEditor.prototype.SheetUndo = function () {
            this.context.sheetobj.SheetUndo();
        }, t.TableEditor.prototype.SheetRedo = function () {
            this.context.sheetobj.SheetRedo();
        }, t.TableEditor.prototype.EditorStepSet = function (e, o) {
            t.EditorStepSet(this, e, o);
        }, t.TableEditor.prototype.GetStatuslineString = function (e, o, i) {
            return t.EditorGetStatuslineString(this, e, o, i);
        }, t.TableEditor.prototype.EditorMouseRegister = function () {
            return t.EditorMouseRegister(this);
        }, t.TableEditor.prototype.EditorMouseUnregister = function () {
            return t.EditorMouseUnregister(this);
        }, t.TableEditor.prototype.EditorMouseRange = function (e) {
            return t.EditorMouseRange(this, e);
        }, t.TableEditor.prototype.EditorProcessKey = function (e, o) {
            return t.EditorProcessKey(this, e, o);
        }, t.TableEditor.prototype.EditorAddToInput = function (e, o) {
            return t.EditorAddToInput(this, e, o);
        }, t.TableEditor.prototype.DisplayCellContents = function () {
            return t.EditorDisplayCellContents(this);
        }, t.TableEditor.prototype.EditorSaveEdit = function (e) {
            return t.EditorSaveEdit(this, e);
        }, t.TableEditor.prototype.EditorApplySetCommandsToRange = function (e, o) {
            return t.EditorApplySetCommandsToRange(this, e, o);
        }, t.TableEditor.prototype.MoveECellWithKey = function (e) {
            return t.MoveECellWithKey(this, e);
        }, t.TableEditor.prototype.MoveECell = function (e) {
            return t._app ? "A1" : t.MoveECell(this, e);
        }, t.TableEditor.prototype.ReplaceCell = function (e, o, i) {
            t.ReplaceCell(this, e, o, i);
        }, t.TableEditor.prototype.UpdateCellCSS = function (e, o, i) {
            t.UpdateCellCSS(this, e, o, i);
        }, t.TableEditor.prototype.SetECellHeaders = function (e) {
            t.SetECellHeaders(this, e);
        }, t.TableEditor.prototype.EnsureECellVisible = function () {
            t.EnsureECellVisible(this);
        }, t.TableEditor.prototype.ECellReadonly = function (e) {
            return t.ECellReadonly(this, e);
        }, t.TableEditor.prototype.RangeAnchor = function (e) {
            t.RangeAnchor(this, e);
        }, t.TableEditor.prototype.RangeExtend = function (e) {
            t.RangeExtend(this, e);
        }, t.TableEditor.prototype.RangeRemove = function () {
            t.RangeRemove(this);
        }, t.TableEditor.prototype.Range2Remove = function () {
            t.Range2Remove(this);
        }, t.TableEditor.prototype.FitToEditTable = function () {
            t.FitToEditTable(this);
        }, t.TableEditor.prototype.CalculateEditorPositions = function () {
            t.CalculateEditorPositions(this);
        }, t.TableEditor.prototype.ScheduleRender = function () {
            this.ScheduleRender(!0);
        }, t.TableEditor.prototype.ScheduleRender = function (e) {
            t._app && 1 == e && (this.context.sheetobj.widgetsClean = !1), t.ScheduleRender(this);
        }, t.TableEditor.prototype.DoRenderStep = function () {
            t.DoRenderStep(this);
        }, t.TableEditor.prototype.SchedulePositionCalculations = function () {
            t.SchedulePositionCalculations(this);
        }, t.TableEditor.prototype.DoPositionCalculations = function () {
            t.DoPositionCalculations(this);
        }, t.TableEditor.prototype.CalculateRowPositions = function (e, o, i) {
            return t.CalculateRowPositions(this, e, o, i);
        }, t.TableEditor.prototype.CalculateColPositions = function (e, o, i) {
            return t.CalculateColPositions(this, e, o, i);
        }, t.TableEditor.prototype.ScrollRelative = function (e, o) {
            t.ScrollRelative(this, e, o);
        }, t.TableEditor.prototype.ScrollRelativeBoth = function (e, o) {
            t.ScrollRelativeBoth(this, e, o);
        }, t.TableEditor.prototype.PageRelative = function (e, o) {
            t.PageRelative(this, e, o);
        }, t.TableEditor.prototype.LimitLastPanes = function () {
            t.LimitLastPanes(this);
        }, t.TableEditor.prototype.ScrollTableUpOneRow = function () {
            return t.ScrollTableUpOneRow(this);
        }, t.TableEditor.prototype.ScrollTableDownOneRow = function () {
            return t.ScrollTableDownOneRow(this);
        }, t.TableEditor.prototype.ScrollTableLeftOneCol = function () {
            return t.ScrollTableLeftOneCol(this);
        }, t.TableEditor.prototype.ScrollTableRightOneCol = function () {
            return t.ScrollTableRightOneCol(this);
        }, t.TableEditor.prototype.StopPropagation = function () {
            return t.StopPropagation(this);
        }, t.TableEditor.prototype.SetMouseMoveUp = function () {
            return t.SetMouseMoveUp(this);
        }, t.TableEditor.prototype.RemoveMouseMoveUp = function () {
            return t.RemoveMouseMoveUp(this);
        }, t.CreateTableEditor = function (o, i, n) {
            var r = t.Constants,
                a = t.AssignID;
            o.toplevel = document.createElement("div"), o.toplevel.style.position = "relative",
                a(o, o.toplevel, "toplevel"), 
               // i = "400",
               // n = "200",
                o.width = i, // JP Hack width of Spreadsheet !  
                o.height = n, // JP Hack Eight of Spreadsheet ! 
                o.griddiv = document.createElement("div"),
                o.tablewidth = Math.max(0, i - r.defaultTableControlThickness), o.tableheight = Math.max(0, n - r.defaultTableControlThickness), //Ajust width of sheet cells JP control moidfying i variable
                o.griddiv.style.width = o.tablewidth + "px", o.griddiv.style.height = o.tableheight + "px",
                o.griddiv.style.overflow = "hidden", o.griddiv.style.cursor = "default", r.cteGriddivClass && (o.griddiv.className = r.cteGriddivClass),
                a(o, o.griddiv, "griddiv"), o.FitToEditTable(), o.EditorRenderSheet(), o.griddiv.appendChild(o.fullgrid),
                o.verticaltablecontrol = new t.TableControl(o, !0, o.tableheight), o.verticaltablecontrol.CreateTableControl(),
                a(o, o.verticaltablecontrol.main, "tablecontrolv"), o.horizontaltablecontrol = new t.TableControl(o, !1, o.tablewidth),
                o.horizontaltablecontrol.CreateTableControl(), a(o, o.horizontaltablecontrol.main, "tablecontrolh");
            var s, l, c, u, d;

            function cellWriter() {
                if (typeof config.script[0] !== "undefined") {
                    for (let i = 0; i < config.script[0].length; i++) {
                        o.EditorScheduleSheetCommands(config.script[0][i].command[0], !0, !1);
                    }
                }
            };

            return s = document.createElement("table"), o.layouttable = s, s.cellSpacing = 0,
                s.cellPadding = 0, a(o, s, "layouttable"), l = document.createElement("tbody"),
                s.appendChild(l), c = document.createElement("tr"), l.appendChild(c), u = document.createElement("td"),
                u.appendChild(o.griddiv), c.appendChild(u), 1 != t._app && (u = document.createElement("td"),
                    u.appendChild(o.verticaltablecontrol.main), c.appendChild(u)), c = document.createElement("tr"),
                l.appendChild(c), 1 != t._app && (u = document.createElement("td"), u.appendChild(o.horizontaltablecontrol.main),
                    c.appendChild(u)), u = document.createElement("td"), u.style.background = t._app ? "url(" + assetManager.resolve('EtherCalc/runtime/assets/logo.gif') + " no-repeat right center" : "url(" + assetManager.resolve('EtherCalc/runtime/assets/logo.gif') + " no-repeat center center",
                u.innerHTML = "<div style='cursor:pointer;font-size:1px;'><div class='sc_1x1 sprite'></div> < /div>",
                c.appendChild(u), o.logo = u, a(o, o.logo, "logo"), u.firstChild.firstChild.title = "SocialCalc",
                o.toplevel.appendChild(o.layouttable), o.noEdit || (o.inputEcho = new t.InputEcho(o),
                    a(o, o.inputEcho.main, "inputecho")), o.cellhandles = new t.CellHandles(o), d = document.createElement("textarea"),


                cellWriter(), // JP MOD Cells Writer

                t.setStyles(d, "display:none;position:absolute;height:1px;width:1px;opacity:0;filter:alpha(opacity=0);"),
                d.value = "", o.pasteTextarea = d, a(o, o.pasteTextarea, "pastetextarea"), navigator.userAgent.match(/Safari\//) && !navigator.userAgent.match(/Chrome\//) && (e.removeEventListener("beforepaste", t.SafariPasteFunction, !1),
                    e.addEventListener("beforepaste", t.SafariPasteFunction, !1), e.removeEventListener("beforecopy", t.SafariPasteFunction, !1),
                    e.addEventListener("beforecopy", t.SafariPasteFunction, !1), e.removeEventListener("beforecut", t.SafariPasteFunction, !1),
                    e.addEventListener("beforecut", t.SafariPasteFunction, !1)), o.toplevel.appendChild(o.pasteTextarea),
                t.MouseWheelRegister(o.toplevel, {
                    WheelMove: t.EditorProcessMouseWheel,
                    editor: o
                }), t.KeyboardSetFocus(o), t.EditorSheetStatusCallback(null, "startup", null, o),
                o.toplevel;



        }, t.SafariPasteFunction = function (e) {
            e.preventDefault();
        }, t.ResizeTableEditor = function (e, o, i) {
            var n = t.Constants;
            e.width = o, e.height = i, e.toplevel.style.width = o + "px", e.toplevel.style.height = i + "px",
                e.tablewidth = t._app ? Math.max(0, o) : Math.max(0, o - n.defaultTableControlThickness),
                e.tableheight = Math.max(0, i - n.defaultTableControlThickness), e.griddiv.style.width = e.tablewidth + "px",
                e.griddiv.style.height = e.tableheight + "px", e.verticaltablecontrol.main.style.height = e.tableheight + "px",
                e.horizontaltablecontrol.main.style.width = e.tablewidth + "px", e.FitToEditTable(),
                e.ScheduleRender();
        }, t.SaveEditorSettings = function (e) {
            var t, o, i = e.context,
                n = e.range,
                r = "";
            for (r += "version:1.0\n", t = 0; t < i.rowpanes.length; t++) r += "rowpane:" + t + ":" + i.rowpanes[t].first + ":" + i.rowpanes[t].last + "\n";
            for (t = 0; t < i.colpanes.length; t++) r += "colpane:" + t + ":" + i.colpanes[t].first + ":" + i.colpanes[t].last + "\n";
            e.ecell && (r += "ecell:" + e.ecell.coord + "\n"), n.hasrange && (r += "range:" + n.anchorcoord + ":" + n.top + ":" + n.bottom + ":" + n.left + ":" + n.right + "\n");
            for (o in e.SettingsCallbacks) r += e.SettingsCallbacks[o].save(e, o);
            return r;
        }, t.LoadEditorSettings = function (e, o, i) {
            var n, r, a, s, l, c, u, d, h, p = o.split(/\r\n|\n/),
                f = [],
                m = e.context;
            for (m.rowpanes = [{
                    first: 1,
                    last: 1
                }], m.colpanes = [{
                    first: 1,
                    last: 1
                }], e.ecell = null, e.range = {
                    hasrange: !1
                }, e.range2 = {
                    hasrange: !1
                }, h = e.range, m.highlights = {}, d = m.highlights, r = 0; r < p.length; r++) switch (n = p[r],
                f = n.split(":"), u = f[0]) {
                case "version":
                    break;

                case "rowpane":
                    m.rowpanes[f[1] - 0] = {
                        first: f[2] - 0,
                        last: f[3] - 0
                    };
                    break;

                case "colpane":
                    m.colpanes[f[1] - 0] = {
                        first: f[2] - 0,
                        last: f[3] - 0
                    };
                    break;

                case "ecell":
                    e.ecell = t.coordToCr(f[1]), e.ecell.coord = f[1], d[f[1]] = "cursor";
                    break;

                case "range":
                    for (h.hasrange = !0, h.anchorcoord = f[1], a = t.coordToCr(h.anchorcoord), h.anchorrow = a.row,
                        h.anchorcol = a.col, h.top = f[2] - 0, h.bottom = f[3] - 0, h.left = f[4] - 0, h.right = f[5] - 0,
                        s = h.top; s <= h.bottom; s++)
                        for (l = h.left; l <= h.right; l++) c = t.crToCoord(l, s),
                            "cursor" != d[c] && (d[c] = "range");
                    break;

                default:
                    e.SettingsCallbacks[u] && e.SettingsCallbacks[u].load(e, u, n, i);
            }
        }, t.EditorRenderSheet = function (e) {
            e.EditorMouseUnregister();
            var o = e.context.sheetobj;
            if (null != o.reRenderCellList && t._app && o.widgetsClean === !0) {
                for (var i in o.reRenderCellList) {
                    var n = o.reRenderCellList[i],
                        r = o.cells[n].valuetype;
                    ("i" != r.charAt(1) || r != o.cells[n].prevvaluetype) && (cr = t.coordToCr(n), cell = t.GetEditorCellElement(e, cr.row, cr.col),
                        null != cell && e.ReplaceCell(cell, cr.row, cr.col));
                }
                o.reRenderCellList = [];
            } else e.fullgrid = e.context.RenderSheet(e.fullgrid), null != o.reRenderCellList && t._app && (o.widgetsClean = !0,
                o.reRenderCellList = []);
            e.ecell && e.SetECellHeaders("selected"), t.AssignID(e, e.fullgrid, "fullgrid"),
                t._app || (e.fullgrid.className = "te_download"), e.EditorMouseRegister();
        }, t.EditorScheduleSheetCommands = function (e, o, i, n) {
            if ("start" == e.state || n) {
                if (e.busy && !n) return void e.deferredCommands.push({
                    cmdstr: o,
                    saveundo: i
                });
                var r = o.split(" ");
                switch (r[0]) {
                    case "recalc":
                    case "redisplay":
                        e.context.sheetobj.ScheduleSheetCommands(o, !1);
                        break;

                    case "undo":
                        t._app && (e.context.sheetobj.widgetsClean = !1), e.SheetUndo();
                        break;

                    case "redo":
                        t._app && (e.context.sheetobj.widgetsClean = !1), e.SheetRedo();
                        break;

                    case "setemailparameters":
                        t.TriggerIoAction.Email(r[1], r[2]);
                        break;

                    default:
                        e.context.sheetobj.ScheduleSheetCommands(o, i);
                }
            }
        }, t.EditorSheetStatusCallback = function (e, o, i, n) {
            var r, a, s, l = n.context.sheetobj,
                c = function (e) {
                    for (r in n.StatusCallback) n.StatusCallback[r].func && n.StatusCallback[r].func(n, e, i, n.StatusCallback[r].params);
                };
            switch (o) {
                case "startup":
                    break;

                case "cmdstart":
                    n.busy = !0, l.celldisplayneeded = "";
                    break;

                case "cmdextension":
                    break;

                case "cmdend":
                    if (c(o), l.changedrendervalues && (n.context.PrecomputeSheetFontsAndLayouts(),
                            n.context.CalculateCellSkipData(), l.changedrendervalues = !1), l.celldisplayneeded && !l.renderneeded && l.cells[l.celldisplayneeded] && "e#N/A" != l.cells[l.celldisplayneeded].valuetype && (cr = t.coordToCr(l.celldisplayneeded),
                            a = t.GetEditorCellElement(n, cr.row, cr.col), n.ReplaceCell(a, cr.row, cr.col)),
                        n.deferredCommands.length) return s = n.deferredCommands.shift(), void n.EditorScheduleSheetCommands(s.cmdstr, s.saveundo, !0);
                    if (l.attribs.needsrecalc && ("off" != l.attribs.recalc || l.recalconce) && n.recalcFunction ? (n.FitToEditTable(),
                            l.renderneeded = !1, l.recalconce && delete l.recalconce, n.recalcFunction(n)) : l.renderneeded ? (n.FitToEditTable(),
                            l.renderneeded = !1, n.ScheduleRender(!1)) : n.SchedulePositionCalculations(), "col" == l.hiddencolrow && null !== n.ecell) {
                        for (var u = n.ecell.col;
                            "yes" == l.colattribs.hide[t.rcColname(u)];) u++;
                        var d = t.crToCoord(u, n.ecell.row);
                        n.MoveECell(d), l.hiddencolrow = "";
                    }
                    if ("row" == l.hiddencolrow && null !== n.ecell) {
                        for (var h = n.ecell.row;
                            "yes" == l.rowattribs.hide[h];) h++;
                        var d = t.crToCoord(n.ecell.col, h);
                        n.MoveECell(d), l.hiddencolrow = "";
                    }
                    return;

                case "calcstart":
                    n.busy = !0;
                    break;

                case "calccheckdone":
                case "calcorder":
                case "calcstep":
                case "calcloading":
                case "calcserverfunc":
                    break;

                case "calcfinished":
                    return c(o), void n.ScheduleRender(!1);

                case "schedrender":
                    n.busy = !0;
                    break;

                case "renderdone":
                    break;

                case "schedposcalc":
                    n.busy = !0;
                    break;

                case "doneposcalc":
                    if (n.deferredEmailCommands.length) {
                        c(o);
                        var p = n.deferredEmailCommands.shift();
                        return void n.EditorScheduleSheetCommands(p.cmdstr, p.saveundo, !0);
                    }
                    return void(n.deferredCommands.length ? (c(o), s = n.deferredCommands.shift(),
                        n.EditorScheduleSheetCommands(s.cmdstr, s.saveundo, !0)) : (n.busy = !1, c(o), "start" == n.state && n.DisplayCellContents()));

                case "emailing":
                case "confirmemailsent":
                    break;

                default:
                    alert("Unknown status: " + o);
            }

            c(o);
        }, t.EditorGetStatuslineString = function (e, o, i, n) {
            var r, a, s, l, c, u, d, h, p = t.Constants;
            switch (a = "", o) {
                case "moveecell":
                case "rangechange":
                case "startup":
                    break;

                case "cmdstart":
                    n.command = !0, document.body.style.cursor = "progress", e.griddiv.style.cursor = "progress",
                        a = p.s_statusline_executing;
                    break;

                case "cmdextension":
                    a = "Command Extension: " + i;
                    break;

                case "cmdend":
                    n.command = !1;
                    break;

                case "schedrender":
                    a = p.s_statusline_displaying;
                    break;

                case "renderdone":
                    a = " ";
                    break;

                case "schedposcalc":
                    a = p.s_statusline_displaying;
                    break;

                case "cmdendnorender":
                case "doneposcalc":
                    document.body.style.cursor = "default", e.griddiv.style.cursor = "default", "sent" == n.emailing && (a = n.emailreponse,
                        n.emailreponse = "", n.emailing = "done");
                    break;

                case "calcorder":
                    a = p.s_statusline_ordering + Math.floor(100 * i.count / (i.total || 1)) + "%";
                    break;

                case "calcstep":
                    a = p.s_statusline_calculating + Math.floor(100 * i.count / (i.total || 1)) + "%";
                    break;

                case "calcloading":
                    a = p.s_statusline_calculatingls + ": " + i.sheetname;
                    break;

                case "calcserverfunc":
                    a = p.s_statusline_calculating + Math.floor(100 * i.count / (i.total || 1)) + "%, " + p.s_statusline_doingserverfunc + i.funcname + p.s_statusline_incell + i.coord;
                    break;

                case "calcstart":
                    n.calculating = !0, document.body.style.cursor = "progress", e.griddiv.style.cursor = "progress",
                        a = p.s_statusline_calcstart;
                    break;

                case "calccheckdone":
                    break;

                case "calcfinished":
                    n.calculating = !1;
                    break;

                case "emailing":
                    n.emailing = "sending", n.emailreponse = "";
                    break;

                case "confirmemailsent":
                    n.emailing = "sent", "undefined" == typeof n.emailreponse && (n.emailreponse = ""),
                        n.emailreponse += i;
                    break;

                default:
                    a = o;
            }
            if ("sending" == n.emailing && (a += p.s_statusline_sendemail), "sent" == n.emailing && (a += n.emailreponse),
                !a && n.calculating && (a = p.s_statusline_calculating), !(n.calculating || n.command || a || !e.range.hasrange || e.range.left == e.range.right && e.range.top == e.range.bottom)) {
                for (h = 0, c = e.range.top; c <= e.range.bottom; c++)
                    for (u = e.range.left; u <= e.range.right; u++) d = e.context.sheetobj.cells[t.crToCoord(u, c)],
                        d && d.valuetype && "n" == d.valuetype.charAt(0) && (h += d.datavalue - 0);
                h = t.FormatNumber.formatNumberWithFormat(h, "[,]General", ""), s = t.crToCoord(e.range.left, e.range.top) + ":" + t.crToCoord(e.range.right, e.range.bottom),
                    a = s + " (" + (e.range.right - e.range.left + 1) + "x" + (e.range.bottom - e.range.top + 1) + ") " + p.s_statusline_sum + "=" + h + " " + a;
            }

            return r = (e.ecell || {}).coord + " &nbsp; " + a, n.calculating || "yes" != e.context.sheetobj.attribs.needsrecalc || (r += " &nbsp; " + p.s_statusline_recalcneeded),
                l = e.context.sheetobj.attribs.circularreferencecell, l && (l = l.replace(/\|/, " referenced by "),
                    r += " &nbsp; " + p.s_statusline_circref + l + "</span>"), r += "";
        }, t.EditorMouseInfo = {
            registeredElements: [],
            editor: null,
            element: null,
            ignore: !1,
            mousedowncoord: "",
            mouselastcoord: "",
            mouseresizecol: "",
            mouseresizeclientx: null,
            mouseresizedisplay: null
        }, t.EditorMouseRegister = function (e) {
            var o, i = t.EditorMouseInfo,
                n = e.fullgrid;
            for (o = 0; o < i.registeredElements.length; o++)
                if (i.registeredElements[o].editor == e) {
                    if (i.registeredElements[o].element == n) return;
                    break;
                }
            if (o < i.registeredElements.length ? i.registeredElements[o].element = n : i.registeredElements.push({
                    element: n,
                    editor: e
                }), n.addEventListener) n.addEventListener("mousedown", t.ProcessEditorMouseDown, !1),
                n.addEventListener("dblclick", t.ProcessEditorDblClick, !1);
            else {
                if (!n.attachEvent) throw "Browser not supported";
                n.attachEvent("onmousedown", t.ProcessEditorMouseDown), n.attachEvent("ondblclick", t.ProcessEditorDblClick);
            }
            i.ignore = !1;
        }, t.EditorMouseUnregister = function (e) {
            {
                var o, i, n = t.EditorMouseInfo;
                e.fullgrid;
            }
            for (o = 0; o < n.registeredElements.length && n.registeredElements[o].editor != e; o++);
            o < n.registeredElements.length && (i = n.registeredElements[o].element, i.removeEventListener ? (i.removeEventListener("mousedown", t.ProcessEditorMouseDown, !1),
                i.removeEventListener("dblclick", t.ProcessEditorDblClick, !1)) : i.detachEvent && (i.detachEvent("onmousedown", t.ProcessEditorMouseDown),
                i.detachEvent("ondblclick", t.ProcessEditorDblClick)), n.registeredElements.splice(o, 1));
        }, t.StopPropagation = function (e) {
            e.stopPropagation ? e.stopPropagation() : e.cancelBubble = !0, e.preventDefault ? e.preventDefault() : e.returnValue = !1;
        }, t.SetMouseMoveUp = function (e, o, i, n) {
            document.addEventListener ? (document.addEventListener("mousemove", e, !0), document.addEventListener("mouseup", o, !0)) : i.attachEvent && (i.setCapture(),
                    i.attachEvent("onmousemove", e), i.attachEvent("onmouseup", o), i.attachEvent("onlosecapture", o)),
                t.StopPropagation(n);
        }, t.RemoveMouseMoveUp = function (e, o, i, n) {
            t.StopPropagation(n), document.removeEventListener ? (document.removeEventListener("mousemove", e, !0),
                document.removeEventListener("mouseup", o, !0)) : i.detachEvent && (i.detachEvent("onlosecapture", o),
                i.detachEvent("onmouseup", o), i.detachEvent("onmousemove", e), i.releaseCapture());
        }, t.ProcessEditorMouseDown = function (o) {
            var i, n, r, a, s = o || e.event,
                l = t.EditorMouseInfo,
                c = s.target || s.srcElement,
                u = c;
            3 == u.nodeType && (u = u.parentNode);
            var d;
            if (!l.ignore) {
                for (d = null; !d && c; c = c.parentNode) d = t.LookupElement(c, l.registeredElements);
                if (!d) return void(l.editor = null);
                i = d.editor, l.element = c, a = i.range;
                var h = t.GetElementPositionWithScroll(i.toplevel),
                    p = s.clientX - h.left,
                    f = s.clientY - h.top;
                if (n = t.GridMousePosition(i, p, f)) {
                    if (l.editor = i, n.rowheader) return void(n.rowselect ? t.ProcessEditorRowselectMouseDown(o, c, n) : t.ProcessEditorRowsizeMouseDown(o, c, n));
                    if (n.colheader) return void(n.colselect ? t.ProcessEditorColselectMouseDown(o, c, n) : t.ProcessEditorColsizeMouseDown(o, c, n));
                    if (n.coord) {
                        if (a.hasrange || o.shiftKey && i.RangeAnchor(), r = i.MoveECell(n.coord), 1 == t._app) return void t.CmdGotFocus(!0);
                        var m = i.context.sheetobj.cells[r];
                        if (m && "i" == m.valuetype.charAt(1)) {
                            var g = m.valuetype.substring(2),
                                v = g + "_" + r;
                            if (u && v == u.id) {
                                var b = document.getElementById(v);
                                t.CmdGotFocus(b);
                            }
                        } else a.hasrange && (o.shiftKey ? i.RangeExtend() : i.RangeRemove()), l.mousedowncoord = r,
                            l.mouselastcoord = r, i.EditorMouseRange(r), t.KeyboardSetFocus(i), "start" != i.state && i.inputBox && i.inputBox.element.focus(),
                            t.SetMouseMoveUp(t.ProcessEditorMouseMove, t.ProcessEditorMouseUp, c, s);
                    }
                }
            }
        }, t.EditorMouseRange = function (e, o) {
            var i, n, r = e.range;
            $container.find(".inputZone").find(".focus").val(e.range.anchorcoord + ":" + e.ecell.coord);
            $container.find(".inputZone").find(".focusTitle").val(e.ecell.coord);
            $container.find(".inputZone").find(".focusLegend").val(e.ecell.coord);

            // zoneToChart("A1:B10");
            dataToChart = zoneToChart(e.range.anchorcoord + ":" + e.ecell.coord);

            function zoneToChart(zone) {
                /* 
                The longest list of labels become the LABELS in chart js system and the shortest :LABEL(title of...)
                */
                var xtrems = zone.split(":");
                var regexCol = /[A-Z]/g;
                var regexLine = /\d/g;
                var firstCol = xtrems[0].match(regexCol);
                var lastCol = xtrems[1].match(regexCol);
                var alphab = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.split('');
                var iLF, iLL, dimCol, dimRow, orient, LetterAfter;
                var firstLine = xtrems[0].match(regexLine);
                var lastLine = xtrems[1].match(regexLine).join('');
                var cZone = {
                    firstCol: firstCol,
                    lastCol: lastCol,
                    firstLine: "",
                    lastLine: "",
                    labels: [],
                    data: [],
                    title: []
                };

                if (firstLine != null) {
                    firstLine = firstLine.join('');
                };
                if (firstCol != null) {
                    for (let i = 0; i < alphab.length; i++) {
                        if (firstCol[0] == alphab[i]) {
                            iLF = i;
                        }
                        if (lastCol[0] == alphab[i]) {
                            iLL = i;
                        }
                    }
                }
                dimCol = iLL - iLF;
                dimRow = lastLine - firstLine;
                orient = dimRow - dimCol;
                LetterAfter = iLF + 1;
                cZone.title = firstCol + firstLine;
                cZone.hLabels = [alphab[LetterAfter] + firstLine, lastCol + firstLine];
                cZone.vLabels = [firstCol + (parseInt(firstLine) + 1), firstCol + lastLine];
                if (dimRow > 1 && dimCol > 1) { //Multidimension
                    cZone.datasets = {};
                    cZone.datasets.labels = []; // Cell coord for labels
                    cZone.datasets.data = []; // cell coord for datas
                    if (orient >= 0) { // Horizontal
                        for (let i = 0; i < dimCol; i++) {
                            cZone.dim = "MDH"; //MultiDimHorizontal
                            cZone.datasets.data.push([alphab[LetterAfter + i] + (parseInt(firstLine) + 1) + ':' + alphab[LetterAfter + i] + lastLine]);
                        }
                    } else { //vertical
                        for (let i = 0; i < dimRow; i++) {
                            cZone.dim = "MDV"; //MultiDimVertical 
                            cZone.datasets.data.push([alphab[LetterAfter] + (parseInt(firstLine) + 1 + i) + ':' + lastCol + (parseInt(firstLine) + i)]);
                        }
                    }
                } else { // 2 dimensions
                    if (orient >= 0) {
                        cZone.dim = "2DH"; //2DimHorizontal
                        //cZone.labels = [firstCol+(parseInt(firstLine)+1), firstCol+lastLine];
                        cZone.data = [alphab[LetterAfter] + (parseInt(firstLine) + 1), lastCol + lastLine];
                    } else {
                        cZone.dim = "2DV"; //ZDimVertical
                        //cZone.labels = [alphab[LetterAfter] + firstLine, lastCol + firstLine];
                        cZone.data = [alphab[LetterAfter] + (parseInt(firstLine) + 1), lastCol + lastLine];

                    }

                }


                return cZone
            }
            if (e.chartToolstate == "actif") {
                loadFromCells(focusInput, machin)
            }

            switch (e.state) {
                case "input":
                    i = e.inputBox.GetText(), n = e.workingvalues, ("(+-*/,:!&<>=^".indexOf(i.slice(-1)) >= 0 && "=" == i.slice(0, 1) || "=" == i) && (n.partialexpr = i),
                        n.partialexpr ? o && e.inputBox.SetText(r.hasrange ? n.partialexpr + t.crToCoord(r.left, r.top) + ":" + t.crToCoord(r.right, r.bottom) : n.partialexpr + o) : (e.inputBox.Blur(),
                            e.inputBox.ShowInputBox(!1), e.state = "start", e.cellhandles.ShowCellHandles(!0),
                            e.EditorSaveEdit(), e.inputBox.DisplayCellContents(null));
                    break;

                case "inputboxdirect":
                    e.inputBox.Blur(), e.inputBox.ShowInputBox(!1), e.state = "start", e.cellhandles.ShowCellHandles(!0),
                        e.EditorSaveEdit(), e.inputBox.DisplayCellContents(null);
            }
        }, t.ProcessEditorMouseMove = function (o) {
            var i, n, r, a = o || e.event,
                s = t.EditorMouseInfo;
            if (i = s.editor, i && !s.ignore) {
                n = s.element;
                var l = t.GetElementPositionWithScroll(i.toplevel),
                    c = a.clientX - l.left,
                    u = a.clientY - l.top;
                if (r = t.GridMousePosition(i, c, u)) {
                    if (r && !r.coord) return void t.SetDragAutoRepeat(i, r);
                    t.SetDragAutoRepeat(i, null), r.coord && (r.coord != s.mouselastcoord && (o.shiftKey || i.range.hasrange || i.RangeAnchor(s.mousedowncoord),
                            i.MoveECell(r.coord), i.RangeExtend()), s.mouselastcoord = r.coord, i.EditorMouseRange(r.coord),
                        t.StopPropagation(a));
                }
            }
        }, t.ProcessEditorMouseUp = function (o) {
            var i, n, r, a = o || e.event,
                s = t.EditorMouseInfo;

            if (i = s.editor, i && !s.ignore) {
                n = s.element;
                var l = t.GetElementPositionWithScroll(i.toplevel),
                    c = a.clientX - l.left,
                    u = a.clientY - l.top;
                if (r = t.GridMousePosition(i, c, u), t.SetDragAutoRepeat(i, null), r) return r.coord || (r.coord = i.ecell.coord),
                    i.range.hasrange ? (i.MoveECell(r.coord), i.RangeExtend()) : r.coord && r.coord != s.mousedowncoord && (i.RangeAnchor(s.mousedowncoord),
                        i.MoveECell(r.coord), i.RangeExtend()), i.EditorMouseRange(r.coord), s.editor = null,
                    t.RemoveMouseMoveUp(t.ProcessEditorMouseMove, t.ProcessEditorMouseUp, n, a), !1;
            }
        }, t.ProcessEditorColsizeMouseDown = function (o, i, n) {
            var r = o || e.event,
                a = t.EditorMouseInfo,
                s = a.editor,
                l = t.GetElementPositionWithScroll(s.toplevel),
                c = r.clientX - l.left;
            if (a.mouseresizecolnum = n.coltoresize, a.mouseresizecol = t.rcColname(n.coltoresize),
                a.mousedownclientx = c, a.mousecoltounhide = n.coltounhide, n.coltoresize) {
                var u = document.createElement("div");
                a.mouseresizedisplay = u, u.style.width = "auto", u.style.position = "absolute",
                    u.style.zIndex = 100, u.style.top = s.headposition.top + "px", u.style.left = s.colpositions[n.coltoresize] + "px",
                    u.innerHTML = '<table cellpadding="0" cellspacing="0"><tr><td style="height:100px;border:1px dashed black;background-color:white;width:' + (s.context.colwidth[a.mouseresizecolnum] - 2) + 'px;">&nbsp;</td><td><div style="font-size:small;color:white;background-color:gray;padding:4px;">' + s.context.colwidth[a.mouseresizecolnum] + "</div></td></tr></table>",
                    t.setStyles(u.firstChild.lastChild.firstChild.childNodes[0], "filter:alpha(opacity=85);opacity:.85;"),
                    s.toplevel.appendChild(u);
            }


            t.SetMouseMoveUp(t.ProcessEditorColsizeMouseMove, t.ProcessEditorColsizeMouseUp, s.toplevel, r);
        }, t.ProcessEditorColsizeMouseMove = function (o) {
            var i = o || e.event,
                n = t.EditorMouseInfo,
                r = n.editor;
            if (r) {
                if (n.mouseresizecolnum) {
                    var a = t.GetElementPositionWithScroll(r.toplevel),
                        s = i.clientX - a.left,
                        l = r.context.colwidth[n.mouseresizecolnum] - 0 + (s - n.mousedownclientx);
                    l < t.Constants.defaultMinimumColWidth && (l = t.Constants.defaultMinimumColWidth);
                    var c = n.mouseresizedisplay;
                    c.innerHTML = '<table class="tabos" cellpadding="0" cellspacing="0"><tr><td style="height:100px;border:1px dashed black;background-color:white;width:' + (l - 2) + 'px;">&nbsp;</td><td><div style="font-size:small;color:white;background-color:gray;padding:4px;">' + l + "</div></td></tr></table>",
                        t.setStyles(c.firstChild.lastChild.firstChild.childNodes[0], "filter:alpha(opacity=85);opacity:.85;");
                }
                t.StopPropagation(i);
            }
        }, t.ProcessEditorColsizeMouseUp = function (o) {
            var i = o || e.event,
                n = t.EditorMouseInfo,
                r = n.editor;
            if (r) {
                element = n.element;
                var a = t.GetElementPositionWithScroll(r.toplevel),
                    s = i.clientX - a.left;
                if (t.RemoveMouseMoveUp(t.ProcessEditorColsizeMouseMove, t.ProcessEditorColsizeMouseUp, r.toplevel, i),
                    n.mousecoltounhide) r.EditorScheduleSheetCommands("set " + t.rcColname(n.mousecoltounhide) + " hide", !0, !1);
                else if (n.mouseresizecolnum) {
                    var l = r.context.colwidth[n.mouseresizecolnum] - 0 + (s - n.mousedownclientx);
                    l < t.Constants.defaultMinimumColWidth && (l = t.Constants.defaultMinimumColWidth),
                        r.EditorScheduleSheetCommands("set " + n.mouseresizecol + " width " + l, !0, !1),
                        r.timeout && e.clearTimeout(r.timeout), r.timeout = e.setTimeout(t.FinishColRowSize, 1);
                    if ($.isArray(config.colRows)) { //Becareful array in object needs $.isArray
                        config.colRows.push("set " + n.mouseresizecol + " width " + l);
                    } //JP MODFIFY COL WIDTH
                }
                return !1;
            }
        }, t.FinishColRowSize = function () {
            var e = t.EditorMouseInfo,
                o = e.editor;
            o && (o.toplevel.removeChild(e.mouseresizedisplay), e.mouseresizedisplay = null,
                e.editor = null);
        }, t.ProcessEditorRowselectMouseDown = function (o, i, n) {
            var r = o || e.event,
                a = t.EditorMouseInfo,
                s = a.editor,
                l = t.GetSpreadsheetControlObject().sheet;
            coord1 = t.crToCoord(1, n.row), coord2 = t.crToCoord(l.LastCol(), n.row), coord3 = t.crToCoord(s.firstscrollingcol, n.row),
                s.RangeAnchor(coord1), s.RangeExtend(coord2), s.MoveECell(coord3), t.SetMouseMoveUp(t.ProcessEditorRowselectMouseMove, t.ProcessEditorRowselectMouseUp, s.toplevel, r);
        }, t.ProcessEditorRowselectMouseMove = function (o) {
            var i = o || e.event,
                n = t.EditorMouseInfo,
                r = n.editor,
                a = t.GetSpreadsheetControlObject().sheet;
            if (r) {
                var s = t.GetElementPositionWithScroll(r.toplevel),
                    l = i.clientX - s.left,
                    c = i.clientY - s.top;
                result = t.GridMousePosition(r, l, c), coord2 = t.crToCoord(a.LastCol(), result.row),
                    coord3 = t.crToCoord(r.firstscrollingcol, result.row), r.RangeExtend(coord2), r.MoveECell(coord3);
            }
        }, t.ProcessEditorRowselectMouseUp = function (o) {
            var i = (o || e.event, t.EditorMouseInfo),
                n = i.editor;
            n && t.RemoveMouseMoveUp(t.ProcessEditorRowselectMouseMove, t.ProcessEditorRowselectMouseUp, n.toplevel, o);
        }, t.ProcessEditorColselectMouseDown = function (o, i, n) {
            var r = o || e.event,
                a = t.EditorMouseInfo,
                s = a.editor,
                l = t.GetSpreadsheetControlObject().sheet;
            coord1 = t.crToCoord(n.col, 1), coord2 = t.crToCoord(n.col, l.LastRow()), coord3 = t.crToCoord(n.col, s.firstscrollingrow),
                s.RangeAnchor(coord1), s.RangeExtend(coord2), s.MoveECell(coord3), t.SetMouseMoveUp(t.ProcessEditorColselectMouseMove, t.ProcessEditorColselectMouseUp, s.toplevel, r);
        }, t.ProcessEditorColselectMouseMove = function (o) {
            var i = o || e.event,
                n = t.EditorMouseInfo,
                r = n.editor,
                a = t.GetSpreadsheetControlObject().sheet;
            if (r) {
                var s = t.GetElementPositionWithScroll(r.toplevel),
                    l = i.clientX - s.left,
                    c = i.clientY - s.top;
                result = t.GridMousePosition(r, l, c), coord2 = t.crToCoord(result.col, a.LastRow()),
                    coord3 = t.crToCoord(result.col, r.firstscrollingrow), r.RangeExtend(coord2), r.MoveECell(coord3);
            }
        }, t.ProcessEditorColselectMouseUp = function (o) {
            var i = (o || e.event, t.EditorMouseInfo),
                n = i.editor;
            n && t.RemoveMouseMoveUp(t.ProcessEditorColselectMouseMove, t.ProcessEditorColselectMouseUp, n.toplevel, o);
        }, t.ProcessEditorRowsizeMouseDown = function (o, i, n) {
            var r = o || e.event,
                a = t.EditorMouseInfo,
                s = a.editor,
                l = t.GetSpreadsheetControlObject().spreadsheetDiv.firstChild.offsetHeight,
                c = r.clientY - l;
            if (a.mouseresizerownum = n.rowtoresize, a.mouseresizerow = n.rowtoresize, a.mousedownclienty = c,
                a.mouserowtounhide = n.rowtounhide, n.rowtoresize) {
                var u = document.createElement("div");
                a.mouseresizedisplay = u, u.style.width = s.context.totalwidth + "px", u.style.height = s.rowpositions[n.rowtoresize] + "px",
                    u.style.position = "absolute", u.style.zIndex = 100, u.style.top = s.rowpositions[n.rowtoresize] + "px",
                    u.style.left = s.headposition.left + "px", u.innerHTML = '<table cellpadding="0" cellspacing="0"><tr><td style="width:100pxborder:1px dashed black;background-color:white;height:' + (s.context.rowheight[a.mouseresizerownum] - 2) + 'px;">&nbsp;</td><td><div style="font-size:small;color:white;background-color:gray;padding:4px;">' + s.context.rowheight[a.mouseresizerownum] + "</div></td></tr></table>",
                    t.setStyles(u.firstChild.lastChild.firstChild.childNodes[0], "filter:alpha(opacity=85);opacity:.5;"),
                    s.toplevel.appendChild(u);
            }
            t.SetMouseMoveUp(t.ProcessEditorRowsizeMouseMove, t.ProcessEditorRowsizeMouseUp, s.toplevel, r);
        }, t.ProcessEditorRowsizeMouseMove = function (o) {
            var i = o || e.event,
                n = t.EditorMouseInfo,
                r = n.editor;
            if (r) {
                if (n.mouseresizerownum) {
                    var a = t.GetSpreadsheetControlObject().spreadsheetDiv.firstChild.offsetHeight,
                        s = i.clientY - a,
                        l = r.context.rowheight[n.mouseresizerownum] - 0 + (s - n.mousedownclienty);
                    l < t.Constants.defaultAssumedRowHeight && (l = t.Constants.defaultAssumedRowHeight);
                    var c = n.mouseresizedisplay;
                    c.innerHTML = '<table cellpadding="0" cellspacing="0"><tr><td style="width:100px;border:1px dashed black;background-color:white;height:' + (l - 2) + 'px;">&nbsp;</td><td><div style="font-size:small;color:white;background-color:gray;padding:4px;">' + l + "</div></td></tr></table>",
                        t.setStyles(c.firstChild.lastChild.firstChild.childNodes[0], "filter:alpha(opacity=85);opacity:.5;");
                }
                t.StopPropagation(i);
            }
        }, t.ProcessEditorRowsizeMouseUp = function (o) {
            var i = o || e.event,
                n = t.EditorMouseInfo,
                r = n.editor;
            if (r) {
                element = n.element;
                var a = t.GetSpreadsheetControlObject().spreadsheetDiv.firstChild.offsetHeight,
                    s = i.clientY - a;
                if (t.RemoveMouseMoveUp(t.ProcessEditorRowsizeMouseMove, t.ProcessEditorRowsizeMouseUp, r.toplevel, i),
                    n.mouserowtounhide) r.EditorScheduleSheetCommands("set " + n.mouserowtounhide + " hide", !0, !1);
                else if (n.mouseresizerownum) {
                    var l = r.context.rowheight[n.mouseresizerownum] - 0 + (s - n.mousedownclienty);
                    l < t.Constants.defaultAssumedRowHeight && (l = t.Constants.defaultAssumedRowHeight),
                        r.EditorScheduleSheetCommands("set " + n.mouseresizerownum + " height " + l, !0, !1),
                        r.timeout && e.clearTimeout(r.timeout), r.timeout = e.setTimeout(t.FinishColRowSize, 1);
                    if ($.isArray(config.colRows)) {
                        config.colRows.push("set " + n.mouseresizerownum + " height " + l);
                    } //JP MODFIFY ROW WIDTH;
                }
                return !1;
            }
        }, t.AutoRepeatInfo = {
            timer: null,
            mouseinfo: null,
            repeatinterval: 1e3,
            editor: null,
            repeatcallback: null
        }, t.SetDragAutoRepeat = function (o, i, n) {
            var r, a, s = t.AutoRepeatInfo;
            if (s.repeatcallback = n, !i) return s.timer && (e.clearTimeout(s.timer), s.timer = null),
                void(s.mouseinfo = null);
            if (s.editor = o, s.mouseinfo && (i.rowheader || i.rowfooter ? i.row != s.mouseinfo.row && (r = t.crToCoord(o.ecell.col, i.row),
                    s.repeatcallback ? (a = i.row < s.mouseinfo.row ? "left" : i.row > s.mouseinfo.row ? "right" : "",
                        s.repeatcallback(r, a)) : (o.MoveECell(r), o.MoveECell(r), o.RangeExtend(), o.EditorMouseRange(r))) : (i.colheader || i.colfooter) && i.col != s.mouseinfo.col && (r = t.crToCoord(i.col, o.ecell.row),
                    s.repeatcallback ? (a = i.row < s.mouseinfo.row ? "left" : i.row > s.mouseinfo.row ? "right" : "",
                        s.repeatcallback(r, a)) : (o.MoveECell(r), o.RangeExtend(), o.EditorMouseRange(r)))),
                s.mouseinfo = i, i.distance < 5) s.repeatinterval = 333;
            else if (i.distance < 10) s.repeatinterval = 250;
            else if (i.distance < 25) s.repeatinterval = 100;
            else {
                if (!(i.distance < 35)) return void(s.timer && (e.clearTimeout(s.timer), s.timer = null));
                s.repeatinterval = 75;
            }
            s.timer || (s.timer = e.setTimeout(t.DragAutoRepeat, s.repeatinterval));
        }, t.DragAutoRepeat = function () {
            var o, i, n, r = t.AutoRepeatInfo,
                a = r.mouseinfo;
            a.rowheader ? o = "left" : a.rowfooter ? o = "right" : a.colheader ? o = "up" : a.colfooter && (o = "down"),
                r.repeatcallback ? (n = t.coordToCr(r.editor.ecell.coord), "left" == o && n.col > 1 ? n.col-- : "right" == o ? n.col++ : "up" == o && n.row > 1 ? n.row-- : "down" == o && n.row++,
                    i = t.crToCoord(n.col, n.row), r.repeatcallback(i, o)) : (i = r.editor.MoveECellWithKey("[a" + o + "]shifted"),
                    i && r.editor.EditorMouseRange(i)), r.timer = e.setTimeout(t.DragAutoRepeat, r.repeatinterval);
        }, t.ProcessEditorDblClick = function (o) {
            var i, n, r, a, s = o || e.event,
                l = t.EditorMouseInfo,
                c = s.target || s.srcElement;
            if (!l.ignore) {
                for (a = null; !a && c; c = c.parentNode) a = t.LookupElement(c, l.registeredElements);
                if (!a) return void(l.editor = null);
                i = a.editor;
                var u = t.GetElementPositionWithScroll(i.toplevel),
                    d = s.clientX - u.left,
                    h = s.clientY - u.top;
                if (n = t.GridMousePosition(i, d, h), n && n.coord) {
                    switch (l.editor = i, l.element = c, r = i.range, sheetobj = i.context.sheetobj,
                        i.state) {
                        case "start":
                            t.EditorOpenCellEdit(i);
                            break;

                        case "input":
                    }
                    t.StopPropagation(s);
                }
            }
        }, t.EditorOpenCellEdit = function (e) {
            var t;

            return e.ecell && e.inputBox ? e.inputBox.element.disabled ? !0 : (e.inputBox.ShowInputBox(!0),
                e.inputBox.Focus(), e.inputBox.SetText(""), e.inputBox.DisplayCellContents(), e.inputBox.Select("end"),
                t = e.workingvalues, t.partialexpr = "", t.ecoord = e.ecell.coord, t.erow = e.ecell.row,
                void(t.ecol = e.ecell.col)) : !0;
        }, t.EditorProcessKey = function (e, o, i) {
            var n, r, a, s, l = (e.context.sheetobj, e.workingvalues),
                c = e.range;
            switch ("string" != typeof o && (o = ""), e.state) {
                case "start":
                    if (i.shiftKey && "[a" == o.substr(0, 2) && (o += "shifted"), "[enter]" == o && (o = "[adown]"),
                        "[tab]" == o && (o = i.shiftKey ? "[aleft]" : "[aright]"), "[a" == o.substr(0, 2) || "[pg" == o.substr(0, 3) || "[home]" == o) return n = e.MoveECellWithKey(o),
                        !n;
                    if ("[del]" == o || "[backspace]" == o) {
                        e.noEdit || e.ECellReadonly() || e.EditorApplySetCommandsToRange("empty", "");
                        let dellCellsArr = [];
                        if (e.range.hasrange) {
                            function orderToLetter(c1) {
                                let alphab = '0ABCDEFGHIJKLMNOPQRSTUVWXYZ'.split('');
                                return alphab[c1];
                            } // JP range scan to build del array
                            for (let i = e.range.left; i < e.range.right + 1; i++) {
                                let lettercellToDel = orderToLetter(i);
                                for (let y = e.range.top; y < e.range.bottom + 1; y++) {
                                    let cellToDel = lettercellToDel + y;
                                    dellCellsArr.push(cellToDel);
                                    if(typeof config.cells !== "undefined"){
                                    for (let i = 0; i < config.cells.length; i++) {
                                        if (config.cells[i].search(cellToDel) > 0) {
                                            config.cells.splice(i, 1);
                                        }
                                    }}
                                }
                            }                           
                        } else {
                            if(typeof config.cells !== "undefined"){
                                for (let i = 0; i < config.cells.length; i++) {
                                    
                                    let candidat = "set " + e.ecell.coord;
                                    
                                    if (config.cells[i].search(candidat) == 0) {
                                        
                                        config.cells.splice(i, 1);
                                    }
                                }
                            }
                        }
                        break;
                    }
                    if ("[esc]" == o) {
                        if (c.hasrange) {
                            e.RangeRemove(), e.MoveECell(c.anchorcoord);
                            for (s in e.StatusCallback) e.StatusCallback[s].func(e, "specialkey", o, e.StatusCallback[s].params);
                        }
                        return !1;
                    }
                    if ("[f2]" == o) return e.noEdit || e.ECellReadonly() ? !0 : (t.EditorOpenCellEdit(e),
                        e.state = "inputboxdirect", !1);
                    if (o.length > 1 && "[" == o.substr(0, 1) || 0 == o.length) return e.ctrlkeyFunction && o.length > 0 ? e.ctrlkeyFunction(e, o) : !0;
                    if (!e.ecell) return !0;
                    if (!e.inputBox) return !0;
                    if (e.ECellReadonly()) return !0;
                    e.inputBox.element.disabled = !1, e.state = "input", e.inputBox.ShowInputBox(!0),
                        e.inputBox.Focus(), e.inputBox.SetText(o), e.inputBox.Select("end"), l.partialexpr = "",
                        l.ecoord = e.ecell.coord, l.erow = e.ecell.row, l.ecol = e.ecell.col, e.RangeRemove();
                    break;

                case "input":
                    if (a = e.inputBox.GetText(), e.inputBox.skipOne) return !1;
                    if ("[esc]" == o || "[enter]" == o || "[tab]" == o || o && "[a" == o.substr(0, 2)) {
                        if (("(+-*/,:!&<>=^".indexOf(a.slice(-1)) >= 0 && "=" == a.slice(0, 1) || "=" == a) && (l.partialexpr = a),
                            l.partialexpr && (i.shiftKey && "[a" == o.substr(0, 2) && (o += "shifted"), r = e.MoveECellWithKey(o))) return e.inputBox.SetText(c.hasrange ? l.partialexpr + t.crToCoord(c.left, c.top) + ":" + t.crToCoord(c.right, c.bottom) : l.partialexpr + r),
                            !1;
                        e.inputBox.Blur(), e.inputBox.ShowInputBox(!1), e.state = "start", e.cellhandles.ShowCellHandles(!0),
                            "[esc]" != o ? (e.EditorSaveEdit(), e.ecell.coord != l.ecoord && e.MoveECell(l.ecoord),
                                "[enter]" == o && (o = "[adown]"), "[tab]" == o && (o = i.shiftKey ? "[aleft]" : "[aright]"),
                                "[a" == o.substr(0, 2) && e.MoveECellWithKey(o)) : (e.inputBox.DisplayCellContents(),
                                e.RangeRemove(), e.MoveECell(l.ecoord));
                        break;
                    }
                    return l.partialexpr && "[backspace]" == o ? (e.inputBox.SetText(l.partialexpr),
                        l.partialexpr = "", e.RangeRemove(), e.MoveECell(l.ecoord), e.inputBox.ShowInputBox(!0),
                        !1) : "[f2]" == o ? (e.state = "inputboxdirect", !1) : (c.hasrange && e.RangeRemove(),
                        e.MoveECell(l.ecoord), l.partialexpr && (e.inputBox.ShowInputBox(!0), l.partialexpr = ""),
                        !0);

                case "inputboxdirect":
                    if (a = e.inputBox.GetText(), "[esc]" == o || "[enter]" == o || "[tab]" == o) {
                        e.inputBox.Blur(), e.inputBox.ShowInputBox(!1), e.state = "start", e.cellhandles.ShowCellHandles(!0),
                            "[esc]" == o ? e.inputBox.DisplayCellContents() : (e.EditorSaveEdit(), e.ecell.coord != l.ecoord && e.MoveECell(l.ecoord),
                                "[enter]" == o && (o = "[adown]"), "[tab]" == o && (o = i.shiftKey ? "[aleft]" : "[aright]"),
                                "[a" == o.substr(0, 2) && e.MoveECellWithKey(o));
                        break;
                    }
                    return "[f2]" == o ? (e.state = "input", !1) : !0;

                case "skip-and-start":
                    return e.state = "start", e.cellhandles.ShowCellHandles(!0), !1;

                default:
                    return !0;
            }
            return !1;
        }, t.EditorAddToInput = function (e, t, o) {
            var i = e.workingvalues;
            if (!e.noEdit && !e.ECellReadonly()) switch (e.state) {
                case "start":
                    e.state = "input", e.inputBox.ShowInputBox(!0), e.inputBox.element.disabled = !1,
                        e.inputBox.Focus(), e.inputBox.SetText((o || "") + t), e.inputBox.Select("end"),
                        i.partialexpr = "", i.ecoord = e.ecell.coord, i.erow = e.ecell.row, i.ecol = e.ecell.col,
                        e.RangeRemove();
                    break;

                case "input":
                case "inputboxdirect":
                    e.inputBox.element.focus(), i.partialexpr && (e.inputBox.SetText(i.partialexpr),
                        i.partialexpr = "", e.RangeRemove(), e.MoveECell(i.ecoord)), e.inputBox.SetText(e.inputBox.GetText() + t);
            }
        }, t.EditorDisplayCellContents = function (e) {
            e.inputBox && e.inputBox.DisplayCellContents();
        }, t.EditorSaveEdit = function (e, o) {
            var i, n, r, a, s, l, c = e.context.sheetobj,
                u = e.workingvalues;
            r = "text t",
                //a = "string" == typeof o ? o : e.inputBox.GetText(), // JP INPUT VALUE IN CELL!
                o = e.inputBox.GetText();
            if (typeof o == "string") {
                a = o;
            }
            
            s = t.GetCellContents(c, u.ecoord) + "",
                //Identify = for formula case
                a != s && (n = a.charAt(0), "=" == n && -1 == a.indexOf("\n") ?
                    (r = "formula", a = a.substring(1)) : "'" == n ?
                    (r = "text t", a = a.substring(1), i = t.DetermineValueType(a), "t" == i.type.charAt(0) && (r = "text " + i.type)) : 0 == a.length ?
                    r = "empty" : (i = t.DetermineValueType(a),
                        r = "n" == i.type && a == i.value + "" ?
                        "value n" : "t" == i.type.charAt(0) ?
                        "text " + i.type : "" == i.type ?
                        "text t" : "constant " + i.type + " " + i.value), // JP i.value = transformed inputBox.GetText !!!!!!!
                    "t" == r.charAt(0) && (a = t.encodeForSave(a)),
                    l = "set " + u.ecoord + " " + r + " " + a,
                    e.EditorScheduleSheetCommands(l, !0, !1), "undefined" != typeof c.ioEventTree && "undefined" != typeof c.ioParameterList && "undefined" != typeof c.ioEventTree[u.ecoord] && t.EditedTriggerCell(c.ioEventTree[u.ecoord], u.ecoord, e, c));

           
            if ($.isArray(config.cells)) {
                config.cells.push(l); //JP Get cells to config.cells
            }
        }, t.EditedTriggerCell = function (e, t, o, i) {
            for (var n in e) {
                var r = i.ioParameterList[n];
                if ("undefined" != typeof r) switch (r.function_name) {
                    case "EMAILONEDIT":
                    case "EMAILONEDITIF":
                        cmdline = "setemailparameters " + n + " " + t, o.deferredEmailCommands.push({
                            cmdstr: cmdline,
                            saveundo: !1
                        });
                }
            }
        }, t.EditorApplySetCommandsToRange = function (e, o) {
            var i, n, r = (e.context.sheetobj, e.ecell),
                a = e.range;
            a.hasrange ? (coord = t.crToCoord(a.left, a.top) + ":" + t.crToCoord(a.right, a.bottom),
                i = "set " + coord + " " + o, n = e.EditorScheduleSheetCommands(i, !0, !1)) : (i = "set " + r.coord + " " + o,
                n = e.EditorScheduleSheetCommands(i, !0, !1)), e.DisplayCellContents();
        }, t.EditorProcessMouseWheel = function (e, t, o, i) {
            i.functionobj.editor.busy || (t > 0 && i.functionobj.editor.ScrollRelative(!0, Math.floor(1.5 * -t)),
                0 > t && i.functionobj.editor.ScrollRelative(!0, Math.ceil(1.5 * -t)));
        }, t.GridMousePosition = function (e, o, i) {
            var n, r, a, s, l, c, u = {};
            for (n = 1; n < e.rowpositions.length && !(e.rowheight[n] && e.rowpositions[n] + e.rowheight[n] > i); n++);
            for (a = 1; a < e.colpositions.length && !(e.colwidth[a] && e.colpositions[a] + e.colwidth[a] > o); a++);
            if (u.row = n, u.col = a, e.headposition && 1 != t._app) {
                if (o < e.headposition.left && o >= e.gridposition.left) {
                    for (u.rowheader = !0, u.distance = e.headposition.left - o, u.rowtoresize = !1,
                        u.rowselect = !1, l = 1; l < e.rowpositions.length; l++)
                        if (e.rowheight[l] && e.rowpositions[l] + e.rowheight[l] - 3 <= i && e.rowpositions[l] + e.rowheight[l] + 3 >= i) {
                            u.rowtoresize = l;
                            break;
                        }
                    if ((unhide = e.context.rowunhidetop[n]) && (pos = t.GetElementPosition(unhide),
                            o >= pos.left && o < pos.left + unhide.offsetWidth && i >= e.rowpositions[n] + e.rowheight[n] - unhide.offsetHeight && i < e.rowpositions[n] + e.rowheight[n] && (u.rowtounhide = n + 1)),
                        (unhide = e.context.rowunhidebottom[n]) && (pos = t.GetElementPosition(unhide),
                            o >= pos.left && o < pos.left + unhide.offsetWidth && i >= e.rowpositions[n] && i < e.rowpositions[n] + unhide.offsetHeight && (u.rowtounhide = n - 1)),
                        null == u.rowtounhide) {
                        for (r = 0; r < e.context.rowpanes.length; r++)
                            if (u.rowtoresize >= e.context.rowpanes[r].first && u.rowtoresize <= e.context.rowpanes[r].last) return u;
                        u.rowselect = !0;
                    }
                    return delete u.rowtoresize, u;
                }
                if (i < e.headposition.top && i > e.gridposition.top) {
                    for (u.colheader = !0, u.distance = e.headposition.top - i, u.coltoresize = !1,
                        u.colselect = !1, c = 1; c < e.colpositions.length; c++)
                        if (e.colwidth[c] && e.colpositions[c] + e.colwidth[c] - 3 <= o && e.colpositions[c] + e.colwidth[c] + 3 >= o) {
                            u.coltoresize = c;
                            break;
                        }
                    if ((unhide = e.context.colunhideleft[a]) && (pos = t.GetElementPosition(unhide),
                            o >= pos.left && o < pos.left + unhide.offsetWidth && i >= pos.top && i < pos.top + unhide.offsetHeight && (u.coltounhide = a + 1)),
                        (unhide = e.context.colunhideright[a]) && (pos = t.GetElementPosition(unhide), o >= pos.left && o < pos.left + unhide.offsetWidth && i >= pos.top && i < pos.top + unhide.offsetHeight && (u.coltounhide = a - 1)),
                        null == u.coltounhide) {
                        for (s = 0; s < e.context.colpanes.length; s++)
                            if (u.coltoresize >= e.context.colpanes[s].first && u.coltoresize <= e.context.colpanes[s].last) return u;
                        u.colselect = !0;
                    }
                    return delete u.coltoresize, u;
                }
                return o >= e.verticaltablecontrol.controlborder ? (u.rowfooter = !0, u.distance = o - e.verticaltablecontrol.controlborder,
                    u) : i >= e.horizontaltablecontrol.controlborder ? (u.colfooter = !0, u.distance = i - e.horizontaltablecontrol.controlborder,
                    u) : o < e.gridposition.left ? (u.rowheader = !0, u.distance = e.headposition.left - o,
                    u) : i <= e.gridposition.top ? (u.colheader = !0, u.distance = e.headposition.top - i,
                    u) : (u.coord = t.crToCoord(u.col, u.row), e.context.cellskip[u.coord] && (u.coord = e.context.cellskip[u.coord]),
                    u);
            }
            return null;
        }, t.GetEditorCellElement = function (e, o, i) {
            var n = 0,
                r = 0;
            if (0 == e.context.showRCHeaders) var n = -1,
                r = -1;
            var a, s, l, c, u = 0,
                d = 0;
            for (a = 0; a < e.context.rowpanes.length; a++) {
                if (o >= e.context.rowpanes[a].first && o <= e.context.rowpanes[a].last)
                    for (s = 0; s < e.context.colpanes.length; s++) {
                        if (i >= e.context.colpanes[s].first && i <= e.context.colpanes[s].last) {
                            for (u += o - e.context.rowpanes[a].first + 2, l = e.context.colpanes[s].first; i >= l; l++) c = e.context.cellskip[t.crToCoord(l, o)],
                                c && e.context.CoordInPane(c, a, s) || d++;
                            return {
                                element: e.griddiv.firstChild.lastChild.childNodes[u + r].childNodes[d + n],
                                rowpane: a,
                                colpane: s
                            };
                        }
                        for (l = e.context.colpanes[s].first; l <= e.context.colpanes[s].last; l++) c = e.context.cellskip[t.crToCoord(l, o)],
                            c && e.context.CoordInPane(c, a, s) || d++;
                        d += 1;
                    }
                u += e.context.rowpanes[a].last - e.context.rowpanes[a].first + 1 + 1;
            }
            return null;
        }, t.MoveECellWithKey = function (e, o) {
            var i, n, r, a, s = !1,
                l = 1;
            if (!e.ecell) return null;
            switch ("shifted" == o.slice(-7) && (o = o.slice(0, -7), s = !0), n = e.ecell.row,
                r = e.ecell.col, a = e.context.sheetobj.cells[e.ecell.coord], o) {
                case "[adown]":
                    n += a && a.rowspan || 1;
                    break;

                case "[aup]":
                    n--, l = -1;
                    break;

                case "[pgdn]":
                    n += e.pageUpDnAmount - 1 + (a && a.rowspan || 1);
                    break;

                case "[pgup]":
                    n -= e.pageUpDnAmount, l = -1;
                    break;

                case "[aright]":
                    r += a && a.colspan || 1;
                    break;

                case "[aleft]":
                    r--, l = -1;
                    break;

                case "[home]":
                    n = 1, r = 1;
                    break;

                default:
                    return null;
            }
            for (e.context.sheetobj.attribs.usermaxcol && (r = Math.min(e.context.sheetobj.attribs.usermaxcol, r)),
                e.context.sheetobj.attribs.usermaxrow && (n = Math.min(e.context.sheetobj.attribs.usermaxrow, n));
                "yes" == e.context.sheetobj.colattribs.hide[t.rcColname(r)];) r += l,
                1 > r && (l = -l, r = 1);
            for (;
                "yes" == e.context.sheetobj.rowattribs.hide[n];) n += l, 1 > n && (l = -l,
                n = 1);
            return e.range.hasrange || s && e.RangeAnchor(), i = e.MoveECell(t.crToCoord(r, n)),
                e.range.hasrange && (s ? e.RangeExtend() : e.RangeRemove()), i;
        }, t.MoveECell = function (e, o) {
            var i, n, r = e.context.highlights,
                a = t.coordToCr(o);
            if (e.context.sheetobj.attribs.usermaxcol && a.col > e.context.sheetobj.attribs.usermaxcol && (a.col = e.context.sheetobj.attribs.usermaxcol),
                e.context.sheetobj.attribs.usermaxrow && a.row > e.context.sheetobj.attribs.usermaxrow && (a.row = e.context.sheetobj.attribs.usermaxrow),
                o = t.crToCoord(a.col, a.row), e.ecell) {
                if (e.ecell.coord == o) return o;
                i = t.GetEditorCellElement(e, e.ecell.row, e.ecell.col), delete r[e.ecell.coord],
                    e.range2.hasrange && e.ecell.row >= e.range2.top && e.ecell.row <= e.range2.bottom && e.ecell.col >= e.range2.left && e.ecell.col <= e.range2.right && (r[e.ecell.coord] = "range2"),
                    e.UpdateCellCSS(i, e.ecell.row, e.ecell.col), e.SetECellHeaders(""), e.cellhandles && e.cellhandles.ShowCellHandles(!1);
            }
            o = e.context.cellskip[o] || o, e.ecell = t.coordToCr(o), e.ecell.coord = o, i = t.GetEditorCellElement(e, e.ecell.row, e.ecell.col),
                r[o] = "cursor";
            for (n in e.MoveECellCallback) e.MoveECellCallback[n](e);
            e.UpdateCellCSS(i, e.ecell.row, e.ecell.col), e.SetECellHeaders("selected");
            for (n in e.StatusCallback) e.StatusCallback[n].func(e, "moveecell", o, e.StatusCallback[n].params);
            return e.busy ? e.ensureecell = !0 : (e.ensureecell = !1, e.EnsureECellVisible()),
                o;
        }, t.EnsureECellVisible = function (e) {
            var t = 0,
                o = 0;
            e.ecell.row > e.lastnonscrollingrow && (e.ecell.row < e.firstscrollingrow ? t = e.ecell.row - e.firstscrollingrow - Math.floor((e.lastvisiblerow - e.firstscrollingrow) / 2) : e.ecell.row + 1 > e.lastvisiblerow && (t = e.ecell.row - e.lastvisiblerow + Math.floor((e.lastvisiblerow - e.firstscrollingrow) / 2))),
                e.ecell.col > e.lastnonscrollingcol && (e.ecell.col < e.firstscrollingcol ? o = e.ecell.col - e.firstscrollingcol - Math.floor((e.lastvisiblecol - e.firstscrollingcol) / 2) : e.ecell.col + 1 > e.lastvisiblecol && (o = e.ecell.col - e.lastvisiblecol + Math.floor((e.lastvisiblecol - e.firstscrollingcol) / 2))),
                0 != t || 0 != o ? e.ScrollRelativeBoth(t, o) : e.cellhandles.ShowCellHandles(!0);
        }, t.ReplaceCell = function (e, t, o, i) {
            var n, r;
            if (t && (n = e.context.RenderCell(o, i, t.rowpane, t.colpane, !0, null), n && t.element)) {
                t.element.innerHTML = n.innerHTML, t.element.style.cssText = "", t.element.className = n.className;
                for (r in n.style) "cssText" != n.style[r] && (t.element.style[r] = n.style[r]);
            }
        }, t.UpdateCellCSS = function (e, t, o, i) {
            var n, r;
            
            if (t && (n = e.context.RenderCell(o, i, t.rowpane, t.colpane, !0, null))) {
                t.element.style.cssText = "", t.element.className = n.className;
                for (r in n.style) "cssText" != n.style[r] && (t.element.style[r] = n.style[r]);

            }
        }, t.CSSfromConfig = function (e, stylo) {
            
        }, t.SetECellHeaders = function (e, o) {
            if (e.context.showRCHeaders !== !1) {
                var i, n, r, a, s, l = e.ecell,
                    c = e.context,
                    u = 0,
                    d = 0;
                if (l) {
                    for (;
                        "yes" == c.sheetobj.colattribs.hide[t.rcColname(l.col)];) l.col++;
                    for (;
                        "yes" == c.sheetobj.rowattribs.hide[l.row];) l.row++;
                    for (l.coord = t.crToCoord(l.col, l.row), i = 0; i < c.rowpanes.length; i++) {
                        if (r = c.rowpanes[i].first, a = c.rowpanes[i].last, l.row >= r && l.row <= a) {
                            var h = 2 + u + l.row - r;
                            null !== e.fullgrid && h >= 0 && (s = e.fullgrid.childNodes[1].childNodes[h].childNodes[0],
                                s && (c.classnames && (s.className = c.classnames[o + "rowname"]), c.explicitStyles && (s.style.cssText = c.explicitStyles[o + "rowname"]),
                                    s.style.verticalAlign = "top"));
                        }
                        u += a - r + 1 + 1;
                    }
                    for (n = 0; n < c.colpanes.length; n++) {
                        if (r = c.colpanes[n].first, a = c.colpanes[n].last, l.col >= r && l.col <= a) {
                            var h = 1 + d + l.col - r;
                            null !== e.fullgrid && h >= 0 && (s = e.fullgrid.childNodes[1].childNodes[1].childNodes[h],
                                s && (c.classnames && (s.className = c.classnames[o + "colname"]), c.explicitStyles && (s.style.cssText = c.explicitStyles[o + "colname"])));
                        }
                        d += a - r + 1 + 1;
                    }
                }
            }
        }, t.ECellReadonly = function (e, t) {
            if (!t && e.ecell && (t = e.ecell.coord), !t) return !1;
            var o = e.context.sheetobj.cells[t];
            return o && o.readonly;
        }, t.RangeAnchor = function (e, t) {
            e.range.hasrange && e.RangeRemove(), e.RangeExtend(t);
        }, t.RangeExtend = function (e, o) {
            var i, n, r, a, s, l, c, u = e.context.highlights,
                d = e.range,
                h = e.range2;
            if (o ? (c = t.coordToCr(o), c.coord = o) : c = e.ecell, c) {
                d.hasrange || (d.anchorcoord = c.coord, d.anchorrow = c.row, d.top = c.row, d.bottom = c.row,
                    d.anchorcol = c.col, d.left = c.col, d.right = c.col, d.hasrange = !0), d.anchorrow < c.row ? (d.top = d.anchorrow,
                    d.bottom = c.row) : (d.top = c.row, d.bottom = d.anchorrow), d.anchorcol < c.col ? (d.left = d.anchorcol,
                    d.right = c.col) : (d.left = c.col, d.right = d.anchorcol);
                for (r in u) switch (u[r]) {
                    case "range":
                        u[r] = "unrange";
                        break;

                    case "range2":
                        u[r] = "unrange2";
                }
                for (a = d.top; a <= d.bottom; a++)
                    for (s = d.left; s <= d.right; s++) switch (r = t.crToCoord(s, a),
                        u[r]) {
                        case "unrange":
                            u[r] = "range";
                            break;

                        case "cursor":
                            break;

                        case "unrange2":
                        default:
                            u[r] = "newrange";
                    }
                for (a = h.top; h.hasrange && a <= h.bottom; a++)
                    for (s = h.left; s <= h.right; s++) switch (r = t.crToCoord(s, a),
                        u[r]) {
                        case "unrange2":
                            u[r] = "range2";
                            break;

                        case "range":
                        case "newrange":
                        case "cursor":
                            break;

                        default:
                            u[r] = "newrange2";
                    }
                for (r in u) {
                    switch (u[r]) {
                        case "unrange":
                            delete u[r];
                            break;

                        case "newrange":
                            u[r] = "range";
                            break;

                        case "newrange2":
                            u[r] = "range2";
                            break;

                        case "range":
                        case "range2":
                        case "cursor":
                            continue;
                    }
                    n = t.coordToCr(r), i = t.GetEditorCellElement(e, n.row, n.col), e.UpdateCellCSS(i, n.row, n.col);
                }
                for (l in e.RangeChangeCallback) e.RangeChangeCallback[l](e);
                r = t.crToCoord(e.range.left, e.range.top), (e.range.left != e.range.right || e.range.top != e.range.bottom) && (r += ":" + t.crToCoord(e.range.right, e.range.bottom));
                for (l in e.StatusCallback) e.StatusCallback[l].func(e, "rangechange", r, e.StatusCallback[l].params);
            }
        }, t.RangeRemove = function (e) {
            var o, i, n, r, a, s, l = e.context.highlights,
                c = e.range,
                u = e.range2;
            if (c.hasrange || u.hasrange) {
                for (r = u.top; u.hasrange && r <= u.bottom; r++)
                    for (a = u.left; a <= u.right; a++) switch (n = t.crToCoord(a, r),
                        l[n]) {
                        case "range":
                            l[n] = "newrange2";
                            break;

                        case "range2":
                        case "cursor":
                            break;

                        default:
                            l[n] = "newrange2";
                    }
                for (n in l) {
                    switch (l[n]) {
                        case "range":
                            delete l[n];
                            break;

                        case "newrange2":
                            l[n] = "range2";
                            break;

                        case "cursor":
                            continue;
                    }
                    i = t.coordToCr(n), o = t.GetEditorCellElement(e, i.row, i.col), e.UpdateCellCSS(o, i.row, i.col);
                }
                c.hasrange = !1;
                for (s in e.RangeChangeCallback) e.RangeChangeCallback[s](e);
                for (s in e.StatusCallback) e.StatusCallback[s].func(e, "rangechange", "", e.StatusCallback[s].params);
            }
        }, t.Range2Remove = function (e) {
            var o, i, n, r = e.context.highlights,
                a = e.range2;
            if (a.hasrange) {
                for (n in r) {
                    switch (r[n]) {
                        case "range2":
                            delete r[n];
                            break;

                        case "range":
                        case "cursor":
                            continue;
                    }
                    i = t.coordToCr(n), o = t.GetEditorCellElement(e, i.row, i.col), e.UpdateCellCSS(o, i.row, i.col);
                }
                a.hasrange = !1;
            }
        }, t.FitToEditTable = function (e) {
            {
                var o, i, n, r, a, s, l, c, u = e.context,
                    d = u.sheetobj;
                d.colattribs;
            }
            for (r = u.showRCHeaders ? u.rownamewidth - 0 : 0, colpane = 0; colpane < u.colpanes.length - 1; colpane++)
                for (o = u.colpanes[colpane].first; o <= u.colpanes[colpane].last; o++) i = t.rcColname(o),
                    "yes" != d.colattribs.hide[i] && (n = d.colattribs.width[i] || d.attribs.defaultcolwidth || t.Constants.defaultColWidth,
                        ("blank" == n || "auto" == n) && (n = ""), r += n && n - 0 > 0 ? n - 0 : 10);
            for (o = u.colpanes[colpane].first; 1e4 >= o && (i = t.rcColname(o), "yes" != d.colattribs.hide[i] && (n = d.colattribs.width[i] || d.attribs.defaultcolwidth || t.Constants.defaultColWidth,
                    ("blank" == n || "auto" == n) && (n = ""), r += n && n - 0 > 0 ? n - 0 : 10), !(r > e.tablewidth)); o++);
            u.colpanes[colpane].last = u.sheetobj.attribs.usermaxcol || o;
            for (var h = u.rowpanes[0].first, p = u.sheetobj.attribs.lastrow;
                "yes" == d.rowattribs.hide[h] && p > h;) h++;
            for (u.rowpanes[0].first = h, a = u.showRCHeaders ? 1 : 0, l = 0; l < u.rowpanes.length - 1; l++)
                for (a += u.rowpanes[l].last - u.rowpanes[l].first + 1,
                    s = u.rowpanes[l].first; s <= u.rowpanes[l].last; s++) "yes" == d.rowattribs.hide[s] && a--;
            c = e.tableheight - a * u.pixelsPerRow, u.rowpanes[l].last = u.sheetobj.attribs.usermaxrow || u.rowpanes[l].first + Math.floor(c / u.pixelsPerRow) + 1;
        }, t.CalculateEditorPositions = function (e) {
            var o, i, n;
            e.gridposition = t.GetElementPosition(e.griddiv);
            var r = e.griddiv.firstChild.lastChild.childNodes[1].childNodes[0];
            for (e.headposition = t.GetElementPosition(r), e.headposition.left += r.offsetWidth,
                e.headposition.top += r.offsetHeight, e.rowpositions = [], o = 0; o < e.context.rowpanes.length; o++) e.CalculateRowPositions(o, e.rowpositions, e.rowheight);
            for (n = 0; n < e.rowpositions.length && !(e.rowpositions[n] > e.gridposition.top + e.tableheight); n++);
            for (e.lastvisiblerow = n - 1, e.colpositions = [], i = 0; i < e.context.colpanes.length; i++) e.CalculateColPositions(i, e.colpositions, e.colwidth);
            for (n = 0; n < e.colpositions.length && !(e.colpositions[n] > e.gridposition.left + e.tablewidth); n++);
            for (e.lastvisiblecol = n - 1, e.firstscrollingrow = e.context.rowpanes[e.context.rowpanes.length - 1].first;
                "yes" == e.context.sheetobj.rowattribs.hide[e.firstscrollingrow];) e.firstscrollingrow++;
            for (e.firstscrollingrowtop = e.rowpositions[e.firstscrollingrow] || e.headposition.top,
                e.lastnonscrollingrow = e.context.rowpanes.length - 1 > 0 ? e.context.rowpanes[e.context.rowpanes.length - 2].last : 0,
                e.firstscrollingcol = e.context.colpanes[e.context.colpanes.length - 1].first;
                "yes" == e.context.sheetobj.colattribs.hide[t.rcColname(e.firstscrollingcol)];) e.firstscrollingcol++;
            e.firstscrollingcolleft = e.colpositions[e.firstscrollingcol] || e.headposition.left,
                e.lastnonscrollingcol = e.context.colpanes.length - 1 > 0 ? e.context.colpanes[e.context.colpanes.length - 2].last : 0,
                e.verticaltablecontrol.ComputeTableControlPositions(), e.horizontaltablecontrol.ComputeTableControlPositions();
        }, t.ScheduleRender = function (o) {
            1 != o.ignoreRender && (o.timeout && e.clearTimeout(o.timeout), t.EditorSheetStatusCallback(null, "schedrender", null, o),
                o.timeout = e.setTimeout(function () {
                    t.DoRenderStep(o);
                }, 1));
        }, t.DoRenderStep = function (o) {
            o.timeout = null, o.EditorRenderSheet(), t.EditorSheetStatusCallback(null, "renderdone", null, o),
                t.EditorSheetStatusCallback(null, "schedposcalc", null, o), o.timeout = e.setTimeout(function () {
                    t.DoPositionCalculations(o);
                }, 1);
        }, t.SchedulePositionCalculations = function (o) {
            t.EditorSheetStatusCallback(null, "schedposcalc", null, o), o.timeout = e.setTimeout(function () {
                t.DoPositionCalculations(o);
            }, 1);
        }, t.DoPositionCalculations = function (e) {
            e.timeout = null, e.CalculateEditorPositions(), e.verticaltablecontrol.PositionTableControlElements(),
                e.horizontaltablecontrol.PositionTableControlElements(), t.EditorSheetStatusCallback(null, "doneposcalc", null, e),
                e.ensureecell && e.ecell && !e.deferredCommands.length && (e.ensureecell = !1, e.EnsureECellVisible()),
                e.cellhandles.ShowCellHandles(!0);
        }, t.CalculateRowPositions = function (e, t, o, i) {
            {
                var n, r, a, s, l, c, u = e.context;
                u.sheetobj;
            }
            if (u.showRCHeaders) {
                for (c = e.fullgrid.lastChild, n = 2, r = 0; t > r; r++) n += u.rowpanes[r].last - u.rowpanes[r].first + 2;
                for (s = 0, a = u.rowpanes[r].first; a <= u.rowpanes[r].last; a++) l = c.childNodes[n + s],
                    s++, l && (o[a] || (o[a] = l.firstChild.offsetTop, i[a] = l.firstChild.offsetHeight));
            }
        }, t.CalculateColPositions = function (e, o, i, n) {
            {
                var r, a, s, l, c, u, d, h = e.context;
                h.sheetobj;
            }
            if (h.showRCHeaders) {
                for (d = e.fullgrid.lastChild, r = 1, a = 0; o > a; a++) r += h.colpanes[a].last - h.colpanes[a].first + 2;
                for (c = d.childNodes[1], l = 0, s = h.colpanes[a].first; s <= h.colpanes[a].last; s++) u = t.GetElementPosition(c.childNodes[r + l]),
                    i[s] || (i[s] = u.left, c.childNodes[r + l] && (n[s] = c.childNodes[r + l].offsetWidth)),
                    l++;
            }
        }, t.ScrollRelative = function (e, t, o) {
            t ? e.ScrollRelativeBoth(o, 0) : e.ScrollRelativeBoth(0, o);
        }, t.ScrollRelativeBoth = function (e, o, i) {
            var n = e.context,
                r = o > 0 ? 1 : -1,
                a = i > 0 ? 1 : -1,
                s = n.rowpanes.length,
                l = s > 1 ? n.rowpanes[s - 2].last + 1 : 1;
            n.rowpanes[s - 1].first + o < l && (o = -n.rowpanes[s - 1].first + l);
            var c = n.colpanes.length,
                u = c > 1 ? n.colpanes[c - 2].last + 1 : 1;
            for (n.colpanes[c - 1].first + i < u && (i = -n.colpanes[c - 1].first + u);
                "yes" == n.sheetobj.colattribs.hide[t.rcColname(n.colpanes[c - 1].first + i)];)
                if (i += a,
                    1 > i) {
                    i = 0;
                    break;
                }
            for (;
                "yes" == n.sheetobj.rowattribs.hide[n.rowpanes[s - 1].first + o];)
                if (o += r,
                    1 > o) {
                    o = 0;
                    break;
                }
            return 1 != o && -1 != o || 0 != i ? void((0 != o || 0 != i) && (n.rowpanes[s - 1].first += o,
                n.rowpanes[s - 1].last += o, n.colpanes[c - 1].first += i, n.colpanes[c - 1].last += i,
                e.LimitLastPanes(), e.FitToEditTable(), e.ScheduleRender())) : (1 == o ? e.ScrollTableUpOneRow() : e.ScrollTableDownOneRow(),
                e.ecell && e.SetECellHeaders("selected"), void e.SchedulePositionCalculations());
        }, t.PageRelative = function (e, o, i) {
            var n, r, a, s, l = e.context,
                c = o ? "rowpanes" : "colpanes",
                u = l[c][l[c].length - 1],
                d = o ? "lastvisiblerow" : "lastvisiblecol",
                h = o ? e.rowheight : e.colwidth,
                p = o ? t.Constants.defaultAssumedRowHeight : t.Constants.defaultColWidth;
            if (i > 0) r = e[d], r == u.first && (r += 1);
            else {
                for (a = o ? e.tableheight - (e.firstscrollingrowtop - e.gridposition.top) : e.tablewidth - (e.firstscrollingcolleft - e.gridposition.left),
                    a -= h[e[d]] > 0 ? h[e[d]] : p, r = u.first - 1; r > 0 && (n = h[r] > 0 ? h[r] : p,
                        !(n > a)); r--) a -= n;
                s = u.first, r >= s && (r = s - 1), 1 > r && (r = 1);
            }
            u.first = r, u.last = r + 1, e.LimitLastPanes(), e.FitToEditTable(), e.ScheduleRender();
        }, t.LimitLastPanes = function (e) {
            var t, o = e.context;
            t = o.rowpanes.length, t > 1 && o.rowpanes[t - 1].first <= o.rowpanes[t - 2].last && (o.rowpanes[t - 1].first = o.rowpanes[t - 2].last + 1),
                o.sheetobj.attribs.usermaxrow && o.rowpanes[t - 1].first > o.sheetobj.attribs.usermaxrow && (o.rowpanes[t - 1].first = o.sheetobj.attribs.usermaxrow),
                t = o.colpanes.length, t > 1 && o.colpanes[t - 1].first <= o.colpanes[t - 2].last && (o.colpanes[t - 1].first = o.colpanes[t - 2].last + 1),
                o.sheetobj.attribs.usermaxcol && o.colpanes[t - 1].first > o.sheetobj.attribs.usermaxcol && (o.colpanes[t - 1].first = o.sheetobj.attribs.usermaxcol);
        }, t.ScrollTableUpOneRow = function (e) {
            var o, i, n, r, a, s, l, c, u, d, h, p, f = {},
                m = e.context,
                g = m.sheetobj,
                v = e.fullgrid;
            for (p = v.lastChild, o = m.showRCHeaders ? 2 : 1, i = 0; i < m.rowpanes.length - 1; i++) o += m.rowpanes[i].last - m.rowpanes[i].first + 2;
            if (m.sheetobj.attribs.usermaxrow && m.sheetobj.attribs.usermaxrow - m.rowpanes[i].first < 1) return v;
            for (p.removeChild(p.childNodes[o]), m.rowpanes[i].first++, m.rowpanes[i].last++,
                e.FitToEditTable(), m.CalculateColWidthData(), m.sheetobj.attribs.usermaxrow && m.rowpanes[i].last == m.sheetobj.attribs.usermaxrow || (c = m.RenderRow(m.rowpanes[i].last, i),
                    p.appendChild(c)), maxrowspan = 1, l = m.rowpanes[i].first - 1, a = 0; a < m.colpanes.length; a++)
                for (r = m.colpanes[a].first; r <= m.colpanes[a].last; r++) coord = t.crToCoord(r, l),
                    m.cellskip[coord] || (s = g.cells[coord], s && s.rowspan > maxrowspan && (maxrowspan = s.rowspan));
            if (maxrowspan > 1)
                for (n = 1; maxrowspan > n && !(n + l >= m.rowpanes[i].last); n++) u = m.RenderRow(n + l, i),
                    d = p.childNodes[o + n - 1], p.replaceChild(u, d);
            for (h = m.rowpanes[i].last, a = 0; a < m.colpanes.length; a++)
                for (r = m.colpanes[a].first; r <= m.colpanes[a].last; r++) coord = m.cellskip[t.crToCoord(r, h)],
                    coord && (n = m.coordToCR[coord].row - 0, n == m.rowpanes[i].last || n < m.rowpanes[i].first || (s = g.cells[coord],
                        s && s.rowspan > 1 && (f[n] = !0)));
            for (n in f) u = m.RenderRow(n, i), d = p.childNodes[o + (n - m.rowpanes[i].first)],
                p.replaceChild(u, d);
            return v;
        }, t.ScrollTableDownOneRow = function (e) {
            var o, i, n, r, a, s, l, c, u, d, h, p = {},
                f = e.context,
                m = f.sheetobj,
                g = e.fullgrid;
            for (h = g.lastChild, o = f.showRCHeaders ? 2 : 1, i = 0; i < f.rowpanes.length - 1; i++) o += f.rowpanes[i].last - f.rowpanes[i].first + 2;
            for (f.sheetobj.attribs.usermaxrow || h.removeChild(h.childNodes[o + (f.rowpanes[i].last - f.rowpanes[i].first)]),
                f.rowpanes[i].first--, f.rowpanes[i].last--, e.FitToEditTable(), f.CalculateColWidthData(),
                c = f.RenderRow(f.rowpanes[i].first, i), h.insertBefore(c, h.childNodes[o]), maxrowspan = 1,
                l = f.rowpanes[i].first, a = 0; a < f.colpanes.length; a++)
                for (r = f.colpanes[a].first; r <= f.colpanes[a].last; r++) coord = t.crToCoord(r, l),
                    f.cellskip[coord] || (s = m.cells[coord], s && s.rowspan > maxrowspan && (maxrowspan = s.rowspan));
            if (maxrowspan > 1)
                for (n = 1; maxrowspan > n && !(n + l > f.rowpanes[i].last); n++) c = f.RenderRow(n + l, i),
                    u = h.childNodes[o + n], h.replaceChild(c, u);
            for (d = f.rowpanes[i].last, a = 0; a < f.colpanes.length; a++)
                for (r = f.colpanes[a].first; r <= f.colpanes[a].last; r++) coord = t.crToCoord(r, d),
                    s = m.cells[coord], s && s.rowspan > 1 ? p[d] = !0 : (coord = f.cellskip[t.crToCoord(r, d)],
                        coord && (n = f.coordToCR[coord].row - 0, n == d || n < f.rowpanes[i].first || (s = m.cells[coord],
                            s && s.rowspan > 1 && (p[n] = !0))));
            for (n in p) c = f.RenderRow(n, i), u = h.childNodes[o + (n - f.rowpanes[i].first)],
                h.replaceChild(c, u);
            return g;
        }, t.InputBox = function (e, o) {
            e && (this.element = e, this.editor = o, this.inputEcho = null, o.inputBox = this,
                e.onmousedown = t.InputBoxOnMouseDown, o.MoveECellCallback.formulabar = function (e) {
                    "start" == e.state && o.inputBox.DisplayCellContents(e.ecell.coord);
                });
        }, t.InputBox.prototype.DisplayCellContents = function (e) {
            t.InputBoxDisplayCellContents(this, e);
        }, t.InputBox.prototype.ShowInputBox = function (e) {
            this.editor.inputEcho.ShowInputEcho(e);
        }, t.InputBox.prototype.GetText = function () {
            return this.element.value;
        }, t.InputBox.prototype.SetText = function (e) {
            this.element && (this.element.value = e, this.editor.inputEcho.SetText(e + "_"));
        }, t.InputBox.prototype.Focus = function () {
            t.InputBoxFocus(this);
        }, t.InputBox.prototype.Blur = function () {
            return this.element.blur();
        }, t.InputBox.prototype.Select = function (e) {
            if (this.element) switch (e) {
                case "end":
                    if (document.selection && document.selection.createRange) try {
                        var t = document.selection.createRange().duplicate();
                        t.moveToElementText(this.element), t.collapse(!1), t.select();
                    } catch (o) {
                        void 0 != this.element.selectionStart && (this.element.selectionStart = this.element.value.length,
                            this.element.selectionEnd = this.element.value.length);
                    } else void 0 != this.element.selectionStart && (this.element.selectionStart = this.element.value.length,
                        this.element.selectionEnd = this.element.value.length);
            }
        }, t.InputBoxDisplayCellContents = function (e, o) {
            var i = t.Constants;
            if (e) {
                if (!o) {
                    if (!e.editor) return;
                    if (!e.editor.ecell) return;
                    o = e.editor.ecell.coord;
                }
                var n = t.GetCellContents(e.editor.context.sheetobj, o); -
                1 != n.indexOf("\n") ? (n = i.s_inputboxdisplaymultilinetext, e.element.disabled = !0) : e.element.disabled = e.editor.ECellReadonly() ? !0 : !1,
                    e.SetText(n);
            }
        }, t.InputBoxFocus = function (e) {
            if (e) {
                e.element.focus();
                var t = e.editor;
                t.state = "input";
                var o = t.workingvalues;
                o.partialexpr = "", o.ecoord = t.ecell.coord, o.erow = t.ecell.row, o.ecol = t.ecell.col;
            }
        }, t.InputBoxOnMouseDown = function () {
            var e = t.Keyboard.focusTable;
            if (!e) return !0;
            var o = e.workingvalues;
            switch (e.state) {
                case "start":
                    e.state = "inputboxdirect", o.partialexpr = "", o.ecoord = e.ecell.coord, o.erow = e.ecell.row,
                        o.ecol = e.ecell.col, e.inputEcho.ShowInputEcho(!0);
                    break;

                case "input":
                    o.partialexpr = "", e.MoveECell(o.ecoord), e.state = "inputboxdirect", t.KeyboardFocus();
                    break;

                case "inputboxdirect":
            }
        }, t.InputEcho = function (e) {
            var o = t.Constants;
            this.editor = e, this.text = "", this.interval = null, this.container = null, this.main = null,
                this.prompt = null, this.hint = null, this.functionbox = null, this.container = document.createElement("div"),
                t.setStyles(this.container, "display:none;position:absolute;zIndex:10;"), this.main = document.createElement("div"),
                o.defaultInputEchoClass && (this.main.className = o.defaultInputEchoClass), o.defaultInputEchoStyle && t.setStyles(this.main, o.defaultInputEchoStyle),
                this.main.innerHTML = "&nbsp;", this.hint = document.createElement("div"), o.defaultInputEchoHintClass && (this.hint.className = o.defaultInputEchoHintClass),
                o.defaultInputEchoHintStyle && t.setStyles(this.hint, o.defaultInputEchoHintStyle),
                this.hint.innerHTML = "", this.container.appendChild(this.hint), this.container.appendChild(this.main),
                this.prompt = document.createElement("div"), o.defaultInputEchoPromptClass && (this.prompt.className = o.defaultInputEchoPromptClass),
                o.defaultInputEchoPromptStyle && t.setStyles(this.prompt, o.defaultInputEchoPromptStyle),
                this.prompt.innerHTML = "", this.container.appendChild(this.prompt), t.DragRegister(this.main, !0, !0, {
                    MouseDown: t.DragFunctionStart,
                    MouseMove: t.DragFunctionPosition,
                    MouseUp: t.DragFunctionPosition,
                    Disabled: null,
                    positionobj: this.container
                }, this.editor.toplevel), e.toplevel.appendChild(this.container);
        }, t.InputEcho.prototype.ShowInputEcho = function (e) {
            return t.ShowInputEcho(this, e);
        }, t.InputEcho.prototype.SetText = function (e) {
            return t.SetInputEchoText(this, e);
        }, t.ShowInputEcho = function (o, i) {
            var n, r, a = o.editor;
            a && (i ? (a.cellhandles.ShowCellHandles(!1), n = t.GetEditorCellElement(a, a.ecell.row, a.ecell.col),
                n && (r = t.GetElementPosition(n.element), o.container.style.left = r.left - 1 + "px",
                    o.container.style.top = r.top - 1 + "px"), o.hint.innerHTML = a.ecell.coord, o.container.style.display = "block",
                o.interval && e.clearInterval(o.interval), o.interval = e.setInterval(t.InputEchoHeartbeat, 50)) : (o.interval && e.clearInterval(o.interval),
                o.container.style.display = "none"));
        }, t.SetInputEchoText = function (e, o) {
            var i, n, r = t.Constants,
                a = t.special_chars(o);
            a = a.replace(/\n/g, "<br>"), e.text != a && (e.main.innerHTML = a, e.text = a);
            var s = o.match(/.*[\+\-\*\/\&\^\<\>\=\,\(]([A-Za-z][A-Za-z][\w\.]*?)\([^\)]*$/);
            "=" == o.charAt(0) && s ? (i = s[1].toUpperCase(), t.Formula.FunctionList[i] ? (t.Formula.FillFunctionInfo(),
                    n = t.special_chars(i + "(" + t.Formula.FunctionArgString(i) + ")")) : n = r.ietUnknownFunction + i,
                e.prompt.innerHTML != n && (e.prompt.innerHTML = n, e.prompt.style.display = "block")) : "none" != e.prompt.style.display && (e.prompt.innerHTML = "",
                e.prompt.style.display = "none");
        }, t.InputEchoHeartbeat = function () {
            var e = t.Keyboard.focusTable;
            return e ? void e.inputEcho.SetText(e.inputBox.GetText() + "_") : !0;
        }, t.InputEchoMouseDown = function (o) {
            var i = (o || e.event, t.Keyboard.focusTable);
            return i ? void i.inputBox.element.focus() : !0;
        }, t.CellHandles = function (e) {
            
            t.Constants;
            if (!e.noEdit) {
                this.editor = e, this.noCursorSuffix = !1, this.movedmouse = !1, this.draghandle = document.createElement("div"),
                    t.setStyles(this.draghandle, "display:none;position:absolute;zIndex:8;border:1px solid white;width:7px;height:7px;fontSize:1px;backgroundColor:#0E93D8;cursor:pointer;"),
                    this.draghandle.innerHTML = "&nbsp;", e.toplevel.appendChild(this.draghandle), t.AssignID(e, this.draghandle, "draghandle");
                var o = "png";
                if (navigator.userAgent.match(/MSIE 6\.0/) && (o = "gif"), this.dragpalette = document.createElement("div"),
                    t.setStyles(this.dragpalette, "display:none;position:absolute;zIndex:8;width:90px;height:90px;fontSize:1px;textAlign:center;cursor:default;backgroundImage:url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_drag-handles.png') + ");"),
                    this.dragpalette.innerHTML = "&nbsp;", e.toplevel.appendChild(this.dragpalette),
                    t.AssignID(e, this.dragpalette, "dragpalette"), this.dragtooltip = document.createElement("div"),
                    t.setStyles(this.dragtooltip, "display:none;position:absolute;zIndex:9;border:1px solid black;width:100px;height:auto;fontSize:10px;backgroundColor:#FFFFFF;"),
                    this.dragtooltip.innerHTML = "&nbsp;", e.toplevel.appendChild(this.dragtooltip),
                    t.AssignID(e, this.dragtooltip, "dragtooltip"), this.fillinghandle = document.createElement("div"),
                    t.setStyles(this.fillinghandle, "display:none;position:absolute;zIndex:9;border:1px solid black;width:auto;height:14px;fontSize:10px;backgroundColor:#FFFFFF;"),
                    this.fillinghandle.innerHTML = "&nbsp;", e.toplevel.appendChild(this.fillinghandle),
                    t.AssignID(e, this.fillinghandle, "fillinghandle"), this.draghandle.addEventListener) this.draghandle.addEventListener("mousemove", t.CellHandlesMouseMoveOnHandle, !1),
                    this.dragpalette.addEventListener("mousedown", t.CellHandlesMouseDown, !1), this.dragpalette.addEventListener("mousemove", t.CellHandlesMouseMoveOnHandle, !1);
                else {
                    if (!this.draghandle.attachEvent) throw "Browser not supported";
                    this.draghandle.attachEvent("onmousemove", t.CellHandlesMouseMoveOnHandle), this.dragpalette.attachEvent("onmousedown", t.CellHandlesMouseDown),
                        this.dragpalette.attachEvent("onmousemove", t.CellHandlesMouseMoveOnHandle);
                }
            }
        }, t.CellHandles.prototype.ShowCellHandles = function (e, o) {
            return t.ShowCellHandles(this, e, o);
        }, t.ShowCellHandles = function (e, o, i) {
            var n, r, a, s = e.editor,
                l = !1,
                c = 1,
                u = 1;
            if (s && s.ecell) {
                do {
                    if (!o) break;
                    if (r = s.ecell.row, a = s.ecell.col, "start" != s.state) break;
                    if (r >= s.lastvisiblerow) break;
                    if (a >= s.lastvisiblecol) break;
                    if (r < s.firstscrollingrow) break;
                    if (a < s.firstscrollingcol) break;
                    for (;
                        "yes" == s.context.sheetobj.colattribs.hide[t.rcColname(a + c)];) c++;
                    for (;
                        "yes" == s.context.sheetobj.rowattribs.hide[r + u];) u++;
                    if (n = s.context.sheetobj.cells[t.crToCoord(a + c - 1, r + u - 1)], "undefined" != typeof n && (c += (n.colspan || 1) - 1,
                            u += (n.rowspan || 1) - 1), s.rowpositions[r + u] + 20 > s.horizontaltablecontrol.controlborder) break;
                    if (s.rowpositions[r + u] - 10 < s.headposition.top) break;
                    if (s.colpositions[a + c] + 20 > s.verticaltablecontrol.controlborder) break;
                    if (s.colpositions[a + c] - 30 < s.headposition.left) break;
                    e.draghandle.style.left = s.colpositions[a + c] - 3 + "px", e.draghandle.style.top = s.rowpositions[r + u] - 3 + "px",
                        e.draghandle.style.display = "block", i && (e.draghandle.style.display = "none",
                            e.dragpalette.style.left = s.colpositions[a + c] - 45 + "px", e.dragpalette.style.top = s.rowpositions[r + u] - 45 + "px",
                            e.dragpalette.style.display = "block", e.dragtooltip.style.left = s.colpositions[a + c] - 45 + "px",
                            e.dragtooltip.style.top = s.rowpositions[r + u] + 45 + "px", e.dragtooltip.style.display = "none"),
                        l = !0;
                } while (!1);
                l || (e.draghandle.style.display = "none"), i || (e.dragpalette.style.display = "none",
                    e.dragtooltip.style.display = "none");
            }
        }, t.CellHandlesMouseMoveOnHandle = function (o) {
            var i = t.Constants,
                n = o || e.event,
                r = n.target || n.srcElement,
                a = t.Keyboard.focusTable;
            if (!a) return !0;
            var s = a.cellhandles;
            if (!s.editor) return !0;
            var l = t.GetElementPositionWithScroll(a.toplevel),
                c = n.clientX - l.left,
                u = n.clientY - l.top;
            if (!a.cellhandles.mouseDown) {
                if (a.cellhandles.ShowCellHandles(!0, !0), r == s.dragpalette) {
                    var d = t.SegmentDivHit([i.CH_radius1, i.CH_radius2], a.cellhandles.dragpalette, c, u);
                    if (0 == d) return void t.CellHandlesHoverTimeout();
                }
                s.timer && (e.clearTimeout(s.timer), s.timer = null), s.timer = e.setTimeout(t.CellHandlesHoverTimeout, 3e3);
            }
        }, t.SegmentDivHit = function (e, t, o, i) {
            var n = t.offsetWidth,
                r = t.offsetHeight,
                a = t.offsetLeft,
                s = t.offsetTop,
                l = 0,
                c = e,
                u = Math.sqrt(Math.pow(o - a - (n / 2 - .5), 2) + Math.pow(i - s - (r / 2 - .5), 2));
            if (2 == c.length) return o >= a && a + n / 2 > o && i >= s && s + r / 2 > i && (u <= e[0] ? l = -1 : u <= e[1] && (l = 1)),
                o >= a + n / 2 && a + n > o && i >= s && s + r / 2 > i && (u <= e[0] ? l = -2 : u <= e[1] && (l = 2)),
                o >= a + n / 2 && a + n > o && i >= s + r / 2 && s + r > i && (u <= e[0] ? l = -3 : u <= e[1] && (l = 3)),
                o >= a && a + n / 2 > o && i >= s + r / 2 && s + r > i && (u <= e[0] ? l = -4 : u <= e[1] && (l = 4)),
                l;
            for (;;)
                if (o >= a && a + n / 2 > o && i >= s && s + r / 2 > i) {
                    if (quadrant += "1", l = c[0], "number" == typeof l) break;
                    c = l, n /= 2, r /= 2;
                } else if (o >= a + n / 2 && a + n > o && i >= s && s + r / 2 > i) {
                if (quadrant += "2", l = c[1], "number" == typeof l) break;
                c = l, n /= 2, a += n, r /= 2;
            } else if (o >= a + n / 2 && a + n > o && i >= s + r / 2 && s + r > i) {
                if (quadrant += "3", l = c[2], "number" == typeof l) break;
                c = l, n /= 2, a += n, r /= 2, s += r;
            } else {
                if (!(o >= a && a + n / 2 > o && i >= s + r / 2 && s + r > i)) return 0;
                if (quadrant += "4", l = c[3], "number" == typeof l) break;
                c = l, n /= 2, r /= 2, s += r;
            }
            return l;
        }, t.CellHandlesHoverTimeout = function () {
            if (editor = t.Keyboard.focusTable, !editor) return !0;
            var o = editor.cellhandles;
            o.timer && (e.clearTimeout(o.timer), o.timer = null), editor.cellhandles.ShowCellHandles(!0, !1);
        }, t.CellHandlesMouseDown = function (o) {
            var i, n, r, a = t.Constants,
                s = o || e.event,
                l = t.EditorMouseInfo;
            if (i = t.Keyboard.focusTable, !i) return !0;
            if (!i.busy) {
                var c = i.cellhandles;
                c.movedmouse = !1;
                var u = t.GetElementPositionWithScroll(i.toplevel),
                    d = s.clientX - u.left,
                    h = s.clientY - u.top;
                c.timer && (e.clearTimeout(c.timer), c.timer = null), c.dragtooltip.innerHTML = "&nbsp;",
                    c.dragtooltip.style.display = "none", r = i.range;
                var p = t.SegmentDivHit([a.CH_radius1, a.CH_radius2], i.cellhandles.dragpalette, d, h);
                if (1 == p || -1 == p || 0 == p) return void c.ShowCellHandles(!0, !1);
                switch (l.ignore = !0, -3 == p ? (c.dragtype = "Fill", c.noCursorSuffix = !1) : 3 == p ? (c.dragtype = "FillC",
                    c.noCursorSuffix = !1) : -2 == p ? (c.dragtype = "Move", c.noCursorSuffix = !0) : -4 == p ? (c.dragtype = "MoveI",
                    c.noCursorSuffix = !1) : 2 == p ? (c.dragtype = "MoveC", c.noCursorSuffix = !0) : 4 == p && (c.dragtype = "MoveIC",
                    c.noCursorSuffix = !1), c.filltype = null, c.dragtype) {
                    case "Fill":
                    case "FillC":
                        r.hasrange || i.RangeAnchor(), i.range2.top = i.range.top, i.range2.right = i.range.right,
                            i.range2.bottom = i.range.bottom, i.range2.left = i.range.left, i.range2.hasrange = !0;
                        break;

                    case "Move":
                    case "MoveI":
                    case "MoveC":
                    case "MoveIC":
                        r.hasrange || i.RangeAnchor(), i.range2.top = i.range.top, i.range2.right = i.range.right,
                            i.range2.bottom = i.range.bottom, i.range2.left = i.range.left, i.range2.hasrange = !0,
                            i.RangeRemove();
                        break;

                    default:
                        return;
                }
                c.fillinghandle.style.left = d + "px", c.fillinghandle.style.top = h - 17 + "px",
                    c.fillinghandle.innerHTML = a.s_CHindicatorOperationLookup[c.dragtype] + (a.s_CHindicatorDirectionLookup[i.cellhandles.filltype] || ""),
                    c.fillinghandle.style.display = "block", c.ShowCellHandles(!0, !1), c.mouseDown = !0,
                    l.editor = i, n = i.ecell.coord, c.startingcoord = n, c.startingX = d, c.startingY = h,
                    l.mouselastcoord = n, t.KeyboardSetFocus(i), document.addEventListener ? (document.addEventListener("mousemove", t.CellHandlesMouseMove, !0),
                        document.addEventListener("mouseup", t.CellHandlesMouseUp, !0)) : c.draghandle.attachEvent && (c.draghandle.setCapture(),
                        c.draghandle.attachEvent("onmousemove", t.CellHandlesMouseMove), c.draghandle.attachEvent("onmouseup", t.CellHandlesMouseUp),
                        c.draghandle.attachEvent("onlosecapture", t.CellHandlesMouseUp)), t.StopPropagation(s);
            }
        }, t.CellHandlesMouseMove = function (o) {
            var i, n, r, a, s, l, c, u = t.Constants,
                d = o || e.event,
                h = t.EditorMouseInfo;
            if (i = h.editor) {
                var p = i.cellhandles;
                n = h.element;
                var f = t.GetElementPositionWithScroll(i.toplevel),
                    m = d.clientX - f.left,
                    g = d.clientY - f.top;
                if (r = t.GridMousePosition(i, m, g)) {
                    if (r && !r.coord) return void t.SetDragAutoRepeat(i, r, t.CellHandlesDragAutoRepeat);
                    if (t.SetDragAutoRepeat(i, null), r.coord) {
                        switch (a = t.coordToCr(i.cellhandles.startingcoord), s = t.coordToCr(r.coord),
                            p.movedmouse = !0, p.dragtype) {
                            case "Fill":
                            case "FillC":
                                r.coord == p.startingcoord ? (p.filltype = null, p.startingX = m, p.startingY = g) : p.filltype ? "Down" == p.filltype ? (s.col = a.col,
                                    s.row < a.row && (s.row = a.row)) : (s.row = a.row, s.col < a.col && (s.col = a.col)) : (Math.abs(g - p.startingY) > 10 ? p.filltype = "Down" : Math.abs(m - p.startingX) > 10 && (p.filltype = "Right"),
                                    s.col = a.col, s.row = a.row), r.coord = t.crToCoord(s.col, s.row), r.coord != h.mouselastcoord && (i.MoveECell(r.coord),
                                    i.RangeExtend());
                                break;

                            case "Move":
                            case "MoveC":
                                r.coord != h.mouselastcoord && (i.MoveECell(r.coord), l = i.range2.right - i.range2.left + r.col,
                                    c = i.range2.bottom - i.range2.top + r.row, i.RangeAnchor(t.crToCoord(l, c)), i.RangeExtend());
                                break;

                            case "MoveI":
                            case "MoveIC":
                                r.coord == p.startingcoord ? (p.filltype = null, p.startingX = m, p.startingY = g) : p.filltype ? "Vertical" == p.filltype ? (s.col = i.range2.left,
                                    s.row >= i.range2.top && s.row <= i.range2.bottom + 1 && (s.row = i.range2.bottom + 2)) : (s.row = i.range2.top,
                                    s.col >= i.range2.left && s.col <= i.range2.right + 1 && (s.col = i.range2.right + 2)) : (Math.abs(g - p.startingY) > 10 ? p.filltype = "Vertical" : Math.abs(m - p.startingX) > 10 && (p.filltype = "Horizontal"),
                                    s.col = a.col, s.row = a.row), r.coord = t.crToCoord(s.col, s.row), r.coord != h.mouselastcoord && (i.MoveECell(r.coord),
                                    p.filltype ? (l = i.range2.right - i.range2.left + s.col, c = i.range2.bottom - i.range2.top + s.row,
                                        i.RangeAnchor(t.crToCoord(l, c)), i.RangeExtend()) : i.RangeRemove());
                        }
                        p.fillinghandle.style.left = m + "px", p.fillinghandle.style.top = g - 17 + "px",
                            p.fillinghandle.innerHTML = u.s_CHindicatorOperationLookup[p.dragtype] + (u.s_CHindicatorDirectionLookup[i.cellhandles.filltype] || ""),
                            p.fillinghandle.style.display = "block", h.mouselastcoord = r.coord, t.StopPropagation(d);
                    }
                }
            }
        }, t.CellHandlesDragAutoRepeat = function (e, o) {
            var i = t.EditorMouseInfo,
                n = i.editor;
            if (n) {
                var r, a, s, l = n.cellhandles,
                    c = t.coordToCr(n.cellhandles.startingcoord),
                    u = t.coordToCr(e),
                    d = 0,
                    h = 0;
                switch ("left" == o ? h = -1 : "right" == o ? h = 1 : "up" == o ? d = -1 : "down" == o && (d = 1),
                    n.ScrollRelativeBoth(d, h), l.dragtype) {
                    case "Fill":
                    case "FillC":
                        l.filltype ? "Down" == l.filltype ? (u.col = c.col, u.row < c.row && (u.row = c.row)) : (u.row = c.row,
                                u.col < c.col && (u.col = c.col)) : (u.col = c.col, u.row = c.row), r = t.crToCoord(u.col, u.row),
                            r != i.mouselastcoord && (n.MoveECell(e), n.RangeExtend());
                        break;

                    case "Move":
                    case "MoveC":
                        e != i.mouselastcoord && (n.MoveECell(e), a = n.range2.right - n.range2.left + n.ecell.col,
                            s = n.range2.bottom - n.range2.top + n.ecell.row, n.RangeAnchor(t.crToCoord(a, s)),
                            n.RangeExtend());
                        break;

                    case "MoveI":
                    case "MoveIC":
                        l.filltype ? "Vertical" == l.filltype ? (u.col = n.range2.left, u.row >= n.range2.top && u.row <= n.range2.bottom + 1 && (u.row = n.range2.bottom + 2)) : (u.row = n.range2.top,
                            u.col >= n.range2.left && u.col <= n.range2.right + 1 && (u.col = n.range2.right + 2)) : (u.col = c.col,
                            u.row = c.row), r = t.crToCoord(u.col, u.row), r != i.mouselastcoord && (n.MoveECell(r),
                            a = n.range2.right - n.range2.left + u.col, s = n.range2.bottom - n.range2.top + u.row,
                            n.RangeAnchor(t.crToCoord(a, s)), n.RangeExtend());
                }
                i.mouselastcoord = r;
            }
        }, t.CellHandlesMouseUp = function (o) {
            var i, n, r, a, s, l, c, u, d, h, p, f, m = o || e.event,
                g = t.EditorMouseInfo;
            if (i = g.editor) {
                var v = i.cellhandles;
                n = g.element, g.ignore = !1;
                var b = t.GetElementPositionWithScroll(i.toplevel),
                    y = m.clientX - b.left,
                    C = m.clientY - b.top;
                switch (r = t.GridMousePosition(i, y, C), t.SetDragAutoRepeat(i, null), v.mouseDown = !1,
                    v.noCursorSuffix = !1, v.fillinghandle.style.display = "none", r || (r = {}), r.coord || (r.coord = i.ecell.coord),
                    v.dragtype) {
                    case "Fill":
                    case "Move":
                    case "MoveI":
                        l = " all";
                        break;

                    case "FillC":
                    case "MoveC":
                    case "MoveIC":
                        l = " formulas";
                }
                switch (v.movedmouse || (v.dragtype = "Nothing"), v.dragtype) {
                    case "Nothing":
                        i.Range2Remove(), i.RangeRemove();
                        break;

                    case "Fill":
                    case "FillC":
                        c = t.coordToCr(v.startingcoord), u = t.coordToCr(r.coord), v.filltype && ("Down" == v.filltype ? u.col = c.col : u.row = c.row),
                            r.coord = t.crToCoord(u.col, u.row), i.MoveECell(r.coord), i.RangeExtend(), s = "Right" == i.cellhandles.filltype ? "right" : "down",
                            a = "fill" + s + " " + t.crToCoord(i.range.left, i.range.top) + ":" + t.crToCoord(i.range.right, i.range.bottom) + l,
                            i.EditorScheduleSheetCommands(a, !0, !1);
                        break;

                    case "Move":
                    case "MoveC":
                        i.context.cursorsuffix = "", a = "movepaste " + t.crToCoord(i.range2.left, i.range2.top) + ":" + t.crToCoord(i.range2.right, i.range2.bottom) + " " + i.ecell.coord + l,
                            i.EditorScheduleSheetCommands(a, !0, !1), i.Range2Remove();
                        break;

                    case "MoveI":
                    case "MoveIC":
                        i.context.cursorsuffix = "", d = i.range2.right - i.range2.left, h = i.range2.bottom - i.range2.top,
                            p = i.ecell.col - i.range2.left, f = i.ecell.row - i.range2.top, a = "moveinsert " + t.crToCoord(i.range2.left, i.range2.top) + ":" + t.crToCoord(i.range2.right, i.range2.bottom) + " " + i.ecell.coord + l,
                            i.EditorScheduleSheetCommands(a, !0, !1), i.Range2Remove(), i.RangeRemove(), " Horizontal" == i.cellhandles.filltype && p > 0 ? i.MoveECell(t.crToCoord(i.ecell.col - d - 1, i.ecell.row)) : " Vertical" == i.cellhandles.filltype && f > 0 && i.MoveECell(t.crToCoord(i.ecell.col, i.ecell.row - h - 1)),
                            i.RangeAnchor(t.crToCoord(i.ecell.col + d, i.ecell.row + h)), i.RangeExtend();
                }
                return t.RemoveMouseMoveUp(t.CellHandlesMouseMove, t.CellHandlesMouseUp, v.draghandle, m),
                    g.editor = null, !1;
            }
        }, t.TableControl = function (e, o, i) {
            var n = t.Constants;
            this.editor = e, this.vertical = o, this.size = i, this.main = null, this.endcap = null,
                this.paneslider = null, this.lessbutton = null, this.morebutton = null, this.scrollarea = null,
                this.thumb = null, this.controlborder = null, this.endcapstart = null, this.panesliderstart = null,
                this.lessbuttonstart = null, this.morebuttonstart = null, this.scrollareastart = null,
                this.scrollareaend = null, this.scrollareasize = null, this.thumbpos = null, this.controlthickness = n.defaultTableControlThickness,
                this.sliderthickness = n.defaultTCSliderThickness, this.buttonthickness = n.defaultTCButtonThickness,
                this.thumbthickness = n.defaultTCThumbThickness, this.minscrollingpanesize = this.buttonthickness + this.buttonthickness + this.thumbthickness + 20;
        }, t.TableControl.prototype.CreateTableControl = function () {
            return t.CreateTableControl(this);
        }, t.TableControl.prototype.PositionTableControlElements = function () {
            t.PositionTableControlElements(this);
        }, t.TableControl.prototype.ComputeTableControlPositions = function () {
            t.ComputeTableControlPositions(this);
        }, t.CreateTableControl = function (e) {
            var o, i, n, r = t.AssignID,
                a = t.setStyles,
                s = t.Constants,
                l = e.editor.imageprefix,
                c = e.vertical ? "v" : "h",
                u = t.LocalizeString,
                urlTao;
            urlTao = assetManager.resolve('EtherCalc/runtime/assets/sc_thumb-' + c + 'n.gif');
            urlTao_endcap = assetManager.resolve('EtherCalc/runtime/assets/sc_endcap-' + c + '.gif');
            urlTao_paneslider = assetManager.resolve('EtherCalc/runtime/assets/sc_paneslider-' + c + '.gif');
            urlTao_lessn = assetManager.resolve('EtherCalc/runtime/assets/sc_less-' + c + 'n.gif');
            urlTao_lessd = assetManager.resolve('EtherCalc/runtime/assets/sc_less-' + c + 'd.gif');
            urlTao_lessh = assetManager.resolve('EtherCalc/runtime/assets/sc_less-' + c + 'h.gif');
            urlTao_moren = assetManager.resolve('EtherCalc/runtime/assets/sc_more-' + c + 'n.gif');
            urlTao_mored = assetManager.resolve('EtherCalc/runtime/assets/sc_more-' + c + 'd.gif');
            urlTao_moreh = assetManager.resolve('EtherCalc/runtime/assets/sc_more-' + c + 'h.gif');
            urlTao_scrollarea = assetManager.resolve('EtherCalc/runtime/assets/sc_scrollarea-' + c + '.gif');
            
            return e.main = document.createElement("div"), o = e.main.style, o.height = (e.vertical ? e.size : e.controlthickness) + "px",
                o.width = (e.vertical ? e.controlthickness : e.size) + "px", o.zIndex = 0, a(e.main, s.TCmainStyle),
                //o.backgroundImage = "url(" + l + "main-" + c + ".gif)", s.TCmainClass && (e.main.className = s.TCmainClass),
                o.backgroundImage = "url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_main-' + c + '.gif') + ")",
                s.TCmainClass && (e.main.className = s.TCmainClass),
                e.main.style.display = "none", e.endcap = document.createElement("div"), o = e.endcap.style,
                o.height = e.controlthickness + "px", o.width = e.controlthickness + "px", o.zIndex = 1,
                o.overflow = "hidden", o.position = "absolute", a(e.endcap, s.TCendcapStyle), o.backgroundImage = "url(" + urlTao_endcap + ")",
                s.TCendcapClass && (e.endcap.className = s.TCendcapClass), r(e.editor, e.endcap, "endcap" + c),
                e.main.appendChild(e.endcap), e.paneslider = document.createElement("div"), o = e.paneslider.style,
                o.height = (e.vertical ? e.sliderthickness : e.controlthickness) + "px", o.overflow = "hidden",
                o.width = (e.vertical ? e.controlthickness : e.sliderthickness) + "px", o.position = "absolute",
                o[e.vertical ? "top" : "left"] = "4px", o.zIndex = 3, o.backgroundImage = "url(" + urlTao_paneslider + ")",
                s.TCpanesliderClass && (e.paneslider.className = s.TCpanesliderClass), r(e.editor, e.paneslider, "paneslider" + c),
                e.paneslider.title = u(e.vertical ? "Drag to lock pane horizontally" : "Drag to lock pane vertically"),
                i = {
                    MouseDown: t.TCPSDragFunctionStart,
                    MouseMove: t.TCPSDragFunctionMove,
                    MouseUp: t.TCPSDragFunctionStop,
                    Disabled: function () {
                        return e.editor.busy;
                    }
                }, i.control = e, 1 != t._app && t.DragRegister(e.paneslider, e.vertical, !e.vertical, i, e.editor.toplevel),
                e.main.appendChild(e.paneslider), e.lessbutton = document.createElement("div"),
                o = e.lessbutton.style, o.height = (e.vertical ? e.buttonthickness : e.controlthickness) + "px",
                o.width = (e.vertical ? e.controlthickness : e.buttonthickness) + "px", o.zIndex = 2,
                o.overflow = "hidden", o.position = "absolute", a(e.lessbutton, s.TClessbuttonStyle),
                o.backgroundImage = "url(" + urlTao_lessn + ")", s.TClessbuttonClass && (e.lessbutton.className = s.TClessbuttonClass),
                r(e.editor, e.lessbutton, "lessbutton" + c), n = {
                    repeatwait: s.TClessbuttonRepeatWait,
                    repeatinterval: s.TClessbuttonRepeatInterval,
                    normalstyle: "backgroundImage:url(" + urlTao_lessn + ");",
                    downstyle: "backgroundImage:url(" + urlTao_lessd + ");",
                    hoverstyle: "backgroundImage:url(" + urlTao_lessh + ");"
                }, i = {
                    MouseDown: function () {
                        e.editor.busy || e.editor.ScrollRelative(e.vertical, -1);
                    },
                    Repeat: function () {
                        e.editor.busy || e.editor.ScrollRelative(e.vertical, -1);
                    },
                    Disabled: function () {
                        return e.editor.busy;
                    }
                }, t.ButtonRegister(e.editor, e.lessbutton, n, i), e.main.appendChild(e.lessbutton),
                e.morebutton = document.createElement("div"), o = e.morebutton.style, o.height = (e.vertical ? e.buttonthickness : e.controlthickness) + "px",
                o.width = (e.vertical ? e.controlthickness : e.buttonthickness) + "px", o.zIndex = 2,
                o.overflow = "hidden", o.position = "absolute", a(e.morebutton, s.TCmorebuttonStyle),
                o.backgroundImage = "url(" + urlTao_moren + ")", s.TCmorebuttonClass && (e.morebutton.className = s.TCmorebuttonClass),
                r(e.editor, e.morebutton, "morebutton" + c), n = {
                    repeatwait: s.TCmorebuttonRepeatWait,
                    repeatinterval: s.TCmorebuttonRepeatInterval,
                    normalstyle: "backgroundImage:url(" + urlTao_moren + ");",
                    downstyle: "backgroundImage:url(" + urlTao_mored + ");",
                    hoverstyle: "backgroundImage:url(" + urlTao_moreh + ");"
                }, i = {
                    MouseDown: function () {
                        e.editor.busy || e.editor.ScrollRelative(e.vertical, 1);
                    },
                    Repeat: function () {
                        e.editor.busy || e.editor.ScrollRelative(e.vertical, 1);
                    },
                    Disabled: function () {
                        return e.editor.busy;
                    }
                }, t.ButtonRegister(e.editor, e.morebutton, n, i), e.main.appendChild(e.morebutton),
                e.scrollarea = document.createElement("div"), o = e.scrollarea.style, o.height = e.controlthickness + "px",
                o.width = e.controlthickness + "px", o.zIndex = 1, o.overflow = "hidden", o.position = "absolute",
                a(e.scrollarea, s.TCscrollareaStyle), o.backgroundImage = "url(" + urlTao_scrollarea + ")",
                s.TCscrollareaClass && (e.scrollarea.className = s.TCscrollareaClass), r(e.editor, e.scrollarea, "scrollarea" + c),
                n = {
                    repeatwait: s.TCscrollareaRepeatWait,
                    repeatinterval: s.TCscrollareaRepeatWait
                }, i = {
                    MouseDown: t.ScrollAreaClick,
                    Repeat: t.ScrollAreaClick,
                    Disabled: function () {
                        return e.editor.busy;
                    },

                }, i.control = e, t.ButtonRegister(e.editor, e.scrollarea, n, i), e.main.appendChild(e.scrollarea),
                e.thumb = document.createElement("div"), o = e.thumb.style, o.height = (e.vertical ? e.thumbthickness : e.controlthickness) + "px",
                o.width = (e.vertical ? e.controlthickness : e.thumbthickness) + "px", o.zIndex = 2,
                o.overflow = "hidden", o.position = "absolute", a(e.thumb, s.TCthumbStyle), e.thumb.style.backgroundImage = "url(" + urlTao + ")",
                s.TCthumbClass && (e.thumb.className = s.TCthumbClass), r(e.editor, e.thumb, "thumb" + c),
                i = {
                    MouseDown: t.TCTDragFunctionStart,
                    MouseMove: t.TCTDragFunctionMove,
                    MouseUp: t.TCTDragFunctionStop,
                    Disabled: function () {
                        return e.editor.busy;
                    }
                }, i.control = e, 1 != t._app && t.DragRegister(e.thumb, e.vertical, !e.vertical, i, e.editor.toplevel),
                n = {
                    //normalstyle: "backgroundImage:url(" + l + "thumb-" + c + "n.gif)",
                    normalstyle: "background-image:url(" + urlTao + ")",
                    name: "Thumb",

                    //downstyle: "backgroundImage:url(" + l + "thumb-" + c + "d.gif)",
                    downstyle: "background-image:url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_thumb-' + c + 'd.gif') + ")",
                    hoverstyle: "background-image:url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_thumb-' + c + 'h.gif') + ")"
                    //hoverstyle: "backgroundImage:url(" + l + "thumb-" + c + "h.gif)"
                }, t.ButtonRegister(e.editor, e.thumb, n, null), e.main.appendChild(e.thumb), e.main;
        }, t.ScrollAreaClick = function (e, o, i) {
            var n = i.functionobj.control,
                r = t.GetElementPositionWithScroll(n.editor.toplevel),
                a = n.vertical ? o.clientY - r.top : o.clientX - r.left;
            n.editor.busy || n.editor.PageRelative(n.vertical, a > n.thumbpos ? 1 : -1);
        }, t.PositionTableControlElements = function (e) {
            var t, o, i, n = e.editor;
            e.vertical ? (t = e.controlborder + "px", e.endcap.style.top = e.endcapstart + "px",
                    e.endcap.style.left = t, e.paneslider.style.top = e.panesliderstart + "px", e.paneslider.style.left = t,
                    e.lessbutton.style.top = e.lessbuttonstart + "px", e.lessbutton.style.left = t,
                    e.morebutton.style.top = e.morebuttonstart + "px", e.morebutton.style.left = t,
                    e.scrollarea.style.top = e.scrollareastart + "px", e.scrollarea.style.left = t,
                    e.scrollarea.style.height = e.scrollareasize + "px", o = Math.max(n.context.sheetobj.attribs.lastrow, n.firstscrollingrow + 1),
                    i = (n.firstscrollingrow - (n.lastnonscrollingrow + 1)) * (e.scrollareasize - 3 * e.thumbthickness) / (o - (n.lastnonscrollingrow + 1)) + e.scrollareastart - 1,
                    i = Math.floor(i), e.thumb.style.top = i + "px", e.thumb.style.left = t) : (t = e.controlborder + "px",
                    e.endcap.style.left = e.endcapstart + "px", e.endcap.style.top = t, e.paneslider.style.left = e.panesliderstart + "px",
                    e.paneslider.style.top = t, e.lessbutton.style.left = e.lessbuttonstart + "px",
                    e.lessbutton.style.top = t, e.morebutton.style.left = e.morebuttonstart + "px",
                    e.morebutton.style.top = t, e.scrollarea.style.left = e.scrollareastart + "px",
                    e.scrollarea.style.top = t, e.scrollarea.style.width = e.scrollareasize + "px",
                    o = Math.max(n.context.sheetobj.attribs.lastcol, n.firstscrollingcol + 1), i = (n.firstscrollingcol - (n.lastnonscrollingcol + 1)) * (e.scrollareasize - e.thumbthickness) / (o - n.lastnonscrollingcol) + e.scrollareastart - 1,
                    i = Math.floor(i), e.thumb.style.left = i + "px", e.thumb.style.top = t), e.thumbpos = i,
                e.main.style.display = "block";
        }, t.ComputeTableControlPositions = function (e) {
            var t = e.editor;
            if (!t.gridposition || !t.headposition) throw "Can't compute table control positions before editor positions";
            e.vertical ? (e.controlborder = t.gridposition.left + t.tablewidth, e.endcapstart = t.gridposition.top,
                e.panesliderstart = t.firstscrollingrowtop - e.sliderthickness, e.lessbuttonstart = t.firstscrollingrowtop - 1,
                e.morebuttonstart = t.gridposition.top + t.tableheight - e.buttonthickness, e.scrollareastart = t.firstscrollingrowtop - 1 + e.buttonthickness,
                e.scrollareaend = e.morebuttonstart - 1, e.scrollareasize = e.scrollareaend - e.scrollareastart + 1) : (e.controlborder = t.gridposition.top + t.tableheight,
                e.endcapstart = t.gridposition.left, e.panesliderstart = t.firstscrollingcolleft - e.sliderthickness,
                e.lessbuttonstart = t.firstscrollingcolleft - 1, e.morebuttonstart = t.gridposition.left + t.tablewidth - e.buttonthickness,
                e.scrollareastart = t.firstscrollingcolleft - 1 + e.buttonthickness, e.scrollareaend = e.morebuttonstart - 1,
                e.scrollareasize = e.scrollareaend - e.scrollareastart + 1);
        }, t.TCPSDragFunctionStart = function (e, o, i) {
            var n = i.functionobj.control.editor,
                r = t.Constants;
            t.DragFunctionStart(e, o, i), o.trackingline = document.createElement("div"), o.trackingline.style.height = i.vertical ? r.TCPStrackinglineThickness : n.tableheight - (n.headposition.top - n.gridposition.top) + "px",
                o.trackingline.style.width = i.vertical ? n.tablewidth - (n.headposition.left - n.gridposition.left) + "px" : r.TCPStrackinglineThickness,
                o.trackingline.style.backgroundImage = "url(" + assetManager.resolve('EtherCalc/runtime/assets/' + n.imageprefix + '"trackingline-" + (i.vertical ? "v" : "h") + ".gif)"'),
                r.TCPStrackinglineClass && (o.trackingline.className = r.TCPStrackinglineClass),
                t.setStyles(o.trackingline, r.TCPStrackinglineStyle), i.vertical ? (row = t.Lookup(o.clientY + i.functionobj.control.sliderthickness, n.rowpositions),
                    o.trackingline.style.top = (n.rowpositions[row] || n.headposition.top) + "px", o.trackingline.style.left = n.headposition.left + "px",
                    o.trackingline.id = "trackingline-vertical", n.context.rowpanes.length - 1 && (n.context.SetRowPaneFirstLast(1, n.context.rowpanes[0].last + 1, n.context.rowpanes[0].last + 1),
                        n.FitToEditTable(), n.ScheduleRender())) : (col = t.Lookup(o.clientX + i.functionobj.control.sliderthickness, n.colpositions),
                    o.trackingline.style.top = n.headposition.top + "px", o.trackingline.style.left = (n.colpositions[col] || n.headposition.left) + "px",
                    o.trackingline.id = "trackingline-horizon", n.context.colpanes.length - 1 && (n.context.SetColPaneFirstLast(1, n.context.colpanes[0].last + 1, n.context.colpanes[0].last + 1),
                        n.FitToEditTable(), n.ScheduleRender())), n.griddiv.appendChild(o.trackingline);
        }, t.TCPSDragFunctionMove = function (e, o, i) {
            var n, r, a, s, l = i.functionobj.control,
                c = l.sliderthickness,
                u = l.editor;
            if (i.vertical) {
                for (a = l.morebuttonstart - l.minscrollingpanesize - o.offsetY, o.clientY > a && (o.clientY = a),
                    s = u.headposition.top - c - o.offsetY, o.clientY < s && (o.clientY = s), n = t.Lookup(o.clientY + c, u.rowpositions);
                    "yes" == u.context.sheetobj.rowattribs.hide[n];) n++;
                o.trackingline.style.top = (u.rowpositions[n] || u.headposition.top) + "px";
            } else {
                for (a = l.morebuttonstart - l.minscrollingpanesize - o.offsetX, o.clientX > a && (o.clientX = a),
                    s = u.headposition.left - c - o.offsetX, o.clientX < s && (o.clientX = s), r = t.Lookup(o.clientX + c, u.colpositions);
                    "yes" == u.context.sheetobj.colattribs.hide[t.rcColname(r)];) r++;
                o.trackingline.style.left = (u.colpositions[r] || u.headposition.left) + "px";
            }
            t.DragFunctionPosition(e, o, i);
        }, t.TCPSDragFunctionStop = function (e, o, i) {
            var n, r, a, s, l = i.functionobj.control,
                c = l.sliderthickness,
                u = l.editor;
            if (i.vertical) {
                for (a = l.morebuttonstart - l.minscrollingpanesize - o.offsetY, o.clientY > a && (o.clientY = a),
                    s = u.headposition.top - c - o.offsetY, o.clientY < s && (o.clientY = s), n = t.Lookup(o.clientY + c, u.rowpositions),
                    n > u.context.sheetobj.attribs.lastrow && (n = u.context.sheetobj.attribs.lastrow);
                    "yes" == u.context.sheetobj.rowattribs.hide[n];) n++;
                u.EditorScheduleSheetCommands("pane row " + n, !0, !1);
            } else {
                for (a = l.morebuttonstart - l.minscrollingpanesize - o.offsetX, o.clientX > a && (o.clientX = a),
                    s = u.headposition.left - c - o.offsetX, o.clientX < s && (o.clientX = s), r = t.Lookup(o.clientX + c, u.colpositions),
                    r > u.context.sheetobj.attribs.lastcol && (r = u.context.sheetobj.attribs.lastcol);
                    "yes" == u.context.sheetobj.colattribs.hide[t.rcColname(r)];) r++;
                u.EditorScheduleSheetCommands("pane col " + r, !0, !1);
            }
        }, t.TCTDragFunctionStart = function (e, o, i) {
            var n = i.functionobj.control,
                r = n.editor,
                a = t.Constants;
            if (t.DragFunctionStart(e, o, i), o.thumbstatus && (o.thumbstatus.rowmsgele && (o.thumbstatus.rowmsgele = null),
                    o.thumbstatus.rowpreviewele && (o.thumbstatus.rowpreviewele = null), r.toplevel.removeChild(o.thumbstatus),
                    o.thumbstatus = null), o.thumbstatus = document.createElement("div"), i.vertical) {
                a.TCTDFSthumbstatusvClass && (o.thumbstatus.className = a.TCTDFSthumbstatusvClass),
                    t.setStyles(o.thumbstatus, a.TCTDFSthumbstatusvStyle), o.thumbstatus.style.top = o.clientY + a.TCTDFStopOffsetv + "px",
                    o.thumbstatus.style.left = n.controlborder - 10 - r.tablewidth / 2 + "px", o.thumbstatus.style.width = r.tablewidth / 2 + "px",
                    o.thumbcontext = new t.RenderContext(r.context.sheetobj), o.thumbcontext.showGrid = !0,
                    o.thumbcontext.rowpanes = [{
                        first: 1,
                        last: 1
                    }];
                var s = r.context.colpanes[r.context.colpanes.length - 1];
                o.thumbcontext.colpanes = [{
                        first: s.first,
                        last: s.last
                    }], o.thumbstatus.innerHTML = '<table cellspacing="0" cellpadding="0"><tr><td valign="top" style="' + a.TCTDFSthumbstatusrownumStyle + '" class="' + a.TCTDFSthumbstatusrownumClass + '"><div>msg</div></td><td valign="top"><div style="overflow:hidden;">preview</div></td></tr></table>',
                    o.thumbstatus.rowmsgele = o.thumbstatus.firstChild.firstChild.firstChild.firstChild.firstChild,
                    o.thumbstatus.rowpreviewele = o.thumbstatus.firstChild.firstChild.firstChild.childNodes[1].firstChild,
                    r.toplevel.appendChild(o.thumbstatus), t.TCTDragFunctionRowSetStatus(o, r, r.firstscrollingrow || 1);
            } else a.TCTDFSthumbstatushClass && (o.thumbstatus.className = a.TCTDFSthumbstatushClass),
                t.setStyles(o.thumbstatus, a.TCTDFSthumbstatushStyle), o.thumbstatus.style.top = n.controlborder + a.TCTDFStopOffseth + "px",
                o.thumbstatus.style.left = o.clientX + a.TCTDFSleftOffseth + "px", r.toplevel.appendChild(o.thumbstatus),
                o.thumbstatus.innerHTML = a.s_TCTDFthumbstatusPrefixh + t.rcColname(r.firstscrollingcol);
        }, t.TCTDragFunctionRowSetStatus = function (e, o, i) {
            var n = t.Constants,
                r = n.s_TCTDFthumbstatusPrefixv + i + " ";
            e.thumbstatus.rowmsgele.innerHTML = r, e.thumbcontext.rowpanes = [{
                first: i,
                last: i
            }], e.thumbrowshown = i;
            e.thumbcontext.RenderSheet(e.thumbstatus.rowpreviewele.firstChild, {
                type: "html"
            });
        }, t.TCTDragFunctionMove = function (e, o, i) {
            var n, r, a = i.functionobj.control,
                s = (a.thumbthickness, a.editor),
                l = t.Constants;
            i.vertical ? (o.clientY > a.scrollareaend - o.offsetY - a.thumbthickness + 2 && (o.clientY = a.scrollareaend - o.offsetY - a.thumbthickness + 2),
                    o.clientY < a.scrollareastart - o.offsetY - 1 && (o.clientY = a.scrollareastart - o.offsetY - 1),
                    o.thumbstatus.style.top = o.clientY + "px", n = (o.clientY + o.offsetY - a.scrollareastart + 1) / (a.scrollareasize - a.thumbthickness) * (s.context.sheetobj.attribs.lastrow - s.lastnonscrollingrow) + s.lastnonscrollingrow + 1,
                    n = Math.floor(n), n <= s.lastnonscrollingrow && (n = s.lastnonscrollingrow + 1),
                    n > s.context.sheetobj.attribs.lastrow && (n = s.context.sheetobj.attribs.lastrow),
                    n != o.thumbrowshown && t.TCTDragFunctionRowSetStatus(o, s, n)) : (o.clientX > a.scrollareaend - o.offsetX - a.thumbthickness + 2 && (o.clientX = a.scrollareaend - o.offsetX - a.thumbthickness + 2),
                    o.clientX < a.scrollareastart - o.offsetX - 1 && (o.clientX = a.scrollareastart - o.offsetX - 1),
                    o.thumbstatus.style.left = o.clientX + "px", n = (o.clientX + o.offsetX - a.scrollareastart + 1) / (a.scrollareasize - a.thumbthickness) * (s.context.sheetobj.attribs.lastcol - s.lastnonscrollingcol) + s.lastnonscrollingcol + 1,
                    n = Math.floor(n), n <= s.lastnonscrollingcol && (n = s.lastnonscrollingcol + 1),
                    n > s.context.sheetobj.attribs.lastcol && (n = s.context.sheetobj.attribs.lastcol),
                    r = l.s_TCTDFthumbstatusPrefixh + t.rcColname(n), o.thumbstatus.innerHTML = r),
                t.DragFunctionPosition(e, o, i);
        }, t.TCTDragFunctionStop = function (e, t, o) {
            var i, n = o.functionobj.control,
                r = n.editor;
            o.vertical ? (i = (t.clientY + t.offsetY - n.scrollareastart + 1) / (n.scrollareasize - n.thumbthickness) * (r.context.sheetobj.attribs.lastrow - r.lastnonscrollingrow) + r.lastnonscrollingrow + 1,
                    i = Math.floor(i), i <= r.lastnonscrollingrow && (i = r.lastnonscrollingrow + 1),
                    i > r.context.sheetobj.attribs.lastrow && (i = r.context.sheetobj.attribs.lastrow),
                    r.context.SetRowPaneFirstLast(r.context.rowpanes.length - 1, i, i + 1)) : (i = (t.clientX + t.offsetX - n.scrollareastart + 1) / (n.scrollareasize - n.thumbthickness) * (r.context.sheetobj.attribs.lastcol - r.lastnonscrollingcol) + r.lastnonscrollingcol + 1,
                    i = Math.floor(i), i <= r.lastnonscrollingcol && (i = r.lastnonscrollingcol + 1),
                    i > r.context.sheetobj.attribs.lastcol && (i = r.context.sheetobj.attribs.lastcol),
                    r.context.SetColPaneFirstLast(r.context.colpanes.length - 1, i, i + 1)), r.FitToEditTable(),
                t.thumbstatus.rowmsgele && (t.thumbstatus.rowmsgele = null), t.thumbstatus.rowpreviewele && (t.thumbstatus.rowpreviewele = null),
                r.toplevel.removeChild(t.thumbstatus), t.thumbstatus = null, r.ScheduleRender();
        }, t.DragInfo = {
            registeredElements: [],
            draggingElement: null,
            startX: 0,
            startY: 0,
            startZ: 0,
            clientX: 0,
            clientY: 0,
            offsetX: 0,
            offsetY: 0,
            relativeOffset: {
                left: 0,
                top: 0
            }
        }, t.DragRegister = function (e, o, i, n, r) {
            var a = t.DragInfo;
            if (n || (n = {
                    MouseDown: t.DragFunctionStart,
                    MouseMove: t.DragFunctionPosition,
                    MouseUp: t.DragFunctionPosition,
                    Disabled: null
                }), a.registeredElements.push({
                    element: e,
                    vertical: o,
                    horizontal: i,
                    functionobj: n,
                    parent: r
                }), e.addEventListener) e.addEventListener("mousedown", t.DragMouseDown, !1);
            else {
                if (!e.attachEvent) throw t.Constants.s_BrowserNotSupported;
                e.attachEvent("onmousedown", t.DragMouseDown);
            }
        }, t.DragUnregister = function (e) {
            var o, i = t.DragInfo;
            if (e)
                for (o = 0; o < i.registeredElements.length; o++)
                    if (i.registeredElements[o].element == e) return i.registeredElements.splice(o, 1),
                        void(e.removeEventListener ? e.removeEventListener("mousedown", t.DragMouseDown, !1) : e.detachEvent("onmousedown", t.DragMouseDown));
        }, t.DragMouseDown = function (o) {
            var i = o || e.event,
                n = t.DragInfo,
                r = t.LookupElement(i.target || i.srcElement, n.registeredElements);
            return !r || r && r.functionobj && r.functionobj.Disabled && r.functionobj.Disabled(i, n, r) ? void 0 : (n.draggingElement = r,
                r.parent && (n.relativeOffset = t.GetElementPositionWithScroll(r.parent)), n.clientX = i.clientX - n.relativeOffset.left,
                n.clientY = i.clientY - n.relativeOffset.top, n.startX = n.clientX, n.startY = n.clientY,
                n.startZ = r.element.style.zIndex, n.offsetX = 0, n.offsetY = 0, r.element.style.zIndex = "100",
                t.SetMouseMoveUp(t.DragMouseMove, t.DragMouseUp, r.element, i), r && r.functionobj && r.functionobj.MouseDown && r.functionobj.MouseDown(i, n, r),
                !1);
        }, t.DragMouseMove = function (o) {
            var i = o || e.event,
                n = t.DragInfo,
                r = n.draggingElement;
            return n.clientX = i.clientX - n.relativeOffset.left, n.clientY = i.clientY - n.relativeOffset.top,
                t.StopPropagation(i), r && r.functionobj && r.functionobj.MouseMove && r.functionobj.MouseMove(i, n, r),
                !1;
        }, t.DragMouseUp = function (o) {
            var i = o || e.event,
                n = t.DragInfo,
                r = n.draggingElement;
            return n.clientX = i.clientX - n.relativeOffset.left, n.clientY = i.clientY - n.relativeOffset.top,
                r.element.style.zIndex = n.startZ, r && r.functionobj && r.functionobj.MouseUp && r.functionobj.MouseUp(i, n, r),
                t.RemoveMouseMoveUp(t.DragMouseMove, t.DragMouseUp, r.element, i), n.draggingElement = null,
                !1;
        }, t.DragFunctionStart = function (e, t, o) {
            var i = o.functionobj.positionobj || o.element;
            t.offsetY = parseInt(i.style.top) - t.clientY, t.offsetX = parseInt(i.style.left) - t.clientX;
        }, t.DragFunctionPosition = function (e, t, o) {
            var i = o.functionobj.positionobj || o.element;
            o.vertical && (i.style.top = t.clientY + t.offsetY + "px"), o.horizontal && (i.style.left = t.clientX + t.offsetX + "px");
        }, t.ButtonInfo = {
            registeredElements: [],
            buttonElement: null,
            doingHover: !1,
            buttonDown: !1,
            timer: null,
            relativeOffset: null,
            clientX: 0,
            clientY: 0
        }, t.ButtonRegister = function (e, o, i, n) {
            var r = t.ButtonInfo;
            if (i || (i = {}), r.registeredElements.push({
                    name: i.name,
                    element: o,
                    editor: e,
                    normalstyle: i.normalstyle,
                    hoverstyle: i.hoverstyle,
                    downstyle: i.downstyle,
                    repeatwait: i.repeatwait,
                    repeatinterval: i.repeatinterval,
                    functionobj: n
                }), o.addEventListener) o.addEventListener("mousedown", t.ButtonMouseDown, !1),
                o.addEventListener("mouseover", t.ButtonMouseOver, !1), o.addEventListener("mouseout", t.ButtonMouseOut, !1);
            else {
                if (!o.attachEvent) throw t.Constants.s_BrowserNotSupported;
                o.attachEvent("onmousedown", t.ButtonMouseDown), o.attachEvent("onmouseover", t.ButtonMouseOver),
                    o.attachEvent("onmouseout", t.ButtonMouseOut);
            }
        }, t.ButtonMouseOver = function (o) {
            var i = o || e.event,
                n = t.ButtonInfo,
                r = t.LookupElement(i.target || i.srcElement, n.registeredElements);
            if (r) {
                if (n.buttonDown) return void(n.buttonElement == r && (n.doingHover = !0));
                n.buttonElement && n.buttonElement != r && n.doingHover && t.setStyles(n.buttonElement.element, n.buttonElement.normalstyle),
                    n.buttonElement = r, n.doingHover = !0, t.setStyles(r.element, r.hoverstyle), r && r.functionobj && r.functionobj.MouseOver && r.functionobj.MouseOver(i, n, r);
            }
        }, t.ButtonMouseOut = function (o) {
            var i = o || e.event,
                n = t.ButtonInfo;
            if (n.buttonDown) return void(n.doingHover = !1);
            var r = t.LookupElement(i.target || i.srcElement, n.registeredElements);
            n.doingHover && (n.buttonElement && t.setStyles(n.buttonElement.element, n.buttonElement.normalstyle),
                n.buttonElement = null, n.doingHover = !1), r && r.functionobj && r.functionobj.MouseOut && r.functionobj.MouseOut(i, n, r);
        }, t.ButtonMouseDown = function (o) {
            var i = o || e.event,
                n = t.ButtonInfo,
                r = (t.GetViewportInfo(), t.LookupElement(i.target || i.srcElement, n.registeredElements));
            r && (r && r.functionobj && r.functionobj.Disabled && r.functionobj.Disabled(i, n, r) || (n.buttonElement = r,
                n.buttonDown = !0, t.setStyles(r.element, n.buttonElement.downstyle), document.addEventListener ? document.addEventListener("mouseup", t.ButtonMouseUp, !0) : r.element.attachEvent && (r.element.setCapture(),
                    r.element.attachEvent("onmouseup", t.ButtonMouseUp), r.element.attachEvent("onlosecapture", t.ButtonMouseUp)),
                t.StopPropagation(i), n.relativeOffset = t.GetElementPositionWithScroll(r.editor.toplevel),
                n.clientX = i.clientX - n.relativeOffset.left, n.clientY = i.clientY - n.relativeOffset.top,
                r && r.functionobj && r.functionobj.MouseDown && r.functionobj.MouseDown(i, n, r),
                r.repeatwait && (n.timer = e.setTimeout(t.ButtonRepeat, r.repeatwait))));
        }, t.ButtonMouseUp = function (o) {
            var i = o || e.event,
                n = t.ButtonInfo,
                r = n.buttonElement;
            n.timer && (e.clearTimeout(n.timer), n.timer = null), n.buttonDown && (t.StopPropagation(i),
                document.removeEventListener ? document.removeEventListener("mouseup", t.ButtonMouseUp, !0) : document.detachEvent && (r.element.detachEvent("onlosecapture", t.ButtonMouseUp),
                    r.element.detachEvent("onmouseup", t.ButtonMouseUp), r.element.releaseCapture()),
                n.buttonElement.downstyle && (n.doingHover ? t.setStyles(r.element, n.buttonElement.hoverstyle) : t.setStyles(r.element, n.buttonElement.normalstyle)),
                n.buttonDown = !1, r && r.functionobj && r.functionobj.MouseUp && r.functionobj.MouseUp(i, n, r));
        }, t.ButtonRepeat = function () {
            var o = t.ButtonInfo,
                i = o.buttonElement;
            i && (i && i.functionobj && i.functionobj.Repeat && i.functionobj.Repeat(null, o, i),
                o.timer = e.setTimeout(t.ButtonRepeat, i.repeatinterval || 100));
        }, t.MouseWheelInfo = {
            registeredElements: []
        }, t.MouseWheelRegister = function (e, o) {
            var i = t.MouseWheelInfo;
            if (i.registeredElements.push({
                    element: e,
                    functionobj: o
                }), e.addEventListener) e.addEventListener("DOMMouseScroll", t.ProcessMouseWheel, !1),
                e.addEventListener("mousewheel", t.ProcessMouseWheel, !1);
            else {
                if (!e.attachEvent) throw t.Constants.s_BrowserNotSupported;
                e.attachEvent("onmousewheel", t.ProcessMouseWheel);
            }
        }, t.ProcessMouseWheel = function (o) {
            var i, n = o || e.event;
            if (!t.Keyboard.passThru) {
                var r, a = t.MouseWheelInfo,
                    s = n.target || n.srcElement;
                for (r = null; !r && s; s = s.parentNode) r = t.LookupElement(s, a.registeredElements);
                r && (i = n.wheelDelta ? n.wheelDelta / 120 : -n.detail / 3, i || (i = 0), r.functionobj && r.functionobj.WheelMove && r.functionobj.WheelMove(n, i, a, r),
                    n.preventDefault && n.preventDefault(), n.returnValue = !1);
            }
        }, t.keyboardTables = {
            specialKeysCommon: {
                8: "[backspace]",
                9: "[tab]",
                13: "[enter]",
                25: "[tab]",
                27: "[esc]",
                33: "[pgup]",
                34: "[pgdn]",
                35: "[end]",
                36: "[home]",
                37: "[aleft]",
                38: "[aup]",
                39: "[aright]",
                40: "[adown]",
                45: "[ins]",
                46: "[del]",
                113: "[f2]"
            },
            specialKeysIE: {
                8: "[backspace]",
                9: "[tab]",
                13: "[enter]",
                25: "[tab]",
                27: "[esc]",
                33: "[pgup]",
                34: "[pgdn]",
                35: "[end]",
                36: "[home]",
                37: "[aleft]",
                38: "[aup]",
                39: "[aright]",
                40: "[adown]",
                45: "[ins]",
                46: "[del]",
                113: "[f2]"
            },
            controlKeysIE: {
                65: "[ctrl-a]",
                67: "[ctrl-c]",
                83: "[ctrl-s]",
                86: "[ctrl-v]",
                88: "[ctrl-x]",
                90: "[ctrl-z]"
            },
            specialKeysOpera: {
                8: "[backspace]",
                9: "[tab]",
                13: "[enter]",
                25: "[tab]",
                27: "[esc]",
                33: "[pgup]",
                34: "[pgdn]",
                35: "[end]",
                36: "[home]",
                37: "[aleft]",
                38: "[aup]",
                39: "[aright]",
                40: "[adown]",
                45: "[ins]",
                46: "[del]",
                113: "[f2]"
            },
            controlKeysOpera: {
                65: "[ctrl-a]",
                67: "[ctrl-c]",
                83: "[ctrl-s]",
                86: "[ctrl-v]",
                88: "[ctrl-x]",
                90: "[ctrl-z]"
            },
            specialKeysSafari: {
                8: "[backspace]",
                9: "[tab]",
                13: "[enter]",
                25: "[tab]",
                27: "[esc]",
                63232: "[aup]",
                63233: "[adown]",
                63234: "[aleft]",
                63235: "[aright]",
                63272: "[del]",
                63273: "[home]",
                63275: "[end]",
                63276: "[pgup]",
                63277: "[pgdn]",
                63237: "[f2]"
            },
            controlKeysSafari: {
                97: "[ctrl-a]",
                99: "[ctrl-c]",
                115: "[ctrl-s]",
                118: "[ctrl-v]",
                120: "[ctrl-x]",
                122: "[ctrl-z]"
            },
            ignoreKeysSafari: {
                63236: "[f1]",
                63238: "[f3]",
                63239: "[f4]",
                63240: "[f5]",
                63241: "[f6]",
                63242: "[f7]",
                63243: "[f8]",
                63244: "[f9]",
                63245: "[f10]",
                63246: "[f11]",
                63247: "[f12]",
                63289: "[numlock]"
            },
            specialKeysFirefox: {
                8: "[backspace]",
                9: "[tab]",
                13: "[enter]",
                25: "[tab]",
                27: "[esc]",
                33: "[pgup]",
                34: "[pgdn]",
                35: "[end]",
                36: "[home]",
                37: "[aleft]",
                38: "[aup]",
                39: "[aright]",
                40: "[adown]",
                45: "[ins]",
                46: "[del]",
                113: "[f2]"
            },
            controlKeysFirefox: {
                97: "[ctrl-a]",
                99: "[ctrl-c]",
                115: "[ctrl-s]",
                118: "[ctrl-v]",
                120: "[ctrl-x]",
                122: "[ctrl-z]"
            },
            ignoreKeysFirefox: {
                16: "[shift]",
                17: "[ctrl]",
                18: "[alt]",
                20: "[capslock]",
                19: "[pause]",
                44: "[printscreen]",
                91: "[windows]",
                92: "[windows]",
                112: "[f1]",
                114: "[f3]",
                115: "[f4]",
                116: "[f5]",
                117: "[f6]",
                118: "[f7]",
                119: "[f8]",
                120: "[f9]",
                121: "[f10]",
                122: "[f11]",
                123: "[f12]",
                144: "[numlock]",
                145: "[scrolllock]",
                224: "[cmd]"
            }
        }, t.Keyboard = {
            areListener: !1,
            focusTable: null,
            passThru: null,
            didProcessKey: !1,
            statusFromProcessKey: !1,
            repeatingKeyPress: !1,
            chForProcessKey: ""
        }, t.KeyboardSetFocus = function (o) {
            t.Keyboard.focusTable = o, t.Keyboard.areListener || (document.onkeydown = t.ProcessKeyDown,
                document.onkeypress = t.ProcessKeyPress, t.Keyboard.areListener = !0), t.Keyboard.passThru && (t.Keyboard.passThru.blur && t.Keyboard.passThru.blur(),
                t.Keyboard.passThru = null), e.focus();
        }, t.KeyboardFocus = function () {
            t.Keyboard.passThru = null, e.focus();
        }, t.ProcessKeyDown = function (o) {
            var i = t.keyboardTables;
            i.didProcessKey = !1, i.statusFromProcessKey = !1, i.repeatingKeyPress = !1;
            var n = "",
                r = !0;
            if (!t._app && !t.Keyboard.passThru) {
                if (o = o || e.event, void 0 == o.which) {
                    if (n = i.specialKeysCommon[o.keyCode], !n && (o.ctrlKey && (n = i.controlKeysIE[o.keyCode]),
                            !n)) return !0;
                    r = t.ProcessKey(n, o), r || (o.preventDefault && o.preventDefault(), o.returnValue = !1);
                } else {
                    if (n = i.specialKeysCommon[o.keyCode], !n && ((o.ctrlKey || o.metaKey) && (n = i.controlKeysIE[o.keyCode]),
                            !n)) return !0;
                    r = t.ProcessKey(n, o), i.didProcessKey = !0, i.statusFromProcessKey = r, i.chForProcessKey = n;
                }
                return r;
            }
        }, t.ProcessKeyPress = function (o) {
            var i = t.keyboardTables,
                n = "";
            
            if (o = o || e.event, !t._app && !t.Keyboard.passThru) {
                if (i.didProcessKey) return i.repeatingKeyPress ? t.ProcessKey(i.chForProcessKey, o) : (i.repeatingKeyPress = !0,
                    i.statusFromProcessKey);
                if (void 0 == o.which) n = String.fromCharCode(o.keyCode);
                else {
                    if (!o.which) return !1;
                    if (void 0 == o.charCode) {
                        if (0 == o.which) return !0;
                        if (o.which < 32 || 144 == o.which) {
                            if (n = i.specialKeysOpera[o.which]) return !0;
                        } else n = o.ctrlKey ? i.controlKeysOpera[o.keyCode] : String.fromCharCode(o.which);
                    } else {
                        if (0 == o.keyCode && 0 == o.charCode) return;
                        if (o.keyCode == o.charCode) {
                            if (n = i.specialKeysSafari[o.keyCode], !n) {
                                if (i.ignoreKeysSafari[o.keyCode]) return !0;
                                n = o.metaKey ? i.controlKeysSafari[o.keyCode] : String.fromCharCode(o.which);
                            }
                        } else {
                            if (i.specialKeysFirefox[o.keyCode]) return !0;
                            n = String.fromCharCode(o.which), (o.ctrlKey || o.metaKey) && (n = i.controlKeysFirefox[o.which]);
                        }
                    }
                }
                var r = t.ProcessKey(n, o);
                return r || (o.preventDefault && o.preventDefault(), o.returnValue = !1), r;
            }
        }, t.ProcessKey = function (e, o) {
            var i = t.Keyboard.focusTable;
            return i ? i.EditorProcessKey(e, o) : !0;
        };

        var t;
        t || (t = {}), t.FormatNumber = {}, t.FormatNumber.format_definitions = {}, t.FormatNumber.separatorchar = ",",
            t.FormatNumber.decimalchar = ".", t.FormatNumber.daynames = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
            t.FormatNumber.daynames3 = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
            t.FormatNumber.monthnames3 = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
            t.FormatNumber.monthnames = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
            t.FormatNumber.allowedcolors = {
                BLACK: "#000000",
                BLUE: "#0000FF",
                CYAN: "#00FFFF",
                GREEN: "#00FF00",
                MAGENTA: "#FF00FF",
                RED: "#FF0000",
                WHITE: "#FFFFFF",
                YELLOW: "#FFFF00"
            }, t.FormatNumber.alloweddates = {
                H: "h]",
                M: "m]",
                MM: "mm]",
                S: "s]",
                SS: "ss]"
            }, t.FormatNumber.commands = {
                copy: 1,
                color: 2,
                integer_placeholder: 3,
                fraction_placeholder: 4,
                decimal: 5,
                currency: 6,
                general: 7,
                separator: 8,
                date: 9,
                comparison: 10,
                section: 11,
                style: 12
            }, t.FormatNumber.datevalues = {
                julian_offset: 2415019,
                seconds_in_a_day: 86400,
                seconds_in_an_hour: 3600
            }, t.FormatNumber.formatNumberWithFormat = function (e, o, i) {
                var n, r, a, s, l, c, u, d, h, p, f, m, g, v, b, y, C, w, x, _, S, k, T, F, E, D, P, A, I, M, R, N, L, O, z, H, B, U, j, V = t.Constants,
                    W = t.FormatNumber,
                    G = "";
                if ("string" == typeof e && !e.length) return "";
                if (j = e - 0, !isFinite(j)) return "string" == typeof e ? W.formatTextWithFormat(e, o) : "NaN";
                e = j;
                var $ = 0 > j ? 1 : 0;
                $ && (j = -j);
                var Y = 0 == j ? 1 : 0;
                if (i = i || V.FormatNumber_DefaultCurrency, W.parse_format_string(W.format_definitions, o),
                    C = W.format_definitions[o], !C) throw "Format not parsed error!";
                if (w = C.sectioninfo.length - 1, C.hascomparison)
                    for (w = 0, x = 0, k = 0;; k++) {
                        if (n = C.operators[k], r = C.operands[k], !n) {
                            x && (o = "General", W.parse_format_string(W.format_definitions, o), C = W.format_definitions[o],
                                w = 0);
                            break;
                        }
                        if (n != W.commands.section) {
                            if (n == W.commands.comparison) {
                                if (E = r.indexOf(":"), _ = r.substring(0, E), S = r.substring(E + 1) - 0, "<" == _ && S > e || "<=" == _ && S >= e || "=" == _ && e == S || "<>" == _ && e != S || ">=" == _ && e >= S || ">" == _ && e > S) break;
                                x = 1;
                            }
                        } else {
                            if (!x) break;
                            x = 0, w++;
                        }
                    } else w > 0 && (1 == w ? $ ? ($ = 0, w = 1) : w = 0 : (2 == w || 3 == w) && ($ ? ($ = 0,
                        w = 1) : w = Y ? 2 : 0));
                if (F = C.sectioninfo[w], F.commas > 0)
                    for (E = 0; E < F.commas; E++) j /= 1e3;
                if (F.percent > 0)
                    for (E = 0; E < F.percent; E++) j *= 100;
                for (D = 1, E = 0; E < F.fractiondigits; E++) D *= 10;
                if (P = Math.floor(j * D + .5), P /= D, "number" != typeof P) return "NaN";
                if (!isFinite(P)) return "NaN";
                if (A = P + "", 0 == P && (F.fractiondigits || F.integerdigits) && ($ = 0), A.indexOf("e") >= 0) return e + "";
                if (I = A.match(/^\+{0,1}(\d*)(?:\.(\d*)){0,1}$/), !I) return "NaN";
                if (M = I[1], M && "0" != M || (M = ""), R = I[2], R || (R = ""), F.hasdate) {
                    if (0 > e) return "??-???-??&nbsp;??:??:??";
                    for (c = (e - Math.floor(e)) * W.datevalues.seconds_in_a_day, u = e * W.datevalues.seconds_in_a_day,
                        d = Math.floor(c / W.datevalues.seconds_in_an_hour), f = Math.floor(u / W.datevalues.seconds_in_an_hour),
                        c -= d * W.datevalues.seconds_in_an_hour, h = Math.floor(c / 60), m = Math.floor(u / 60),
                        p = c - 60 * h, D = 1, E = 0; E < F.fractiondigits; E++) D *= 10;
                    for (p = Math.floor(p * D + .5), p /= D, g = Math.floor(u * D + .5), g /= D, p >= 60 && (p = 0,
                            h++, m++, h >= 60 && (h = 0, d++, f++, d >= 24 && (d = 0, e++))), R = p - Math.floor(p) + "",
                        R = R.substring(2), b = t.FormatNumber.convert_date_julian_to_gregorian(Math.floor(e + W.datevalues.julian_offset)),
                        y = 0, mspos = F.sectionstart;
                        (n = C.operators[mspos], r = C.operands[mspos], n) && n != W.commands.section; mspos++) n == W.commands.date ? ("am/pm" != r.toLowerCase() && "a/p" != r.toLowerCase() || v || (d >= 12 ? (d -= 12,
                                v = "a/p" == r.toLowerCase() ? V.s_FormatNumber_pm1 : V.s_FormatNumber_pm) : v = "a/p" == r.toLowerCase() ? V.s_FormatNumber_am1 : V.s_FormatNumber_am,
                            r.indexOf(v) < 0 && (v = v.toLowerCase())), !y || "m" != r && "mm" != r || (C.operands[mspos] += "in"),
                        y = "h" == r.charAt(0) ? 1 : 0) : n != W.commands.copy && (y = 0);
                    for (y = 0, --mspos;
                        (n = C.operators[mspos], r = C.operands[mspos], n) && n != W.commands.section; mspos--) n == W.commands.date ? (!y || "m" != r && "mm" != r || (C.operands[mspos] += "in"),
                        y = "ss" == r ? 1 : 0) : n != W.commands.copy && (y = 0);
                }
                for (N = 0, L = 0, O = 0, z = "", H = "", B = V.FormatNumber_separatorchar, B.indexOf(" ") >= 0 && (B = B.replace(/ /g, "&nbsp;")),
                    U = V.FormatNumber_decimalchar, U.indexOf(" ") >= 0 && (U = U.replace(/ /g, "&nbsp;")),
                    T = F.sectionstart; n = C.operators[T];)
                    if (r = C.operands[T++], n == W.commands.copy) G += r;
                    else if (n == W.commands.color) z = r;
                else if (n == W.commands.style) H = r;
                else if (n == W.commands.integer_placeholder) {
                    if ($ && (G += "-", $ = 0), N++, 1 == N && M.length > F.integerdigits)
                        for (; L < M.length - F.integerdigits; L++) G += M.charAt(L),
                            F.thousandssep && (a = M.length - L - 1, a > 2 && a % 3 == 0 && (G += B));
                    M.length < F.integerdigits && N <= F.integerdigits - M.length ? ("0" == r || "?" == r) && (G += "0" == r ? "0" : "&nbsp;",
                        F.thousandssep && (a = F.integerdigits - N, a > 2 && a % 3 == 0 && (G += B))) : (G += M.charAt(L),
                        F.thousandssep && (a = M.length - L - 1, a > 2 && a % 3 == 0 && (G += B)), L++);
                } else if (n == W.commands.fraction_placeholder) O >= R.length ? ("0" == r || "?" == r) && (G += "0" == r ? "0" : "&nbsp;") : G += R.charAt(O),
                    O++;
                else if (n == W.commands.decimal) $ && (G += "-", $ = 0), G += U;
                else if (n == W.commands.currency) $ && (G += "-",
                    $ = 0), G += r;
                else if (n == W.commands.general) {
                    if (0 != j) {
                        var K = Math.floor(Math.LOG10E * Math.log(j));
                        if (K = Math.pow(10, 13 - K), j = Math.floor(K * j + .5) / K, !isFinite(j)) return "NaN";
                    }
                    if ($ && (G += "-"), A = j + "", A.indexOf("e") >= 0) {
                        G += A;
                        continue;
                    }
                    if (I = A.match(/^\+{0,1}(\d*)(?:\.(\d*)){0,1}$/), M = I[1], M && "0" != M || (M = ""),
                        R = I[2], R || (R = ""), L = 0, O = 0, M.length)
                        for (; L < M.length; L++) G += M.charAt(L),
                            F.thousandssep && (a = M.length - L - 1, a > 2 && a % 3 == 0 && (G += B));
                    else G += "0";
                    if (R.length)
                        for (G += U; O < R.length; O++) G += R.charAt(O);
                } else if (n == W.commands.date) l = r.toLowerCase(), "y" == l || "yy" == l ? G += (b.year + "").substring(2) : "yyyy" == l ? G += b.year + "" : "d" == l ? G += b.day + "" : "dd" == l ? (s = 1e3 + b.day,
                    G += (s + "").substr(2)) : "ddd" == l ? (s = Math.floor(e + 6) % 7, G += V.s_FormatNumber_daynames3[s]) : "dddd" == l ? (s = Math.floor(e + 6) % 7,
                    G += V.s_FormatNumber_daynames[s]) : "m" == l ? G += b.month + "" : "mm" == l ? (s = 1e3 + b.month,
                    G += (s + "").substr(2)) : "mmm" == l ? G += V.s_FormatNumber_monthnames3[b.month - 1] : "mmmm" == l ? G += V.s_FormatNumber_monthnames[b.month - 1] : "mmmmm" == l ? G += V.s_FormatNumber_monthnames[b.month - 1].charAt(0) : "h" == l ? G += d + "" : "h]" == l ? G += f + "" : "mmin" == l ? (s = 1e3 + h + "",
                    G += s.substr(2)) : "mm]" == l ? 100 > m ? (s = 1e3 + m + "", G += s.substr(2)) : G += m + "" : "min" == l ? G += h + "" : "m]" == l ? G += m + "" : "hh" == l ? (s = 1e3 + d + "",
                    G += s.substr(2)) : "s" == l ? (s = Math.floor(p), G += s + "") : "ss" == l ? (s = 1e3 + Math.floor(p) + "",
                    G += s.substr(2)) : "am/pm" == l || "a/p" == l ? G += v : "ss]" == l && (100 > g ? (s = 1e3 + Math.floor(g) + "",
                    G += s.substr(2)) : (s = Math.floor(g), G += s + ""));
                else {
                    if (n == W.commands.section) break;
                    if (n == W.commands.comparison) continue;
                    G += "!! Parse error !!";
                }
                return z && (G = '<span style="color:' + z + ';">' + G + "</span>"), H && (G = '<span style="' + H + ';">' + G + "</span>"),
                    G;
            }, t.FormatNumber.formatTextWithFormat = function (e, o) {
                var i, n, r, a, s = (t.Constants, t.FormatNumber),
                    l = e + "",
                    c = "",
                    u = "",
                    d = "";
                if (s.parse_format_string(s.format_definitions, o), thisformat = s.format_definitions[o],
                    !thisformat) throw "Format not parsed error!";
                if (i = thisformat.sectioninfo.length - 1, 0 == i) i = 0;
                else {
                    if (3 != i) return l;
                    i = 3;
                }
                for (n = thisformat.sectioninfo[i], r = n.sectionstart; op = thisformat.operators[r];) a = thisformat.operands[r++],
                    op == s.commands.copy ? c += "@" == a ? l : a.replace(/ /g, "&nbsp;") : op == s.commands.color ? u = a : op == s.commands.style && (d = a);
                return u && (c = '<span style="color:' + u + ';">' + c + "</span>"), d && (c = '<span style="' + d + ';">' + c + "</span>"),
                    c;
            }, t.FormatNumber.parse_format_string = function (e, o) {
                var i, n, r, a, s, l, c, u, d, h, p, f, m, g, v, b, y, C = t.FormatNumber,
                    w = 1;
                if (!e[o]) {
                    for (i = {
                            operators: [],
                            operands: [],
                            sectioninfo: [{}]
                        }, e[o] = i, n = 0, sectioninfo = i.sectioninfo[n], sectioninfo.sectionstart = 0,
                        sectioninfo.integerdigits = 0, sectioninfo.fractiondigits = 0, sectioninfo.commas = 0,
                        sectioninfo.percent = 0, b = 0; b < o.length; b++)
                        if (y = o.charAt(b), c) {
                            if ('"' == y) {
                                c = 0, i.operators.push(C.commands.copy), i.operands.push(u);
                                continue;
                            }
                            u += y;
                        } else if (d) {
                        if ("]" == y) {
                            if (d = 0, p = t.FormatNumber.parse_format_bracket(h), p.operator == C.commands.separator) {
                                sectioninfo.thousandssep = 1;
                                continue;
                            }
                            p.operator == C.commands.date && (sectioninfo.hasdate = 1), p.operator == C.commands.comparison && (i.hascomparison = 1),
                                i.operators.push(p.operator), i.operands.push(p.operand);
                            continue;
                        }
                        h += y;
                    } else if (a) i.operators.push(C.commands.copy), i.operands.push(y), a = !1;
                    else if (s) i.operators.push(C.commands.copy),
                        i.operands.push(y + y + y + y + y), s = !1;
                    else if (l) i.operators.push(C.commands.copy),
                        i.operands.push("&nbsp;"), l = !1;
                    else {
                        if (f) {
                            if ("general".charAt(f) == y.toLowerCase()) {
                                f++, 7 == f && (i.operators.push(C.commands.general), i.operands.push(y), f = 0);
                                continue;
                            }
                            f = 0;
                        }
                        if (v) {
                            if (v.charAt(0) == y) {
                                v += y;
                                continue;
                            }
                            i.operators.push(C.commands.date), i.operands.push(v), sectioninfo.hasdate = 1,
                                v = "";
                        }
                        m ? (m += y, g = m.toLowerCase(), g != "am/pm".substring(0, g.length) && g != "a/p".substring(0, g.length) ? ampstr = "" : ("am/pm" == g || "a/p" == g) && (i.operators.push(C.commands.date),
                            i.operands.push(m), m = "")) : "#" == y || "0" == y || "?" == y ? w ? (sectioninfo.integerdigits++,
                            sectioninfo.commas && (sectioninfo.thousandssep = 1, sectioninfo.commas = 0), r = 1,
                            i.operators.push(C.commands.integer_placeholder), i.operands.push(y)) : (sectioninfo.fractiondigits++,
                            r = 1, i.operators.push(C.commands.fraction_placeholder), i.operands.push(y)) : "." == y ? (r = 0,
                            i.operators.push(C.commands.decimal), i.operands.push(y), w = 0) : "$" == y ? (r = 0,
                            i.operators.push(C.commands.currency), i.operands.push(y)) : "," == y ? r ? sectioninfo.commas++ : (i.operators.push(C.commands.copy),
                            i.operands.push(y)) : "%" == y ? (r = 0, sectioninfo.percent++, i.operators.push(C.commands.copy),
                            i.operands.push(y)) : '"' == y ? (r = 0, c = 1, u = "") : "[" == y ? (r = 0, d = 1,
                            h = "") : "\\" == y ? (a = 1, r = 0) : "*" == y ? (s = 1, r = 0) : "_" == y ? (l = 1,
                            r = 0) : ";" == y ? (n++, i.sectioninfo[n] = {}, sectioninfo = i.sectioninfo[n],
                            sectioninfo.sectionstart = 1 + i.operators.length, sectioninfo.integerdigits = 0,
                            sectioninfo.fractiondigits = 0, sectioninfo.commas = 0, sectioninfo.percent = 0,
                            w = 1, r = 0, i.operators.push(C.commands.section), i.operands.push(y)) : "g" == y.toLowerCase() ? (f = 1,
                            r = 0) : "a" == y.toLowerCase() ? (m = y, r = 0) : "dmyhHs".indexOf(y) >= 0 ? v = y : (r = 0,
                            i.operators.push(C.commands.copy), i.operands.push(y));
                    }
                    v && (i.operators.push(C.commands.date), i.operands.push(v), sectioninfo.hasdate = 1);
                }
            }, t.FormatNumber.parse_format_bracket = function (e) {
                var o, i = t.FormatNumber,
                    n = t.Constants,
                    r = {};
                return "$" == e.charAt(0) ? (r.operator = i.commands.currency, o = e.match(/^\$(.+?)(\-.+?){0,1}$/),
                    r.operand = o ? o[1] || n.FormatNumber_defaultCurrency || "$" : e.substring(1) || n.FormatNumber_defaultCurrency || "$") : "?$" == e ? (r.operator = i.commands.currency,
                    r.operand = "[?$]") : i.allowedcolors[e.toUpperCase()] ? (r.operator = i.commands.color,
                    r.operand = i.allowedcolors[e.toUpperCase()]) : (o = e.match(/^style=([^"]*)$/)) ? (r.operator = i.commands.style,
                    r.operand = o[1]) : "," == e ? (r.operator = i.commands.separator, r.operand = e) : i.alloweddates[e.toUpperCase()] ? (r.operator = i.commands.date,
                    r.operand = i.alloweddates[e.toUpperCase()]) : (o = e.match(/^[<>=]/)) ? (o = e.match(/^([<>=]+)(.+)$/),
                    r.operator = i.commands.comparison, r.operand = o[1] + ":" + o[2]) : (r.operator = i.commands.copy,
                    r.operand = "[" + e + "]"), r;
            }, t.FormatNumber.convert_date_gregorian_to_julian = function (e, o, i) {
                var n;
                return n = i - 32075 + t.intFunc(1461 * (e + 4800 + t.intFunc((o - 14) / 12)) / 4),
                    n += t.intFunc(367 * (o - 2 - 12 * t.intFunc((o - 14) / 12)) / 12), n -= t.intFunc(3 * t.intFunc((e + 4900 + t.intFunc((o - 14) / 12)) / 100) / 4);
            }, t.FormatNumber.convert_date_julian_to_gregorian = function (e) {
                var t, o, i, n, r;
                return t = e + 68569, o = Math.floor(4 * t / 146097), t -= Math.floor((146097 * o + 3) / 4),
                    i = Math.floor(4e3 * (t + 1) / 1461001), t = t - Math.floor(1461 * i / 4) + 31,
                    n = Math.floor(80 * t / 2447), r = t - Math.floor(2447 * n / 80), t = Math.floor(n / 11),
                    n = n + 2 - 12 * t, i = 100 * (o - 49) + i + t, {
                        year: i,
                        month: n,
                        day: r
                    };
            }, t.intFunc = function (e) {
                return 0 > e ? -Math.floor(-e) : Math.floor(e);
            };
        var t;
        t || (t = {}), t.Formula = {}, t.TriggerIoAction = {}, t.Formula.ParseState = {
                num: 1,
                alpha: 2,
                coord: 3,
                string: 4,
                stringquote: 5,
                numexp1: 6,
                numexp2: 7,
                alphanumeric: 8,
                specialvalue: 9
            }, t.Formula.TokenType = {
                num: 1,
                coord: 2,
                op: 3,
                name: 4,
                error: 5,
                string: 6,
                space: 7
            }, t.Formula.CharClass = {
                num: 1,
                numstart: 2,
                op: 3,
                eof: 4,
                alpha: 5,
                incoord: 6,
                error: 7,
                quote: 8,
                space: 9,
                specialstart: 10
            }, t.Formula.CharClassTable = {
                " ": 9,
                "!": 3,
                '"': 8,
                "'": 8,
                "#": 10,
                $: 6,
                "%": 3,
                "&": 3,
                "(": 3,
                ")": 3,
                "*": 3,
                "+": 3,
                ",": 3,
                "-": 3,
                ".": 2,
                "/": 3,
                "0": 1,
                "1": 1,
                "2": 1,
                "3": 1,
                "4": 1,
                "5": 1,
                "6": 1,
                "7": 1,
                "8": 1,
                "9": 1,
                ":": 3,
                "<": 3,
                "=": 3,
                ">": 3,
                A: 5,
                B: 5,
                C: 5,
                D: 5,
                E: 5,
                F: 5,
                G: 5,
                H: 5,
                I: 5,
                J: 5,
                K: 5,
                L: 5,
                M: 5,
                N: 5,
                O: 5,
                P: 5,
                Q: 5,
                R: 5,
                S: 5,
                T: 5,
                U: 5,
                V: 5,
                W: 5,
                X: 5,
                Y: 5,
                Z: 5,
                "^": 3,
                _: 5,
                a: 5,
                b: 5,
                c: 5,
                d: 5,
                e: 5,
                f: 5,
                g: 5,
                h: 5,
                i: 5,
                j: 5,
                k: 5,
                l: 5,
                m: 5,
                n: 5,
                o: 5,
                p: 5,
                q: 5,
                r: 5,
                s: 5,
                t: 5,
                u: 5,
                v: 5,
                w: 5,
                x: 5,
                y: 5,
                z: 5
            }, t.Formula.UpperCaseTable = {
                a: "A",
                b: "B",
                c: "C",
                d: "D",
                e: "E",
                f: "F",
                g: "G",
                h: "H",
                i: "I",
                j: "J",
                k: "K",
                l: "L",
                m: "M",
                n: "N",
                o: "O",
                p: "P",
                q: "Q",
                r: "R",
                s: "S",
                t: "T",
                u: "U",
                v: "V",
                w: "W",
                x: "X",
                y: "Y",
                z: "Z",
                A: "A",
                B: "B",
                C: "C",
                D: "D",
                E: "E",
                F: "F",
                G: "G",
                H: "H",
                I: "I",
                J: "J",
                K: "K",
                L: "L",
                M: "M",
                N: "N",
                O: "O",
                P: "P",
                Q: "Q",
                R: "R",
                S: "S",
                T: "T",
                U: "U",
                V: "V",
                W: "W",
                X: "X",
                Y: "Y",
                Z: "Z"
            }, t.Formula.SpecialConstants = {
                "#NULL!": "0,e#NULL!",
                "#NUM!": "0,e#NUM!",
                "#DIV/0!": "0,e#DIV/0!",
                "#VALUE!": "0,e#VALUE!",
                "#REF!": "0,e#REF!",
                "#NAME?": "0,e#NAME?"
            }, t.Formula.TokenPrecedence = {
                "!": 1,
                ":": 2,
                ",": 2,
                M: -3,
                P: -3,
                "%": 4,
                "^": 5,
                "*": 6,
                "/": 6,
                "+": 7,
                "-": 7,
                "&": 8,
                "<": 9,
                ">": 9,
                G: 9,
                L: 9,
                N: 9
            }, t.Formula.TokenOpExpansion = {
                G: ">=",
                L: "<=",
                M: "-",
                N: "<>",
                P: "+"
            }, t.Formula.TypeLookupTable = {
                unaryminus: {
                    "n*": "|n*:1|",
                    "e*": "|e*:1|",
                    "t*": "|t*:e#VALUE!|",
                    b: "|b:n|"
                },
                unaryplus: {
                    "n*": "|n*:1|",
                    "e*": "|e*:1|",
                    "t*": "|t*:e#VALUE!|",
                    b: "|b:n|"
                },
                unarypercent: {
                    "n*": "|n:n%|n*:n|",
                    "e*": "|e*:1|",
                    "t*": "|t*:e#VALUE!|",
                    b: "|b:n|"
                },
                plus: {
                    "n%": "|n%:n%|nd:n|nt:n|ndt:n|n$:n|n:n|n*:n|b:n|e*:2|t*:e#VALUE!|",
                    nd: "|n%:n|nd:nd|nt:ndt|ndt:ndt|n$:n|n:nd|n*:n|b:n|e*:2|t*:e#VALUE!|",
                    nt: "|n%:n|nd:ndt|nt:nt|ndt:ndt|n$:n|n:nt|n*:n|b:n|e*:2|t*:e#VALUE!|",
                    ndt: "|n%:n|nd:ndt|nt:ndt|ndt:ndt|n$:n|n:ndt|n*:n|b:n|e*:2|t*:e#VALUE!|",
                    n$: "|n%:n|nd:n|nt:n|ndt:n|n$:n$|n:n$|n*:n|b:n|e*:2|t*:e#VALUE!|",
                    nl: "|n%:n|nd:n|nt:n|ndt:n|n$:n|n:n|n*:n|b:n|e*:2|t*:e#VALUE!|",
                    n: "|n%:n|nd:nd|nt:nt|ndt:ndt|n$:n$|n:n|n*:n|b:n|e*:2|t*:e#VALUE!|",
                    b: "|n%:n%|nd:nd|nt:nt|ndt:ndt|n$:n$|n:n|n*:n|b:n|e*:2|t*:e#VALUE!|",
                    "t*": "|ni:1|n*:e#VALUE!|t*:e#VALUE!|b:e#VALUE!|e*:2|",
                    "n*": "|ni:1|e*:2|",
                    "e*": "|e*:1|n*:1|t*:1|b:1|"
                },
                concat: {
                    t: "|t:t|th:th|tw:tw|tl:t|tr:tr|t*:2|e*:2|",
                    th: "|t:th|th:th|tw:t|tl:th|tr:t|t*:t|e*:2|",
                    tw: "|t:tw|th:t|tw:tw|tl:tw|tr:tw|t*:t|e*:2|",
                    tl: "|t:tl|th:th|tw:tw|tl:tl|tr:tr|t*:t|e*:2|",
                    "t*": "|t*:t|e*:2|",
                    "e*": "|e*:1|n*:1|t*:1|"
                },
                oneargnumeric: {
                    "n*": "|n*:n|",
                    "e*": "|e*:1|",
                    "t*": "|t*:e#VALUE!|",
                    b: "|b:n|"
                },
                twoargnumeric: {
                    "n*": "|n*:n|t*:e#VALUE!|e*:2|",
                    "e*": "|e*:1|n*:1|t*:1|",
                    "t*": "|t*:e#VALUE!|n*:e#VALUE!|e*:2|"
                },
                propagateerror: {
                    "n*": "|n*:2|e*:2|",
                    "e*": "|e*:2|",
                    "t*": "|t*:2|e*:2|",
                    b: "|b:2|e*:2|"
                }
            }, t.Formula.ParseFormulaIntoTokens = function (e) {
                var o, i, n, r, a, s, l, c, u = t.Formula,
                    d = t.Constants,
                    h = u.ParseState,
                    p = u.TokenType,
                    f = u.CharClass,
                    m = u.CharClassTable,
                    g = u.UpperCaseTable,
                    v = u.ParsePushToken,
                    b = /^\$?[A-Z]{1,2}\$?[1-9]\d*$/i,
                    y = [],
                    C = "",
                    w = 0,
                    r = !1,
                    x = "";
                for (o = 0; o <= e.length; o++) o < e.length ? (i = e.charAt(o), n = m[i]) : (i = "",
                        n = f.eof), w == h.num && (n == f.num ? C += i : n != f.numstart || r ? "E" == i || "e" == i ? (C += i,
                        r = !1, w = h.numexp1) : (v(y, C, p.num, 0), r = !1, w = 0) : (r = !0, C += i)),
                    w == h.numexp1 && (n == h.num ? w = h.numexp2 : "+" != i && "-" != i || "E" != g[C.charAt(C.length - 1)] ? "E" == i || "e" == i || (v(y, d.s_parseerrexponent, p.error, 0),
                        w = 0) : C += i), w == h.numexp2 && (n == f.num ? C += i : (v(y, C, p.num, 0), w = 0)),
                    w == h.alpha && (n == f.num ? w = h.coord : n == f.alpha || "." == i ? C += i : n == f.incoord ? w = h.coord : n == f.op || n == f.numstart || n == f.space || n == f.eof ? (v(y, C.toUpperCase(), p.name, 0),
                        w = 0) : (v(y, d.s_parseerrchar, p.error, 0), w = 0)), w == h.coord && (n == f.num ? C += i : n == f.incoord ? C += i : n == f.alpha ? w = h.alphanumeric : n == f.op || n == f.numstart || n == f.eof || n == f.space ? (c = b.test(C) ? p.coord : p.name,
                        v(y, C.toUpperCase(), c, 0), w = 0) : (v(y, d.s_parseerrchar, p.error, 0), w = 0)),
                    w == h.alphanumeric && (n == f.num || n == f.alpha ? C += i : n == f.op || n == f.numstart || n == f.space || n == f.eof ? (v(y, C.toUpperCase(), p.name, 0),
                        w = 0) : (v(y, d.s_parseerrchar, p.error, 0), w = 0)), w == h.string ? n == f.quote ? w = h.stringquote : n == f.eof ? (v(y, d.s_parseerrstring, p.error, 0),
                        w = 0) : C += i : w == h.stringquote ? n == f.quote ? (C += i, w = h.string) : (v(y, C, p.string, 0),
                        w = 0) : w == h.specialvalue && ("!" == C.charAt(C.length - 1) ? (v(y, C, p.name, 0),
                        w = 0) : n == f.eof ? (v(y, d.s_parseerrspecialvalue, p.error, 0), w = 0) : C += i),
                    0 == w && (n == f.num ? (C = i, w = h.num) : n == f.numstart ? (C = i, r = !0, w = h.num) : n == f.alpha || n == f.incoord ? (C = i,
                        w = h.alpha) : n == f.specialstart ? (C = i, w = h.specialvalue) : n == f.op ? (C = i,
                        y.length > 0 ? (a = y[y.length - 1], s = a.type, l = a.text, s == f.op && (x = l + C,
                            ("<=" == x || ">=" == x || "<>" == x) && (C = l + C, y.pop(), y.length > 0 ? (a = y[y.length - 1],
                                s = a.type, l = a.text) : (s = f.eof, l = "EOF")))) : (s = f.eof, l = "EOF"), c = p.op,
                        0 == y.length || s == f.op && ")" != l && "%" != l ? "-" == C ? (C = "M", i = "M") : "+" == C ? (C = "P",
                            i = "P") : ")" == C && "(" == l || "(" != C && (c = p.error, C = d.s_parseerrtwoops) : C.length > 1 && (">=" == C ? (C = "G",
                            i = "G") : "<=" == C ? (C = "L", i = "L") : "<>" == C ? (C = "N", i = "N") : (c = p.error,
                            C = d.s_parseerrtwoops)), v(y, C, c, i), w = 0) : n == f.quote ? (C = "", w = h.string) : n == f.space || n == f.eof || v(y, d.s_parseerrchar, p.error, 0));
                return y;
            }, t.Formula.ParsePushToken = function (e, t, o, i) {
                e.push({
                    text: t,
                    type: o,
                    opcode: i
                });
            }, t.Formula.evaluate_parsed_formula = function (e, o, i) {
                {
                    var n, r, a = t.Formula;
                    a.TokenType;
                }
                return r = a.ConvertInfixToPolish(e), n = a.EvaluatePolish(e, r, o, i);
            }, t.Formula.ConvertInfixToPolish = function (e) {
                var o, i, n, r, a, s, l = t.Formula,
                    c = t.Constants,
                    u = l.TokenType,
                    d = l.TokenPrecedence,
                    h = [],
                    p = [],
                    f = "",
                    m = -1;
                for (o = 0; o < e.length; o++)
                    if (i = e[o], n = i.type, r = i.text, n == u.num || n == u.coord || n == u.string) h.push(o);
                    else if (n == u.name) p.push(o),
                    h.push(m);
                else {
                    if (n == u.space) continue;
                    if ("," == r) {
                        for (; p.length && "(" != e[p[p.length - 1]].text;) h.push(p.pop());
                        if (0 == p.length) {
                            f = c.s_parseerrmissingopenparen;
                            break;
                        }
                    } else if ("(" == r) p.push(o);
                    else if (")" == r) {
                        for (; p.length && "(" != e[p[p.length - 1]].text;) h.push(p.pop());
                        if (0 == p.length) {
                            f = c.s_parseerrcloseparennoopen;
                            break;
                        }
                        p.pop(), p.length && e[p[p.length - 1]].type == u.name && h.push(p.pop());
                    } else {
                        if (n != u.op) {
                            if (n == u.error) {
                                f = r;
                                break;
                            }
                            f = "Internal error while processing parsed formula. ";
                            break;
                        }
                        for (p.length && e[p[p.length - 1]].type == u.name && h.push(p.pop()); !(!p.length || e[p[p.length - 1]].type != u.op || "(" == e[p[p.length - 1]].text || (a = d[i.opcode],
                                s = d[e[p[p.length - 1]].opcode], a >= 0 && s > a) || 0 > a && (a = -a, 0 > s && (s = -s),
                                s >= a));) h.push(p.pop());
                        p.push(o);
                    }
                }
                for (; p.length > 0;) {
                    if ("(" == e[p[p.length - 1]].text) {
                        f = c.s_parseerrmissingcloseparen;
                        break;
                    }
                    h.push(p.pop());
                }
                return f ? f : h;
            }, "undefined" == typeof t.debug_log && (t.debug_log = []), t.DebugLog = function () {},
            t.Formula.EvaluatePolish = function (e, o, i, n) {
                var r, a, s, l, c, u, d, h, p, f, m, g, v, b, y = t.Formula,
                    C = t.Constants,
                    w = y.TokenType,
                    x = y.LookupResultType,
                    _ = y.TypeLookupTable,
                    S = y.OperandAsNumber,
                    k = y.OperandAsText,
                    T = y.OperandValueAndType,
                    F = y.OperandsAsCoordOnSheet,
                    E = t.format_number_for_display || function (e) {
                        return e + "";
                    },
                    D = "",
                    P = -1,
                    A = {
                        value: "",
                        type: "e#VALUE!",
                        error: C.s_parseerrmissingoperand
                    },
                    I = [],
                    M = function (e, t) {
                        I.push({
                            type: e,
                            value: t
                        });
                    };
                if (!(e.length && o instanceof Array)) return {
                    value: "",
                    type: "e#VALUE!",
                    error: "string" == typeof o ? o : ""
                };
                var R = [];
                for (r = 0; r < o.length; r++)
                    if (a = o[r], a != P)
                        if (s = e[a], l = s.type, c = s.text,
                            R.push(s), l == w.num) M("n", c - 0);
                        else if (l == w.coord) M("coord", c);
                else if (l == w.string) M("t", c);
                else if (l == w.op) {
                    if (I.length <= 0) return A;
                    if ("M" == c) u = S(i, I), f = x(u.type, u.type, _.unaryminus), M(f, -u.value);
                    else if ("P" == c) u = S(i, I),
                        f = x(u.type, u.type, _.unaryplus), M(f, u.value);
                    else if ("%" == c) u = S(i, I),
                        f = x(u.type, u.type, _.unarypercent), M(f, .01 * u.value);
                    else if ("&" == c) {
                        if (I.length <= 1) return A;
                        d = k(i, I), u = k(i, I), f = x(u.type, u.type, _.concat), M(f, u.value + d.value);
                    } else if (":" == c) {
                        if (I.length <= 1) return A;
                        u = y.OperandsAsRangeOnSheet(i, I), u.error && (D = D || u.error), M(u.type, u.value);
                    } else if ("!" == c) {
                        if (I.length <= 1) return A;
                        u = F(i, I), u.error && (D = D || u.error), M(u.type, u.value);
                    } else if ("<" == c || "L" == c || "=" == c || "G" == c || ">" == c || "N" == c) {
                        if (I.length <= 1) {
                            D = C.s_parseerrmissingoperand;
                            break;
                        }
                        d = T(i, I), u = T(i, I), "n" == u.type.charAt(0) && "n" == d.type.charAt(0) ? (g = 0,
                            "<" == c ? g = u.value < d.value ? 1 : 0 : "L" == c ? g = u.value <= d.value ? 1 : 0 : "=" == c ? g = u.value == d.value ? 1 : 0 : "G" == c ? g = u.value >= d.value ? 1 : 0 : ">" == c ? g = u.value > d.value ? 1 : 0 : "N" == c && (g = u.value != d.value ? 1 : 0),
                            M("nl", g)) : "e" == u.type.charAt(0) ? M(u.type, 0) : "e" == d.type.charAt(0) ? M(d.type, 0) : (h = u.type.charAt(0),
                            p = d.type.charAt(0), "n" == h ? u.value = E(u.value, "n", "") : "b" == h && (u.value = ""),
                            "n" == p ? d.value = E(d.value, "n", "") : "b" == p && (d.value = ""), g = 0, u.value = u.value.toLowerCase(),
                            d.value = d.value.toLowerCase(), "<" == c ? g = u.value < d.value ? 1 : 0 : "L" == c ? g = u.value <= d.value ? 1 : 0 : "=" == c ? g = u.value == d.value ? 1 : 0 : "G" == c ? g = u.value >= d.value ? 1 : 0 : ">" == c ? g = u.value > d.value ? 1 : 0 : "N" == c && (g = u.value != d.value ? 1 : 0),
                            M("nl", g));
                    } else {
                        if (I.length <= 1) {
                            D = C.s_parseerrmissingoperand;
                            break;
                        }
                        "+" == c ? (d = T(i, I), u = T(i, I), f = x(u.type, d.type, _.plus), M(f, u.value + d.value)) : (d = S(i, I),
                            u = S(i, I)), "-" == c ? (f = x(u.type, d.type, _.plus), M(f, u.value - d.value)) : "*" == c ? (f = x(u.type, d.type, _.plus),
                            M(f, u.value * d.value)) : "/" == c ? 0 != d.value ? M("n", u.value / d.value) : M("e#DIV/0!", 0) : "^" == c && (u.value = Math.pow(u.value, d.value),
                            u.type = "n", isNaN(u.value) && (u.value = 0, u.type = "e#NUM!"), M(u.type, u.value));
                    }
                } else {
                    if (l != w.name) {
                        D = C.s_InternalError + "Unknown token " + l + " (" + c + "). ";
                        break;
                    }
                    if (D = y.CalculateFunction(c, I, i, e.coord)) break;
                } else M("start", 0);
                return value = I[0] ? I[0].value : "", h = I[0] ? I[0].type : "", "name" == h && (u = t.Formula.LookupName(i, value),
                        value = u.value, h = u.type, D = D || u.error), "coord" == h && (u = T(i, I), value = u.value,
                        h = u.type, "b" == h && (h = "n", value = 0)), I.length > 1 && !D && (D += C.s_parseerrerrorinformula),
                    m = h, "e" == h.charAt(0) ? D = D || h.substring(1) || C.s_calcerrerrorvalueinformula : "range" == h && (v = value.match(/^(.*)\|(.*)\|/),
                        b = v[1].indexOf("!"), v[1] = b >= 0 ? v[1].substring(b + 1) + "!" + v[1].substring(0, b).toUpperCase() : v[1].toUpperCase(),
                        value = v[1] + ":" + v[2].toUpperCase(), n || (D = C.s_formularangeresult + " " + value)),
                    D && "e" != m.charAt(0) && (value = D, m = "e"), "n" != m.charAt(0) || !isNaN(value) && isFinite(value) || (value = 0,
                        m = "e#NUM!", D = isNaN(value) ? C.s_calcerrnumericnan : C.s_calcerrnumericoverflow), {
                        value: value,
                        type: m,
                        error: D
                    };
            }, t.Formula.LookupResultType = function (e, t, o) {
                var i, n, r, a = o[e];
                return a || (a = o[e.charAt(0) + "*"]) ? (i = a.indexOf("|" + t + ":"), i >= 0 ? (n = a.indexOf("|", i + 1),
                    0 > n ? "e#VALUE! (internal error, incorrect LookupResultType " + a + ")" : (r = a.substring(i + t.length + 2, n),
                        "1" == r ? e : "2" == r ? t : r)) : (i = a.indexOf("|" + t.charAt(0) + "*:"), i >= 0 ? (n = a.indexOf("|", i + 1),
                    0 > n ? "e#VALUE! (internal error, incorrect LookupResultType " + a + ")" : (r = a.substring(i + 4, n),
                        "1" == r ? e : "2" == r ? t : r)) : "e#VALUE!")) : "e#VALUE! (internal error, missing LookupResultType " + e.charAt(0) + "*)";
            }, t.Formula.TopOfStackValueAndType = function (e, o) {
                var i = t.Formula,
                    n = {
                        type: "",
                        value: ""
                    },
                    r = o.length;
                return r ? (n.value = o[r - 1].value, n.type = o[r - 1].type, o.pop(), "name" == n.type && (n = i.LookupName(e, n.value)),
                    n) : (n.error = t.Constants.s_InternalError + "no operand on stack", n);
            }, t.Formula.OperandAsNumber = function (e, o) {
                var i, n, r = t.Formula.OperandValueAndType(e, o);
                return i = r.type.charAt(0), "n" == i ? r.value = r.value - 0 : "b" == i ? (r.type = "n",
                    r.value = 0) : "e" == i ? r.value = 0 : (n = t.DetermineValueType ? t.DetermineValueType(r.value) : {
                    value: r.value - 0,
                    type: "n"
                }, "n" == n.type.charAt(0) ? (r.value = n.value - 0, r.type = n.type) : (r.value = 0,
                    r.type = n.type)), r;
            }, t.Formula.OperandAsText = function (e, o) {
                var i, n = t.Formula.OperandValueAndType(e, o);
                return i = n.type.charAt(0), "t" == i || ("n" == i ? (n.value = t.format_number_for_display ? t.format_number_for_display(n.value, n.type, "") : n.value = n.value + "",
                    n.type = "t") : "b" == i ? (n.value = "", n.type = "t") : "e" == i ? n.value = "" : (o.value = n.value + "",
                    o.type = "t")), n;
            }, t.Formula.OperandValueAndType = function (e, o) {
                var i, n, r, a, s = t.Formula,
                    l = {
                        type: "",
                        value: ""
                    },
                    c = o.length;
                if (!c) return l.error = t.Constants.s_InternalError + "no operand on stack", l;
                if (l.value = o[c - 1].value, l.type = o[c - 1].type, o.pop(), "name" == l.type && (l = s.LookupName(e, l.value)),
                    "range" == l.type && (l = s.StepThroughRangeDown(o, l.value)), "coord" == l.type) {
                    if (a = e, r = l.value.indexOf("!"), -1 != r) {
                        if (a = s.FindInSheetCache(l.value.substring(r + 1)), null == a) return l.type = "e#REF!",
                            l.error = t.Constants.s_sheetunavailable + " " + l.value.substring(r + 1), l.value = 0,
                            l;
                        l.value = l.value.substring(0, r);
                    }
                    a ? (n = a.cells[t.Formula.PlainCoord(l.value)], n ? (i = n.valuetype, l.value = n.datavalue) : i = "b") : (i = "e#N/A",
                        l.value = 0), l.type = i || "b", "b" == l.type && (l.value = 0);
                }
                return l;
            }, t.Formula.OperandAsCoord = function (e, o) {
                return t.Formula.OperandAsType(e, o, "coord");
            }, t.Formula.OperandAsRange = function (e, o) {
                return t.Formula.OperandAsType(e, o, "range");
            }, t.Formula.OperandAsType = function (e, o, i) {
                var n = (t.Formula, {
                        type: "",
                        value: ""
                    }),
                    r = o.length;
                return n.value = o[r - 1].value, n.type = o[r - 1].type, o.pop(), "name" == n.type && (n = t.Formula.LookupName(e, n.value)),
                    n.type == i ? n : (n.value = t.Constants.s_calcerrcellrefmissing, n.type = "e#REF!",
                        n);
            }, t.Formula.OperandsAsCoordOnSheet = function (e, o) {
                var i, n, r, a, s = {},
                    l = {},
                    c = t.Formula,
                    u = o.length;
                return s.value = o[u - 1].value, s.type = o[u - 1].type, o.pop(), i = c.OperandAsSheetName(e, o),
                    n = c.FindInSheetCache(i.value), null == n ? (l.type = "e#REF!", l.value = 0, l.error = t.Constants.s_sheetunavailable + " " + i.value,
                        l) : ("name" == s.type && (s = c.LookupName(n, s.value)), l.type = s.type, "coord" == s.type ? l.value = s.value + "!" + i.value : "range" == s.type ? (r = s.value.indexOf("|"),
                        a = s.value.indexOf("|", r + 1), l.value = s.value.substring(0, r) + "!" + i.value + "|" + s.value.substring(r + 1, a) + "|") : "e" == s.type.charAt(0) ? l.value = s.value : (l.error = t.Constants.s_calcerrcellrefmissing,
                        l.type = "e#REF!", l.value = 0), l);
            }, t.Formula.OperandsAsRangeOnSheet = function (e, o) {
                var i, n, r, a, s = {},
                    l = t.Formula,
                    c = t.Constants,
                    u = o.length;
                return s.value = o[u - 1].value, s.type = o[u - 1].type, o.pop(), i = l.OperandAsCoord(e, o),
                    "coord" != i.type ? {
                        value: 0,
                        type: "e#REF!"
                    } : (n = e, r = i.value.indexOf("!"), -1 != r && (a = i.value.indexOf("|", r + 1),
                        0 > a && (a = i.value.length), n = l.FindInSheetCache(i.value.substring(r + 1, a)),
                        null == n) ? {
                        value: 0,
                        type: "e#REF!",
                        errortext: c.s_sheetunavailable + " " + i.value.substring(r + 1, a)
                    } : ("name" == s.type && (s = l.LookupName(n, s.value, "end")), "coord" == s.type ? {
                        value: i.value + "|" + s.value + "|",
                        type: "range"
                    } : {
                        value: c.s_calcerrcellrefmissing,
                        type: "e#REF!"
                    }));
            }, t.Formula.OperandAsSheetName = function (e, o) {
                var i, n, r = (t.Formula, {
                        type: "",
                        value: ""
                    }),
                    a = o.length;
                if (r.value = o[a - 1].value, r.type = o[a - 1].type, o.pop(), "name" == r.type) {
                    if (i = t.Formula.LookupName(e, r.value), !i.value) return r;
                    r.value = i.value, r.type = i.type;
                }
                return "coord" == r.type && (n = e.cells[t.Formula.PlainCoord(r.value)], n ? (r.value = n.datavalue,
                    r.type = n.valuetype) : (r.value = "", r.type = "b")), "t" == r.type.charAt(0) ? r : (r.value = "",
                    r.error = t.Constants.s_calcerrsheetnamemissing, r);
            }, t.Formula.LookupName = function (e, o, i) {
                var n, r, a, s = e.names,
                    l = {},
                    c = !1;
                if (s[o.toUpperCase()]) {
                    if (l.value = s[o.toUpperCase()].definition, "=" == l.value.charAt(0)) {
                        if (e.checknamecirc) {
                            if (e.checknamecirc[o]) return l.type = "e#NAME?", l.error = t.Constants.s_circularnameref + ' "' + o + '".',
                                l;
                        } else e.checknamecirc = {}, c = !0;
                        if (e.checknamecirc[o] = !0, a = t.Formula.ParseFormulaIntoTokens(l.value.substring(1)),
                            l = t.Formula.evaluate_parsed_formula(a, e, 1), delete e.checknamecirc[o], c && delete e.checknamecirc,
                            "range" != l.type) return l;
                    }
                    return n = l.value.indexOf(":"), -1 != n ? (l.type = "range", l.value = l.value.substring(0, n) + "|" + l.value.substring(n + 1) + "|",
                            l.value = l.value.toUpperCase()) : (l.type = "coord", l.value = l.value.toUpperCase()),
                        l;
                }
                return (r = t.Formula.SpecialConstants[o.toUpperCase()]) ? (n = r.indexOf(","),
                    l.value = r.substring(0, n) - 0, l.type = r.substring(n + 1), l) : /^[a-zA-Z][a-zA-Z]?$/.test(o) ? (l.type = "coord",
                    l.value = o.toUpperCase() + (i ? e.attribs.lastrow : 1), l) : (l.value = "", l.type = "e#NAME?",
                    l.error = t.Constants.s_calcerrunknownname + ' "' + o + '"', l);
            }, t.Formula.StepThroughRangeDown = function (e, o) {
                var i, n, r, a, s, l, c, u, d, h, p = t.Formula;
                for (a = o.indexOf("|"), s = o.indexOf("|", a + 1), i = o.substring(0, a), n = o.substring(a + 1, s),
                    r = o.substring(s + 1) - 0, a = i.indexOf("!"), -1 != a ? (l = i.substring(a), i = i.substring(0, a)) : l = "",
                    a = n.indexOf("!"), -1 != a && (n = n.substring(0, a)), c = p.OrderRangeParts(i, n),
                    h = 0, d = c.r1; d <= c.r2; d++)
                    for (u = c.c1; u <= c.c2; u++)
                        if (h++, h > r) return (d != c.r2 || u != c.c2) && p.PushOperand(e, "range", i + l + "|" + n + "|" + h), {
                            value: t.crToCoord(u, d) + l,
                            type: "coord"
                        };
            }, t.Formula.DecodeRangeParts = function (e, o) {
                var i, n, r, a, s, l, c, u = t.Formula;
                return r = o.indexOf("|"), a = o.indexOf("|", r + 1), i = o.substring(0, r), n = o.substring(r + 1, a),
                    r = i.indexOf("!"), -1 != r ? (s = i.substring(r + 1), i = i.substring(0, r)) : s = "",
                    r = n.indexOf("!"), -1 != r && (n = n.substring(0, r)), l = e, s && (l = u.FindInSheetCache(s),
                        null == l) ? null : (c = u.OrderRangeParts(i, n), {
                        sheetdata: l,
                        sheetname: s,
                        col1num: c.c1,
                        ncols: c.c2 - c.c1 + 1,
                        row1num: c.r1,
                        nrows: c.r2 - c.r1 + 1
                    });
            }, t.Formula.FunctionList || (t.Formula.FunctionList = {}), t.Formula.FunctionClasses = null,
            t.Formula.FunctionArgDefs = {}, t.Formula.StoreIoEventFormula = function (e, o, i, n, r) {
                var a = [];
                if (t.Formula.Clone(a, i), a.reverse(), 0 != a.length) {
                    if ("undefined" == typeof n.ioEventTree && (n.ioEventTree = {}), "undefined" == typeof n.ioParameterList && (n.ioParameterList = {}),
                        "undefined" == typeof n.ioTimeTriggerList && (n.ioTimeTriggerList = {}), "undefined" == typeof n.radioGroupList && (n.radioGroupList = {}),
                        "undefined" == typeof n.ioParameterList[o] && (n.ioParameterList[o] = {}), n.ioParameterList[o] = a,
                        n.ioParameterList[o].function_name = e, "TimeTrigger" == r) {
                        var s = function (e, t, o) {
                                var i = o.cells[t];
                                "undefined" != typeof i && "n" == i.valuetype.charAt(0) && e.push(i.datavalue);
                            },
                            l = t.Formula.PlainCoord(a[0].value),
                            c = [];
                        if ("range" == a[0].type)
                            for (var u = t.Formula.DecodeRangeParts(n, l), d = 0; d < u.ncols; d++)
                                for (var h = 0; h < u.nrows; h++) {
                                    var p = t.crToCoord(u.col1num + d, u.row1num + h);
                                    s(c, p, n);
                                }
                        if ("coord" == a[0].type && s(c, l, n), "n" == a[0].type.charAt(0) && c.push(a[0].value),
                            "undefined" == typeof n.ioTimeTriggerList[o] || 0 == t.Formula.ArrayValuesEqual(n.ioTimeTriggerList[o], c)) {
                            n.ioTimeTriggerList[o] = c;
                            for (var f = new Date().getTimezoneOffset(), m = 25569, g = [], v = 0; v < c.length; ++v) g[v] = Math.floor(24 * (c[v] - m) * 60 + f);
                            n.ScheduleSheetCommands("settimetrigger " + o + " " + g.toString());
                        }
                    }
                    if ("EventTree" == r && ("coord" == a[0].type || "range" == a[0].type)) {
                        var b = a[0].value.replace(/\$/g, ""),
                            y = function (e, t, o) {
                                "undefined" == typeof e[t] && (e[t] = {}), e[t][o] = o;
                            };
                        if ("range" == a[0].type)
                            for (var u = t.Formula.DecodeRangeParts(n, b), d = 0; d < u.ncols; d++)
                                for (var h = 0; h < u.nrows; h++) {
                                    var C = t.crToCoord(u.col1num + d, u.row1num + h);
                                    y(n.ioEventTree, C, o);
                                }
                        "coord" == a[0].type && y(n.ioEventTree, b, o);
                    }
                    if ("Input" == r) {
                        var w = null != t.CurrentSpreadsheetControlObject ? t.CurrentSpreadsheetControlObject.formDataViewer : t.CurrentSpreadsheetViewerObject.formDataViewer;
                        if (null != w && 1 == w.loaded) {
                            null == w.formFields && t.Formula.LoadFormFields();
                            var x = (e + o).toLowerCase(),
                                _ = null;
                            if (null == w.formFields[x]) {
                                var S = w.formFields[x] = w.formFieldsLength++ + 2,
                                    k = t.crToCoord(S, 1);
                                _ = "set " + k + " text t " + t.encodeForSave(e.toLowerCase() + o);
                            }
                            if ("t" == a[0].type.charAt(0) || "n" == a[0].type.charAt(0)) {
                                var T = t.crToCoord(w.formFields[x], 2);
                                if (null == w.sheet.cells[T] || w.sheet.cells[T].datavalue != a[0].value) {
                                    var F = "set " + T + " text t " + t.encodeForSave(a[0].value);
                                    _ = null != _ ? _ + "\n" + F : F;
                                }
                            }
                            null != _ && w.sheet.ScheduleSheetCommands(_, !1);
                        }
                    }
                }
            }, t.Formula.ArrayValuesEqual = function (e, t) {
                var o = e.length;
                if (o != t.length) return !1;
                for (; o--;)
                    if (e[o] !== t[o]) return !1;
                return !0;
            }, t.Formula.Clone = function (e, o) {
                for (var i in o) "object" == typeof o[i] && null !== o[i] && e[i] ? t.Formula.Clone(e[i], o[i]) : e[i] = o[i];
            }, t.Formula.LoadFormFields = function () {
                var e = null != t.CurrentSpreadsheetControlObject ? t.CurrentSpreadsheetControlObject.formDataViewer : t.CurrentSpreadsheetViewerObject.formDataViewer;
                e.formFields = {}, null == e.sheet.cells.A1 && e.sheet.ScheduleSheetCommands("set A1 text t " + t.encodeForSave("FieldName:"), !1),
                    null == e.sheet.cells.A2 && e.sheet.ScheduleSheetCommands("set A2 text t " + t.encodeForSave("Pending:"), !1);
                for (var o = 2;;) {
                    var i = t.crToCoord(o, 1),
                        n = e.sheet.cells[i];
                    if (!n) break;
                    e.formFields[n.datavalue.toLowerCase()] = o, o++;
                }
                e.formFieldsLength = o - 2;
            }, t.Formula.CalculateFunction = function (e, o, i, n) {
                var r, a, s, l, c, u = t.Formula,
                    d = "";
                if (r = u.FunctionList[e]) {
                    if (a = [], s = r[0], l = r[1], u.CopyFunctionArgs(o, a), r[6] && "" != r[6] && (t.DebugLog("action:" + e),
                            u.StoreIoEventFormula(e, n, a, i, r[6])), 100 != l)
                        if (0 > l) {
                            if (a.length < -l) return d = u.FunctionArgsError(e, o);
                        } else if (a.length != l) return d = u.FunctionArgsError(e, o);
                    d = s(e, o, a, i, n);
                } else c = e, o.length && "start" == o[o.length - 1].type ? (o.pop(), u.PushOperand(o, "name", c)) : d = t.Constants.s_sheetfuncunknownfunction + " " + c + ". ";
                return d;
            }, t.Formula.PushOperand = function (e, t, o) {
                e.push({
                    type: t,
                    value: o
                });
            }, t.Formula.CopyFunctionArgs = function (e, o) {
                var o;
                for (t.Formula; e.length > 0 && "start" != e[e.length - 1].type;) o.push(e.pop());
                e.pop();
            }, t.Formula.FunctionArgsError = function (e, o) {
                var i = t.Constants.s_calcerrincorrectargstofunction + " " + e + ". ";
                return t.Formula.PushOperand(o, "e#VALUE!", i), i;
            }, t.Formula.FunctionSpecificError = function (e, o, i, n) {
                return t.Formula.PushOperand(o, i, n), n;
            }, t.Formula.CheckForErrorValue = function (e, t) {
                return "e" == t.type.charAt(0) ? (e.push(t), !0) : !1;
            }, t.Formula.FillFunctionInfo = function () {
                var e, o, i, n, r, a = t.Formula,
                    s = t.Constants;
                if (!a.FunctionClasses) {
                    for (e in a.FunctionList) o = a.FunctionList[e], o[2] && (a.FunctionArgDefs[o[2]] = s["s_farg_" + o[2]] || ""),
                        o[3] || s["s_fdef_" + e] && (a.FunctionList[e][3] = s["s_fdef_" + e]);
                    for (a.FunctionClasses = {}, r = 0; r < s.function_classlist.length; r++) n = s.function_classlist[r],
                        a.FunctionClasses[n] = {
                            name: s["s_fclass_" + n],
                            items: []
                        };
                    for (e in a.FunctionList)
                        for (o = a.FunctionList[e], i = o[4] ? o[4].split(",") : [],
                            i.push("all"), r = 0; r < i.length; r++) n = i[r], a.FunctionClasses[n].items.push(e);
                    for (n in a.FunctionClasses) a.FunctionClasses[n].items.sort();
                }
            }, t.Formula.FunctionArgString = function (e) {
                var o, i, n, r = t.Formula,
                    a = r.FunctionList[e],
                    s = a[2];
                if (!s) {
                    if (o = a[1], 0 != o) {
                        if (o > 0) {
                            for (n = "v1", i = 2; o >= i; i++) n += ", v" + i;
                            return n;
                        }
                        if (0 > o) {
                            for (n = "v1", i = 2; - o > i; i++) n += ", v" + i;
                            return n + ", ...";
                        }
                        return "nargs: " + o;
                    }
                    s = " ";
                }
                return n = r.FunctionArgDefs[s] || s;
            }, t.Formula.SeriesFunctions = function (e, o, i, n) {
                for (var r, a, s, l, c, u, d, h, p, f = t.Formula, m = f.OperandValueAndType, g = f.LookupResultType, v = f.TypeLookupTable.plus, b = function (e, t) {
                        o.push({
                            type: e,
                            value: t
                        });
                    }, y = "", C = 0, w = "", x = 0, _ = 0, S = 0, k = 1; i.length > 0;) r = m(n, i),
                    a = r.type.charAt(0), "n" == a && (x += 1), "b" != a && (_ += 1), "b" == a && (S += 1),
                    "e" != a && "b" != a && (y += r.value), "n" == a ? (s = r.value - 0, C += s, k *= s,
                        l = void 0 != l ? s > l ? s : l : s, c = void 0 != c ? c > s ? s : c : s, 1 == x ? (h = s,
                            p = 0) : (u = h + (s - h) / x, d = p + (s - h) * (s - u), p = d, h = u), w = g(r.type, w || r.type, v)) : "e" == a && "e" != w.charAt(0) && (w = r.type);
                switch (w = w || "n", e) {
                    case "CONCAT":
                    case "CONCATENATE":
                        b("t", y);
                        break;

                    case "SUM":
                        b(w, C);
                        break;

                    case "PRODUCT":
                        b(w, k);
                        break;

                    case "MIN":
                        b(w, c || 0);
                        break;

                    case "MAX":
                        b(w, l || 0);
                        break;

                    case "COUNT":
                        b("n", x);
                        break;

                    case "COUNTA":
                        b("n", _);
                        break;

                    case "COUNTBLANK":
                        b("n", S);
                        break;

                    case "AVERAGE":
                        x > 0 ? b(w, C / x) : b("e#DIV/0!", 0);
                        break;

                    case "STDEV":
                        x > 1 ? b(w, Math.sqrt(d / (x - 1))) : b("e#DIV/0!", 0);
                        break;

                    case "STDEVP":
                        x > 1 ? b(w, Math.sqrt(d / x)) : b("e#DIV/0!", 0);
                        break;

                    case "VAR":
                        x > 1 ? b(w, d / (x - 1)) : b("e#DIV/0!", 0);
                        break;

                    case "VARP":
                        x > 1 ? b(w, d / x) : b("e#DIV/0!", 0);
                }
                return null;
            }, t.Formula.FunctionList.AVERAGE = [t.Formula.SeriesFunctions, -1, "vn", null, "stat"],
            t.Formula.FunctionList.CONCAT = [t.Formula.SeriesFunctions, -1, "vn", null, "text"],
            t.Formula.FunctionList.CONCATENATE = [t.Formula.SeriesFunctions, -1, "vn", null, "text"],
            t.Formula.FunctionList.COUNT = [t.Formula.SeriesFunctions, -1, "vn", null, "stat"],
            t.Formula.FunctionList.COUNTA = [t.Formula.SeriesFunctions, -1, "vn", null, "stat"],
            t.Formula.FunctionList.COUNTBLANK = [t.Formula.SeriesFunctions, -1, "vn", null, "stat"],
            t.Formula.FunctionList.MAX = [t.Formula.SeriesFunctions, -1, "vn", null, "stat"],
            t.Formula.FunctionList.MIN = [t.Formula.SeriesFunctions, -1, "vn", null, "stat"],
            t.Formula.FunctionList.PRODUCT = [t.Formula.SeriesFunctions, -1, "vn", null, "stat"],
            t.Formula.FunctionList.STDEV = [t.Formula.SeriesFunctions, -1, "vn", null, "stat"],
            t.Formula.FunctionList.STDEVP = [t.Formula.SeriesFunctions, -1, "vn", null, "stat"],
            t.Formula.FunctionList.SUM = [t.Formula.SeriesFunctions, -1, "vn", null, "stat"],
            t.Formula.FunctionList.VAR = [t.Formula.SeriesFunctions, -1, "vn", null, "stat"],
            t.Formula.FunctionList.VARP = [t.Formula.SeriesFunctions, -1, "vn", null, "stat"],
            t.Formula.SumProductFunction = function (e, o, n, r) {
                for (var a, s = [], l = 0, c = t.Formula, u = 0, d = 0, h = function (e, t) {
                        o.push({
                            type: e,
                            value: t
                        });
                    }; n.length > 0;) {
                    if (a = c.TopOfStackValueAndType(r, n), "range" != a.type) return void h("e#VALUE!", 0);
                    if (rangeinfo = c.DecodeRangeParts(r, a.value), u) {
                        if (u != rangeinfo.ncols) return void h("e#VALUE!", 0);
                    } else u = rangeinfo.ncols;
                    if (d) {
                        if (d != rangeinfo.nrows) return void h("e#VALUE!", 0);
                    } else d = rangeinfo.nrows;
                    for (i = 0; i < rangeinfo.ncols; i++)
                        for (j = 0; j < rangeinfo.nrows; j++) k = i * rangeinfo.nrows + j,
                            cellcr = t.crToCoord(rangeinfo.col1num + i, rangeinfo.row1num + j), cell = rangeinfo.sheetdata.GetAssuredCell(cellcr),
                            value = "n" == cell.valuetype ? cell.datavalue : 0, s[k] = ("undefined" != typeof s[k] ? s[k] : 1) * value;
                }
                for (i = 0; i < s.length; i++) l += s[i];
                h("n", l);
            }, t.Formula.FunctionList.SUMPRODUCT = [t.Formula.SumProductFunction, -1, "rangen", "", "stat"],
            t.Formula.DSeriesFunctions = function (e, o, i, n) {
                var r, a, s, l, c, u, d, h, p, f, m, g, v, b, y, C, w, x, _, S, k, T, F, E, D, P, A = t.Formula,
                    I = (A.OperandValueAndType,
                        A.LookupResultType),
                    M = A.TypeLookupTable.plus,
                    R = function (e, t) {
                        o.push({
                            type: e,
                            value: t
                        });
                    },
                    r = {},
                    N = 0,
                    L = "",
                    O = 0,
                    z = 0,
                    H = 0,
                    B = 0,
                    U = 1;
                if (s = A.TopOfStackValueAndType(n, i), l = A.OperandValueAndType(n, i), c = A.TopOfStackValueAndType(n, i),
                    "range" != s.type || "range" != c.type) return A.FunctionArgsError(e, o);
                if (u = A.DecodeRangeParts(n, s.value), d = A.DecodeRangeParts(n, c.value), h = A.FieldToColnum(u.sheetdata, u.col1num, u.ncols, u.row1num, l.value, l.type),
                    0 >= h) return void R("e#VALUE!", 0);
                for (p = u.col1num + h - 1, b = [], f = 0; f < d.ncols; f++) {
                    if (v = d.sheetdata.GetAssuredCell(t.crToCoord(d.col1num + f, d.row1num)), criterianum = A.FieldToColnum(u.sheetdata, u.col1num, u.ncols, u.row1num, v.datavalue, v.valuetype),
                        0 >= criterianum) return void R("e#VALUE!", 0);
                    b.push(u.col1num + criterianum - 1);
                }
                for (f = 1; f < u.nrows; f++) {
                    y = !1;
                    e: for (m = 1; m < d.nrows; m++) {
                        for (g = 0; g < d.ncols; g++)
                            if (C = t.crToCoord(d.col1num + g, d.row1num + m),
                                v = d.sheetdata.GetAssuredCell(C), w = v.datavalue, ("string" != typeof w || 0 != w.length) && (x = b[g],
                                    _ = t.crToCoord(x, u.row1num + f), v = u.sheetdata.GetAssuredCell(_), !A.TestCriteria(v.datavalue, v.valuetype || "b", w))) continue e;
                        y = !0;
                        break e;
                    }
                    y && (a = t.crToCoord(p, u.row1num + f), v = u.sheetdata.GetAssuredCell(a), r.value = v.datavalue,
                        r.type = v.valuetype, S = r.type.charAt(0), B += 1, "n" == S && (O += 1), "b" != S && (z += 1),
                        "b" == S && (H += 1), "n" == S ? (v1 = r.value - 0, N += v1, U *= v1, k = void 0 != k ? v1 > k ? v1 : k : v1,
                            T = void 0 != T ? T > v1 ? v1 : T : v1, 1 == O ? (D = v1, P = 0) : (F = D + (v1 - D) / O,
                                E = P + (v1 - D) * (v1 - F), P = E, D = F), L = I(r.type, L || r.type, M)) : "e" == S && "e" != L.charAt(0) && (L = r.type));
                }
                switch (L = L || "n", e) {
                    case "DSUM":
                        R(L, N);
                        break;

                    case "DPRODUCT":
                        R(L, U);
                        break;

                    case "DMIN":
                        R(L, T || 0);
                        break;

                    case "DMAX":
                        R(L, k || 0);
                        break;

                    case "DCOUNT":
                        R("n", O);
                        break;

                    case "DCOUNTA":
                        R("n", z);
                        break;

                    case "DAVERAGE":
                        O > 0 ? R(L, N / O) : R("e#DIV/0!", 0);
                        break;

                    case "DSTDEV":
                        O > 1 ? R(L, Math.sqrt(E / (O - 1))) : R("e#DIV/0!", 0);
                        break;

                    case "DSTDEVP":
                        O > 1 ? R(L, Math.sqrt(E / O)) : R("e#DIV/0!", 0);
                        break;

                    case "DVAR":
                        O > 1 ? R(L, E / (O - 1)) : R("e#DIV/0!", 0);
                        break;

                    case "DVARP":
                        O > 1 ? R(L, E / O) : R("e#DIV/0!", 0);
                        break;

                    case "DGET":
                        1 == B ? R(r.type, r.value) : 0 == B ? R("e#VALUE!", 0) : R("e#NUM!", 0);
                }
            }, t.Formula.FunctionList.DAVERAGE = [t.Formula.DSeriesFunctions, 3, "dfunc", "", "stat"],
            t.Formula.FunctionList.DCOUNT = [t.Formula.DSeriesFunctions, 3, "dfunc", "", "stat"],
            t.Formula.FunctionList.DCOUNTA = [t.Formula.DSeriesFunctions, 3, "dfunc", "", "stat"],
            t.Formula.FunctionList.DGET = [t.Formula.DSeriesFunctions, 3, "dfunc", "", "stat"],
            t.Formula.FunctionList.DMAX = [t.Formula.DSeriesFunctions, 3, "dfunc", "", "stat"],
            t.Formula.FunctionList.DMIN = [t.Formula.DSeriesFunctions, 3, "dfunc", "", "stat"],
            t.Formula.FunctionList.DPRODUCT = [t.Formula.DSeriesFunctions, 3, "dfunc", "", "stat"],
            t.Formula.FunctionList.DSTDEV = [t.Formula.DSeriesFunctions, 3, "dfunc", "", "stat"],
            t.Formula.FunctionList.DSTDEVP = [t.Formula.DSeriesFunctions, 3, "dfunc", "", "stat"],
            t.Formula.FunctionList.DSUM = [t.Formula.DSeriesFunctions, 3, "dfunc", "", "stat"],
            t.Formula.FunctionList.DVAR = [t.Formula.DSeriesFunctions, 3, "dfunc", "", "stat"],
            t.Formula.FunctionList.DVARP = [t.Formula.DSeriesFunctions, 3, "dfunc", "", "stat"],
            t.Formula.FieldToColnum = function (e, o, i, n, r, a) {
                var s, l, c;
                if ("n" == a.charAt(0)) return s = r - 0, 0 >= s || s > i ? 0 : Math.floor(s);
                if ("t" != a.charAt(0)) return 0;
                for (r = r ? r.toLowerCase() : "", s = 0; i > s; s++)
                    if (l = e.GetAssuredCell(t.crToCoord(o + s, n)),
                        c = l.datavalue, c = (c + "").toLowerCase(), c == r) return s + 1;
                return 0;
            }, t.Formula.LookupFunctions = function (e, o, i, n) {
                var r, a, s, l, c, u, d, h, p, f, m, g, v, b, y, C, r, w = t.Formula,
                    x = w.OperandValueAndType,
                    _ = (w.LookupResultType,
                        w.TypeLookupTable.plus,
                        function (e, t) {
                            o.push({
                                type: e,
                                value: t
                            });
                        });
                if (r = x(n, i), "string" == typeof r.value && (r.value = r.value.toLowerCase()),
                    a = w.TopOfStackValueAndType(n, i), s = 1, "MATCH" == e) {
                    if (i.length) {
                        if (s = w.OperandAsNumber(n, i), "n" != s.type.charAt(0)) return void _("e#VALUE!", 0);
                        if (i.length) return w.FunctionArgsError(e, o), 0;
                        s = s.value - 0;
                    }
                } else {
                    if (l = w.OperandAsNumber(n, i), "n" != l.type.charAt(0)) return void _("e#VALUE!", 0);
                    if (l = Math.floor(l.value), i.length) {
                        if (s = w.OperandAsNumber(n, i), "n" != s.type.charAt(0)) return void _("e#VALUE!", 0);
                        if (i.length) return w.FunctionArgsError(e, o), 0;
                        s = s.value ? 1 : 0;
                    }
                }
                if (r.type = r.type.charAt(0), "n" == r.type && (r.value = r.value - 0), "range" != a.type) return w.FunctionArgsError(e, o),
                    0;
                if (c = w.DecodeRangeParts(n, a.value, a.type), !c) return void _("e#REF!", 0);
                if (u = 0, d = 0, h = 0, p = 0, "HLOOKUP" == e) {
                    if (h = 1, l > c.nrows) return void _("e#REF!", 0);
                } else if ("VLOOKUP" == e) {
                    if (p = 1, l > c.ncols) return void _("e#REF!", 0);
                } else {
                    if ("MATCH" != e) return w.FunctionArgsError(e, o), 0;
                    if (c.ncols > 1) {
                        if (c.nrows > 1) return void _("e#N/A", 0);
                        h = 1;
                    } else p = 1;
                }
                if (1 > l && "MATCH" != e) return _("e#VALUE!", 0), 0;
                for (;;) {
                    if (C = t.crToCoord(c.col1num + u, c.row1num + d), v = c.sheetdata.GetAssuredCell(C),
                        b = v.datavalue, y = v.valuetype ? v.valuetype.charAt(0) : "b", "n" == y && (b -= 0),
                        s) {
                        if ("n" == r.type && "n" == y) {
                            if (r.value == b) break;
                            if (s > 0 && r.value > b || 0 > s && r.value < b) f = 1, m = u, g = d;
                            else if (f) {
                                f = 2;
                                break;
                            }
                        } else if ("t" == r.type && "t" == y) {
                            if (b = "string" == typeof b ? b.toLowerCase() : "", r.value == b) break;
                            if (s > 0 && r.value > b || 0 > s && r.value < b) f = 1, m = u, g = d;
                            else if (f) {
                                f = 2;
                                break;
                            }
                        }
                    } else if ("n" == r.type && "n" == y) {
                        if (r.value == b) break;
                    } else if ("t" == r.type && "t" == y && (b = "string" == typeof b ? b.toLowerCase() : "",
                            r.value == b)) break;
                    if (d += p, u += h, d >= c.nrows || u >= c.ncols) {
                        if (f) {
                            f = 2;
                            break;
                        }
                        return void _("e#N/A", 0);
                    }
                }
                2 == f && (d = g, u = m), "MATCH" == e ? (b = u + d + 1, y = "n") : (C = t.crToCoord(c.col1num + u + ("VLOOKUP" == e ? l - 1 : 0), c.row1num + d + ("HLOOKUP" == e ? l - 1 : 0)),
                    v = c.sheetdata.GetAssuredCell(C), b = v.datavalue, y = v.valuetype), _(y, b);
            }, t.Formula.FunctionList.HLOOKUP = [t.Formula.LookupFunctions, -3, "hlookup", "", "lookup"],
            t.Formula.FunctionList.MATCH = [t.Formula.LookupFunctions, -2, "match", "", "lookup"],
            t.Formula.FunctionList.VLOOKUP = [t.Formula.LookupFunctions, -3, "vlookup", "", "lookup"],
            t.Formula.IndexFunction = function (e, o, i, n) {
                var r, a, s, l, c, u, d, h = t.Formula,
                    p = function (e, t) {
                        o.push({
                            type: e,
                            value: t
                        });
                    };
                if (r = h.TopOfStackValueAndType(n, i), "range" != r.type) return h.FunctionArgsError(e, o),
                    0;
                if (s = h.DecodeRangeParts(n, r.value, r.type), a = s.sheetname ? "!" + s.sheetname : "",
                    l = {
                        value: 0
                    }, c = {
                        value: 0
                    }, i.length) {
                    if (l = h.OperandAsNumber(n, i), "n" != l.type.charAt(0) || l.value < 0) return void p("e#VALUE!", 0);
                    if (i.length) {
                        if (c = h.OperandAsNumber(n, i), "n" != c.type.charAt(0) || c.value < 0) return void p("e#VALUE!", 0);
                        if (i.length) return h.FunctionArgsError(e, o), 0;
                    } else 1 == s.nrows && (c.value = l.value, l.value = 0);
                }
                return l.value > s.nrows || c.value > s.ncols ? void p("e#REF!", 0) : (0 == l.value ? 0 == c.value ? 1 == s.nrows && 1 == s.ncols ? (u = t.crToCoord(s.col1num, s.row1num) + a,
                    d = "coord") : (u = t.crToCoord(s.col1num, s.row1num) + a + "|" + t.crToCoord(s.col1num + s.ncols - 1, s.row1num + s.nrows - 1) + "|",
                    d = "range") : 1 == s.nrows ? (u = t.crToCoord(s.col1num + c.value - 1, s.row1num) + a,
                    d = "coord") : (u = t.crToCoord(s.col1num + c.value - 1, s.row1num) + a + "|" + t.crToCoord(s.col1num + c.value - 1, s.row1num + s.nrows - 1) + "|",
                    d = "range") : 0 == c.value ? 1 == s.ncols ? (u = t.crToCoord(s.col1num, s.row1num + l.value - 1) + a,
                    d = "coord") : (u = t.crToCoord(s.col1num, s.row1num + l.value - 1) + a + "|" + t.crToCoord(s.col1num + s.ncols - 1, s.row1num + l.value - 1) + "|",
                    d = "range") : (u = t.crToCoord(s.col1num + c.value - 1, s.row1num + l.value - 1) + a,
                    d = "coord"), void p(d, u));
            }, t.Formula.FunctionList.INDEX = [t.Formula.IndexFunction, -1, "index", "", "lookup"],
            t.Formula.CountifSumifFunctions = function (e, o, i, n) {
                var r, a, s, l, c, u, d = 0,
                    h = "",
                    p = 0,
                    f = t.Formula,
                    m = f.OperandValueAndType,
                    g = f.LookupResultType,
                    v = f.TypeLookupTable.plus,
                    b = function (e, t) {
                        o.push({
                            type: e,
                            value: t
                        });
                    };
                if (r = f.TopOfStackValueAndType(n, i), a = f.OperandAsText(n, i), "SUMIF" == e)
                    if (1 == i.length) s = f.TopOfStackValueAndType(n, i);
                    else {
                        if (0 != i.length) return f.FunctionArgsError(e, o), 0;
                        s = {
                            value: r.value,
                            type: r.type
                        };
                    }
                else s = {
                    value: r.value,
                    type: r.type
                };
                if ("n" == a.type.charAt(0) ? a.value = a.value + "" : "e" == a.type.charAt(0) ? a.value = null : "b" == a.type.charAt(0) && (a.value = null),
                    "coord" != r.type && "range" != r.type) return f.FunctionArgsError(e, o), 0;
                if ("SUMIF" == e && "coord" != s.type && "range" != s.type) return f.FunctionArgsError(e, o),
                    0;
                for (i.push(r), l = [], l.push(s); i.length;) c = m(n, i), u = m(n, l), f.TestCriteria(c.value, c.type, a.value) && (p += 1,
                    "n" == u.type.charAt(0) ? (d += u.value - 0, h = g(u.type, h || u.type, v)) : "e" == u.type.charAt(0) && "e" != h.charAt(0) && (h = u.type));
                h = h || "n", "SUMIF" == e ? b(h, d) : "COUNTIF" == e && b("n", p);
            }, t.Formula.FunctionList.COUNTIF = [t.Formula.CountifSumifFunctions, 2, "rangec", "", "stat"],
            t.Formula.FunctionList.SUMIF = [t.Formula.CountifSumifFunctions, -2, "sumif", "", "stat"],
            t.Formula.SumifsFunction = function (e, o, i, n) {
                var r, a, s, l, c, u, d = 0,
                    h = "",
                    p = t.Formula,
                    f = p.OperandValueAndType,
                    m = p.LookupResultType,
                    g = p.TypeLookupTable.plus,
                    v = function (e, t) {
                        o.push({
                            type: e,
                            value: t
                        });
                    };
                if (s = p.TopOfStackValueAndType(n, i), "coord" != s.type && "range" != s.type) return p.FunctionArgsError(e, o),
                    0;
                for (var b = [], y = []; i.length;) {
                    if (r = p.TopOfStackValueAndType(n, i), a = p.OperandAsText(n, i), "n" == a.type.charAt(0) ? a.value = a.value + "" : "e" == a.type.charAt(0) ? a.value = null : "b" == a.type.charAt(0) && (a.value = null),
                        "coord" != r.type && "range" != r.type) return p.FunctionArgsError(e, o), 0;
                    b.push([r]), y.push(a);
                }
                for (l = [], l.push(s); l.length;) {
                    u = f(n, l);
                    for (var C = !0, w = 0; w < b.length; w++) c = f(n, b[w]), C && (p.TestCriteria(c.value, c.type, y[w].value) || (C = !1));
                    C && ("n" == u.type.charAt(0) ? (d += u.value - 0, h = m(u.type, h || u.type, g)) : "e" == u.type.charAt(0) && "e" != h.charAt(0) && (h = u.type));
                }
                h = h || "n", v(h, d);
            }, t.Formula.FunctionList.SUMIFS = [t.Formula.SumifsFunction, -3, "sum_range, criteria_range1, criteria1, [criteria_range2, criteria2, ... criteria_range_n, criteria_n]", "", "stat"],
            t.Formula.IfFunction = function (e, o, i, n) {
                var r, a, s = t.Formula;
                if (r = t.Formula.OperandValueAndType(n, i), a = r.type.charAt(0), "n" != a && "b" != a) return void o.push({
                    type: "e#VALUE!",
                    value: 0
                });
                var l, c;
                if (l = i.pop(), 1 == i.length) c = i.pop();
                else {
                    if (0 != i.length) return void s.FunctionArgsError(e, o);
                    c = {
                        type: "n",
                        value: 0
                    };
                }
                o.push(r.value ? l : c);
            }, t.Formula.FunctionList.IF = [t.Formula.IfFunction, -2, "iffunc", "", "test"],
            t.Formula.DateFunction = function (e, o, i, n) {
                var r = t.Formula,
                    a = 0,
                    s = r.OperandAsNumber(n, i),
                    l = r.OperandAsNumber(n, i),
                    c = r.OperandAsNumber(n, i),
                    u = r.LookupResultType(s.type, l.type, r.TypeLookupTable.twoargnumeric);
                u = r.LookupResultType(u, c.type, r.TypeLookupTable.twoargnumeric), "n" == u.charAt(0) && (a = t.FormatNumber.convert_date_gregorian_to_julian(Math.floor(s.value), Math.floor(l.value), Math.floor(c.value)) - t.FormatNumber.datevalues.julian_offset,
                    u = "nd"), r.PushOperand(o, u, a);
            }, t.Formula.FunctionList.DATE = [t.Formula.DateFunction, 3, "date", "", "datetime"],
            t.Formula.TimeFunction = function (e, o, i, n) {
                var r = t.Formula,
                    a = 0,
                    s = r.OperandAsNumber(n, i),
                    l = r.OperandAsNumber(n, i),
                    c = r.OperandAsNumber(n, i),
                    u = r.LookupResultType(s.type, l.type, r.TypeLookupTable.twoargnumeric);
                u = r.LookupResultType(u, c.type, r.TypeLookupTable.twoargnumeric), "n" == u.charAt(0) && (a = (60 * s.value * 60 + 60 * l.value + c.value) / 86400,
                    u = "nt"), r.PushOperand(o, u, a);
            }, t.Formula.FunctionList.TIME = [t.Formula.TimeFunction, 3, "hms", "", "datetime"],
            t.Formula.DMYFunctions = function (e, o, i, n) {
                var r, a, s, l = t.Formula,
                    c = 0,
                    u = l.OperandAsNumber(n, i),
                    d = l.LookupResultType(u.type, u.type, l.TypeLookupTable.oneargnumeric);
                if ("n" == d.charAt(0)) switch (r = t.FormatNumber.convert_date_julian_to_gregorian(Math.floor(u.value + t.FormatNumber.datevalues.julian_offset)),
                    e) {
                    case "DAY":
                        c = r.day;
                        break;

                    case "MONTH":
                        c = r.month;
                        break;

                    case "YEAR":
                        c = r.year;
                        break;

                    case "WEEKDAY":
                        if (a = {
                                value: 1
                            }, i.length) {
                            if (a = l.OperandAsNumber(n, i), "n" != a.type.charAt(0) || a.value < 1 || a.value > 3) return void l.PushOperand(o, "e#VALUE!", 0);
                            if (i.length) return void l.FunctionArgsError(e, o);
                        }
                        s = 6, a.value > 1 && (s -= 1), c = Math.floor(u.value + s) % 7 + (a.value < 3 ? 1 : 0);
                }
                l.PushOperand(o, d, c);
            }, t.Formula.FunctionList.DAY = [t.Formula.DMYFunctions, 1, "v", "", "datetime"],
            t.Formula.FunctionList.MONTH = [t.Formula.DMYFunctions, 1, "v", "", "datetime"],
            t.Formula.FunctionList.YEAR = [t.Formula.DMYFunctions, 1, "v", "", "datetime"],
            t.Formula.FunctionList.WEEKDAY = [t.Formula.DMYFunctions, -1, "weekday", "", "datetime"],
            t.Formula.HMSFunctions = function (e, o, i, n) {
                var r, a, s, l, c = t.Formula,
                    u = 0,
                    d = c.OperandAsNumber(n, i),
                    h = c.LookupResultType(d.type, d.type, c.TypeLookupTable.oneargnumeric);
                if ("n" == h.charAt(0)) {
                    if (d.value < 0) return void c.PushOperand(o, "e#NUM!", 0);
                    l = d.value - Math.floor(d.value), l *= 24, r = Math.floor(l), l -= Math.floor(l),
                        l *= 60, a = Math.floor(l), l -= Math.floor(l), l *= 60, s = Math.floor(l + (d.value >= 0 ? .5 : -.5)),
                        "HOUR" == e ? u = r : "MINUTE" == e ? u = a : "SECOND" == e && (u = s);
                }
                c.PushOperand(o, h, u);
            }, t.Formula.FunctionList.HOUR = [t.Formula.HMSFunctions, 1, "v", "", "datetime"],
            t.Formula.FunctionList.MINUTE = [t.Formula.HMSFunctions, 1, "v", "", "datetime"],
            t.Formula.FunctionList.SECOND = [t.Formula.HMSFunctions, 1, "v", "", "datetime"],
            t.Formula.ExactFunction = function (e, o, i, n) {
                var r = t.Formula,
                    a = 0,
                    s = "nl",
                    l = r.OperandValueAndType(n, i),
                    c = l.type.charAt(0),
                    u = r.OperandValueAndType(n, i),
                    d = u.type.charAt(0);
                "t" == c ? "t" == d ? a = l.value == u.value ? 1 : 0 : "b" == d ? a = l.value.length ? 0 : 1 : "n" == d ? a = l.value == u.value + "" ? 1 : 0 : "e" == d ? (a = u.value,
                    s = u.type) : a = 0 : "n" == c ? "n" == d ? a = l.value - 0 == u.value - 0 ? 1 : 0 : "b" == d ? a = 0 : "t" == d ? a = l.value + "" == u.value ? 1 : 0 : "e" == d ? (a = u.value,
                    s = u.type) : a = 0 : "b" == c ? "t" == d ? a = u.value.length ? 0 : 1 : "b" == d ? a = 1 : "n" == d ? a = 0 : "e" == d ? (a = u.value,
                    s = u.type) : a = 0 : "e" == c && (a = l.value, s = l.type), r.PushOperand(o, s, a);
            }, t.Formula.FunctionList.EXACT = [t.Formula.ExactFunction, 2, "", "", "text"],
            t.Formula.ArgList = {
                FIND: [1, 1, 0],
                LEFT: [1, 0],
                LEN: [1],
                LOWER: [1],
                MID: [1, 0, 0],
                PROPER: [1],
                REPLACE: [1, 0, 0, 1],
                REPT: [1, 0],
                RIGHT: [1, 0],
                SUBSTITUTE: [1, 1, 1, 0],
                TRIM: [1],
                HEXCODE: [1],
                UPPER: [1]
            }, t.Formula.StringFunctions = function (e, o, i, n) {
                var r, a, s, l, c, u, d = t.Formula,
                    h = 0,
                    p = "e#VALUE!",
                    f = i.length,
                    m = d.ArgList[e],
                    g = [],
                    v = [];
                for (r = 1; f >= r; r++) {
                    if (r > m.length) return void d.FunctionArgsError(e, o);
                    if (0 == m[r - 1] ? a = d.OperandAsNumber(n, i) : 1 == m[r - 1] ? a = d.OperandAsText(n, i) : -1 == m[r - 1] && (a = d.OperandValueAndType(n, i)),
                        g[r] = a.value, v[r] = a.type, "e" == a.type.charAt(0)) return void d.PushOperand(o, a.type, h);
                }
                switch (e) {
                    case "FIND":
                        s = v[3] ? g[3] - 1 : 0, 0 > s ? h = "Start is before string" : (h = g[2].indexOf(g[1], s),
                            h >= 0 ? (h += 1, p = "n") : h = "Not found");
                        break;

                    case "LEFT":
                        l = v[2] ? g[2] - 0 : 1, 0 > l ? h = "Negative length" : (h = g[1].substring(0, l),
                            p = "t");
                        break;

                    case "LEN":
                        h = g[1].length, p = "n";
                        break;

                    case "LOWER":
                        h = g[1].toLowerCase(), p = "t";
                        break;

                    case "MID":
                        c = g[2] - 0, l = g[3] - 0, 1 > l || 1 > c ? h = "Bad arguments" : (h = g[1].substring(c - 1, c + l - 1),
                            p = "t");
                        break;

                    case "PROPER":
                        h = g[1].replace(/\b\w+\b/g, function (e) {
                            return e.substring(0, 1).toUpperCase() + e.substring(1);
                        }), p = "t";
                        break;

                    case "REPLACE":
                        c = g[2] - 0, l = g[3] - 0, 0 > l || 1 > c ? h = "Bad arguments" : (h = g[1].substring(0, c - 1) + g[4] + g[1].substring(c - 1 + l),
                            p = "t");
                        break;

                    case "REPT":
                        if (u = g[2] - 0, 0 > u) h = "Negative count";
                        else {
                            for (h = ""; u > 0; u--) h += g[1];
                            p = "t";
                        }
                        break;

                    case "RIGHT":
                        l = v[2] ? g[2] - 0 : 1, 0 > l ? h = "Negative length" : (h = g[1].slice(-l), p = "t");
                        break;

                    case "SUBSTITUTE":
                        if (fulltext = g[1], oldtext = g[2], newtext = g[3], null != g[4]) {
                            if (which = g[4] - 0, 0 >= which) {
                                h = "Non-positive instance number";
                                break;
                            }
                        } else which = 0;
                        for (u = 0, oldpos = 0, h = "";;) {
                            if (pos = fulltext.indexOf(oldtext, oldpos), !(pos >= 0)) {
                                h += fulltext.substring(oldpos);
                                break;
                            }
                            if (u++, h += fulltext.substring(oldpos, pos), 0 == which) h += newtext;
                            else {
                                if (which == u) {
                                    h += newtext + fulltext.substring(pos + oldtext.length);
                                    break;
                                }
                                h += oldtext;
                            }
                            oldpos = pos + oldtext.length;
                        }
                        p = "t";
                        break;

                    case "TRIM":
                        h = g[1], h = h.replace(/^ */, ""), h = h.replace(/ *$/, ""), h = h.replace(/ +/g, " "),
                            p = "t";
                        break;

                    case "HEXCODE":
                        h = String(g[1]);
                        var b = h.charCodeAt(0);
                        if (b >= 55296 && 56319 >= b) {
                            var y = h.charCodeAt(1);
                            y >= 56320 && 57343 >= y && (b = 1024 * (b - 55296) + (y - 56320) + 65536);
                        }
                        h = b.toString(16).toUpperCase(), p = "t";
                        break;

                    case "UPPER":
                        h = g[1].toUpperCase(), p = "t";
                }
                d.PushOperand(o, p, h);
            }, t.Formula.FunctionList.FIND = [t.Formula.StringFunctions, -2, "find", "", "text"],
            t.Formula.FunctionList.LEFT = [t.Formula.StringFunctions, -2, "tc", "", "text"],
            t.Formula.FunctionList.LEN = [t.Formula.StringFunctions, 1, "txt", "", "text"],
            t.Formula.FunctionList.LOWER = [t.Formula.StringFunctions, 1, "txt", "", "text"],
            t.Formula.FunctionList.MID = [t.Formula.StringFunctions, 3, "mid", "", "text"],
            t.Formula.FunctionList.PROPER = [t.Formula.StringFunctions, 1, "v", "", "text"],
            t.Formula.FunctionList.REPLACE = [t.Formula.StringFunctions, 4, "replace", "", "text"],
            t.Formula.FunctionList.REPT = [t.Formula.StringFunctions, 2, "tc", "", "text"],
            t.Formula.FunctionList.RIGHT = [t.Formula.StringFunctions, -1, "tc", "", "text"],
            t.Formula.FunctionList.SUBSTITUTE = [t.Formula.StringFunctions, -3, "subs", "", "text"],
            t.Formula.FunctionList.TRIM = [t.Formula.StringFunctions, 1, "v", "", "text"],
            t.Formula.FunctionList.HEXCODE = [t.Formula.StringFunctions, 1, "v", "", "text"],
            t.Formula.FunctionList.UPPER = [t.Formula.StringFunctions, 1, "v", "", "text"],
            t.Formula.IsFunctions = function (e, o, i, n) {
                var r = t.Formula,
                    a = 0,
                    s = "nl",
                    l = r.OperandValueAndType(n, i),
                    c = l.type.charAt(0);
                switch (e) {
                    case "ISBLANK":
                        a = "b" == l.type ? 1 : 0;
                        break;

                    case "ISERR":
                        a = "e" == c ? "e#N/A" == l.type ? 0 : 1 : 0;
                        break;

                    case "ISERROR":
                        a = "e" == c ? 1 : 0;
                        break;

                    case "ISLOGICAL":
                        a = "nl" == l.type ? 1 : 0;
                        break;

                    case "ISNA":
                        a = "e#N/A" == l.type ? 1 : 0;
                        break;

                    case "ISNONTEXT":
                        a = "t" == c ? 0 : 1;
                        break;

                    case "ISNUMBER":
                        a = "n" == c ? 1 : 0;
                        break;

                    case "ISTEXT":
                        a = "t" == c ? 1 : 0;
                }
                r.PushOperand(o, s, a);
            }, t.Formula.FunctionList.ISBLANK = [t.Formula.IsFunctions, 1, "v", "", "test"],
            t.Formula.FunctionList.ISERR = [t.Formula.IsFunctions, 1, "v", "", "test"], t.Formula.FunctionList.ISERROR = [t.Formula.IsFunctions, 1, "v", "", "test"],
            t.Formula.FunctionList.ISLOGICAL = [t.Formula.IsFunctions, 1, "v", "", "test"],
            t.Formula.FunctionList.ISNA = [t.Formula.IsFunctions, 1, "v", "", "test"], t.Formula.FunctionList.ISNONTEXT = [t.Formula.IsFunctions, 1, "v", "", "test"],
            t.Formula.FunctionList.ISNUMBER = [t.Formula.IsFunctions, 1, "v", "", "test"],
            t.Formula.FunctionList.ISTEXT = [t.Formula.IsFunctions, 1, "v", "", "test"], t.Formula.NTVFunctions = function (e, o, i, n) {
                var r = t.Formula,
                    a = 0,
                    s = "e#VALUE!",
                    l = r.OperandValueAndType(n, i),
                    c = l.type.charAt(0);
                switch (e) {
                    case "N":
                        a = "n" == c ? l.value - 0 : 0, s = "n";
                        break;

                    case "T":
                        a = "t" == c ? l.value + "" : "", s = "t";
                        break;

                    case "VALUE":
                        "n" == c || "b" == c ? (a = l.value || 0, s = "n") : "t" == c && (l = t.DetermineValueType(l.value),
                            "n" != l.type.charAt(0) ? (a = 0, s = "e#VALUE!") : (a = l.value - 0, s = "n"));
                }
                "e" == c && (s = l.type), r.PushOperand(o, s, a);
            }, t.Formula.FunctionList.N = [t.Formula.NTVFunctions, 1, "v", "", "math"], t.Formula.FunctionList.T = [t.Formula.NTVFunctions, 1, "v", "", "text"],
            t.Formula.FunctionList.VALUE = [t.Formula.NTVFunctions, 1, "v", "", "text"], t.Formula.Math1Functions = function (e, o, i, n) {
                var r, a, s, l = {},
                    c = t.Formula;
                if (r = c.OperandAsNumber(n, i), a = r.value, l.type = c.LookupResultType(r.type, r.type, c.TypeLookupTable.oneargnumeric),
                    "n" == l.type) switch (e) {
                    case "ABS":
                        a = Math.abs(a);
                        break;

                    case "ACOS":
                        a >= -1 && 1 >= a ? a = Math.acos(a) : l.type = "e#NUM!";
                        break;

                    case "ASIN":
                        a >= -1 && 1 >= a ? a = Math.asin(a) : l.type = "e#NUM!";
                        break;

                    case "ATAN":
                        a = Math.atan(a);
                        break;

                    case "COS":
                        a = Math.cos(a);
                        break;

                    case "DEGREES":
                        a = 180 * a / Math.PI;
                        break;

                    case "EVEN":
                        a = 0 > a ? -a : a, a != Math.floor(a) ? a = Math.floor(a + 1) + Math.floor(a + 1) % 2 : a += a % 2,
                            r.value < 0 && (a = -a);
                        break;

                    case "EXP":
                        a = Math.exp(a);
                        break;

                    case "FACT":
                        for (s = 1, a = Math.floor(a); a > 0; a--) s *= a;
                        a = s;
                        break;

                    case "INT":
                        a = Math.floor(a);
                        break;

                    case "LN":
                        0 >= a && (l.type = "e#NUM!", l.error = t.Constants.s_sheetfunclnarg), a = Math.log(a);
                        break;

                    case "LOG10":
                        0 >= a && (l.type = "e#NUM!", l.error = t.Constants.s_sheetfunclog10arg), a = Math.log(a) / Math.log(10);
                        break;

                    case "ODD":
                        a = 0 > a ? -a : a, a != Math.floor(a) ? a = Math.floor(a + 1) + (1 - Math.floor(a + 1) % 2) : a += 1 - a % 2,
                            r.value < 0 && (a = -a);
                        break;

                    case "RADIANS":
                        a = a * Math.PI / 180;
                        break;

                    case "SIN":
                        a = Math.sin(a);
                        break;

                    case "SQRT":
                        a >= 0 ? a = Math.sqrt(a) : l.type = "e#NUM!";
                        break;

                    case "TAN":
                        0 != Math.cos(a) ? a = Math.tan(a) : l.type = "e#NUM!";
                }
                return l.value = a, o.push(l), null;
            }, t.Formula.FunctionList.ABS = [t.Formula.Math1Functions, 1, "v", "", "math"],
            t.Formula.FunctionList.ACOS = [t.Formula.Math1Functions, 1, "v", "", "math"],
            t.Formula.FunctionList.ASIN = [t.Formula.Math1Functions, 1, "v", "", "math"],
            t.Formula.FunctionList.ATAN = [t.Formula.Math1Functions, 1, "v", "", "math"],
            t.Formula.FunctionList.COS = [t.Formula.Math1Functions, 1, "v", "", "math"], t.Formula.FunctionList.DEGREES = [t.Formula.Math1Functions, 1, "v", "", "math"],
            t.Formula.FunctionList.EVEN = [t.Formula.Math1Functions, 1, "v", "", "math"],
            t.Formula.FunctionList.EXP = [t.Formula.Math1Functions, 1, "v", "", "math"], t.Formula.FunctionList.FACT = [t.Formula.Math1Functions, 1, "v", "", "math"],
            t.Formula.FunctionList.INT = [t.Formula.Math1Functions, 1, "v", "", "math"], t.Formula.FunctionList.LN = [t.Formula.Math1Functions, 1, "v", "", "math"],
            t.Formula.FunctionList.LOG10 = [t.Formula.Math1Functions, 1, "v", "", "math"],
            t.Formula.FunctionList.ODD = [t.Formula.Math1Functions, 1, "v", "", "math"], t.Formula.FunctionList.RADIANS = [t.Formula.Math1Functions, 1, "v", "", "math"],
            t.Formula.FunctionList.SIN = [t.Formula.Math1Functions, 1, "v", "", "math"], t.Formula.FunctionList.SQRT = [t.Formula.Math1Functions, 1, "v", "", "math"],
            t.Formula.FunctionList.TAN = [t.Formula.Math1Functions, 1, "v", "", "math"], t.Formula.Math2Functions = function (e, o, i, n) {
                var r, a, s, l, c, u, d = {},
                    h = t.Formula;
                if (r = h.OperandAsNumber(n, i), a = h.OperandAsNumber(n, i), s = 0, d.type = h.LookupResultType(r.type, a.type, h.TypeLookupTable.twoargnumeric),
                    "n" == d.type) switch (e) {
                    case "ATAN2":
                        0 == r.value && 0 == a.value ? d.type = "e#DIV/0!" : d.value = Math.atan2(a.value, r.value);
                        break;

                    case "POWER":
                        d.value = Math.pow(r.value, a.value), isNaN(d.value) && (d.value = 0, d.type = "e#NUM!");
                        break;

                    case "MOD":
                        0 == a.value ? d.type = "e#DIV/0!" : (l = r.value / a.value, l = Math.floor(l),
                            d.value = r.value - l * a.value);
                        break;

                    case "TRUNC":
                        if (c = 1, a.value >= 0) {
                            for (a.value = Math.floor(a.value), u = 0; u < a.value; u++) c *= 10;
                            d.value = Math.floor(Math.abs(r.value) * c) / c;
                        } else if (a.value < 0) {
                            for (a.value = Math.floor(-a.value), u = 0; u < a.value; u++) c *= 10;
                            d.value = Math.floor(Math.abs(r.value) / c) * c;
                        }
                        r.value < 0 && (d.value = -d.value);
                }
                return o.push(d), null;
            }, t.Formula.FunctionList.ATAN2 = [t.Formula.Math2Functions, 2, "xy", "", "math"],
            t.Formula.FunctionList.MOD = [t.Formula.Math2Functions, 2, "", "", "math"], t.Formula.FunctionList.POWER = [t.Formula.Math2Functions, 2, "", "", "math"],
            t.Formula.FunctionList.TRUNC = [t.Formula.Math2Functions, 2, "valpre", "", "math"],
            t.Formula.LogFunction = function (e, o, i, n) {
                var r, a, s = {},
                    l = t.Formula;
                if (s.value = 0, r = l.OperandAsNumber(n, i), s.type = l.LookupResultType(r.type, r.type, l.TypeLookupTable.oneargnumeric),
                    1 == i.length) {
                    if (a = l.OperandAsNumber(n, i), "n" != a.type.charAt(0) || a.value <= 0) return l.FunctionSpecificError(e, o, "e#NUM!", t.Constants.s_sheetfunclogsecondarg),
                        0;
                } else {
                    if (0 != i.length) return l.FunctionArgsError(e, o), 0;
                    a = {
                        value: Math.E,
                        type: "n"
                    };
                }
                if ("n" == s.type) {
                    if (r.value <= 0) return l.FunctionSpecificError(e, o, "e#NUM!", t.Constants.s_sheetfunclogfirstarg),
                        0;
                    s.value = Math.log(r.value) / Math.log(a.value);
                }
                o.push(s);
            }, t.Formula.FunctionList.LOG = [t.Formula.LogFunction, -1, "log", "", "math"],
            t.Formula.RoundFunction = function (e, o, i, n) {
                var r, a, s, l, c = t.Formula,
                    u = 0,
                    d = "e#VALUE!",
                    h = c.OperandValueAndType(n, i),
                    d = c.LookupResultType(h.type, h.type, c.TypeLookupTable.oneargnumeric);
                if (1 == i.length) {
                    if (r = c.OperandValueAndType(n, i), "n" != r.type.charAt(0)) return c.FunctionSpecificError(e, o, "e#NUM!", t.Constants.s_sheetfuncroundsecondarg),
                        0;
                } else {
                    if (0 != i.length) return c.FunctionArgsError(e, o), 0;
                    r = {
                        value: 0,
                        type: "n"
                    };
                }
                if ("n" == d)
                    if (r.value = r.value - 0, 0 == r.value) u = Math.round(h.value);
                    else if (r.value > 0) {
                    for (a = 1, r.value = Math.floor(r.value), l = 0; l < r.value; l++) a *= 10;
                    s = Math.round(h.value * a), u = s / a;
                } else if (r.value < 0) {
                    for (a = 1, r.value = Math.floor(-r.value), l = 0; l < r.value; l++) a *= 10;
                    s = Math.round(h.value / a), u = s * a;
                }
                c.PushOperand(o, d, u);
            }, t.Formula.FunctionList.ROUND = [t.Formula.RoundFunction, -1, "vp", "", "math"],
            t.Formula.CeilingFloorFunctions = function (e, o, i, n) {
                var r, a, s, l = t.Formula,
                    c = function (e, t) {
                        o.push({
                            type: e,
                            value: t
                        });
                    };
                if (r = l.OperandValueAndType(n, i), s = r.type.charAt(0), "n" != s) return void c("e#VALUE!", 0);
                if (0 == r.value) return void c("n", 0);
                if (1 == i.length) {
                    if (a = l.OperandValueAndType(n, i), s = r.type.charAt(0), "n" != s) return void c("e#VALUE!", 0);
                } else {
                    if (0 != i.length) return void c("e#VALUE!", 0);
                    a = {
                        type: "n",
                        value: r.value > 0 ? 1 : -1
                    };
                }
                if (0 == a.value) return void c("n", 0);
                if (a.value * r.value < 0) return void c("e#NUM!", 0);
                switch (e) {
                    case "CEILING":
                        c("n", Math.ceil(r.value / a.value) * a.value);
                        break;

                    case "FLOOR":
                        c("n", Math.floor(r.value / a.value) * a.value);
                }
            }, t.Formula.FunctionList.CEILING = [t.Formula.CeilingFloorFunctions, -1, "vsig", "", "math"],
            t.Formula.FunctionList.FLOOR = [t.Formula.CeilingFloorFunctions, -1, "vsig", "", "math"],
            t.Formula.AndOrFunctions = function (e, o, i, n) {
                var r, a, s = t.Formula,
                    l = "";
                for ("AND" == e ? a = 1 : "OR" == e && (a = 0); i.length;) r = s.OperandValueAndType(n, i),
                    "n" == r.type.charAt(0) ? (r.value = r.value - 0, "AND" == e ? a = 0 != r.value ? a : 0 : "OR" == e && (a = 0 != r.value ? 1 : a),
                        l = s.LookupResultType(r.type, l || "nl", s.TypeLookupTable.propagateerror)) : "e" == r.type.charAt(0) && "e" != l.charAt(0) && (l = r.type);
                l.length < 1 && (l = "e#VALUE!", a = 0), s.PushOperand(o, l, a);
            }, t.Formula.FunctionList.AND = [t.Formula.AndOrFunctions, -1, "vn", "", "test"],
            t.Formula.FunctionList.OR = [t.Formula.AndOrFunctions, -1, "vn", "", "test"],
            t.Formula.NotFunction = function (e, o, i, n) {
                var r = 0,
                    a = t.Formula,
                    s = a.OperandValueAndType(n, i),
                    l = a.LookupResultType(s.type, s.type, a.TypeLookupTable.propagateerror);
                "n" == s.type.charAt(0) || "b" == s.type ? (r = s.value - 0 != 0 ? 0 : 1, l = "nl") : "t" == s.type.charAt(0) && (l = "e#VALUE!"),
                    a.PushOperand(o, l, r);
            }, t.Formula.FunctionList.NOT = [t.Formula.NotFunction, 1, "v", "", "test"], t.Formula.ChooseFunction = function (e, o, i, n) {
                var r, a, s, l = 0,
                    c = t.Formula,
                    u = c.OperandAsNumber(n, i);
                for ("n" != u.type.charAt(0) && (u.value = 0), u.value = Math.floor(u.value), a = 0; i.length;)
                    if (s = c.TopOfStackValueAndType(n, i),
                        a += 1, u.value == a) {
                        l = s.value, r = s.type;
                        break;
                    }
                r ? c.PushOperand(o, r, l) : c.PushOperand(o, "e#VALUE!", 0);
            }, t.Formula.FunctionList.CHOOSE = [t.Formula.ChooseFunction, -2, "choose", "", "lookup"],
            t.Formula.ColumnsRowsFunctions = function (e, o, i, n) {
                var r, a, s = 0,
                    l = t.Formula,
                    c = l.TopOfStackValueAndType(n, i);
                "coord" == c.type ? (s = 1, r = "n") : "range" == c.type ? (a = l.DecodeRangeParts(n, c.value),
                    "COLUMNS" == e ? s = a.ncols : "ROWS" == e && (s = a.nrows), r = "n") : (s = 0,
                    r = "e#VALUE!"), l.PushOperand(o, r, s);
            }, t.Formula.FunctionList.COLUMNS = [t.Formula.ColumnsRowsFunctions, 1, "range", "", "lookup"],
            t.Formula.FunctionList.ROWS = [t.Formula.ColumnsRowsFunctions, 1, "range", "", "lookup"],
            t.Formula.ZeroArgFunctions = function (e, o) {
                var i, n, r, a, s, l = {
                    value: 0
                };
                switch (e) {
                    case "FALSE":
                        l.type = "nl", l.value = 0;
                        break;

                    case "NA":
                        l.type = "e#N/A";
                        break;

                    case "NOW":
                        i = new Date(), n = i.getTimezoneOffset(), i = i.getTime() / 1e3, r = 25569, a = 86400,
                            s = r + i / a - n / 1440, l.value = s, l.type = "ndt", t.Formula.FreshnessInfo.volatile.NOW = !0;
                        break;

                    case "PI":
                        l.type = "n", l.value = Math.PI;
                        break;

                    case "TODAY":
                        i = new Date(), n = i.getTimezoneOffset(), i = i.getTime() / 1e3, r = 25569, a = 86400,
                            s = r + i / a - n / 1440, l.value = Math.floor(s), l.type = "nd", t.Formula.FreshnessInfo.volatile.TODAY = !0;
                        break;

                    case "TRUE":
                        l.type = "nl", l.value = 1;
                        break;

                    case "RAND":
                        l.type = "n", l.value = Math.random(), t.Formula.FreshnessInfo.volatile.RAND = !0;
                }
                return o.push(l), null;
            }, t.Formula.FunctionList.FALSE = [t.Formula.ZeroArgFunctions, 0, "", "", "test"],
            t.Formula.FunctionList.NA = [t.Formula.ZeroArgFunctions, 0, "", "", "test"], t.Formula.FunctionList.NOW = [t.Formula.ZeroArgFunctions, 0, "", "", "datetime"],
            t.Formula.FunctionList.RAND = [t.Formula.ZeroArgFunctions, 0, "", "", "math"],
            t.Formula.FunctionList.PI = [t.Formula.ZeroArgFunctions, 0, "", "", "math"], t.Formula.FunctionList.TODAY = [t.Formula.ZeroArgFunctions, 0, "", "", "datetime"],
            t.Formula.FunctionList.TRUE = [t.Formula.ZeroArgFunctions, 0, "", "", "test"],
            t.Formula.DDBFunction = function (e, o, i, n) {
                var r, a, s, l, c = t.Formula,
                    u = c.OperandAsNumber(n, i),
                    d = c.OperandAsNumber(n, i),
                    h = c.OperandAsNumber(n, i),
                    p = c.OperandAsNumber(n, i);
                if (!(c.CheckForErrorValue(o, u) || c.CheckForErrorValue(o, d) || c.CheckForErrorValue(o, h) || c.CheckForErrorValue(o, p))) {
                    if (h.value < 1) return c.FunctionSpecificError(e, o, "e#NUM!", t.Constants.s_sheetfuncddblife),
                        0;
                    if (r = {
                            value: 2,
                            type: "n"
                        }, i.length > 0 && (r = c.OperandAsNumber(n, i)), 0 != i.length) return c.FunctionArgsError(e, o),
                        0;
                    if (!c.CheckForErrorValue(o, r)) {
                        for (a = 0, s = 0, l = 1; l <= p.value - 0 && l <= h.value; l++) a = (u.value - s) * (r.value / h.value),
                            u.value - s - a < d.value && (a = u.value - s - d.value), s += a;
                        c.PushOperand(o, "n$", a);
                    }
                }
            }, t.Formula.FunctionList.DDB = [t.Formula.DDBFunction, -4, "ddb", "", "financial"],
            t.Formula.SLNFunction = function (e, o, i, n) {
                var r, a = t.Formula,
                    s = a.OperandAsNumber(n, i),
                    l = a.OperandAsNumber(n, i),
                    c = a.OperandAsNumber(n, i);
                if (!a.CheckForErrorValue(o, s) && !a.CheckForErrorValue(o, l) && !a.CheckForErrorValue(o, c)) {
                    if (c.value < 1) return a.FunctionSpecificError(e, o, "e#NUM!", t.Constants.s_sheetfuncslnlife),
                        0;
                    r = (s.value - l.value) / c.value, a.PushOperand(o, "n$", r);
                }
            }, t.Formula.FunctionList.SLN = [t.Formula.SLNFunction, 3, "csl", "", "financial"],
            t.Formula.SYDFunction = function (e, o, i, n) {
                var r, a, s = t.Formula,
                    l = s.OperandAsNumber(n, i),
                    c = s.OperandAsNumber(n, i),
                    u = s.OperandAsNumber(n, i),
                    d = s.OperandAsNumber(n, i);
                if (!(s.CheckForErrorValue(o, l) || s.CheckForErrorValue(o, c) || s.CheckForErrorValue(o, u) || s.CheckForErrorValue(o, d))) {
                    if (u.value < 1 || d.value <= 0) return s.PushOperand(o, "e#NUM!", 0), 0;
                    a = (u.value + 1) * u.value / 2, r = (l.value - c.value) * (u.value - d.value + 1) / a,
                        s.PushOperand(o, "n$", r);
                }
            }, t.Formula.FunctionList.SYD = [t.Formula.SYDFunction, 4, "cslp", "", "financial"],
            t.Formula.InterestFunctions = function (e, o, i, n) {
                var r, a, s, l, c, u, d, h, p, f, m, g, v, b, y, C, w, x, _, S, h, k, T, F = t.Formula,
                    E = F.OperandAsNumber(n, i),
                    D = F.OperandAsNumber(n, i),
                    P = F.OperandAsNumber(n, i);
                if (r = F.LookupResultType(E.type, D.type, F.TypeLookupTable.twoargnumeric), r = F.LookupResultType(r, P.type, F.TypeLookupTable.twoargnumeric),
                    i.length && (s = F.OperandAsNumber(n, i), r = F.LookupResultType(r, s.type, F.TypeLookupTable.twoargnumeric),
                        i.length && (l = F.OperandAsNumber(n, i), r = F.LookupResultType(r, l.type, F.TypeLookupTable.twoargnumeric),
                            i.length))) {
                    if ("RATE" != e) return F.FunctionArgsError(e, o), 0;
                    c = F.OperandAsNumber(n, i), r = F.LookupResultType(r, c.type, F.TypeLookupTable.twoargnumeric);
                }
                if ("n" == r) switch (e) {
                    case "FV":
                        h = E.value, p = D.value, f = P.value, u = null != s ? s.value : 0, m = null != l && l.value ? 1 : 0,
                            d = 0 == h ? -u - f * p : -(u * Math.pow(1 + h, p) + f * (1 + h * m) * (Math.pow(1 + h, p) - 1) / h),
                            a = d, r = "n$";
                        break;

                    case "NPER":
                        if (h = E.value, f = D.value, u = P.value, d = null != s ? s.value : 0, m = null != l && l.value ? 1 : 0,
                            0 == h) {
                            if (0 == f) return void F.PushOperand(o, "e#NUM!", 0);
                            p = (u + d) / -f;
                        } else {
                            if (v = f * (1 + h * m) / h, b = u + v, 0 == b || -1 >= h) return void F.PushOperand(o, "e#NUM!", 0);
                            if (y = (v - d) / b, 0 >= y) return void F.PushOperand(o, "e#NUM!", 0);
                            C = Math.log(y), w = Math.log(1 + h), p = C / w;
                        }
                        a = p, r = "n";
                        break;

                    case "PMT":
                        if (h = E.value, p = D.value, u = P.value, d = null != s ? s.value : 0, m = null != l && l.value ? 1 : 0,
                            0 == p) return void F.PushOperand(o, "e#NUM!", 0);
                        f = 0 == h ? (d - u) / p : (0 - d - u * Math.pow(1 + h, p)) / ((1 + h * m) * (Math.pow(1 + h, p) - 1) / h),
                            a = f, r = "n$";
                        break;

                    case "PV":
                        if (h = E.value, p = D.value, f = P.value, d = null != s ? s.value : 0, m = null != l && l.value ? 1 : 0,
                            -1 == h) return void F.PushOperand(o, "e#DIV/0!", 0);
                        u = 0 == h ? -d - f * p : (-d - f * (1 + h * m) * (Math.pow(1 + h, p) - 1) / h) / Math.pow(1 + h, p),
                            a = u, r = "n$";
                        break;

                    case "RATE":
                        for (p = E.value, f = D.value, u = P.value, d = null != s ? s.value : 0, m = null != l && l.value ? 1 : 0,
                            g = null != c ? c.value : .1, _ = 100, S = 0, delta = 1, epsilon = 1e-7, h = g || 1e-8;
                            (delta >= 0 ? delta : -delta) > epsilon && h != k;)
                            if (delta = d + u * Math.pow(1 + h, p) + f * (1 + h * m) * (Math.pow(1 + h, p) - 1) / h,
                                null != x ? (T = (delta - x) / (h - k) || .001, k = h, h -= delta / T, x = delta) : (k = h,
                                    h = 1.1 * h, x = delta), S++, S >= _) return void F.PushOperand(o, "e#NUM!", 0);
                        a = h, r = "n%";
                }
                F.PushOperand(o, r, a);
            }, t.Formula.FunctionList.FV = [t.Formula.InterestFunctions, -3, "fv", "", "financial"],
            t.Formula.FunctionList.NPER = [t.Formula.InterestFunctions, -3, "nper", "", "financial"],
            t.Formula.FunctionList.PMT = [t.Formula.InterestFunctions, -3, "pmt", "", "financial"],
            t.Formula.FunctionList.PV = [t.Formula.InterestFunctions, -3, "pv", "", "financial"],
            t.Formula.FunctionList.RATE = [t.Formula.InterestFunctions, -3, "rate", "", "financial"],
            t.Formula.NPVFunction = function (e, o, i, n) {
                var r, a, s, l, c, u = t.Formula,
                    a = u.OperandAsNumber(n, i);
                if (!u.CheckForErrorValue(o, a)) {
                    for (s = 0, r = "n", l = 1; i.length;)
                        if (c = u.OperandValueAndType(n, i), "n" == c.type.charAt(0)) {
                            if (l *= 1 + a.value, 0 == l) return void u.PushOperand(o, "e#DIV/0!", 0);
                            s += c.value / l, r = u.LookupResultType(c.type, r || c.type, u.TypeLookupTable.plus);
                        } else if ("e" == c.type.charAt(0) && "e" != r.charAt(0)) {
                        r = c.type;
                        break;
                    }
                    "n" == r.charAt(0) && (r = "n$"), u.PushOperand(o, r, s);
                }
            }, t.Formula.FunctionList.NPV = [t.Formula.NPVFunction, -2, "npv", "", "financial"],
            t.Formula.IRRFunction = function (e, o, i, n) {
                var r, a, s, l, c, u, d, h, p, f, m, g, v = [],
                    b = [],
                    y = t.Formula;
                for (v.push(i.pop()); v.length;)
                    if (r = y.OperandValueAndType(n, v), "n" == r.type.charAt(0)) b.push(r.value);
                    else if ("e" == r.type.charAt(0)) return void y.PushOperand(o, "e#VALUE!", 0);
                if (!b.length) return void y.PushOperand(o, "e#NUM!", 0);
                if (a = {
                        value: 0
                    }, i.length) {
                    if (a = y.OperandAsNumber(n, i), "n" != a.type.charAt(0) && "b" != a.type.charAt(0)) return void y.PushOperand(o, "e#VALUE!", 0);
                    if (i.length) return void y.FunctionArgsError(e, o);
                }
                for (a.value = a.value || .1, l = 20, c = 0, u = 1e-7, d = a.value, f = 1;
                    (f >= 0 ? f : -f) > u && d != h;) {
                    for (f = 0, m = 1, g = 0; g < b.length; g++) {
                        if (m *= 1 + d, 0 == m) return void y.PushOperand(o, "e#DIV/0!", 0);
                        f += b[g] / m;
                    }
                    if (null != s ? (p = (f - s) / (d - h), h = d, d -= f / p, s = f) : (h = d, d = 1.1 * d,
                            s = f), c++, c >= l) return void y.PushOperand(o, "e#NUM!", 0);
                }
                y.PushOperand(o, "n%", d);
            }, t.Formula.FunctionList.IRR = [t.Formula.IRRFunction, -1, "irr", "", "financial"],
            t.Formula.IoFunctions = function (o, i, n, r, a) {
                var s, l, c, u, d = {
                        BUTTON: [2],
                        IMAGEBUTTON: [2],
                        EMAIL: [14, 14, 14, 14],
                        EMAILIF: [13, 14, 14, 14, 14],
                        EMAILONEDIT: [14, 14, 14, 14, 14],
                        EMAILAT: [13, 14, 14, 14, 14],
                        EMAILONEDITIF: [14, 13, 14, 14, 14, 14],
                        EMAILATIF: [13, 13, 14, 14, 14, 14],
                        SUBMIT: [2],
                        TEXTBOX: [2],
                        AUTOCOMPLETE: [2, 14],
                        SELECT: [2, 14, 1, 1],
                        CHECKBOX: [3],
                        RADIOBUTTON: [2, 2],
                        COPYVALUE: [4, 12, 15],
                        COPYFORMULA: [4, 12, 12],
                        INSERT: [4, 8, -12, -15],
                        DELETEIF: [4, 7, 8],
                        COMMAND: [4, 14],
                        COMMANDIF: [4, 13, 14],
                        PANEL: [15, -12],
                        SPLASH: [12],
                        STYLE: [6]
                    },
                    h = t.Formula,
                    p = 0,
                    f = "e#VALUE!",
                    m = n.length,
                    g = d[o],
                    v = [],
                    b = [],
                    y = -1;
                for (s = 1; m >= s; s++) {
                    if (-1 != y) u = Math.abs(g[c + (s - 1 - c) % y]);
                    else {
                        if (s > g.length) return void h.FunctionArgsError(o, i);
                        u = g[s - 1], 0 > u && (y = g.length - (s - 1), c = s - 1, u = Math.abs(u));
                    }
                    if (1 == u) l = h.OperandAsNumber(r, n);
                    else if (2 == u) l = h.OperandAsText(r, n);
                    else if (3 == u) l = h.OperandValueAndType(r, n);
                    else {
                        var C = n[n.length - 1].type,
                            w = !1;
                        if (("n" == C.charAt(0) && 0 != (1 & u) || "t" == C.charAt(0) && 0 != (2 & u)) && (w = !0,
                                l = h.OperandValueAndType(r, n)), "coord" == C && 0 != (4 & u) && (w = !0, l = h.OperandAsCoord(r, n),
                                l.value = t.Formula.PlainCoord(l.value)), "range" == C && 0 != (8 & u) && (w = !0,
                                l = h.OperandAsRange(r, n), l.value = t.Formula.PlainCoord(l.value)), 0 == w) return void h.FunctionArgsError(o, i);
                    }
                    if (v[s] = l.value, b[s] = l.type, "e" == l.type.charAt(0)) return void h.PushOperand(i, l.type, p);
                }
                switch (o) {
                    case "STYLE":
                        var x = r.ioParameterList[a];
                        if (x) {
                            var _ = t.Formula.getStandardizedList(r, {
                                value: v[1],
                                type: b[1]
                            });
                            _.length > 0 && (x.css = _[0], x.cssParameter = "t" == b[1] ? '"' + v[1] + '"' : v[1]),
                                p = "", f = "ni";
                        }
                        break;

                    case "SELECT":
                        var x = r.ioParameterList[a],
                            S = t.Formula.getStandardizedList(r, x[1]);
                        if (x.html = [], x.html[0] = 1 == v[4] ? "multiple" : "", x.html[1] = v[3] ? "" + v[3] : "1",
                            S.length > 0) {
                            var k = "<option>" + S.join("</option><option>") + "</option>",
                                T = new RegExp("<option>" + v[1], "");
                            x.html[2] = k.replace(T, "<option selected>" + v[1]);
                        }
                        p = v[1], f = "ti" + o;
                        break;

                    case "SUBMIT":
                        p = "Submit";

                    case "BUTTON":
                    case "IMAGEBUTTON":
                    case "TEXTBOX":
                    case "AUTOCOMPLETE":
                        m > 0 && (p = v[1]), f = "ti" + o;
                        break;

                    case "EMAIL":
                    case "EMAILIF":
                        f = "ti" + o, p = "Send";
                        break;

                    case "EMAILONEDIT":
                    case "EMAILONEDITIF":
                    case "EMAILAT":
                    case "EMAILATIF":
                        f = "ti" + o, p = "Send Now";
                        break;

                    case "CHECKBOX":
                    case "RADIOBUTTON":
                        p = "t" == b[1].charAt(0) ? "TRUE" == v[1].toUpperCase() ? 1 : 0 : 0 == v[1] ? 0 : 1,
                            f = "ni" + o;
                        break;

                    case "COPYVALUE":
                    case "COPYFORMULA":
                    case "INSERT":
                    case "DELETEIF":
                    case "COMMAND":
                    case "COMMANDIF":
                        var F = r.cells[v[1]];
                        if ("undefined" == typeof F) break;
                        p = F.datavalue, p = String(p).split("/"), p = p[p.length - 1], f = "t";
                        break;

                    case "PANEL":
                    case "SPLASH":
                        var E, D = 2;
                        if ("SPLASH" == o) {
                            if (p = "SPLASH:" + v[1], f = "t", 1 == r.splashdone) break;
                            r.splashdone = !0, D = 1, E = [0];
                        } else E = t.Formula.getStandardizedList(r, {
                            value: v[1],
                            type: b[1]
                        }), p = o + ":" + E;
                        if (f = "t", t._app) {
                            for (var P = [], A = [], I = D; I < v.length; ++I) {
                                var M = !1;
                                for (var R in E)
                                    if (E[R] == I - 1) {
                                        M = !0;
                                        break;
                                    }
                                if (M !== !1) {
                                    for (var N = t.Formula.getStandardizedCoords(r, {
                                            value: v[I],
                                            type: b[I]
                                        }), s = 0; s < N.ncols; s++) A[N.col1num + s] = !0;
                                    for (var L = 0; L < N.nrows; L++) P[N.row1num + L] = !0;
                                }
                            }
                            var O = e.spreadsheet;
                            null == O && (O = e.ss);
                            var z = !1,
                                H = 0,
                                B = function (e, t, o, i, n) {
                                    for (var r = 1; t >= r; r++) {
                                        var a = n(r);
                                        "undefined" == typeof o[a] ? i[r] !== !0 ? (o[a] = "yes", z = !0) : H = r : i[r] === !0 && (delete o[a],
                                            z = !0, H = r);
                                    }
                                },
                                U = function (e) {
                                    return e;
                                };
                            B(r, r.attribs.lastrow, r.rowattribs.hide, P, U), H = 0, B(r, r.attribs.lastcol, r.colattribs.hide, A, t.rcColname),
                                r.attribs.usermaxcol = H, z && (r.renderneeded = !0, r.widgetsClean = !1, O.editor.context.rowpanes[0].first = 1,
                                    O.editor.context.CalculateColWidthData(), O.width = O.editor.context.totalwidth,
                                    O.height = 2500, O.editor.ResizeTableEditor(O.editor.context.totalwidth, 2500));
                        }
                }
                h.PushOperand(i, f, p);
            }, t.Formula.FunctionList.BUTTON = [t.Formula.IoFunctions, 1, "label", "", "gui", "<button type='button' onclick=\"SocialCalc.TriggerIoAction.Button('<%=cell_reference%>');\"><%=formated_value%></button>", "ParameterList"],
            t.Formula.FunctionList.IMAGEBUTTON = [t.Formula.IoFunctions, 1, "imageurl", "", "gui", "<input type='image' src='<%=display_value%>' alt='Submit' onclick=\"SocialCalc.TriggerIoAction.Button('<%=cell_reference%>');\">", "ParameterList"],
            t.Formula.FunctionList.EMAIL = [t.Formula.IoFunctions, -3, "to_range subject_range, body_range", "", "action", "<button type='button' onclick=\"SocialCalc.TriggerIoAction.Email('<%=cell_reference%>');\"><%=formated_value%></button>", "ParameterList"],
            t.Formula.FunctionList.EMAILIF = [t.Formula.IoFunctions, -4, "condition_range, to_range subject_range, body_range", "", "action", "<button type='button' onclick=\"SocialCalc.TriggerIoAction.Email('<%=cell_reference%>');\"><%=formated_value%></button>", "ParameterList"],
            t.Formula.FunctionList.EMAILONEDIT = [t.Formula.IoFunctions, -4, "editRange, to_range subject_range, body_range", "", "action", "<button type='button' onclick=\"SocialCalc.TriggerIoAction.Email('<%=cell_reference%>');\"><%=formated_value%></button>", "EventTree"],
            t.Formula.FunctionList.EMAILAT = [t.Formula.IoFunctions, -4, "datetime_value, to_range subject_range, body_range", "", "action", "<button type='button' onclick=\"SocialCalc.TriggerIoAction.Email('<%=cell_reference%>');\"><%=formated_value%></button>", "TimeTrigger"],
            t.Formula.FunctionList.EMAILONEDITIF = [t.Formula.IoFunctions, -5, "editRange, condition, to_range subject_range, body_range", "", "action", "<button type='button' onclick=\"SocialCalc.TriggerIoAction.Email('<%=cell_reference%>');\"><%=formated_value%></button>", "EventTree"],
            t.Formula.FunctionList.EMAILATIF = [t.Formula.IoFunctions, -5, "datetime_value, condition, to_range subject_range, body_range", "", "action", "<button type='button' onclick=\"SocialCalc.TriggerIoAction.Email('<%=cell_reference%>');\"><%=formated_value%></button>", "TimeTrigger"],
            t.Formula.FunctionList.SUBMIT = [t.Formula.IoFunctions, 100, "[label]", "", "action", "<button type='button' onclick=\"SocialCalc.TriggerIoAction.Submit('<%=cell_reference%>');\"><%=formated_value%></button>", "ParameterList"],
            t.Formula.FunctionList.TEXTBOX = [t.Formula.IoFunctions, 1, "value", "", "gui", "<input type='text' id='TEXTBOX_<%=cell_reference%>' onblur='SocialCalc.CmdGotFocus(null);' oninput=\"SocialCalc.TriggerIoAction.TextBox('<%=cell_reference%>')\" value='<%=display_value%>' >", "Input"],
            t.Formula.FunctionList.AUTOCOMPLETE = [t.Formula.IoFunctions, 2, "value, range or csv_text", "", "gui", "<input type='text' id='AUTOCOMPLETE_<%=cell_reference%>' onfocus=\"SocialCalc.TriggerIoAction.AddAutocomplete('<%=cell_reference%>');\" onblur='SocialCalc.CmdGotFocus(null);' value='<%=display_value%>' >", "Input"],
            t.Formula.FunctionList.SELECT = [t.Formula.IoFunctions, -2, "value, range or csv_text [,size]", "", "gui", "<select size='<%=html1_value%>' id='SELECT_<%=cell_reference%>' onchange=\"SocialCalc.TriggerIoAction.SelectList('<%=cell_reference%>')\" <%=html0_value%>><%=html2_value%></select>", "Input"],
            t.Formula.FunctionList.CHECKBOX = [t.Formula.IoFunctions, 1, "value", "", "gui", "<input type='checkbox' id='CHECKBOX_<%=cell_reference%>' <%=checked%> onblur='SocialCalc.CmdGotFocus(null);' onchange=\"SocialCalc.TriggerIoAction.CheckBox('<%=cell_reference%>')\" >", "Input"],
            t.Formula.FunctionList.RADIOBUTTON = [t.Formula.IoFunctions, 2, "value, groupname", "", "gui", "<input type='radio' value='<%=cell_reference%>' id='RADIOBUTTON_<%=cell_reference%>' <%=checked%> name='<%=parameter1_value%>' onblur=\"SocialCalc.CmdGotFocus(null);\" onclick=\"SocialCalc.TriggerIoAction.RadioButton('<%=parameter1_value%>');\" >", "Input"],
            t.Formula.FunctionList.COPYVALUE = [t.Formula.IoFunctions, 3, "trigger_cell, destinationCell, value_or_range", "", "action", "", "EventTree"],
            t.Formula.FunctionList.COPYFORMULA = [t.Formula.IoFunctions, 3, "trigger_cell, destinationCell, formula_range", "", "action", "", "EventTree"],
            t.Formula.FunctionList.INSERT = [t.Formula.IoFunctions, -2, "trigger_cell, destination_range [,formula_range,value_or_range,formula_range, ...]", "", "action", "", "EventTree"],
            t.Formula.FunctionList.DELETEIF = [t.Formula.IoFunctions, -1, "trigger_cell, criteria , test_range", "", "action", "", "EventTree"],
            t.Formula.FunctionList.COMMAND = [t.Formula.IoFunctions, -1, "trigger_cell, commands", "", "action", "", "EventTree"],
            t.Formula.FunctionList.COMMANDIF = [t.Formula.IoFunctions, -1, "trigger_cell, conditions, commands", "", "action", "", "EventTree"],
            t.Formula.FunctionList.PANEL = [t.Formula.IoFunctions, -1, "showindices_range_or_csv, panel1_range [, panel2_range , ...]", "", "gui", ""],
            t.Formula.FunctionList.SPLASH = [t.Formula.IoFunctions, -1, "splash_panel_range", "", "gui", ""],
            t.Formula.FunctionList.STYLE = [t.Formula.IoFunctions, -1, "css", "", "gui", ""],
            t.TriggerIoAction.AddAutocomplete = function (o) {
                var i = e.spreadsheet;
                null == i && (i = e.ss);
                var n = i.sheet,
                    r = (t.Formula, n.ioParameterList[o]);
                if ("undefined" != typeof r) {
                    var a = t.Formula.getStandardizedList(n, r[1]);
                    $.ui.autocomplete.filter = function (e, t) {
                        var o = new RegExp("\\b" + $.ui.autocomplete.escapeRegex(t), "i");
                        return $.grep(e, function (e) {
                            return o.test(e.label || e.value || e);
                        });
                    }, $container.find("#AUTOCOMPLETE_" + o).autocomplete({
                        source: a,
                        minLength: 1,
                        autoFocus: !0,
                        select: function (e, i) {
                            $container.find(this).val(i.item.label), t.TriggerIoAction.AutoComplete(o);
                        },
                        change: function (e, i) {
                            null === i.item && $container.find(this).val(""), t.TriggerIoAction.AutoComplete(o);
                        }
                    });
                }
            }, t.TriggerIoAction.Button = function (o) {
                var i = e.spreadsheet;
                null == i && (i = e.ss); {
                    var n = i.sheet;
                    t.Formula;
                }
                if ("undefined" != typeof n.ioEventTree && "undefined" != typeof n.ioParameterList && "undefined" !== n.ioEventTree[o])
                    for (var r in n.ioEventTree[o]) {
                        var a = n.ioParameterList[r],
                            s = null;
                        switch (a.function_name) {
                            case "COPYVALUE":
                                var l = t.Formula.getStandardizedValues(n, a[2]),
                                    c = t.coordToCr(a[1].value),
                                    u = t.TriggerIoAction.CopyValueToRange(l, c);
                                i.editor.EditorScheduleSheetCommands(u, !0, !1);
                                break;

                            case "COPYFORMULA":
                                var l = t.Formula.getStandardizedValues(n, a[2]),
                                    c = t.coordToCr(a[1].value),
                                    u = t.TriggerIoAction.CopyFormulaToRange(l, c);
                                i.editor.EditorScheduleSheetCommands(u, !0, !1);
                                break;

                            case "INSERT":
                                var l = t.Formula.getStandardizedValues(n, a[1]);
                                if ("range" != l.type) break;
                                var d, h, p;
                                l.ncols > 1 && (h = 1, p = 0, d = "insertcol"), l.nrows > 1 && (h = 0, p = 1, d = "insertrow");
                                for (var f = l.cellcoord[h][p], u = d + " " + f, c = t.coordToCr(f), m = 2; m < a.length;)("range" == a[m].type || "coord" == a[m].type || m % 2 == 1) && (copyCellRange = t.Formula.getStandardizedValues(n, a[m]),
                                        u = m % 2 == 0 ? u + "\n" + t.TriggerIoAction.CopyFormulaToRange(copyCellRange, c) : u + "\n" + t.TriggerIoAction.CopyValueToRange(copyCellRange, c),
                                        l.nrows > 1 && (c.col += copyCellRange.ncols), l.ncols > 1 && (c.row += copyCellRange.nrows)),
                                    m++;
                                i.editor.EditorScheduleSheetCommands(u, !0, !1);
                                break;

                            case "DELETEIF":
                                var h, p, g, v = t.Formula.getStandardizedValues(n, a[1]),
                                    b = t.Formula.getStandardizedValues(n, a[2]),
                                    u = "";
                                if (b.ncols > 1 && b.nrows > 1) return;
                                b.ncols > 1 && (h = 1, p = 0, g = "deletecol"), b.nrows > 1 && (h = 0, p = 1, g = "deleterow");
                                for (var y = v.celldata[0][0].datavalue, C = b.ncols - h - 1; C >= h; C--)
                                    for (var w = b.nrows - p - 1; w >= p; w--) {
                                        var x = b.celldata[C][w];
                                        1 == t.Formula.TestCriteria(x.datavalue, x.valuetype, y) && ("" != u && (u += "\n"),
                                            u = u + g + " " + b.cellcoord[C][w]);
                                    }
                                "" != u && i.editor.EditorScheduleSheetCommands(u, !0, !1);
                                break;

                            case "COMMANDIF":
                                s = t.Formula.getStandardizedValues(n, a[1]);

                            case "COMMAND":
                                var _, u = "";
                                if (null != s) {
                                    var _ = t.Formula.getStandardizedValues(n, a[2]);
                                    if (s.ncols != _.ncols || s.nrows != _.nrows) break;
                                } else _ = t.Formula.getStandardizedValues(n, a[1]);
                                for (var C = 0; C < _.ncols; C++)
                                    for (var w = 0; w < _.nrows; w++) {
                                        if (null != s) {
                                            var S = s.celldata[C][w];
                                            if (0 == S.datavalue) continue;
                                        }
                                        "" != u && (u += "\n");
                                        var k = _.celldata[C][w];
                                        u += k.datavalue.toString().trim();
                                    }
                                "" != u && i.editor.EditorScheduleSheetCommands(u, !0, !1);
                        }
                    }
            }, t.TriggerIoAction.CopyFormulaToRange = function (e, o) {
                for (var i, n = "", r = 0; r < e.ncols; r++)
                    for (var a = 0; a < e.nrows; a++) {
                        var s = e.celldata[r][a],
                            l = t.crToCoord(o.col + r, o.row + a);
                        if ((0 != r || 0 != a) && (n += "\n"), "undefined" != typeof s && "b" != s.valuetype) {
                            var c = s.datatype,
                                u = s.valuetype,
                                d = s.datavalue,
                                h = s.formula;
                            "f" == c ? (h = t.OffsetFormulaCoords(h, o.col - e.col1num, o.row - e.row1num),
                                d = "", u = "") : "c" != c && (h = ""), i = "set " + l + " " + t.Constants.cellDataType[c] + " " + u + " " + t.encodeForSave(d) + " " + h;
                        } else i = "set " + l + " empty";
                        n += i.trim();
                    }
                return n;
            }, t.TriggerIoAction.CopyValueToRange = function (e, o) {
                for (var i, n = "", r = 0; r < e.ncols; r++)
                    for (var a = 0; a < e.nrows; a++) {
                        var s = e.celldata[r][a],
                            l = t.crToCoord(o.col + r, o.row + a);
                        if ((0 != r || 0 != a) && (n += "\n"), "undefined" != typeof s && "b" != s.valuetype) {
                            var c = s.datatype,
                                u = s.valuetype,
                                d = s.datavalue,
                                h = s.formula;
                            "f" == c ? (h = "", c = u, "n" != u && "t" != u.charAt(0) && (c = "c", h = s.displaystring),
                                "t" == u.charAt(0) && (c = "t")) : "c" != c && (h = ""), i = "set " + l + " " + t.Constants.cellDataType[c] + " " + u + " " + t.encodeForSave(d) + " " + h;
                        } else i = "set " + l + " empty";
                        n += i.trim();
                    }
                return n;
            }, t.TriggerIoAction.Email = function (o, i) {
                i = "undefined" != typeof i ? i : null;
                var n = t.Formula,
                    r = e.spreadsheet;
                null == r && (r = e.ss);
                var a = r.sheet,
                    s = a.cells[o];
                if ("undefined" != typeof a.ioParameterList) {
                    var l = a.ioParameterList[o];
                    if ("undefined" != typeof l) {
                        for (var c = [], u = [], d = 1, h = 0; h < l.length; h++)
                            if ("t" == l[h].type.charAt(0) && (c[h] = [String(l[h].value).replace(/ /g, "%20")]),
                                "coord" == l[h].type && (c[h] = [String(a.GetAssuredCell(l[h].value).datavalue).replace(/ /g, "%20")]),
                                "range" == l[h].type) {
                                var p = n.DecodeRangeParts(a, l[h].value);
                                c[h] = [], u[h] = [];
                                for (var f = 0, m = 0; m < p.ncols; m++)
                                    for (var g = 0; g < p.nrows; g++) {
                                        var v = t.crToCoord(p.col1num + m, p.row1num + g),
                                            s = p.sheetdata.GetAssuredCell(v);
                                        c[h].push(s.datavalue.toString().replace(/ /g, "%20")), u[h].push(v), f++;
                                    }
                                f > d && (d = f);
                            }
                        var b = -1,
                            y = 0;
                        switch (l.function_name) {
                            case "EMAILIF":
                                b = 0;

                            case "EMAILAT":
                            case "EMAILONEDIT":
                                y = 1;
                                break;

                            case "EMAILONEDITIF":
                            case "EMAILATIF":
                                b = 1, y = 2;
                                break;

                            case "EMAIL":
                        }
                        switch (l.function_name) {
                            case "EMAILONEDIT":
                            case "EMAILONEDITIF":
                                i && "coord" == l[0].type && l[0].value == i && (i = null);
                                break;

                            default:
                                i = null;
                        }
                        for (var C = !1, w = [], x = d - 1; x > -1; x--) {
                            if (-1 != b) {
                                var _ = x >= c[b].length ? 0 : x;
                                if (0 == c[b][_]) continue;
                            }
                            if (!i || i == u[0][x]) {
                                var S = x >= c[y].length ? 0 : x,
                                    k = x >= c[y + 1].length ? 0 : x,
                                    T = x >= c[y + 2].length ? 0 : x,
                                    F = c[y][S] + " " + c[y + 1][k] + " " + c[y + 2][T];
                                C = !0, a.ScheduleSheetCommands("sendemail " + F, !1), w.push([c[y][S], c[y + 1][k], c[y + 2][T]]);
                            }
                        }
                        return C && t.EditorSheetStatusCallback(null, "emailing", null, r.editor), w;
                    }
                }
            }, t.TriggerIoAction.Submit = function () {
                var o = null != t.CurrentSpreadsheetControlObject ? t.CurrentSpreadsheetControlObject.formDataViewer : t.CurrentSpreadsheetViewerObject.formDataViewer;
                if (null != o && 1 == o.loaded) {
                    var i = e.spreadsheet;
                    null == i && (i = e.ss);
                    for (var n = i.sheet, r = new Date(), a = "" + r.getFullYear() + "-" + (r.getMonth() + 1) + "-" + r.getDate() + " " + r.getHours() + ":" + r.getMinutes() + ":" + r.getSeconds(), s = 2; s <= o.formFieldsLength + 1; s++) {
                        var l = t.crToCoord(s, 2);
                        a += "\r" + o.sheet.cells[l].datavalue;
                    }
                    n.ScheduleSheetCommands("submitform \r" + a, !1);
                }
            }, t.TriggerIoAction.SelectList = function (e) {
                var o = function (e) {
                        return e.value;
                    },
                    i = "SELECT";
                t.TriggerIoAction.updateInputWidgetFormula(i, e, o);
            }, t.TriggerIoAction.AutoComplete = function (e) {
                var o = function (e) {
                        return e.value;
                    },
                    i = "AUTOCOMPLETE";
                t.TriggerIoAction.updateInputWidgetFormula(i, e, o);
            }, t.TriggerIoAction.TextBox = function (e) {
                var o = function (e) {
                        return e.value;
                    },
                    i = "TEXTBOX";
                t.TriggerIoAction.updateInputWidgetFormula(i, e, o);
            }, t.TriggerIoAction.CheckBox = function (e) {
                var o = function (e) {
                        return e.checked ? "TRUE" : "FALSE";
                    },
                    i = "CHECKBOX";
                t.TriggerIoAction.updateInputWidgetFormula(i, e, o);
            }, t.TriggerIoAction.RadioButton = function (e) {
                var o = function (e) {
                        return e.checked ? "TRUE" : "FALSE";
                    },
                    i = "RADIOBUTTON";
                $container.find('input[name="' + e + '"]').each(function () {
                    t.TriggerIoAction.updateInputWidgetFormula(i, $container.find(this).attr("id").replace(/RADIOBUTTON_/, ""), o);
                });
            }, t.TriggerIoAction.updateInputWidgetFormula = function (o, i, n) {
                var r = e.spreadsheet;
                null == r && (r = e.ss);
                var a = r.sheet,
                    s = (a.cells[i], a.ioParameterList[i]);
                if ("undefined" != typeof s) {
                    var l = document.getElementById(o + "_" + i),
                        c = n(l);
                    c = t.encodeForSave(c);
                    for (var u = "set " + i + " formula " + o + '("' + c + '"', d = 1; d < s.length; d++) "n" == s[d].type.charAt(0) && (u += "," + s[d].value),
                        "t" == s[d].type.charAt(0) && (u += ',"' + s[d].value + '"'), "range" == s[d].type && (u += "," + s[d].value.toString().replace(/(\$?[A-Z]+\$?[0-9]+)([!]?)([^|]*)[|](\$?[A-Z]+\$?[0-9]+)[|]/i, "$3$2$1:$4")),
                        "coord" == s[d].type && (u += "," + s[d].value);
                    u += ")", s.cssParameter && (u += "+style(" + s.cssParameter + ")"), r.editor.EditorScheduleSheetCommands(u, !0, !1),
                        t.TriggerIoAction.UpdateFormDataSheet(o, i, c);
                }
            }, t.TriggerIoAction.UpdateFormDataSheet = function (e, o, i) {
                var n = null != t.CurrentSpreadsheetControlObject ? t.CurrentSpreadsheetControlObject.formDataViewer : t.CurrentSpreadsheetViewerObject.formDataViewer;
                if (null != n) {
                    var r = (e + o).toLowerCase();
                    if (null != n.formFields[r]) {
                        var a = t.crToCoord(n.formFields[r], 2);
                        n.sheet.ScheduleSheetCommands("set " + a + " text t " + i, !1);
                    }
                }
            }, t.Formula.getStandardizedValues = function (e, o) {
                return t.Formula.getStandardizedParameter(e, o, !0, !0);
            }, t.Formula.getStandardizedCoords = function (e, o) {
                return t.Formula.getStandardizedParameter(e, o, !0, !1);
            }, t.Formula.getStandardizedList = function (e, o) {
                var i = [],
                    n = t.Formula.getStandardizedValues(e, o);
                if (1 == n.ncols && 1 == n.nrows) i = String(n.celldata[0][0].datavalue).split(",");
                else
                    for (var r = 0; r < n.ncols; r++)
                        for (var a = 0; a < n.nrows; a++) {
                            var s = n.celldata[r][a];
                            i.push(s.datavalue.toString());
                        }
                return i;
            }, t.Formula.getStandardizedParameter = function (e, o, i, n) {
                var r = {
                    type: o.type,
                    value: o.value
                };
                if (n && (r.celldata = []), "coord" != o.type && "range" != o.type) {
                    if (r.ncols = 1, r.nrows = 1, r.col1num = 1, r.row1num = 1, i && (r.cellcoord = null),
                        n) {
                        r.celldata[0] = [];
                        var a = "n" == o.type ? "v" : "t" == o.type ? o.type : "c";
                        r.celldata[0][0] = {
                            coord: null,
                            datatype: a,
                            valuetype: o.type,
                            datavalue: o.value
                        };
                    }
                } else {
                    var s, l = t.Formula;
                    if ("coord" == o.type) {
                        var c = t.Formula.PlainCoord(o.value);
                        s = l.DecodeRangeParts(e, c + "|" + c + "|");
                    }
                    "range" == o.type && (s = l.DecodeRangeParts(e, o.value)), i && (r.cellcoord = []);
                    for (var u = 0; u < s.ncols; u++)
                        for (var d = 0; d < s.nrows; d++) {
                            var h = t.crToCoord(s.col1num + u, s.row1num + d);
                            if (i && ("undefined" == typeof r.cellcoord[u] && (r.cellcoord[u] = []), r.cellcoord[u][d] = h),
                                n) {
                                "undefined" == typeof r.celldata[u] && (r.celldata[u] = []);
                                var p = s.sheetdata.GetAssuredCell(h);
                                r.celldata[u][d] = p;
                            }
                        }
                    r.ncols = s.ncols, r.nrows = s.nrows, r.col1num = s.col1num, r.row1num = s.row1num;
                }
                return r;
            }, t.Formula.SheetCache = {
                sheets: {},
                waitingForLoading: null,
                constants: {
                    asloaded: 0,
                    recalcing: 1,
                    recalcdone: 2
                },
                loadsheet: null
            }, t.Formula.FindInSheetCache = function (e) {
                var o = t.Formula.SheetCache,
                    i = t.Formula.NormalizeSheetName(e);
                return o.sheets[i] ? o.sheets[i].sheet : o.waitingForLoading ? null : o.loadsheet ? (alert("Using SocialCalc.Formula.SheetCache.loadsheet - deprecated"),
                    t.Formula.AddSheetToCache(i, o.loadsheet(i))) : (o.waitingForLoading = i, null);
            }, t.Formula.AddSheetToCache = function (e, o, i) {
                var n = null,
                    r = t.Formula.SheetCache,
                    a = r.constants,
                    s = t.Formula.NormalizeSheetName(e);
                return o && (n = new t.Sheet(), n.ParseSheetSave(o)), r.sheets[s] = {
                    sheet: n,
                    recalcstate: a.asloaded,
                    name: s
                }, t.Formula.FreshnessInfo.sheets[s] = "undefined" == typeof i || i === !1, n;
            }, t.Formula.NormalizeSheetName = function (e) {
                return t.Callbacks.NormalizeSheetName ? t.Callbacks.NormalizeSheetName(e) : e.toLowerCase();
            }, t.Formula.RemoteFunctionInfo = {
                waitingForServer: null
            }, t.Formula.FreshnessInfo = {
                sheets: {},
                "volatile": {},
                recalc_completed: !1
            }, t.Formula.FreshnessInfoReset = function () {
                var e = t.Formula.FreshnessInfo,
                    o = t.Formula.SheetCache;
                for (var i in e.sheets) e.sheets[i] === !1 && delete o.sheets[i];
                e.sheets = {}, e.volatile = {}, e.recalc_completed = !1;
            }, t.Formula.PlainCoord = function (e) {
                return -1 == e.indexOf("$") ? e : e.replace(/\$/g, "");
            }, t.Formula.OrderRangeParts = function (e, o) {
                var i, n, r = {};
                return i = t.coordToCr(e), n = t.coordToCr(o), i.col > n.col ? (r.c1 = n.col, r.c2 = i.col) : (r.c1 = i.col,
                        r.c2 = n.col), i.row > n.row ? (r.r1 = n.row, r.r2 = i.row) : (r.r1 = i.row, r.r2 = n.row),
                    r;
            }, t.Formula.TestCriteria = function (e, o, i) {
                var n, r, a, s, l;
                if (null == i) return !1;
                if (i += "", n = i.charAt(0), "=" == n || "<" == n || ">" == n ? r = i.substring(1) : -1 != i.search(/([^~]\*|^\*)/) || -1 != i.search(/([^~]\?|^\?)/) ? (n = "regex",
                        "*" == i ? r = ".+" : (r = i.split("").reverse().join(""), r = r.replace(/\?(?=[^~])|\?$/g, "?.").replace(/\?~/g, "?\\").replace(/\*(?=[^~])|\*$/g, "*.").replace(/\*~/, "*\\"),
                            r = r.split("").reverse().join("")), r = "^" + r + "$") : (n = i.substring(0, 2),
                        "<=" == n || "<>" == n || ">=" == n ? r = i.substring(2) : (n = "none", r = i)),
                    a = t.DetermineValueType(r), !a.type) {
                    if ("none" == n) return !1;
                    if ("b" == o.charAt(0)) {
                        if ("=" == n) return !0;
                    } else if ("<>" == n) return !0;
                    return !1;
                }
                if (s = !1, "n" == a.type.charAt(0) && "t" == o.charAt(0) && (l = t.DetermineValueType(e),
                        "n" == l.type.charAt(0) && (e = l.value, o = l.type)), "n" == o.charAt(0) && "n" == a.type.charAt(0)) switch (e -= 0,
                        a.value = a.value - 0, n) {
                        case "<":
                            s = e < a.value;
                            break;

                        case "<=":
                            s = e <= a.value;
                            break;

                        case "=":
                        case "none":
                            s = e == a.value;
                            break;

                        case ">=":
                            s = e >= a.value;
                            break;

                        case ">":
                            s = e > a.value;
                            break;

                        case "<>":
                            s = e != a.value;
                    } else if ("e" == o.charAt(0)) s = !1;
                    else if ("e" == a.type.charAt(0)) s = !1;
                else {
                    if ("n" == o.charAt(0) && (e = t.format_number_for_display(e, "n", "")), "n" == a.type.charAt(0)) return !1;
                    switch (e = e ? e.toLowerCase() : "", a.value = a.value ? a.value.toLowerCase() : "",
                        n) {
                        case "<":
                            s = e < a.value;
                            break;

                        case "<=":
                            s = e <= a.value;
                            break;

                        case "=":
                            s = e == a.value;
                            break;

                        case "none":
                            s = e.substring(0, a.value.length) == a.value;
                            break;

                        case ">=":
                            s = e >= a.value;
                            break;

                        case ">":
                            s = e > a.value;
                            break;

                        case "<>":
                            s = e != a.value;
                            break;

                        case "regex":
                            try {
                                s = -1 != e.search(new RegExp(a.value));
                            } catch (c) {
                                s = !1;
                            }
                    }
                }
                return s;
            };
        var t;
        t || (t = {}), t.Popup = {}, t.Popup.Types = {}, t.Popup.Controls = {}, t.Popup.Current = {},
            t.Popup.LocalizeString = function (e) {
                return e;
            }, t.Popup.Create = function (e, o, i) {
                var n = t.Popup.Types[e];
                n && n.Create && n.Create(e, o, i), t.Popup.imagePrefix = t.Constants.defaultImagePrefix;
            }, t.Popup.SetValue = function (e, o) {
                var i = t.Popup,
                    n = i.Types,
                    r = i.Controls;
                if (!r[e]) return void alert("Unknown control " + e);
                var a = r[e].type,
                    s = n[a],
                    l = r[e].data;
                s && s.Create && (s.SetValue(a, e, o), l.attribs && l.attribs.changedcallback && l.attribs.changedcallback(l.attribs, e, o));
            }, t.Popup.SetDisabled = function (e, o) {
                var i = t.Popup,
                    n = i.Types,
                    r = i.Controls;
                if (!r[e]) return void alert("Unknown control " + e);
                var a = r[e].type,
                    s = n[a];
                s && s.Create && (i.Current.id && e == i.Current.id && (s.Hide(a, i.Current.id),
                    i.Current.id = null), s.SetDisabled(a, e, o));
            }, t.Popup.GetValue = function (e) {
                var o = t.Popup,
                    i = o.Types,
                    n = o.Controls;
                if (!n[e]) return void alert("Unknown control " + e);
                var r = n[e].type,
                    a = i[r];
                return a && a.Create ? a.GetValue(r, e) : null;
            }, t.Popup.Initialize = function (e, o) {
                var i = t.Popup,
                    n = i.Types,
                    r = i.Controls;
                if (!r[e]) return void alert("Unknown control " + e);
                var a = r[e].type,
                    s = n[a];
                s && s.Initialize && s.Initialize(a, e, o);
            }, t.Popup.Reset = function (e) {
                {
                    var o = t.Popup,
                        i = o.Types;
                    o.Controls;
                }
                i[e].Reset && i[e].Reset(e);
            }, t.Popup.CClick = function (e) {
                var o = t.Popup,
                    i = o.Types,
                    n = o.Controls;
                if (!n[e]) return void alert("Unknown control " + e);
                if (!n[e].data || !n[e].data.disabled) {
                    var r = n[e].type,
                        a = i[r];
                    if (o.Current.id && (i[n[o.Current.id].type].Hide(r, o.Current.id), e == o.Current.id)) return void(o.Current.id = null);
                    a && a.Show && a.Show(r, e), o.Current.id = e;
                }
            }, t.Popup.Close = function () {
                {
                    var e = t.Popup;
                    e.Types, e.Controls;
                }
                e.Current.id && e.CClick(e.Current.id);
            }, t.Popup.Cancel = function () {
                var e = t.Popup,
                    o = e.Types,
                    i = e.Controls;
                if (e.Current.id) {
                    var n = i[e.Current.id].type,
                        r = o[n];
                    r.Cancel(n, e.Current.id), e.Current.id = null;
                }
            }, t.Popup.CreatePopupDiv = function (e, o) {
                var i, n = t.Popup,
                    r = n.Controls,
                    a = r[e].data,
                    s = document.createElement("div");
                return s.style.position = "absolute", i = t.GetElementPosition(a.mainele), s.style.top = i.top + a.mainele.offsetHeight + "px",
                    s.style.left = i.left + "px", s.style.zIndex = 100, s.style.backgroundColor = "#FFF",
                    s.style.border = "1px solid black", o.width && (s.style.width = o.width), a.mainele.appendChild(s),
                    o.title && (s.innerHTML = '<table cellspacing="0" cellpadding="0" style="border-bottom:1px solid black;"><tr><td style="font-size:10px;cursor:default;width:100%;background-color:#999;color:#FFF;">' + o.title + '</td><td class="closePalette" style="font-size:10px;cursor:default;color:#666;">&nbsp;X&nbsp;</td></tr></table>',
                        o.moveable && (a.dragregistered = s.firstChild.firstChild.firstChild.firstChild,
                            t.DragRegister(a.dragregistered, !0, !0, {
                                MouseDown: t.DragFunctionStart,
                                MouseMove: t.DragFunctionPosition,
                                MouseUp: t.DragFunctionPosition,
                                Disabled: null,
                                positionobj: s
                            }, a.mainele))), s;
            }, t.Popup.EnsurePosition = function (e, o) {
                function i(e) {
                    var o = t.GetElementPosition(e);
                    return o.height = e.offsetHeight, o.width = e.offsetWidth, o.bottom = o.top + o.height,
                        o.right = o.left + o.width, o;
                }
                var n = t.Popup,
                    r = n.Controls,
                    a = r[e].data,
                    s = a.mainele.firstChild;
                if (!s) return void alert("No main popup element firstChild.");
                var l = a.popupele,
                    c = i(l),
                    u = i(o),
                    d = i(s),
                    h = 0;
                d.bottom + c.height < u.bottom && d.left + c.width < u.right ? (l.style.top = d.bottom + "px",
                    l.style.left = d.left + "px", h = 1) : d.top - c.height > u.top && d.left + c.width < u.right ? (l.style.top = d.top - c.height + "px",
                    l.style.left = d.left + "px", h = 2) : d.bottom + c.height < u.bottom && d.right - c.width > u.left ? (l.style.top = d.bottom + "px",
                    l.style.left = d.right - c.width + "px", h = 3) : d.top - c.height > u.top && d.right - c.width > u.left ? (l.style.top = d.top - c.height + "px",
                    l.style.left = d.right - c.width + "px", h = 4) : d.bottom + c.height < u.bottom && c.width < u.width ? (l.style.top = d.bottom + "px",
                    l.style.left = u.left + Math.floor((u.width - c.width) / 2) + "px", h = 5) : d.top - c.height > u.top && c.width < u.width ? (l.style.top = d.top - c.height + "px",
                    l.style.left = u.left + Math.floor((u.width - c.width) / 2) + "px", h = 6) : c.height < u.height && d.right + c.width < u.right ? (l.style.top = u.top + Math.floor((u.height - c.height) / 2) + "px",
                    l.style.left = d.right + "px", h = 7) : c.height < u.height && d.left - c.width > u.left && (l.style.top = u.top + Math.floor((u.height - c.height) / 2) + "px",
                    l.style.left = d.left - c.width + "px", h = 8);
            }, t.Popup.DestroyPopupDiv = function (e, o) {
                e && (e.innerHTML = "", t.DragUnregister(o), e.parentNode && e.parentNode.removeChild(e));
            }, t.Popup.RGBToHex = function (e) {
                var o = t.Popup;
                if ("" == e) return "000000";
                var i = e.match(/(\d+)\D+(\d+)\D+(\d+)/);
                return i ? o.ToHex(i[1]) + o.ToHex(i[2]) + o.ToHex(i[3]) : "000000";
            }, t.Popup.HexDigits = "0123456789ABCDEF", t.Popup.ToHex = function (e) {
                var o = t.Popup,
                    i = Math.floor(e / 16),
                    n = e % 16;
                return o.HexDigits.charAt(i) + o.HexDigits.charAt(n);
            }, t.Popup.FromHex = function (e) {
                var o = t.Popup,
                    i = o.HexDigits.indexOf(e.charAt(0).toUpperCase()),
                    n = o.HexDigits.indexOf(e.charAt(1).toUpperCase());
                return 16 * (i >= 0 ? i : 0) + (n >= 0 ? n : 0);
            }, t.Popup.HexToRGB = function (e) {
                var o = t.Popup;
                return "rgb(" + o.FromHex(e.substring(1, 3)) + "," + o.FromHex(e.substring(3, 5)) + "," + o.FromHex(e.substring(5, 7)) + ")";
            }, t.Popup.makeRGB = function (e, t, o) {
                return "rgb(" + (e > 0 ? e : 0) + "," + (t > 0 ? t : 0) + "," + (o > 0 ? o : 0) + ")";
            }, t.Popup.splitRGB = function (e) {
                var t = e.match(/(\d+)\D+(\d+)\D+(\d+)\D/);
                return t ? {
                    r: t[1] - 0,
                    g: t[2] - 0,
                    b: t[3] - 0
                } : {
                    r: 0,
                    g: 0,
                    b: 0
                };
            }, t.Popup.Types.List = {}, t.Popup.Types.List.Create = function (e, o, i) {
                var n = t.Popup,
                    r = (n.Types, n.Controls),
                    a = {
                        type: e,
                        value: "",
                        display: "",
                        data: {}
                    };
                r[o] = a;
                var s = a.data;
                s.attribs = i || {};
                var l = document.getElementById(o);
                return l ? (s.mainele = l, l.innerHTML = '<input style="cursor:pointer;width:100px;font-size:smaller;" onfocus="this.blur();" onclick="SocialCalc.Popup.CClick(\'' + o + '\');" value="">',
                    void(s.options = [])) : void alert("Missing element " + o);
            }, t.Popup.Types.List.SetValue = function (e, i, n) {
                var r, a = t.Popup,
                    s = (a.Types, a.Controls),
                    l = s[i].data;
                for (l.value = n, l.custom = !1, r = 0; r < l.options.length; r++)
                    if (o = l.options[r],
                        !(o.a && (o.a.skip || o.a.custom || o.a.cancel) || o.v != l.value)) {
                        l.display = o.o;
                        break;
                    }
                r == l.options.length && (l.display = "Custom", l.custom = !0), l.mainele && l.mainele.firstChild && (l.mainele.firstChild.value = l.display);
            }, t.Popup.Types.List.SetDisabled = function (e, o, i) {
                var n = t.Popup,
                    r = (n.Types, n.Controls),
                    a = r[o].data;
                a.disabled = i, a.mainele && a.mainele.firstChild && (a.mainele.firstChild.disabled = i);
            }, t.Popup.Types.List.GetValue = function (e, o) {
                var i = t.Popup,
                    n = (i.Types, i.Controls),
                    r = n[o].data;
                return r.value;
            }, t.Popup.Types.List.Initialize = function (e, o, i) {
                var n, r = t.Popup,
                    a = (r.Types, r.Controls),
                    s = a[o].data;
                for (n in i.attribs) s.attribs[n] = i.attribs[n];
                s.options = i ? i.options : [], i.value && r.SetValue(o, i.value);
            }, t.Popup.Types.List.Reset = function (e) {
                var o = t.Popup,
                    i = o.Types,
                    n = o.Controls;
                o.Current.id && n[o.Current.id].type == e && (i[e].Hide(e, o.Current.id), o.Current.id = null);
            }, t.Popup.Types.List.Show = function (e, o) {
                var i, n = t.Popup,
                    r = (n.Types, n.Controls),
                    a = r[o].data,
                    s = "";
                a.popupele = n.CreatePopupDiv(o, a.attribs), a.custom ? (s = t.Popup.Types.List.MakeCustom(e, o),
                        i = document.createElement("div"), i.innerHTML = '<div style="cursor:default;padding:4px;background-color:#CCC;">' + s + "</div>",
                        a.customele = i.firstChild.firstChild.childNodes[1], a.listdiv = null, a.contentele = i) : (s = t.Popup.Types.List.MakeList(e, o),
                        i = document.createElement("div"), i.innerHTML = '<div style="cursor:default;padding:4px;">' + s + "</div>",
                        a.customele = null, a.listdiv = i.firstChild, a.contentele = i), a.mainele && a.mainele.firstChild && (a.mainele.firstChild.disabled = !0),
                    a.popupele.appendChild(i), a.attribs.ensureWithin && t.Popup.EnsurePosition(o, a.attribs.ensureWithin);
            }, t.Popup.Types.List.MakeList = function (e, o) {
                var i, n, r, a = t.Popup,
                    s = (a.Types, a.Controls),
                    l = s[o].data,
                    c = '<table cellspacing="0" cellpadding="0"><tr>',
                    u = '<td style="vertical-align:top;">';
                for (c += u, l.ncols = 1, i = 0; i < l.options.length; i++) {
                    if (n = l.options[i], n.a) {
                        if (n.a.newcol) {
                            c += "</td>" + u + "&nbsp;&nbsp;&nbsp;&nbsp;</td>" + u, l.ncols += 1;
                            continue;
                        }
                        if (n.a.skip) {
                            c += '<div style="font-size:x-small;white-space:nowrap;">' + n.o + "</div>";
                            continue;
                        }
                    }
                    r = n.v != l.value || n.a && (n.a.custom || n.a.cancel) ? "" : "background-color:#DDF;",
                        c += '<div class="' + o + '_' + i + '" style="font-size:x-small;white-space:nowrap;' + r + '" onclick="SocialCalc.Popup.Types.List.ItemClicked(\'' + o + "','" + i + "');\" onmousemove=\"SocialCalc.Popup.Types.List.MouseMove('" + o + "',this);\">" + n.o + "</div>";
                }
                return c += "</td></tr></table>";
            }, t.Popup.Types.List.MakeCustom = function (e, o) {
                var i = t.Popup.LocalizeString,
                    n = t.Popup,
                    r = (n.Types, n.Controls),
                    a = r[o].data,
                    s = 'style="font-size:smaller;"',
                    l = "",
                    c = a.value;
                return c = t.special_chars(c), l = '<div style="white-space:nowrap;"><br><input id="customvalue" value="' + c + '"><br><br><input ' + s + ' type="button" value="' + i("OK") + '" onclick="SocialCalc.Popup.Types.List.CustomOK(\'' + o + "');return false;\"><input " + s + ' type="button" value="' + i("List") + '" onclick="SocialCalc.Popup.Types.List.CustomToList(\'' + o + "');\"><input " + s + ' type="button" value="' + i("Cancel") + '" onclick="SocialCalc.Popup.Close();"><br></div>';
            }, t.Popup.Types.List.ItemClicked = function (e, o) {
                var i, n, r, a = t.Popup,
                    s = (a.Types, a.Controls),
                    l = s[e].data,
                    c = l.options[o].a;
                return c && c.custom ? (i = l.contentele, n = t.Popup.Types.List.MakeCustom("List", e),
                    r = document.createElement("div"), r.innerHTML = '<div style="cursor:default;padding:4px;background-color:#CCC;">' + n + "</div>",
                    l.customele = r.firstChild.firstChild.childNodes[1], l.listdiv = null, l.contentele = r,
                    l.popupele.replaceChild(r, i), void(l.attribs.ensureWithin && t.Popup.EnsurePosition(e, l.attribs.ensureWithin))) : c && c.cancel ? void t.Popup.Close() : (t.Popup.SetValue(e, l.options[o].v),
                    void t.Popup.Close());
            }, t.Popup.Types.List.CustomToList = function (e) {
                var o, i, n, r = t.Popup,
                    a = (r.Types, r.Controls),
                    s = a[e].data;
                o = s.contentele, i = t.Popup.Types.List.MakeList("List", e), n = document.createElement("div"),
                    n.innerHTML = '<div style="cursor:default;padding:4px;">' + i + "</div>", s.customele = null,
                    s.listdiv = n.firstChild, s.contentele = n, s.popupele.replaceChild(n, o), s.attribs.ensureWithin && t.Popup.EnsurePosition(e, s.attribs.ensureWithin);
            }, t.Popup.Types.List.CustomOK = function (e) {
                var o = t.Popup,
                    i = (o.Types, o.Controls),
                    n = i[e].data;
                t.Popup.SetValue(e, n.customele.value), t.Popup.Close();
            }, t.Popup.Types.List.MouseMove = function (e, o) {
                var i, n, r = t.Popup,
                    a = (r.Types, r.Controls),
                    s = a[e].data,
                    l = s.listdiv;
                if (l) {
                    var c = l.firstChild.firstChild.firstChild;
                    for (i = 0; i < s.ncols; i++)
                        for (n = 0; n < c.childNodes[2 * i].childNodes.length; n++) c.childNodes[2 * i].childNodes[n].style.backgroundColor = "#FFF";
                    o.style.backgroundColor = "#DDF";
                }
            }, t.Popup.Types.List.Hide = function (e, o) {
                var i = t.Popup,
                    n = (i.Types, i.Controls),
                    r = n[o].data;
                i.DestroyPopupDiv(r.popupele, r.dragregistered), r.popupele = null, r.mainele && r.mainele.firstChild && (r.mainele.firstChild.disabled = !1);
            }, t.Popup.Types.List.Cancel = function (e, o) {
                t.Popup.Types.List.Hide(e, o);
            }, t.Popup.Types.ColorChooser = {}, t.Popup.Types.ColorChooser.Create = function (e, o, i) {
                var n = t.Popup,
                    r = (n.Types, n.Controls),
                    a = {
                        type: e,
                        value: "",
                        display: "",
                        data: {}
                    };
                r[o] = a;
                var s = a.data;
                s.attribs = i || {};
                var l = s.attribs;
                s.value = "";
                var c = document.getElementById(o);
                return c ? (s.mainele = c, void(c.innerHTML = '<div class="cb' + o + '" name="' + o + '" style="cursor:pointer;border:1px solid black;vertical-align:top;width:' + (l.sampleWidth || "15px") + ";height:" + (l.sampleHeight || "15px") + '">&nbsp;</div>')) : void alert("Missing element " + o),

                    $container.find(".cb" + o).on("click", function () {
                        let nameo = $container.find(this).attr("name");
                        
                        t.Popup.Types.ColorChooser.ControlClicked(nameo);
                        //close Palette
                        $container.find(".closePalette").on("click", function () {
                            t.Popup.Cancel();
                        });

                    });
            }, t.Popup.Types.ColorChooser.SetValue = function (e, o, i) {
                var n, r, a = t.Popup,
                    s = (a.Types, a.Controls),
                    l = s[o].data,
                    c = l.attribs;
                l.value = i, l.custom = !1, l.mainele && l.mainele.firstChild && (l.value ? (l.mainele.firstChild.style.backgroundColor = l.value,
                        n = c.backgroundImage ? "url(" + a.imagePrefix + c.backgroundImage + ")" : "", r = "center center") : (l.mainele.firstChild.style.backgroundColor = "#FFF",
                        c.backgroundImageDefault ? (n = "url(" + a.imagePrefix + c.backgroundImageDefault + ")",
                            r = "center center") : (n = "url(" + assetManager.resolve("EtherCalc/runtime/assets/sc_defaultcolor.gif") + ")", r = "left top")),
                    l.mainele.firstChild.style.backgroundPosition = r, l.mainele.firstChild.style.backgroundImage = n);
            }, t.Popup.Types.ColorChooser.SetDisabled = function (e, o, i) {
                var n = t.Popup,
                    r = (n.Types, n.Controls),
                    a = r[o].data,
                    s = a.attribs;
                a.disabled = i, a.mainele && a.mainele.firstChild && (i ? (a.mainele.firstChild.style.backgroundColor = "#DDD",
                    s.backgroundImageDisabled ? (img = "url(" + n.imagePrefix + s.backgroundImageDisabled + ")",
                        pos = "center center") : (img = "url(" + assetManager.resolve("EtherCalc/runtime/assets/sc_defaultcolor.gif") + ")", pos = "left top"),
                    a.mainele.firstChild.style.backgroundPosition = pos, a.mainele.firstChild.style.backgroundImage = img) : n.SetValue(o, a.value));
            }, t.Popup.Types.ColorChooser.GetValue = function (e, o) {
                var i = t.Popup,
                    n = (i.Types, i.Controls),
                    r = n[o].data;
                return r.value;
            }, t.Popup.Types.ColorChooser.Initialize = function (e, o, i) {
                var n, r = t.Popup,
                    a = (r.Types, r.Controls),
                    s = a[o].data;
                for (n in i.attribs) s.attribs[n] = i.attribs[n];
                i.value && r.SetValue(o, i.value);
            }, t.Popup.Types.ColorChooser.Reset = function (e) {
                var o = t.Popup,
                    i = o.Types,
                    n = o.Controls;
                o.Current.id && n[o.Current.id].type == e && (i[e].Hide(e, o.Current.id), o.Current.id = null);
            }, t.Popup.Types.ColorChooser.Show = function (e, o) {
                var i, n, r = t.Popup,
                    a = (r.Types, r.Controls),
                    s = a[o].data,
                    l = "";
                s.oldvalue = s.value, s.popupele = r.CreatePopupDiv(o, s.attribs), s.custom ? (l = t.Popup.Types.ColorChooser.MakeCustom(e, o),
                        i = document.createElement("div"), i.innerHTML = '<div style="cursor:default;padding:4px;background-color:#CCC;">' + l + "</div>",
                        s.customele = i.firstChild.firstChild.childNodes[2], s.contentele = i) : (n = t.Popup.Types.ColorChooser.CreateGrid(e, o),
                        i = document.createElement("div"), i.style.padding = "3px", i.style.backgroundColor = "#CCC",
                        i.appendChild(n), s.customele = null, s.contentele = i), s.popupele.appendChild(i),
                    s.attribs.ensureWithin && t.Popup.EnsurePosition(o, s.attribs.ensureWithin);
            }, t.Popup.Types.ColorChooser.MakeCustom = function (e, o) {
                var i = t.Popup,
                    n = (i.Types, i.Controls),
                    r = n[o].data,
                    a = i.LocalizeString,
                    s = 'style="font-size:smaller;"',
                    l = "";
                return l = '<div style="white-space:nowrap;"><br>#<input id="customvalue" style="width:75px;" value="' + r.value + '"><br><br><input ' + s + ' type="button" value="' + a("OK") + '" onclick="SocialCalc.Popup.Types.ColorChooser.CustomOK(\'' + o + "');return false;\"><input " + s + ' type="button" value="' + a("Grid") + '" onclick="SocialCalc.Popup.Types.ColorChooser.CustomToGrid(\'' + o + "');\"><br></div>";
            }, t.Popup.Types.ColorChooser.ItemClicked = function (e) {
                {
                    var o = t.Popup,
                        i = (o.Types, o.Controls);
                    i[e].data;
                }
                t.Popup.Close();
            }, t.Popup.Types.ColorChooser.CustomToList = function (e) {
                {
                    var o = t.Popup,
                        i = (o.Types, o.Controls);
                    i[e].data;
                }
            }, t.Popup.Types.ColorChooser.CustomOK = function (e) {
                var o = t.Popup,
                    i = (o.Types, o.Controls),
                    n = i[e].data;
                o.SetValue(e, n.customele.value), o.Close();
            }, t.Popup.Types.ColorChooser.Hide = function (e, o) {
                var i = t.Popup,
                    n = (i.Types, i.Controls),
                    r = n[o].data;
                i.DestroyPopupDiv(r.popupele, r.dragregistered), r.popupele = null;
            }, t.Popup.Types.ColorChooser.Cancel = function (e, o) {
                var i = t.Popup,
                    n = (i.Types, i.Controls),
                    r = n[o].data;
                i.SetValue(o, r.oldvalue), t.Popup.Types.ColorChooser.Hide(e, o);
            }, t.Popup.Types.ColorChooser.CreateGrid = function (e, o) {
                var i, n, r, a, s, l = t.Popup,
                    c = l.Types,
                    u = l.Controls,
                    d = l.LocalizeString,
                    h = u[o].data;
                h.grid = {};
                var p = h.grid,
                    f = document.createElement("div"),
                    imgIncluder = "url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_defaultcolor.gif') + ")";
                for (i = document.createElement("table"), i.cellSpacing = 0, i.cellPadding = 0,
                    i.style.width = "100px", p.table = i, i = document.createElement("tbody"), p.table.appendChild(i),
                    p.tbody = i, n = 0; 16 > n; n++) {
                    for (r = document.createElement("tr"), a = 0; 5 > a; a++) s = {}, p[n + "," + a] = s,
                        i = document.createElement("td"), i.style.fontSize = "1px", i.innerHTML = "&nbsp;",
                        i.style.height = "10px", 1 >= a ? (i.style.width = "17px", i.style.borderRight = "3px solid white") : (i.style.width = "20px",
                            i.style.backgroundRepeat = "no-repeat"), r.appendChild(i), s.ele = i;
                    p.tbody.appendChild(r);
                }
                return f.appendChild(p.table), i = document.createElement("div"), i.style.marginTop = "3px",

                    i.innerHTML = '<table cellspacing="0" cellpadding="0"><tr><td style="width:17px;background-color:#FFF;background-image:url(' + imgIncluder + ');height:16px;font-size:10px;cursor:pointer;" title="' + d("Default") + '">&nbsp;</td><td style="width:23px;height:16px;font-size:10px;text-align:center;cursor:pointer;" title="' + d("Custom") + '">#</td><td style="width:60px;height:16px;font-size:10px;text-align:center;cursor:pointer;">' + d("OK") + "</td></tr></table>",
                    p.defaultbox = i.firstChild.firstChild.firstChild.childNodes[0], p.defaultbox.onclick = c.ColorChooser.DefaultClicked,
                    p.custom = i.firstChild.firstChild.firstChild.childNodes[1], p.custom.onclick = c.ColorChooser.CustomClicked,
                    p.msg = i.firstChild.firstChild.firstChild.childNodes[2], p.msg.onclick = c.ColorChooser.CloseOK,
                    f.appendChild(i), p.table.onmousedown = c.ColorChooser.GridMouseDown, c.ColorChooser.DetermineColors(o),
                    c.ColorChooser.SetColors(o), f;
            }, t.Popup.Types.ColorChooser.gridToG = function (e, t, o) {
                return e[t + "," + o];
            }, t.Popup.Types.ColorChooser.DetermineColors = function (e) {
                var o, i, n = t.Popup,
                    r = n.Types,
                    a = r.ColorChooser,
                    s = n.Controls,
                    l = s[e].data,
                    c = l.grid,
                    u = n.splitRGB(l.value);
                for (o = 2, i = 16 - Math.floor((u.r + 16) / 16), c["selectedrow" + o] = i, i = 0; 16 > i; i++) a.gridToG(c, i, o).rgb = n.makeRGB(17 * (15 - i), 0, 0);
                for (o = 3, i = 16 - Math.floor((u.g + 16) / 16), c["selectedrow" + o] = i, i = 0; 16 > i; i++) a.gridToG(c, i, o).rgb = n.makeRGB(0, 17 * (15 - i), 0);
                for (o = 4, i = 16 - Math.floor((u.b + 16) / 16), c["selectedrow" + o] = i, i = 0; 16 > i; i++) a.gridToG(c, i, o).rgb = n.makeRGB(0, 0, 17 * (15 - i));
                for (o = 1, i = 0; 16 > i; i++) a.gridToG(c, i, o).rgb = n.makeRGB(17 * (15 - i), 17 * (15 - i), 17 * (15 - i));
                o = 0;
                var d, h = [0, 68, 153, 204, 255],
                    p = ["400", "310", "420", "440", "442", "340", "040", "042", "032", "044", "024", "004", "204", "314", "402", "414"];
                for (i = 0; 16 > i; i++) d = p[i], a.gridToG(c, i, o).rgb = "rgb(" + h[d.charAt(0) - 0] + "," + h[d.charAt(1) - 0] + "," + h[d.charAt(2) - 0] + ")";
            }, t.Popup.Types.ColorChooser.SetColors = function (e) {
                var o, i, n, r, a = t.Popup,
                    s = a.Types,
                    l = s.ColorChooser,
                    c = a.Controls,
                    u = c[e].data,
                    d = u.grid;
                for (o = 0; 16 > o; o++)
                    for (i = 0; 5 > i; i++) n = l.gridToG(d, o, i), n.ele.style.backgroundColor = n.rgb,
                        n.ele.title = a.RGBToHex(n.rgb), n.ele.style.backgroundImage = d["selectedrow" + i] == o ? "url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_chooserarrow.gif') + ")" : "";
                a.SetValue(e, u.value), d.msg.style.backgroundColor = u.value, r = a.splitRGB(u.value || "rgb(255,255,255)"),
                    d.msg.style.color = r.r + r.g + r.b < 220 ? "#FFF" : "#000", u.value ? (d.msg.style.backgroundImage = "",
                        d.msg.title = a.RGBToHex(u.value)) : (d.msg.style.backgroundColor = "#FFF", d.msg.style.backgroundImage = "url(" + assetManager.resolve('EtherCalc/runtime/assets/sc_defaultcolor.gif') + ")",
                        d.msg.title = "Default");
            }, t.Popup.Types.ColorChooser.GridMouseDown = function (o) {
                var i = o || e.event,
                    n = t.Popup,
                    r = n.Types,
                    a = r.ColorChooser,
                    s = n.Controls,
                    l = n.Current.id;
                if (l) {
                    var c = s[l].data,
                        u = c.grid;
                    switch (i.type) {
                        case "mousedown":
                            u.mousedown = !0;
                            break;

                        case "mouseup":
                            u.mousedown = !1;
                            break;

                        case "mousemove":
                            if (!u.mousedown) return;
                    }
                    var d = t.GetElementPositionWithScroll(c.mainele),
                        h = i.clientX - d.left,
                        p = i.clientY - d.top,
                        f = t.GetElementPositionWithScroll(u.table);
                    f.left -= d.left, f.top -= d.top;
                    var m = Math.floor((p - f.top - 2) / 10);
                    m = 0 > m ? 0 : m;
                    var g = Math.floor((h - f.left) / 20);
                    m = 0 > m ? 0 : m > 15 ? 15 : m, g = 0 > g ? 0 : g > 4 ? 4 : g;
                    var v = a.gridToG(u, m, g).ele.style.backgroundColor,
                        b = n.splitRGB(v),
                        y = n.splitRGB(c.value);
                    switch (g) {
                        case 2:
                            c.value = n.makeRGB(b.r, y.g, y.b);
                            break;

                        case 3:
                            c.value = n.makeRGB(y.r, b.g, y.b);
                            break;

                        case 4:
                            c.value = n.makeRGB(y.r, y.g, b.b);
                            break;

                        case 0:
                        case 1:
                            c.value = v;
                    }
                    a.DetermineColors(l), a.SetColors(l);
                }
            }, t.Popup.Types.ColorChooser.ControlClicked = function (e) {
                var o = t.Popup,
                    i = o.Types,
                    n = i.ColorChooser,
                    r = (o.Controls, o.Current.id);
                return r && e == r ? void n.CloseOK() : void o.CClick(e);
            }, t.Popup.Types.ColorChooser.DefaultClicked = function (o) {
                var i = (o || e.event, t.Popup),
                    n = i.Types,
                    r = (n.ColorChooser, i.Controls),
                    a = i.Current.id;
                if (a) {
                    var s = r[a].data;
                    s.value = "", t.Popup.SetValue(a, s.value), t.Popup.Close();
                }
            }, t.Popup.Types.ColorChooser.CustomClicked = function (o) {
                var i = (o || e.event, t.Popup),
                    n = i.Types,
                    r = (n.ColorChooser, i.Controls),
                    a = i.Current.id;
                if (a) {
                    var s, l, c, u = r[a].data;
                    s = u.contentele, l = t.Popup.Types.ColorChooser.MakeCustom("ColorChooser", a),
                        c = document.createElement("div"), c.innerHTML = '<div style="cursor:default;padding:4px;background-color:#CCC;">' + l + "</div>",
                        u.customele = c.firstChild.firstChild.childNodes[2], u.contentele = c, u.popupele.replaceChild(c, s),
                        u.customele.value = i.RGBToHex(u.value), u.attribs.ensureWithin && t.Popup.EnsurePosition(a, u.attribs.ensureWithin);
                }
            }, t.Popup.Types.ColorChooser.CustomToGrid = function (e) {
                var o, i, n = t.Popup,
                    r = (n.Types, n.Controls),
                    a = r[e].data;
                t.Popup.SetValue(e, n.HexToRGB("#" + a.customele.value));
                var o, s, i;
                o = a.contentele, s = t.Popup.Types.ColorChooser.CreateGrid("ColorChooser", e),
                    i = document.createElement("div"), i.style.padding = "3px", i.style.backgroundColor = "#CCC",
                    i.appendChild(s), a.customele = null, a.contentele = i, a.popupele.replaceChild(i, o),
                    a.attribs.ensureWithin && t.Popup.EnsurePosition(e, a.attribs.ensureWithin);
            }, t.Popup.Types.ColorChooser.CustomOK = function (e) {
                var o = t.Popup,
                    i = (o.Types, o.Controls),
                    n = i[e].data;
                t.Popup.SetValue(e, o.HexToRGB("#" + n.customele.value)), t.Popup.Close();
            }, t.Popup.Types.ColorChooser.CloseOK = function (o) {
                var i = (o || e.event, t.Popup),
                    n = i.Types,
                    r = (n.ColorChooser, i.Controls),
                    a = i.Current.id;
                if (a) {
                    var s = r[a].data;
                    t.Popup.SetValue(a, s.value), t.Popup.Close();
                }
            };



        var t;
        t || (alert("Main SocialCalc code module needed"), t = {}), t.TableEditor || alert("SocialCalc TableEditor code module needed"),
            t.CurrentSpreadsheetControlObject = null,
            t.SpreadsheetControl = function (e) {
                var o = t.Constants;
                this.parentNode = null, this.spreadsheetDiv = null, this.requestedHeight = 0, this.requestedWidth = 0,
                    this.requestedSpaceBelow = 0, this.height = 0, this.width = 0, this.viewheight = 0,
                    this.tabs = [], this.tabnums = {}, this.tabreplacements = {}, this.currentTab = -1,
                    this.views = {}, this.sheet = null, this.context = null, this.editor = null, this.spreadsheetDiv = null,
                    this.editorDiv = null, this.sortrange = "", this.moverange = "", this.idPrefix = e || "SocialCalc-",
                    this.multipartBoundary = "SocialCalcSpreadsheetControlSave", this.imagePrefix = o.defaultImagePrefix,
                    this.toolbarbackground = o.SCToolbarbackground, this.tabbackground = o.SCTabbackground,
                    this.tabselectedCSS = o.SCTabselectedCSS, this.tabplainCSS = o.SCTabplainCSS, this.toolbartext = o.SCToolbartext,
                    this.formulabarheight = o.SCFormulabarheight, this.statuslineheight = o.SCStatuslineheight,
                    this.statuslineCSS = o.SCStatuslineCSS, this.ExportCallback = null, "undefined" == typeof t.debug_log && (t.debug_log = []),
                    this.sheet = new t.Sheet(), this.context = new t.RenderContext(this.sheet), this.context.showGrid = !0,
                    this.context.showRCHeaders = !0, this.editor = new t.TableEditor(this.context),
                    this.editor.StatusCallback.statusline = {
                        func: t.SpreadsheetControlStatuslineCallback,
                        params: {
                            statuslineid: this.idPrefix + "statusline",
                            recalcid1: this.idPrefix + "divider_recalc",
                            recalcid2: this.idPrefix + "button_recalc"
                        }
                    }, t.CurrentSpreadsheetControlObject = this, this.editor.MoveECellCallback.movefrom = function (e) {
                        var o = t.GetSpreadsheetControlObject();;
                        o.context.cursorsuffix = "", e.range2.hasrange && !e.cellhandles.noCursorSuffix && (e.ecell.row == e.range2.top && (e.ecell.col < e.range2.left || e.ecell.col > e.range2.right + 1) && (o.context.cursorsuffix = "insertleft"),
                            e.ecell.col == e.range2.left && (e.ecell.row < e.range2.top || e.ecell.row > e.range2.bottom + 1) && (o.context.cursorsuffix = "insertup"));
                    }, this.formulabuttons = {
                        formulafunctions: {
                            image: "insertformula.png",
                            tooltip: lang.synt43,
                            command: t.SpreadsheetControl.DoFunctionList
                        },
                        multilineinput: {
                            image: "listbox.png",
                            tooltip: lang.synt214,
                            command: t.SpreadsheetControl.DoMultiline
                        },
                        link: {
                            image: "inserthyperlink.png",
                            tooltip: lang.synt206,
                            command: t.SpreadsheetControl.DoLink
                        },
                        sum: {
                            image: "autosum.png",
                            tooltip: lang.synt45,
                            command: t.SpreadsheetControl.DoSum
                        }
                    }, this.findbuttons = {
                        last: {
                            image: "upsearch.png",
                            tooltip: lang.synt380,
                            command: t.SpreadsheetControl.SearchUp
                        },
                        next: {
                            image: "downsearch.png",
                            tooltip: lang.synt381,
                            command: t.SpreadsheetControl.SearchDown
                        }
                    }, this.tabnums.edit = this.tabs.length, this.tabs.push({
                        name: "edit",
                        text: lang.synt1,
                        html: '<div id="%id.edittools" style="padding:10px 0px 0px 0px;">' +
                            '<div id="%id.button_undo" class="sprite barBt sc_undo" "style ="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_redo" class="sprite barBt sc_redo" style="vertical-align:bottom;"></div>' +
                            '<div class="sprite  sc_divider1" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_copy" class="sprite barBt sc_copy" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_cut" class="sprite barBt sc_cut" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_paste" class="sprite barBt sc_paste" style="vertical-align:bottom;"></div>' +
                            '<div class="sprite  sc_divider1" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_delete" class="sprite barBt sc_delete" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_pasteformats" class="sprite barBt sc_formatpaintbrush" style="vertical-align:bottom;"></div>' +
                            '<div class="sprite  sc_divider1" style="vertical-align:bottom;"><span id="%id.locktools"></div>' +
                            '<div id="%id.button_lock" class="sprite barBt sc_lock" style="vertical-align:bottom;"> </div>' +
                            '<div id="%id.button_unlock" class="sprite barBt sc_unlock" style="vertical-align:bottom;"> </div>' +
                            '<div class="sprite  sc_divider1" style="vertical-align:bottom;"></span> </div>' +
                            '<div id="%id.button_filldown" class="sprite barBt sc_filldown" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_fillright" class="sprite barBt sc_fillright" style="vertical-align:bottom;"> </div>' +
                            '<div class="sprite  sc_divider1" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_movefrom" class="sprite barBt sc_movefromoff" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_movepaste" class="sprite barBt sc_movepasteoff" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_moveinsert" class="sprite barBt sc_moveinsertoff" style="vertical-align:bottom;"> </div>' +
                            '<div class="sprite  sc_divider1" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_alignleft" class="sprite barBt sc_alignleft" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_aligncenter" class="sprite barBt sc_aligncenter" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_alignright" class="sprite barBt sc_alignright" style="vertical-align:bottom;"> </div>' +
                            '<div class="sprite  sc_divider1" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_borderon" class="sprite barBt sc_borderson" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_borderoff" class="sprite barBt sc_bordersoff" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_swapcolors" class="sprite barBt sc_swapcolors" style="vertical-align:bottom;">  </div>' +
                            '<div class="sprite  c_divider1" style=" vertical-align:bottom;"></div>' +
                            '<div id="%id.button_merge" class="sprite barBt sc_mergecells" style="vertical-align:bottom;">  </div>' +
                            '<div class="sprite  sc_divider1" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_insertrow" class="sprite barBt sc_insertrows" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_insertcol" class="sprite barBt sc_insertcolumns" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_deleterow" class="sprite barBt sc_deleterows" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_deletecol" class="sprite barBt sc_deletecolumns" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_hiderow" class="sprite barBt sc_hiderow" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_hidecol" class="sprite barBt sc_hidecol" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.divider_recalc" class="sprite barBt sc_divider1" style="vertical-align:bottom;"></div>' +
                            '<div id="%id.button_recalc" class="sprite barBt sc_recalc" style="vertical-align:bottom"></div>' +
                            '<div class="sprite  sc_divider1" style="vertical-align:bottom;"></div>' +
                            '<div name="line" title="'+lang.synt36+'" class="sprite chartBt chart-line  chartLineBt" id="%id.chartLine" style="vertical-align:bottom"></div>' +
                            '<div name="area" title="'+lang.synt37+'" class="sprite chartBt chart-area  chartareaBt" id="%id.chartarea)" style="vertical-align:bottom"></div>' +
                            '<div name="bar"  title="'+lang.synt38+'"  class="sprite chartBt chart-bar  chartbarBt" id="%id.chartbar" style="vertical-align:bottom"></div>' +
                            '<div name="pie"  title="'+lang.synt39+'"  class="sprite chartBt chart-pie  chartPieBt" id="%id.chartpie" style="vertical-align:bottom"></div>' +
                            '<div name="polarArea" title="'+lang.synt40+'" class="sprite chartBt chart-polar  chartpolarBt" id="%id.chartpolar" style="vertical-align:bottom"></div>' +
                            '<div name="doughnut" title="'+lang.synt41+'" class="sprite chartBt chart-ring  chartringBt" id="%id.chartring" style="vertical-align:bottom"></div>' +
                            //'<div name="scatter" title="'+lang.synt36+'" class="sprite chartBt chart-scatter  chartscatterBt" id="%id.chartscatter" style="vertical-align:bottom"></div>' +
                            '</div>',
                        oncreate: null,
                        onclick: null
                    }), 
                    this.tabnums.settings = this.tabs.length, this.tabs.push({
                        name: "settings",
                        text: lang.synt2,
                        // original : html: '<div id="%id.settingstools" style="display:none;"> <div id="%id.sheetsettingstoolbar" style="display:none;">  <table cellspacing="0" cellpadding="0"><tr><td>   <div style="%tbt.">%loc!SHEET SETTINGS!:</div>   </td></tr><tr><td><input id="%id.settings-savesheet" type="button" value="%loc!Save!" onclick="SocialCalc.SettingsControlSave(\'sheet\');">   <input type="button" value="%loc!Cancel!" onclick="SocialCalc.SettingsControlSave(\'cancel\');">   <input type="button" value="%loc!Show Cell Settings!" onclick="SocialCalc.SpreadsheetControlSettingsSwitch(\'cell\');return false;">  </td></tr></table> </div> <div id="%id.cellsettingstoolbar" style="display:none;">  <table cellspacing="0" cellpadding="0"><tr><td>   <div style="%tbt.">%loc!CELL SETTINGS!: <span id="%id.settingsecell">&nbsp;</span></div>   </td></tr><tr><td>  <input id="%id.settings-savecell" type="button" value="%loc!Save!" onclick="SocialCalc.SettingsControlSave(\'cell\');">  <input type="button" value="%loc!Cancel!" onclick="SocialCalc.SettingsControlSave(\'cancel\');">  <input type="button" value="%loc!Show Sheet Settings!" onclick="SocialCalc.SpreadsheetControlSettingsSwitch(\'sheet\');return false;">  </td></tr></table> </div></div>',
                        html: '<div id="%id.settingstools" style="display:none;"> <div id="%id.sheetsettingstoolbar" style="display:none;">  <table cellspacing="0" cellpadding="0"><tr><td>   <div style="%tbt.">%loc!SHEET SETTINGS!:</div>   </td></tr><tr><td><input id="%id.settings-savesheet" type="button" value="%loc!Save!" onclick="SocialCalc.SettingsControlSave(\'sheet\');">   <input  class="cancelSheetMod" type="button" value="%loc!Cancel!" onclick="SocialCalc.SettingsControlSave(\'cancel\');">   <input class="showCellSettings" type="button" value="%loc!Show Cell Settings!" >  </td></tr></table> </div> <div id="%id.cellsettingstoolbar" style="display:none;">  <table cellspacing="0" cellpadding="0"><tr><td>   <div style="%tbt.">%loc!'+lang.synt46+'!: <span id="%id.settingsecell">&nbsp;</span></div>   </td></tr><tr><td>  <input id="%id.settings-savecell" class="saveToCell" type="button" value="%loc!Save!">  <input class="cancelBT2" type="button" value="%loc!'+lang.synt48+'!">  <input class="switchSheet" type="button" value="%loc!Show Sheet Settings!">  </td></tr></table> </div></div>',
                        view: "settings",
                        onclick: function (e) {
                            t.SettingsControls.idPrefix = e.idPrefix, t.SettingControlReset();
                            var o = e.sheet.EncodeSheetAttributes(),
                                i = e.sheet.EncodeCellAttributes(e.editor.ecell.coord);
                            t.SettingsControlLoadPanel(e.views.settings.values.sheetspanel, o), t.SettingsControlLoadPanel(e.views.settings.values.cellspanel, i),
                                document.getElementById(e.idPrefix + "settingsecell").innerHTML = e.editor.ecell.coord,
                                t.SpreadsheetControlSettingsSwitch("cell"), e.views.settings.element.style.height = e.viewheight + "px",
                                e.views.settings.element.firstChild.style.height = e.viewheight + "px";
                            var n;
                            n = e.editor.range.hasrange ? t.crToCoord(e.editor.range.left, e.editor.range.top) + ":" + t.crToCoord(e.editor.range.right, e.editor.range.bottom) : e.editor.ecell.coord,
                                document.getElementById(e.idPrefix + "settings-savecell").value = t.LocalizeString(lang.synt47) + ": " + n; //Build button css to save a cell format
                        },
                        onclickFocus: !0
                    }), this.views.settings = {
                        name: "settings",
                        values: {},
                        oncreate: function (e, o) {
                            var i = t.Constants;
                            o.values.sheetspanel = {
                                colorchooser: {
                                    id: e.idPrefix + "scolorchooser"
                                },
                                formatnumber: {
                                    setting: "numberformat",
                                    type: "PopupList",
                                    id: e.idPrefix + "formatnumber",
                                    class: "jp_formatnumber",
                                    initialdata: i.SCFormatNumberFormats
                                },
                                formattext: {
                                    setting: "textformat",
                                    type: "PopupList",
                                    id: e.idPrefix + "formattext",
                                    initialdata: i.SCFormatTextFormats
                                },
                                fontfamily: {
                                    setting: "fontfamily",
                                    type: "PopupList",
                                    id: e.idPrefix + "fontfamily",
                                    initialdata: i.SCFormatFontfamilies
                                },
                                fontlook: {
                                    setting: "fontlook",
                                    type: "PopupList",
                                    id: e.idPrefix + "fontlook",
                                    initialdata: i.SCFormatFontlook
                                },
                                fontsize: {
                                    setting: "fontsize",
                                    type: "PopupList",
                                    id: e.idPrefix + "fontsize",
                                    initialdata: i.SCFormatFontsizes
                                },
                                textalignhoriz: {
                                    setting: "textalignhoriz",
                                    type: "PopupList",
                                    id: e.idPrefix + "textalignhoriz",
                                    initialdata: i.SCFormatTextAlignhoriz
                                },
                                numberalignhoriz: {
                                    setting: "numberalignhoriz",
                                    type: "PopupList",
                                    id: e.idPrefix + "numberalignhoriz",
                                    initialdata: i.SCFormatNumberAlignhoriz
                                },
                                alignvert: {
                                    setting: "alignvert",
                                    type: "PopupList",
                                    id: e.idPrefix + "alignvert",
                                    initialdata: i.SCFormatAlignVertical
                                },
                                textcolor: {
                                    setting: "textcolor",
                                    type: "ColorChooser",
                                    id: e.idPrefix + "textcolor"
                                },
                                bgcolor: {
                                    setting: "bgcolor",
                                    type: "ColorChooser",
                                    id: e.idPrefix + "bgcolor"
                                },
                                padtop: {
                                    setting: "padtop",
                                    type: "PopupList",
                                    id: e.idPrefix + "padtop",
                                    initialdata: i.SCFormatPadsizes
                                },
                                padright: {
                                    setting: "padright",
                                    type: "PopupList",
                                    id: e.idPrefix + "padright",
                                    initialdata: i.SCFormatPadsizes
                                },
                                padbottom: {
                                    setting: "padbottom",
                                    type: "PopupList",
                                    id: e.idPrefix + "padbottom",
                                    initialdata: i.SCFormatPadsizes
                                },
                                padleft: {
                                    setting: "padleft",
                                    type: "PopupList",
                                    id: e.idPrefix + "padleft",
                                    initialdata: i.SCFormatPadsizes
                                },
                                colwidth: {
                                    setting: "colwidth",
                                    type: "PopupList",
                                    id: e.idPrefix + "colwidth",
                                    initialdata: i.SCFormatColwidth
                                },
                                recalc: {
                                    setting: "recalc",
                                    type: "PopupList",
                                    id: e.idPrefix + "recalc",
                                    initialdata: i.SCFormatRecalc
                                },
                                usermaxcol: {
                                    setting: "usermaxcol",
                                    type: "PopupList",
                                    id: e.idPrefix + "usermaxcol",
                                    initialdata: i.SCFormatUserMaxCol
                                },
                                usermaxrow: {
                                    setting: "usermaxrow",
                                    type: "PopupList",
                                    id: e.idPrefix + "usermaxrow",
                                    initialdata: i.SCFormatUserMaxRow
                                }
                            }, o.values.cellspanel = {
                                name: "cell",
                                colorchooser: {
                                    id: e.idPrefix + "scolorchooser"
                                },
                                cformatnumber: {
                                    setting: "numberformat",
                                    type: "PopupList",
                                    id: e.idPrefix + "cformatnumber",
                                    initialdata: i.SCFormatNumberFormats
                                },
                                cformattext: {
                                    setting: "textformat",
                                    type: "PopupList",
                                    id: e.idPrefix + "cformattext",
                                    initialdata: i.SCFormatTextFormats
                                },
                                cfontfamily: {
                                    setting: "fontfamily",
                                    type: "PopupList",
                                    id: e.idPrefix + "cfontfamily",
                                    initialdata: i.SCFormatFontfamilies
                                },
                                cfontlook: {
                                    setting: "fontlook",
                                    type: "PopupList",
                                    id: e.idPrefix + "cfontlook",
                                    initialdata: i.SCFormatFontlook
                                },
                                cfontsize: {
                                    setting: "fontsize",
                                    type: "PopupList",
                                    id: e.idPrefix + "cfontsize",
                                    initialdata: i.SCFormatFontsizes
                                },
                                calignhoriz: {
                                    setting: "alignhoriz",
                                    type: "PopupList",
                                    id: e.idPrefix + "calignhoriz",
                                    initialdata: i.SCFormatTextAlignhoriz
                                },
                                calignvert: {
                                    setting: "alignvert",
                                    type: "PopupList",
                                    id: e.idPrefix + "calignvert",
                                    initialdata: i.SCFormatAlignVertical
                                },
                                ctextcolor: {
                                    setting: "textcolor",
                                    type: "ColorChooser",
                                    id: e.idPrefix + "ctextcolor"
                                },
                                cbgcolor: {
                                    setting: "bgcolor",
                                    type: "ColorChooser",
                                    id: e.idPrefix + "cbgcolor"
                                },
                                cbt: {
                                    setting: "bt",
                                    type: "BorderSide",
                                    id: e.idPrefix + "cbt"
                                },
                                cbr: {
                                    setting: "br",
                                    type: "BorderSide",
                                    id: e.idPrefix + "cbr"
                                },
                                cbb: {
                                    setting: "bb",
                                    type: "BorderSide",
                                    id: e.idPrefix + "cbb"
                                },
                                cbl: {
                                    setting: "bl",
                                    type: "BorderSide",
                                    id: e.idPrefix + "cbl"
                                },
                                cpadtop: {
                                    setting: "padtop",
                                    type: "PopupList",
                                    id: e.idPrefix + "cpadtop",
                                    initialdata: i.SCFormatPadsizes
                                },
                                cpadright: {
                                    setting: "padright",
                                    type: "PopupList",
                                    id: e.idPrefix + "cpadright",
                                    initialdata: i.SCFormatPadsizes
                                },
                                cpadbottom: {
                                    setting: "padbottom",
                                    type: "PopupList",
                                    id: e.idPrefix + "cpadbottom",
                                    initialdata: i.SCFormatPadsizes
                                },
                                cpadleft: {
                                    setting: "padleft",
                                    type: "PopupList",
                                    id: e.idPrefix + "cpadleft",
                                    initialdata: i.SCFormatPadsizes
                                }
                            }, t.SettingsControlInitializePanel(o.values.sheetspanel), t.SettingsControlInitializePanel(o.values.cellspanel);

                        },
                        replacements: {
                            itemtitle: {
                                regex: /\%itemtitle\./g,
                                replacement: 'style="padding:12px 10px 0px 10px;font-weight:bold;text-align:right;vertical-align:top;font-size:small;"'
                            },
                            sectiontitle: {
                                regex: /\%sectiontitle\./g,
                                replacement: 'style="padding:16px 10px 0px 0px;font-weight:bold;vertical-align:top;font-size:small;color:#C00;"'
                            },
                            parttitle: {
                                regex: /\%parttitle\./g,
                                replacement: 'style="font-weight:bold;font-size:x-small;padding:0px 0px 3px 0px;"'
                            },
                            itembody: {
                                regex: /\%itembody\./g,
                                replacement: 'style="padding:12px 0px 0px 0px;vertical-align:top;font-size:small;"'
                            },
                            bodypart: {
                                regex: /\%bodypart\./g,
                                replacement: 'style="padding:0px 10px 0px 0px;font-size:small;vertical-align:top;"'
                            }
                        },
                        divStyle: "border:1px solid black;overflow:auto;",
                        html: '<div id="%id.scolorchooser" style="display:none;position:absolute;z-index:20;"></div><table cellspacing="0" cellpadding="0"> <tr><td style="vertical-align:top;"><table id="%id.sheetsettingstable" style="display:block;" cellspacing="0" cellpadding="0"><tr> <td %itemtitle.><br>%loc!Default Format!:</td> <td %itembody.>   <table cellspacing="0" cellpadding="0"><tr>    <td %bodypart.>     <div %parttitle.>%loc!Number!</div>     <span id="%id.formatnumber"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Text!</div>     <span id="%id.formattext"></span>    </td>   </tr></table> </td></tr><tr> <td %itemtitle.><br>%loc!Default Alignment!:</td> <td %itembody.>   <table cellspacing="0" cellpadding="0"><tr>    <td %bodypart.>     <div %parttitle.>%loc!Text Horizontal!</div>     <span id="%id.textalignhoriz"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Number Horizontal!</div>     <span id="%id.numberalignhoriz"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Vertical!</div>     <span id="%id.alignvert"></span>    </td>   </tr></table> </td></tr><tr> <td %itemtitle.><br>%loc!Default Font!:</td> <td %itembody.>   <table cellspacing="0" cellpadding="0"><tr>    <td %bodypart.>     <div %parttitle.>%loc!Family!</div>     <span id="%id.fontfamily"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Bold &amp; Italics!</div>     <span id="%id.fontlook"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Size!</div>     <span id="%id.fontsize"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!'+lang.synt60+'!</div>     <div id="%id.textcolor"></div>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Background!</div>     <div id="%id.bgcolor"></div>    </td>   </tr></table> </td></tr><tr> <td %itemtitle.><br>%loc!Default Padding!:</td> <td %itembody.>   <table cellspacing="0" cellpadding="0"><tr>    <td %bodypart.>     <div %parttitle.>%loc!Top!</div>     <span id="%id.padtop"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Right!</div>     <span id="%id.padright"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Bottom!</div>     <span id="%id.padbottom"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Left!</div>     <span id="%id.padleft"></span>    </td>   </tr></table> </td></tr><tr> <td %itemtitle.><br>%loc!Default Column Width!:</td> <td %itembody.>   <table cellspacing="0" cellpadding="0"><tr>    <td %bodypart.>     <div %parttitle.>&nbsp;</div>     <span id="%id.colwidth"></span>    </td>   </tr></table> </td></tr><tr> <td %itemtitle.><br>%loc!Recalculation!:</td> <td %itembody.>   <table cellspacing="0" cellpadding="0"><tr>    <td %bodypart.>     <div %parttitle.>&nbsp;</div>     <span id="%id.recalc"></span>    </td>   </tr></table> </td></tr><tr> <td %itemtitle.><br>%loc!Dimensions!:</td> <td %itembody.>   <table cellspacing="0" cellpadding="0"><tr>    <td %bodypart.>     <div %parttitle.>%loc!Columns!</div>     <span id="%id.usermaxcol"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Rows!</div>     <span id="%id.usermaxrow"></span>    </td>   </tr></table> </td></tr></table><table id="%id.cellsettingstable" cellspacing="0" cellpadding="0"><tr> <td %itemtitle.><br>%loc!Format!:</td> <td %itembody.>   <table cellspacing="0" cellpadding="0"><tr>    <td %bodypart.>     <div %parttitle.>%loc!Number!</div>     <span id="%id.cformatnumber"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Text!</div>     <span id="%id.cformattext"></span>    </td>   </tr></table> </td></tr><tr> <td %itemtitle.><br>%loc!Alignment!:</td> <td %itembody.>   <table cellspacing="0" cellpadding="0"><tr>    <td %bodypart.>     <div %parttitle.>%loc!Horizontal!</div>     <span id="%id.calignhoriz"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Vertical!</div>     <span id="%id.calignvert"></span>    </td>   </tr></table> </td></tr><tr> <td %itemtitle.><br>%loc!Font!:</td> <td %itembody.>   <table cellspacing="0" cellpadding="0"><tr>    <td %bodypart.>     <div %parttitle.>%loc!Family!</div>     <span id="%id.cfontfamily">ici</span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Bold &amp; Italics!</div>     <span id="%id.cfontlook"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Size!</div>     <span id="%id.cfontsize"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Color!</div>     <div id="%id.ctextcolor"></div>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Background!</div>     <div id="%id.cbgcolor"></div>    </td>   </tr></table> </td></tr><tr> <td %itemtitle.><br>%loc!'+lang.synt62+'!:</td> <td %itembody.>   <table cellspacing="0" cellpadding="0">    <tr><td %bodypart. colspan="3"><div %parttitle.>%loc!Top Border!</div></td>     <td %bodypart. colspan="3"><div %parttitle.>%loc!Right Border!</div></td>     <td %bodypart. colspan="3"><div %parttitle.>%loc!Bottom Border!</div></td>     <td %bodypart. colspan="3"><div %parttitle.>%loc!Left Border!</div></td>    </tr><tr>    <td %bodypart.>     <input id="%id.cbt-onoff-bcb" class="xboxBorder"   type="checkbox">    </td>    <td %bodypart.>     <div id="%id.cbt-color"></div>    </td>    <td>&nbsp;&nbsp;&nbsp;&nbsp;</td>    <td %bodypart.>     <input id="%id.cbr-onoff-bcb" class="xboxBorder";" type="checkbox">    </td>    <td %bodypart.>     <div id="%id.cbr-color"></div>    </td>    <td>&nbsp;&nbsp;&nbsp;&nbsp;</td>    <td %bodypart.>     <input id="%id.cbb-onoff-bcb" class="xboxBorder" type="checkbox">    </td>    <td %bodypart.>     <div id="%id.cbb-color"></div>    </td>    <td>&nbsp;&nbsp;&nbsp;&nbsp;</td>    <td %bodypart.>     <input id="%id.cbl-onoff-bcb" class="xboxBorder" type="checkbox">    </td>    <td %bodypart.>     <div id="%id.cbl-color"></div>    </td>    <td>&nbsp;&nbsp;&nbsp;&nbsp;</td>   </tr></table> </td></tr><tr> <td %itemtitle.><br>%loc!Padding!:</td> <td %itembody.>   <table cellspacing="0" cellpadding="0"><tr>    <td %bodypart.>     <div %parttitle.>%loc!Top!</div>     <span id="%id.cpadtop"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Right!</div>     <span id="%id.cpadright"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Bottom!</div>     <span id="%id.cpadbottom"></span>    </td>    <td %bodypart.>     <div %parttitle.>%loc!Left!</div>     <span id="%id.cpadleft"></span>    </td>   </tr></table> </td></tr></table> </td><td style="vertical-align:top;padding:12px 0px 0px 12px;">  <div style="width:100px;height:100px;overflow:hidden;border:1px solid black;background-color:#EEE;padding:6px;">   <table cellspacing="0" cellpadding="0"><tr>    <td id="sample-text" style="height:100px;width:100px;"><div>%loc!This is a<br>sample!</div><div>-1234.5</div></td>   </tr></table>  </div> </td></tr></table><br>'
                    }, // End of Settings

                    this.tabnums.sort = this.tabs.length, this.tabs.push({
                        name: "sort",
                        text: lang.synt3,
                        html: ' <div id="%id.sorttools" style="display:none;">  <table cellspacing="0" cellpadding="0"><tr>   <td style="vertical-align:top;padding-right:4px;width:160px;">    <div style="%tbt.">%loc!Set Cells To Sort!</div>    <select id="%id.sortlist" size="1" onfocus="%s.CmdGotFocus(this);"><option selected>[select range]</option><option value="all">Sort All</option></select>    <input class="doCmdSort" type="button" value="%loc!OK!" onclick="%s.DoCmd(this, \'ok-setsort\');" style="font-size:x-small;">   </td>   <td style="vertical-align:middle;padding-right:16px;width:100px;text-align:right;">    <div style="%tbt.">&nbsp;</div>    <input type="button" id="%id.sortbutton" value="%loc!Sort Cells! A1:A1" onclick="%s.DoCmd(this, \'dosort\');" style="visibility:hidden;">   </td>   <td style="vertical-align:top;padding-right:16px;">    <table cellspacing="0" cellpadding="0"><tr>     <td style="vertical-align:top;">      <div style="%tbt.">%loc!Major Sort!</div>      <select id="%id.majorsort" size="1" onfocus="%s.CmdGotFocus(this);"></select>     </td><td>      <input type="radio" name="majorsort" id="%id.majorsortup" value="up" checked><span style="font-size:x-small;color:#555753;">%loc!Up!</span><br>      <input type="radio" name="majorsort" id="%id.majorsortdown" value="down"><span style="font-size:x-small;color:#555753;">%loc!Down!</span>     </td>    </tr></table>   </td>   <td style="vertical-align:top;padding-right:16px;">    <table cellspacing="0" cellpadding="0"><tr>     <td style="vertical-align:top;">      <div style="%tbt.">%loc!Minor Sort!</div>      <select id="%id.minorsort" size="1" onfocus="%s.CmdGotFocus(this);"></select>     </td><td>      <input type="radio" name="minorsort" id="%id.minorsortup" value="up" checked><span style="font-size:x-small;color:#555753;">%loc!Up!</span><br>      <input type="radio" name="minorsort" id="%id.minorsortdown" value="down"><span style="font-size:x-small;color:#555753;">%loc!Down!</span>     </td>    </tr></table>   </td>   <td style="vertical-align:top;padding-right:16px;">    <table cellspacing="0" cellpadding="0"><tr>     <td style="vertical-align:top;">      <div style="%tbt.">%loc!Last Sort!</div>      <select id="%id.lastsort" size="1" onfocus="%s.CmdGotFocus(this);"></select>     </td><td>      <input type="radio" name="lastsort" id="%id.lastsortup" value="up" checked><span style="font-size:x-small;color:#555753;">%loc!Up!</span><br>      <input type="radio" name="lastsort" id="%id.lastsortdown" value="down"><span style="font-size:x-small;color:#555753;">%loc!Down!</span>     </td>    </tr></table>   </td>  </tr></table> </div>',
                        onclick: t.SpreadsheetControlSortOnclick
                    }), this.editor.SettingsCallbacks.sort = {
                        save: t.SpreadsheetControlSortSave,
                        load: t.SpreadsheetControlSortLoad
                    },
                    this.tabnums.audit = this.tabs.length, this.tabs.push({
                        name: "audit",
                        text: lang.synt4,
                        html: '<div id="%id.audittools" style="display:none;"> <div style="%tbt.">&nbsp;</div></div>',
                        view: "audit",
                        onclick: function (e) {
                            var o, i, n = t.LocalizeString,
                                r = '<table cellspacing="0" cellpadding="0" style="margin-bottom:10px;"><tr><td style="font-size:small;padding:6px;"><b>' + n("Audit Trail This Session") + ":</b><br><br>",
                                a = e.sheet.changes.stack,
                                s = e.sheet.changes.tos;
                            for (o = 0; o < a.length; o++)
                                for (o == s + 1 && (r += '<br></td></tr><tr><td style="font-size:small;background-color:#EEE;padding:6px;">' + n("UNDONE STEPS") + ":<br>"),
                                    i = 0; i < a[o].command.length; i++) r += t.special_chars(a[o].command[i]) + "<br>";
                            var l = function (e) {
                                if ("string" == typeof e) return e;
                                if (!e) return "null";
                                if ("object" == typeof e) {
                                    l.check || (l.check = new Array());
                                    for (var t = 0, o = l.check.length; o > t; ++t)
                                        if (l.check[t] == e) return "{}";
                                    l.check.push(e);
                                }
                                var o = "",
                                    i = "undefined" == typeof e.length ? 1 : 0,
                                    n = "";
                                for (var r in e) i && (o = "'" + r + "':"), n += "string" == typeof e[r] ? o + "'" + e[r] + "'," : "object" == typeof e[r] ? o + l(e[r]) + "," : o + e[r] + ",";

                                return "object" == typeof e && l.check.pop(), i ? "{" + n.slice(0, -1) + "}" : "[" + n.slice(0, -1) + "]";
                            };
                            if ("undefined" != typeof t.debug_log)
                                for (var c in t.debug_log) r += l(t.debug_log[c]) + "<br>";
                            e.views.audit.element.innerHTML = r + "</td></tr></table>", t.CmdGotFocus(!0);

                        },
                        onclickFocus: !0
                    }),
                    this.views.audit = {
                        name: "audit",
                        divStyle: "border:1px solid black;overflow:auto;",
                        html: "Audit Trail"
                    }, this.tabnums.comment = this.tabs.length, this.tabs.push({
                        name: "comment",
                        text: lang.synt5,
                        html: '<div id="%id.commenttools" style="display:none;"><table cellspacing="0" cellpadding="0"><tr><td><textarea id="%id.commenttext" style="font-size:small;height:32px;width:600px;overflow:auto;" onfocus="%s.CmdGotFocus(this);"></textarea></td><td style="vertical-align:top;">&nbsp;<input class="commentButton" type="button" value="%loc!Save!"  style="font-size:x-small;"></td></tr></table></div>',
                        view: "sheet",
                        onclick: t.SpreadsheetControlCommentOnclick,
                        onunclick: t.SpreadsheetControlCommentOnunclick
                    }), this.tabnums.names = this.tabs.length, this.tabs.push({
                        name: "names",
                        text: lang.synt6,
                        html: '<div id="%id.namestools" style="display:none;">  <table cellspacing="0" cellpadding="0"><tr>   <td style="vertical-align:top;padding-right:24px;">    <div style="%tbt.">%loc!Existing Names!</div>    <select id="%id.nameslist" size="1"  onfocus="%s.CmdGotFocus(this);"><option selected>[New]</option></select>   </td>   <td style="vertical-align:top;padding-right:6px;">    <div style="%tbt.">%loc!Name!</div>    <input type="text" id="%id.namesname" style="font-size:x-small;width:75px;" onfocus="%s.CmdGotFocus(this);">   </td>   <td style="vertical-align:top;padding-right:6px;">    <div style="%tbt.">%loc!Description!</div>    <input type="text" id="%id.namesdesc" style="font-size:x-small;width:150px;" onfocus="%s.CmdGotFocus(this);">   </td>   <td style="vertical-align:top;padding-right:6px;">    <div style="%tbt.">%loc!Cell Coordinates!</div>    <input type="text" id="%id.namesvalue" width="16" style="font-size:x-small;width:100px;" onfocus="%s.CmdGotFocus(this);">   </td>   <td style="vertical-align:top;padding-right:12px;width:100px;">    <div style="%tbt.">%loc!Set Value To!</div>    <input type="button" id="%id.namesrangeproposal" value="A1"  style="font-size:x-small;">   </td>   <td style="vertical-align:top;padding-right:6px;">    <div style="%tbt.">&nbsp;</div>    <input class="nameSaver" type="button" value="%loc!Save!" style="font-size:x-small;">    <input class="deleteName" type="button" value="%loc!Delete!"  style="font-size:x-small;">   </td>  </tr></table></div>',
                        view: "sheet",
                        onclick: t.SpreadsheetControlNamesOnclick,
                        onunclick: t.SpreadsheetControlNamesOnunclick
                    }), this.tabnums.clipboard = this.tabs.length, this.tabs.push({
                        name: "clipboard",
                        text: lang.synt7,
                        html: '<div id="%id.clipboardtools" style="display:none;">  <table cellspacing="0" cellpadding="0"><tr>   <td style="vertical-align:top;padding-right:24px;">    <div style="%tbt.">     &nbsp;    </div>   </td>  </tr></table></div>',
                        view: "clipboard",
                        onclick: t.SpreadsheetControlClipboardOnclick,
                        onclickFocus: "clipboardtext"
                    }), this.views.clipboard = {
                        name: "clipboard",
                        divStyle: "overflow:auto;",
                        html: ' <div style="font-size:x-small;padding:5px 0px 10px 0px;"><b>%loc!Display Clipboard in!:</b>  <input  class="tabFormat" type="radio" id="%id.clipboardformat-tab" name="%id.clipboardformat" checked > %loc!Tab-delimited format! &nbsp;  <input class="csvFormat" type="radio" id="%id.clipboardformat-csv" name="%id.clipboardformat" > %loc!CSV format! &nbsp;  <input class="" type="radio" id="%id.clipboardformat-scsave" name="%id.clipboardformat"> %loc!SocialCalc-save format! </div> <input class="fillValues" type="button" value="%loc!Load SocialCalc Clipboard With This!" style="font-size:x-small;" >&nbsp;  <input class="scSaveFormat" type="button" value="%loc!Clear SocialCalc Clipboard!" style="font-size:x-small;" >&nbsp;  <br> <textarea class="clipBoardTArea" id="%id.clipboardtext" style="font-size:small;height:350px;width:800px;overflow:auto;"></textarea>'
                    };



                $container.find(".tabFormat").on("click", function () {
                    t.SpreadsheetControlClipboardFormat('tab');
                });
                $container.find(".csvFormat").on("click", function () {
                    t.SpreadsheetControlClipboardFormat('csv');
                });
                $container.find(".scSaveFormat").on("click", function () {
                    t.SpreadsheetControlClipboardFormat();
                });
            }, // End of EtherCore Object**************************************************************** 

            t.SpreadsheetControl.prototype.InitializeSpreadsheetControl = function (e, o, i, n) {
                return t.InitializeSpreadsheetControl(this, e, o, i, n);
            }, t.SpreadsheetControl.prototype.DoOnResize = function () {
                return t.DoOnResize(this);
            }, t.SpreadsheetControl.prototype.SizeSSDiv = function () {
                return t.SizeSSDiv(this);
            }, t.SpreadsheetControl.prototype.ExecuteCommand = function (e, o) {
                return t.SpreadsheetControlExecuteCommand(this, e, o);
            }, t.SpreadsheetControl.prototype.CreateSheetHTML = function () {
                return t.SpreadsheetControlCreateSheetHTML(this);
            }, t.SpreadsheetControl.prototype.CreateSpreadsheetSave = function (e) {
                return t.SpreadsheetControlCreateSpreadsheetSave(this, e);
            }, t.SpreadsheetControl.prototype.DecodeSpreadsheetSave = function (e) {
                return t.SpreadsheetControlDecodeSpreadsheetSave(this, e);
            }, t.SpreadsheetControl.prototype.CreateCellHTML = function (e) {
                return t.SpreadsheetControlCreateCellHTML(this, e);
            }, t.SpreadsheetControl.prototype.CreateCellHTMLSave = function (e) {
                return t.SpreadsheetControlCreateCellHTMLSave(this, e);
            }, t.SpreadsheetControl.prototype.ParseSheetSave = function (e) {
                return this.sheet.ParseSheetSave(e);
            }, t.SpreadsheetControl.prototype.CreateSheetSave = function () {
                return this.sheet.CreateSheetSave();
            }, t.InitializeSpreadsheetControl = function (e, o, i, n, r) {//JP : Initialisation de la spreadsheet !!!!
                var a, s, l, c, u, d, h, p, f = t.Constants,
                    m = t.LocalizeString,
                    g = t.LocalizeSubstrings,
                    v = e.tabs,
                    b = e.views;

                for (e.requestedHeight = i, e.requestedWidth = n, e.requestedSpaceBelow = r, "string" == typeof o && (o = document.getElementById(o)),
                    null == o && alert("SocialCalc.SpreadsheetControl not given parent node."), 
                    e.parentNode = o,
                    //e.spreadsheetDiv = $container.html("<div></div>"),
                    e.spreadsheetDiv = document.createElement("div"),
                    //e.spreadsheetDiv.style.backgroundColor = "red", 
                    e.SizeSSDiv(), 
                    s = o.firstChild; null != s; 
                    s = o.firstChild) o.removeChild(s);
                let bigElementNumber = 0;
                for (a = "<div>", a += '<div class="bElement' + bigElementNumber + '" style="' + e.tabbackground + '"><table cellpadding="0" cellspacing="0"><tr>',
                    bigElementNumber++,
                    l = 0; l < v.length; l++) a += '  <td id="%id.' + v[l].name + 'tab" style="' + (0 == l ? e.tabselectedCSS : e.tabplainCSS) + '">' + v[l].text + "</td>";
                for (a += " </tr></table></div>", a += '<div style="' + e.toolbarbackground + 'padding:12px 10px 10px 4px; margin-bottom:10px">',
                    l = 0; l < v.length; l++) a += v[l].html;
                a += "</div>", a += "</div>", e.currentTab = 0;
                for (d in e.tabreplacements) a = a.replace(e.tabreplacements[d].regex, e.tabreplacements[d].replacement);
                a = a.replace(/\%s\./g, "SocialCalc."), a = a.replace(/\%id\./g, e.idPrefix), a = a.replace(/\%tbt\./g, e.toolbartext),
                    a = a.replace(/\%img\./g, e.imagePrefix), a = g(a), e.spreadsheetDiv.innerHTML = a, //HERE HACK JP PATH IMAGE BUG ! Change %img (joker path)
                    o.appendChild(e.spreadsheetDiv), e.Buttons = {
                        button_undo: {
                            tooltip: lang.synt9,
                            command: "undo"
                        },
                        button_redo: {
                            tooltip: lang.synt10,
                            command: "redo"
                        },
                        button_copy: {
                            tooltip: lang.synt11,
                            command: "copy"
                        },
                        button_cut: {
                            tooltip: lang.synt12,
                            command: "cut"
                        },
                        button_paste: {
                            tooltip: lang.synt13,
                            command: "paste"
                        },
                        button_pasteformats: {
                            tooltip: lang.synt15,
                            command: "pasteformats"
                        },
                        button_lock: {
                            tooltip: lang.synt16,
                            command: "lock"
                        },
                        button_unlock: {
                            tooltip: lang.synt17,
                            command: "unlock"
                        },
                        button_delete: {
                            tooltip: lang.synt14,
                            command: "delete"
                        },
                        button_filldown: {
                            tooltip: lang.synt18,
                            command: "filldown"
                        },
                        button_fillright: {
                            tooltip: lang.synt19,
                            command: "fillright"
                        },
                        button_movefrom: {
                            tooltip: lang.synt20,
                            command: "movefrom"
                        },
                        button_movepaste: {
                            tooltip: lang.synt21,
                            command: "movepaste"
                        },
                        button_moveinsert: {
                            tooltip: lang.synt22,
                            command: "moveinsert"
                        },
                        button_alignleft: {
                            tooltip: lang.synt23,
                            command: "align-left"
                        },
                        button_aligncenter: {
                            tooltip: lang.synt24,
                            command: "align-center"
                        },
                        button_alignright: {
                            tooltip: lang.synt25,
                            command: "align-right"
                        },
                        button_borderon: {
                            tooltip: lang.synt26,
                            command: "borderon"
                        },
                        button_borderoff: {
                            tooltip: lang.synt27,
                            command: "borderoff"
                        },
                        button_swapcolors: {
                            tooltip: lang.synt28,
                            command: "swapcolors"
                        },
                        button_merge: {
                            tooltip: lang.synt29,
                            command: "merge"
                        },
                        button_insertrow: {
                            tooltip: lang.synt30,
                            command: "insertrow"
                        },
                        button_insertcol: {
                            tooltip: lang.synt31,
                            command: "insertcol"
                        },
                        button_deleterow: {
                            tooltip: lang.synt32,
                            command: "deleterow"
                        },
                        button_deletecol: {
                            tooltip: lang.synt33,
                            command: "deletecol"
                        },
                        button_hiderow: {
                            tooltip: lang.synt34,
                            command: "hiderow"
                        },
                        button_hidecol: {
                            tooltip: lang.synt35,
                            command: "hidecol"
                        },
                        button_recalc: {
                            tooltip: "Recalculate",
                            command: "recalc"
                        }
                    };
                for (h in e.Buttons) p = document.getElementById(e.idPrefix + h), p ? (p.style.border = "1px solid " + f.ISCButtonBorderNormal,
                    p.title = m(e.Buttons[h].tooltip), t.ButtonRegister(e.editor, p, {
                        normalstyle: "border:1px solid " + f.ISCButtonBorderNormal + ";background-color:" + f.ISCButtonNormalBackground + ";",
                        hoverstyle: "border:1px solid " + f.ISCButtonBorderHover + ";background-color:" + f.ISCButtonHoverBackground + ";",
                        downstyle: "border:1px solid " + f.ISCButtonBorderDown + ";background-color:" + f.ISCButtonDownBackground + ";"
                    }, {
                        MouseDown: t.DoButtonCmd,
                        command: e.Buttons[h].command
                    })) : alert("Button " + (e.idPrefix + h) + " missing");
                e.formulabarDiv = document.createElement("div"), e.formulabarDiv.innerHTML = '<input type="text" size="60" value="">&nbsp;',
                    e.spreadsheetDiv.appendChild(e.formulabarDiv);
                new t.InputBox(e.formulabarDiv.firstChild, e.editor);
                var btsplit;
                for (h in e.formulabuttons) p = document.createElement("div"), p.id = e.idPrefix + h,
                    btsplit = (e.formulabuttons[h].image).split("."),
                    p.style.verticalAlign = "middle", p.style.border = "1px solid #FFF", p.style.marginLeft = "4px",
                    p.title = m(e.formulabuttons[h].tooltip), t.ButtonRegister(e.editor, p, {
                        normalstyle: "border:1px solid #FFF;backgroundColor:#FFF;",
                        hoverstyle: "border:1px solid #CCC;backgroundColor:#FFF;",
                        downstyle: "border:1px solid #000;backgroundColor:#FFF;"
                    }, {
                        MouseDown: e.formulabuttons[h].command,
                        Disabled: function () {
                            return e.editor.ECellReadonly();
                        }
                    }), e.formulabarDiv.appendChild(p),
                    $container.find("#" + p.id).addClass("sc_" + btsplit[0]).addClass("barBt").addClass("barFunction").addClass("sprite");


                //Hide all TabSystem*************************************************************
                if (config.level == 'not visible') {
                    $container.find('.bElement0').hide();
                }

                for (let i = 0; i < config.hiddenBt.length; i++) {
                    $container.find("." + config.hiddenBt[i]).hide();
                }
                let chartNumber = 0;
                t.chartTool = {};
                t.chartTool.chartList = [];
                // GRAPH TRIGGER   - SHART TRIGGER
                $container.find(".chartBt").on("click", function () {
                    var graphType = $container.find(this).attr("name");
                    
                    chartNumber++;
                    $container.find("#te_appView").append("<div style='z-index:9' class='chart chart" + chartNumber + "'><button class='closeGraph" + chartNumber +
                        "'style='float:right' >X</button> <div class='topGraph' style='text-align:center; padding : 5px;'>" +
                        "<button class='editionBT'>Edit</button><div class='titleOfChart'>Title example Chart" + chartNumber + "</div></div>" +
                        "<div class='graphPanel'><div class='gPanelContent'> <button class='closeEditionPanel' style='float:right;'>X</button>" +
                        "<div class='paramTitle'>"+lang.synt443+"</div>" +
                        "<div class='inputZone panelOf'>" +
                        "</div></div></div> " +
                        "<canvas id = 'myChart" + chartNumber + "' width = '400' height = '370'> < /canvas>'</div >");

                    var GWidget = $container.find(".chart" + chartNumber);

                    let chartN = "chart" + chartNumber;
                    $container.find(".chart" + chartNumber).addClass("chartDivStyle").draggable();
                    t.chartTool.chartList.push("chart" + chartNumber);
                    t.chartTool[chartN] = {};

                    $container.find(".closeEditionPanel").on("click", function () {
                        let Groot = $container.find(this).parent().parent().parent();
                        let $graphPanel = $container.find(this).parent().parent();
                        let $panelContent = $container.find(this).parent();
                        $graphPanel.removeClass("graphPanelOpening");
                        $panelContent.hide();
                        $graphPanel.addClass("graphPanelClosing");
                        Groot.find(".closeEditionPanel").hide();
                        // $(".closeEditionPanel")
                        //Groot.find(".editionBT").toggle('right');
                        Groot.find(".editionBT").show();
                    })

                    $container.find(".editionBT").on("click", function () {
                        let Groot = $container.find(this).parent().parent();
                        
                        Groot.find(".gPanelContent").show();
                        Groot.find(".graphPanel").removeClass("graphPanelClosing");
                        Groot.find(".graphPanel").addClass("graphPanelOpening");
                        //Groot.find(".closeEditionPanel").toggle('left');
                        Groot.find(".closeEditionPanel").show();
                        $container.find(this).hide();
                    })
                    $container.find(".closeGraph" + chartNumber).on("click", function () {
                        let chartN = $container.find(this.parentNode)[0].classList[1];
                        $container.find(this.parentNode).remove();
                        //delete thisIsObject[key];
                        delete t.chartTool[chartN];
                        var index = t.chartTool.chartList.indexOf(chartN);
                        if (index !== -1) t.chartTool.chartList.splice(index, 1);

                    });

                    var GWidget = $container.find(".chart" + chartNumber);
                    var $ctx = $container.find("#myChart" + chartNumber);
                    var chartData = {};
                    var dataSetMultiDim = [];
                    dataSetMultiDim.data = {};
                    dataSetMultiDim.data.datasets = [];


                    chartData.dataScatter = [{
                            x: -10,
                            y: 0
                        },
                        {
                            x: 0,
                            y: 10
                        },
                        {
                            x: 30,
                            y: 5
                        },
                        {
                            x: 40,
                            y: 6
                        },
                        {
                            x: 23,
                            y: 10
                        },
                        {
                            x: 1,
                            y: 8
                        },
                    ];

                    if (typeof dataToChart != "undefined") {
                        chartData = feedChartData(dataToChart, graphType);
                        chartData.title = singleCellToValue(dataToChart.title);
                        $container.find(".titleOfChart").html("<span class='graphTitle'>" + chartData.title + " </span>");


                        chartData.bgColor = [
                            'rgba(255, 99, 132, 0.2)',
                            'rgba(54, 162, 235, 0.2)',
                            'rgba(255, 206, 86, 0.2)',
                            'rgba(75, 192, 192, 0.2)',
                            'rgba(153, 102, 255, 0.2)',
                            'rgba(255, 159, 64, 0.2)'
                        ];
                        chartData.bgColorLine = [
                            'rgba(255, 99, 132, 0)',
                            'rgba(54, 162, 235, 0)',
                            'rgba(255, 206, 86, 0)',
                            'rgba(75, 192, 192, 0)',
                            'rgba(153, 102, 255, 0)',
                            'rgba(255, 159, 64, 0)'
                        ];

                        chartData.borderColor = [
                            'rgba(255,99,132,1)',
                            'rgba(54, 162, 235, 1)',
                            'rgba(255, 206, 86, 1)',
                            'rgba(75, 192, 192, 1)',
                            'rgba(153, 102, 255, 1)',
                            'rgba(255, 159, 64, 1)'
                        ];
                        chartData.borderWidth = 1;



                        function feedChartData(dToChart, graphtype) {
                            var datatMDH = {},
                                dataMDV = {};
                            var serieLabel, serieLabelValue, serieDataValue, dataSetBiDim, dtSet, mdata = "";
                            var bgColor, lineColor;
                            var colorArea;
                            if (graphType == 'line') {
                                colorArea = 0;
                            } else {
                                colorArea = 0.2;
                            }

                            bgColor = [
                                'rgba(255, 99, 132, ' + colorArea + ')',
                                'rgba(54, 162, 235, ' + colorArea + ')',
                                'rgba(255, 206, 86, ' + colorArea + ')',
                                'rgba(75, 192, 192, ' + colorArea + ')',
                                'rgba(153, 102, 255, ' + colorArea + ')',
                                'rgba(235, 79, 132, ' + colorArea + ')',
                                'rgba(14, 162, 235, ' + colorArea + ')',
                                'rgba(155, 226, 86, ' + colorArea + ')',
                                'rgba(15, 188, 192, ' + colorArea + ')',
                                'rgba(123, 52, 255, ' + colorArea + ')',
                                'rgba(235, 200, 64, ' + colorArea + ')',
                                'rgba(155, 99, 132, ' + colorArea + ')',
                                'rgba(154, 162, 235, ' + colorArea + ')',
                                'rgba(155, 206, 86, ' + colorArea + ')',
                                'rgba(175, 192, 12, ' + colorArea + ')',
                                'rgba(53, 102, 25, ' + colorArea + ')',
                                'rgba(35, 79, 12, ' + colorArea + ')',
                                'rgba(24, 162, 25, ' + colorArea + ')',
                                'rgba(255, 266, 86, ' + colorArea + ')',
                                'rgba(215, 128, 192, ' + colorArea + ')',
                                'rgba(23, 152, 255, ' + colorArea + ')',
                                'rgba(35, 100, 64, ' + colorArea + ')'
                            ];

                            lineColor = [
                                'rgba(255, 99, 132, 1)',
                                'rgba(54, 162, 235, 1)',
                                'rgba(255, 206, 86, 1)',
                                'rgba(75, 192, 192, 1)',
                                'rgba(153, 102, 255, 1)',
                                'rgba(235, 79, 132, 1)',
                                'rgba(14, 162, 235, 1)',
                                'rgba(155, 226, 86, 1)',
                                'rgba(15, 188, 192, 1)',
                                'rgba(123, 52, 255, 1)',
                                'rgba(235, 200, 64, 1)',
                                'rgba(155, 99, 132, 1)',
                                'rgba(154, 162, 235, 1)',
                                'rgba(155, 206, 86, 1)',
                                'rgba(175, 192, 12, 1)',
                                'rgba(53, 102, 25, 1)',
                                'rgba(35, 79, 12, 1)',
                                'rgba(24, 162, 25, 1)',
                                'rgba(255, 266, 86, 1)',
                                'rgba(215, 128, 192, 1)',
                                'rgba(23, 152, 255, 1)',
                                'rgba(35, 100, 64, 1)'
                            ];
                            chData = {}
                            chData.data = [];

                            if (dToChart.dim == "2DH") {
                                chData.labels = coordsToValue(rangeToArray(dToChart.vLabels[0] + ':' + dToChart.vLabels[1]));
                                chData.data = coordsToValue(rangeToArray(dToChart.data[0] + ':' + dToChart.data[1]));
                                chData.legend = [singleCellToValue(dToChart.hLabels[0])];

                                dataSetBiDim = {
                                    labels: chData.labels,
                                    label: chData.legend,
                                    data: chData.data,
                                    backgroundColor: dToChart.bgColor,
                                    borderColor: dToChart.bgColor,
                                    borderWidth: dToChart.borderWidth,
                                    dataId: 'id',
                                    dim: '2D'
                                };

                                dtSet = dataSetBiDim;

                            } else if (dToChart.dim == "2DV") {
                                chData.labels = coordsToValue(rangeToArray(dToChart.hLabels[0] + ':' + dToChart.hLabels[1]));
                                chData.data = coordsToValue(rangeToArray(dToChart.data[0] + ':' + dToChart.data[1]));
                                chData.legend = [singleCellToValue(dToChart.vLabels[0])];

                                dataSetBiDim = {
                                    labels: chData.labels,
                                    label: chData.legend,
                                    data: chData.data,
                                    backgroundColor: dToChart.bgColor,
                                    borderColor: dToChart.bgColor,
                                    borderWidth: dToChart.borderWidth,
                                    dataId: 'id',
                                    dim: '2D'
                                };
                                dtSet = dataSetBiDim;

                            } else if (dToChart.dim == "MDH") {
                                //chData.labels = coordsToValue(rangeToArray(dToChart.vLabels[0] + ':' + dToChart.vLabels[1]));
                                // Les labels de série (legend) sont : Hlabels
                                // Les labels sont les Vlabels
                                // En fonction du nombre de séries je dois constituer un objet qui respecte la structure data de ShartJS
                                chData.labels = coordsToValue(rangeToArray(dToChart.vLabels[0] + ':' + dToChart.vLabels[1]));
                                serieLabel = rangeToArray(dToChart.hLabels[0] + ':' + dToChart.hLabels[1]);
                                serieLabelValue = coordsToValue(serieLabel);

                                for (let i = 0; i < serieLabel.length; i++) {
                                    serieDataValue = (coordsToValue(rangeToArray(dToChart.datasets.data[i][0])));
                                    dataMDH = {
                                        label: serieLabelValue[i],
                                        data: serieDataValue,
                                        backgroundColor: bgColor[i],
                                        borderColor: lineColor[i],
                                        borderWidth: 1
                                    }
                                    //Ici je génère le Json.
                                    //{label: 'Bar Dataset',data: [10, 20, 30, 40]}
                                    //Que j'ajoute au tableau datasets : dataSetMultiDim
                                    dataSetMultiDim.data.datasets.push(dataMDH);
                                }
                                dataSetMultiDim.labels = chData.labels;
                                dataSetMultiDim.dim = "MD"
                                dtSet = dataSetMultiDim;

                            } else if (dToChart.dim == "MDV") {
                                chData.labels = coordsToValue(rangeToArray(dToChart.hLabels[0] + ':' + dToChart.hLabels[1]));
                                serieLabel = rangeToArray(dToChart.vLabels[0] + ':' + dToChart.vLabels[1]);
                                serieLabelValue = coordsToValue(serieLabel);
                                

                                for (let i = 0; i < (serieLabel.length); i++) {
                                    serieDataValue = (coordsToValue(rangeToArray(dToChart.datasets.data[i][0])));
                                    dataMDV = {
                                        label: serieLabelValue[i],
                                        data: serieDataValue,
                                        backgroundColor: bgColor[i],
                                        borderColor: lineColor[i],
                                        borderWidth: 1
                                    }
                                    dataSetMultiDim.data.datasets.push(dataMDV);
                                }
                                dataSetMultiDim.labels = chData.labels;
                                dataSetMultiDim.dim = "MD"
                                dtSet = dataSetMultiDim;
                            }
                            return dtSet
                        }
                        chartCreator($ctx, graphType, chartData);

                        function chartCreator($ctx, graphType, cdata) {
                            var area = 0;
                            var dataLegend;
                            var dataSet;
                            if (graphType == "line") {
                                area = 0;
                            }

                            if (graphType == "area") {
                                graphType = "line";
                                area = 0.2;
                            } else if (graphType == "bar" || graphType == "scatter" || graphType == "pie" || graphType == "polarArea" || graphType == "doughnut") {
                                area = 0.2;
                            }

                            if (cdata.dim == "2D") {
                                dataSet = [{
                                    label: cdata.label,
                                    data: cdata.data,
                                    backgroundColor: [
                                        'rgba(255, 99, 132, ' + area + ')',
                                        'rgba(54, 162, 235, ' + area + ')',
                                        'rgba(255, 206, 86, ' + area + ')',
                                        'rgba(75, 192, 192, ' + area + ')',
                                        'rgba(153, 102, 255, ' + area + ')',
                                        'rgba(255, 159, 64, ' + area + ')'
                                    ],
                                    borderColor: cdata.borderColor,
                                    borderWidth: cdata.borderWidth,
                                    dataId: cdata.dataId
                                }];
                            } else {
                                dataSet = cdata.data.datasets;
                            }
                            var ctx = $ctx;
                            var lgMD;
                            var myChart = new Chart(ctx, {
                                type: graphType,
                                data: {
                                    labels: cdata.labels,
                                    datasets: dataSet,
                                    backgroundColor: [
                                        'rgba(255, 99, 132, ' + area + ')',
                                        'rgba(54, 162, 235, ' + area + ')',
                                        'rgba(255, 206, 86, ' + area + ')',
                                        'rgba(75, 192, 192, ' + area + ')',
                                        'rgba(153, 102, 255, ' + area + ')',
                                        'rgba(255, 159, 64, ' + area + ')'
                                    ],
                                    borderColor: cdata.borderColor,
                                    borderWidth: cdata.borderWidth
                                },
                                options: {
                                    scales: {
                                        yAxes: [{
                                            ticks: {
                                                beginAtZero: true
                                            }
                                        }]
                                    },
                                    animation: {
                                        onComplete: function () {
                                            $container.find(".chartCatcher").append("<div>" + myChart.toBase64Image() + "</div>");
                                        }
                                    }
                                }
                            });

                            if (graphType == "line" || graphType == "bar" || graphType == "pie" || graphType == "polarArea" || graphType == "doughnut") {
                                GWidget.find(".panelOf").html(
                                    "<div class='explic'>Write the range (example A1:A3) for labels and data or click in input field and select cells to choose label and data</div>" +
                                    "<table>" +
                                    "<tr class='etiquette'><td>" + lang.synt440 + "</td><td>" + lang.synt441 + "</td></tr>" +
                                    "<tr><td><input class='inputChartTitle CSinput' type='text' placeholder='A3' title='" + lang.synt432 + "'></td><td><input class='itemPanel data1 label CSinput' type='text' placeholder='Labels: A1:A5' title='"+lang.synt434+"' /></td></tr>" +
                                    "</table><br>" +
                                    "<table class='tblInput'><tr class='etiquette'><td class='smallWidth'>" + lang.synt438 + "</td><td class='smallWidth'>" + lang.synt439 + "</td><td class='smallWidth'>"+lang.synt60+"</td></tr>" +
                                    "<tr class='rSerie rSerie1'></td><td><input class='itemPanel data1 serie smallWidth CSinput' type='text' placeholder='B1:B5' title='"+ lang.synt436 +"'/></td><td><input placeholder='A4' title='"+ lang.synt435 +"' class='itemPanel legend1 legend smallWidth CSinput'></td><td><input class='CSinput itemPanel colorSerie1 colorSerie' style='width:10px!important' type='color' value='#e66465' title='"+ lang.synt437 +"'></td><td></td></tr>" +
                                    "</table><table class='tblCommand'>" +
                                    "<tr><td><button class='itemPanel draw btItemPanel CSinput'>"+lang.synt140+"</button>" +
                                    "</td><td><button class='itemPanel addData btItemPanel CSinput'>" + lang.synt141 + "</button></td></tr>" +
                                    "</table>");
                                $container.find(".inputChartTitle").val(dataToChart.title);
                                if (dataToChart.dim == "2DH") {
                                    $container.find(".label").val(dataToChart.vLabels[0] + ':' + dataToChart.vLabels[1]);
                                    $container.find(".legend1").val(dataToChart.hLabels[1]);
                                    $container.find(".serie").val(dataToChart.data[0] + ':' + dataToChart.data[1])
                                }
                                if (dataToChart.dim == "2DV") {
                                    $container.find(".label").val(dataToChart.hLabels[0] + ':' + dataToChart.hLabels[1]);
                                    $container.find(".legend1").val(dataToChart.vLabels[1]);
                                    $container.find(".serie").val(dataToChart.data[0] + ':' + dataToChart.data[1])
                                }
                                if (dataToChart.dim == "MDH") {
                                    $container.find(".label").val(dataToChart.vLabels[0] + ':' + dataToChart.vLabels[1]);
                                    $container.find(".legend1").val(dataToChart.hLabels[0]);
                                    $container.find(".serie").val(dataToChart.datasets.data[0]);
                                    lgMD = rangeToArray(dataToChart.hLabels[0] + ':' + dataToChart.hLabels[1]);
                                    
                                    serieN = 1
                                    for (let i = 1; i < dataToChart.datasets.data.length; i++) {
                                        addDataRow();
                                        
                                        $container.find(".legend" + (i + 1)).val(lgMD[i]);
                                        $container.find(".data" + (i + 1)).val([dataToChart.datasets.data[i]]);
                                    }
                                }
                                if (dataToChart.dim == "MDV") {
                                    $container.find(".label").val(dataToChart.hLabels[0] + ':' + dataToChart.hLabels[1]);
                                    $container.find(".legend1").val(dataToChart.vLabels[0]);
                                    $container.find(".serie").val(dataToChart.datasets.data[0]);
                                    lgMD = rangeToArray(dataToChart.vLabels[0] + ':' + dataToChart.vLabels[1]);
                                    
                                    serieN = 1
                                    for (let i = 1; i < dataToChart.datasets.data.length; i++) {
                                        addDataRow();
                                        
                                        $container.find(".legend" + (i + 1)).val(lgMD[i]);
                                        $container.find(".data" + (i + 1)).val([dataToChart.datasets.data[i]]);
                                    }

                                }

                                function rgb2hex(rgb) {
                                    rgb = rgb.match(/^rgba?[\s+]?\([\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?/i);
                                    return (rgb && rgb.length === 4) ? "#" +
                                        ("0" + parseInt(rgb[1], 10).toString(16)).slice(-2) +
                                        ("0" + parseInt(rgb[2], 10).toString(16)).slice(-2) +
                                        ("0" + parseInt(rgb[3], 10).toString(16)).slice(-2) : '';
                                }

                                function addDataRow() {
                                    serieN++
                                    var Nserie = 1;
                                    $container.find(".rSerie").each(function () {
                                        Nserie++
                                    })
                                    lineColor = [
                                        'rgba(255, 99, 132, 1)',
                                        'rgba(154,205,50,1)',
                                        'rgba(255, 206, 86, 1)',
                                        'rgba(75, 192, 192, 1)',
                                        'rgba(153, 102, 255, 1)',
                                        'rgba(235, 79, 132, 1)',
                                        'rgba(14, 162, 235, 1)',
                                        'rgba(155, 226, 86, 1)',
                                        'rgba(15, 188, 192, 1)',
                                        'rgba(123, 52, 255, 1)',
                                        'rgba(235, 200, 64, 1)',
                                        'rgba(155, 99, 132, 1)',
                                        'rgba(154, 162, 235, 1)',
                                        'rgba(155, 206, 86, 1)',
                                        'rgba(175, 192, 12, 1)',
                                        'rgba(53, 102, 25, 1)',
                                        'rgba(35, 79, 12, 1)',
                                        'rgba(24, 162, 25, 1)',
                                        'rgba(255, 266, 86, 1)',
                                        'rgba(215, 128, 192, 1)',
                                        'rgba(23, 152, 255, 1)',
                                        'rgba(35, 100, 64, 1)'
                                    ];
                                    GWidget.find(".tblInput").append("<tr class='rSerie rSerie" + Nserie + "'></td> <td><input class=' CSinput itemPanel newItemPanel serie data" + serieN + " smallWidth' type='text' placeholder='Data: B1:B5' title='Select a range of data from the spreadsheet'/></td> <td><input class='CSinput itemPanel legend" + serieN + " legend smallWidth' title='" + lang.synt435 + "'></td><td><input class='itemPanel colorSerie1 colorSerie' style='width:10px!important' type='color' title='" + lang.synt437 + "' value='" + rgb2hex(lineColor[serieN]) + "'></td><td> \u200C \u200C \u200C </td><td class='deleteRow' title='Delete Data'><img src='" + assetManager.resolve('EtherCalc/runtime/assets/sc_delete.png') + "' style='width:50% ;height:50%'></td></tr>");

                                    GWidget.find(".deleteRow").on('click', function () {
                                        let rowID = $container.find(this).parent().attr("class");
                                        for (let i = 0; i < myChart.data.datasets.length; i++) {
                                            if (myChart.data.datasets[i].dataId == rowID) {
                                                myChart.data.datasets.splice(i, 1);
                                                myChart.update();
                                                $container.find(this).parent().remove();
                                            } else {
                                                $container.find(this).parent().remove();
                                            }
                                        }
                                    });

                                    GWidget.find(".inputZone").find(".newItemPanel").on("focus", function () {
                                        $container.find(this).addClass("focus");
                                    });
                                    GWidget.find(".inputZone").find(".newItemPanel").on("focusout", function () {
                                        $container.find(this).removeClass("focus");
                                    });
                                    GWidget.find(".inputZone").find(".legend").on("focus", function () {
                                        $container.find(this).addClass("focusLegend");
                                    });
                                    GWidget.find(".inputZone").find(".legend").on("focusout", function () {
                                        $container.find(this).removeClass("focusLegend");
                                    });
                                    GWidget.find(".draw").off("click"); //Multi Graph Structure
                                    GWidget.find(".draw").prop("disabled", false);
                                    drawListener();
                                }


                                var serieN = 1
                                GWidget.find(".addData").on("click", function () {
                                    addDataRow();
                                });
                                /*  GWidget.find(".deleteRow").on('click', function () {
                                     $(this).parent().remove();
                                 }); 

                                GWidget.find(".ctitleBT").on("click", function () {

                                });*/

                                GWidget.find(".inputZone").find(".inputChartTitle").on("focus", function () {
                                    $container.find(this).addClass("focusTitle");
                                });
                                GWidget.find(".inputZone").find(".inputChartTitle").on("focusout", function () {
                                    $container.find(this).removeClass("focusTitle");
                                });

                                GWidget.find(".inputZone").find(".legend").on("focus", function () {
                                    $container.find(this).addClass("focusLegend");
                                });
                                GWidget.find(".inputZone").find(".legend").on("focusout", function () {
                                    $container.find(this).removeClass("focusLegend");
                                });

                                GWidget.find(".inputZone").find(".itemPanel").on("focus", function () {
                                    $container.find(this).addClass("focus");
                                });

                                GWidget.find(".inputZone").find(".itemPanel").on("focusout", function () {
                                    $container.find(this).removeClass("focus");
                                });

                            } //close line or area or bar

                            // Use for test 
                            if (graphType == 'scatter') {
                                // o.EditorScheduleSheetCommands("paste A1 all", !0, !1);

                            }



                            drawListener();

                            function randomColor() {
                                return "#" + ((1 << 24) * Math.random() | 0).toString(16);
                            }

                            function shadeColor(color, percent) {
                                var R = parseInt(color.substring(1, 3), 16);
                                var G = parseInt(color.substring(3, 5), 16);
                                var B = parseInt(color.substring(5, 7), 16);

                                R = parseInt(R * (100 + percent) / 100);
                                G = parseInt(G * (100 + percent) / 100);
                                B = parseInt(B * (100 + percent) / 100);

                                R = (R < 255) ? R : 255;
                                G = (G < 255) ? G : 255;
                                B = (B < 255) ? B : 255;

                                var RR = ((R.toString(16).length == 1) ? "0" + R.toString(16) : R.toString(16));
                                var GG = ((G.toString(16).length == 1) ? "0" + G.toString(16) : G.toString(16));
                                var BB = ((B.toString(16).length == 1) ? "0" + B.toString(16) : B.toString(16));

                                var hexaColor = "#" + RR + GG + BB;

                                var rgbaColor = hexToRgbA(hexaColor)

                                function hexToRgbA(hex) {
                                    var c;
                                    if (/^#([A-Fa-f0-9]{3}){1,2}$/.test(hex)) {
                                        c = hex.substring(1).split('');
                                        if (c.length == 3) {
                                            c = [c[0], c[0], c[1], c[1], c[2], c[2]];
                                        }
                                        c = '0x' + c.join('');
                                        return 'rgba(' + [(c >> 16) & 255, (c >> 8) & 255, c & 255].join(',') + ',' + area + ')';
                                    }
                                    throw new Error('Bad Hex');
                                }

                                return rgbaColor;
                            }




                            function drawListener() {

                                GWidget.find(".draw").on('click', function () {
                                    var etherData = [];
                                    //data
                                    GWidget.find(".rSerie").each(function (index) {
                                        etherData.push(itemPanelScanner(this));
                                    });

                                    GWidget.find(".graphTitle").html(singleCellToValue(GWidget.find(".inputChartTitle").val()));
                                    myChart.data.labels = coordsToValue(rangeToArray(GWidget.find(".label").val()));
                                    myChart.data.datasets = etherData;
                                    myChart.update();


                                    function itemPanelScanner(item) {
                                        var rowLabel, rowData, rowColor, dtRow = {};
                                        rowLabel = $container.find(item).find('.legend').val();
                                        rowData = $container.find(item).find('.serie').val();
                                        rowColor = $container.find(item).find('.colorSerie').val();
                                        dtRow.label = singleCellToValue(rowLabel)[0];
                                        if (graphType == 'line') {
                                            dtRow.fill = 'false'
                                        };
                                        dtRow.data = coordsToValue(rangeToArray(rowData));
                                        dtRow.backgroundColor = shadeColor(rowColor, 40);
                                        dtRow.borderColor = rowColor;
                                        dtRow.borderWidth = 1;
                                        if (graphType == 'pie') {
                                            dtRow.backgroundColor = [
                                                shadeColor(rowColor, 100),
                                                shadeColor('#e6194b', 100),
                                                shadeColor('#3cb44b', 100),
                                                shadeColor('#ffe119', 100),
                                                shadeColor('#4363d8', 100),
                                                shadeColor('#f58231', 100),
                                                shadeColor('#911eb4', 100),
                                                shadeColor('#46f0f0', 100),
                                                shadeColor('#f032e6', 100),
                                                shadeColor('#bcf60c', 100),
                                                shadeColor('#fabebe', 100),
                                                shadeColor('#008080', 100),
                                                shadeColor('#e6beff', 100),
                                                shadeColor('#9a6324', 100),
                                                shadeColor('#fffac8', 100),
                                                shadeColor('#800000', 100),
                                                shadeColor('#aaffc3', 100),
                                                shadeColor('#808000', 100),
                                                shadeColor('#ffd8b1', 100),
                                                shadeColor('#000075', 100),
                                                shadeColor('#808080', 100),
                                                shadeColor('#ffffff', 100),
                                                shadeColor('#000000', 100)
                                            ];
                                            dtRow.borderColor = "gainsboro";
                                            dtRow.borderWidth = 2;
                                        };
                                        return dtRow;
                                    }
                                });
                            } //close draw listener


                            function removeData(chart) {
                                myChart.data.labels.pop();
                                myChart.data.datasets.forEach((dataset) => {
                                    dataset.data.pop();
                                });
                                myChart.update();
                            }

                        }

                        function coordsToValue(cellRang) {
                            var cellValueAr = [];
                            if(typeof cellRang !="undefined"){
                            for (let i = 0; i < cellRang.length; i++) {
                                cellValueAr.push($container.find("#cell_" + cellRang[i]).html());
                            }}
                            return cellValueAr
                        }

                        function singleCellToValue(cell) {
                            var cellValueAr = [];
                            cellValueAr.push($container.find("#cell_" + cell).html());
                            return cellValueAr;
                        }

                        function rangeToArray(cellRange) {
                            if(!cellRange.includes("NaN")){
                            var arrValue = [];
                            var cellRange = cellRange.split(":")
                            var firstCell = cellRange[0];
                            var lastCell = cellRange[1];
                            var firstCellRow = firstCell.match(/\d+/g).map(Number);
                            var firstCellCol = firstCell.replace(firstCellRow, "");
                            var lastCellRow = lastCell.match(/\d+/g).map(Number);;
                            var lastCellCol = lastCell.replace(lastCellRow, "");

                            if (firstCellRow[0] == lastCellRow[0]) {
                                if (letterOrder(firstCellCol) > letterOrder(lastCellCol)) {
                                    arrValue = to_a(lastCellCol, firstCellCol);
                                } else {
                                    arrValue = to_a(firstCellCol, lastCellCol);
                                }

                                for (let i = 0; i < arrValue.length; i++) {
                                    arrValue[i] = arrValue[i] + firstCellRow[0];
                                }
                            } else if (firstCellCol[0] == lastCellCol[0]) {

                                if (firstCellRow[0] > lastCellRow[0]) {
                                    let y = 0;
                                    for (let i = lastCellRow[0]; i < (firstCellRow[0] + 1); i++) {
                                        arrValue.push(firstCellCol[0] + (lastCellRow[0] + y));
                                        y++;
                                    }
                                } else {
                                    let y = 0;
                                    for (let i = firstCellRow[0]; i < (lastCellRow[0] + 1); i++) {
                                        arrValue.push(firstCellCol[0] + (firstCellRow[0] + y));
                                        y++;
                                    }
                                }


                            } else {
                                alert(lang.synt433)
                                return
                            }
                          
                            return arrValue;
                        }

                            function to_a(c1, c2) { //Borns to list of interval
                                let alphab = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.split('');
                                return (alphab.slice(alphab.indexOf(c1), alphab.indexOf(c2) + 1));
                            }

                            function letterOrder(c1) {
                                alphab = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.split('');
                                return alphab.indexOf(c1);
                            }
                        }
                    } else {
                        alert("No cells selected, to create a graph, select a range of labels and data.")
                    }

                }); //CLOSE SHART TRIGGER



                $container.find("#SocialCalc-formtab").hide();
                $container.find("#SocialCalc-graphtab").hide();


                // JP modification : add click possible on tabs. 

                $container.find("#tableeditor > div:nth-child(1) > div:nth-child(2)").prepend('<div style="display:inline;margin-right:10px; width:70px" class="statusTop"></div>');
                $container.find('#SocialCalc-edittab').on("click", function () {
                    t.SetTab(this)
                });
                $container.find('#SocialCalc-settingstab').on("click", function () {
                    t.SetTab(this);
                    $container.find(".xboxBorder").on("click", function () {
                        t.SettingsControlOnchangeBorder(this)
                    });
                    /* $(".colorBorder").on("click", function () {
                        let nameo = $(this).attr("name");
                        t.Popup.Types.ColorChooser.ControlClicked(nameo);
                        //close Palette
                        $(".closePalette").on("click",function(){t.Popup.Cancel();});

                    }); */
                    $container.find("#SocialCalc-cfontfamily input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-cfontfamily input").on("click", function () {
                        t.Popup.CClick('SocialCalc-cfontfamily');
                        for (let i = 0; i < 7; i++) { //item number non dynamic -> fix to 56
                            $container.find(".SocialCalc-cfontfamily_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-cfontfamily_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-cfontfamily', this);
                            });
                            $container.find(".SocialCalc-cfontfamily_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-cfontfamily_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-cfontfamily', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-cfontlook input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-cfontlook input").on("click", function () {
                        t.Popup.CClick('SocialCalc-cfontlook');
                        for (let i = 0; i < 7; i++) { //item number non dynamic -> fix to 56
                            $container.find(".SocialCalc-cfontlook_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-cfontlook_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-cfontlook', this);
                            });
                            $container.find(".SocialCalc-cfontlook_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-cfontlook_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-cfontlook', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-cfontsize input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-cfontsize input").on("click", function () {
                        t.Popup.CClick('SocialCalc-cfontsize');
                        for (let i = 0; i < 44; i++) { //item number non dynamic -> fix to 56
                            $container.find(".SocialCalc-cfontsize_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-cfontsize_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-cfontsize', this);
                            });
                            $container.find(".SocialCalc-cfontsize_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-cfontsize_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-cfontsize', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-calignhoriz input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-calignhoriz input").on("click", function () {
                        t.Popup.CClick('SocialCalc-calignhoriz');
                        for (let i = 0; i < 6; i++) { //item number non dynamic -> fix to 56
                            $container.find(".SocialCalc-calignhoriz_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-calignhoriz_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-calignhoriz', this);
                            });
                            $container.find(".SocialCalc-calignhoriz_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-calignhoriz_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-calignhoriz', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-calignvert input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-calignvert input").on("click", function () {
                        t.Popup.CClick('SocialCalc-calignvert');
                        for (let i = 0; i < 6; i++) { //item number non dynamic -> fix to 56
                            $container.find(".SocialCalc-calignvert_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-calignvert_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-calignvert', this);
                            });
                            $container.find(".SocialCalc-calignvert_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-calignvert_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-calignvert', i);
                            });
                        }
                    });

                    $container.find("#SocialCalc-cformatnumber input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-cformatnumber input").on("click", function () {
                        t.Popup.CClick('SocialCalc-cformatnumber');
                        for (let i = 0; i < 56; i++) { //item number non dynamic -> fix to 56
                            $container.find(".SocialCalc-cformatnumber_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-cformatnumber_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-cformatnumber', this);
                            });
                            $container.find(".SocialCalc-cformatnumber_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-cformatnumber_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-cformatnumber', i);
                            });
                        }
                    });

                    $container.find("#SocialCalc-cformattext input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-cformattext input").on("click", function () {
                        t.Popup.CClick('SocialCalc-cformattext');
                        for (let i = 0; i < 12; i++) { //item number non dynamic -> fix to 12
                            $container.find(".SocialCalc-cformattext_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-cformattext_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-cformattext', this);
                            });
                            $container.find(".SocialCalc-cformattext_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-cformattext_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-cformattext', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-cpadtop input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-cpadtop input").on("click", function () {
                        t.Popup.CClick('SocialCalc-cpadtop');
                        for (let i = 0; i < 29; i++) { //item number non dynamic -> fix to 29
                            $container.find(".SocialCalc-cpadtop_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-cpadtop_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-cpadtop', this);
                            });
                            $container.find(".SocialCalc-cpadtop_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-cpadtop_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-cpadtop', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-cpadright input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-cpadright input").on("click", function () {
                        t.Popup.CClick('SocialCalc-cpadright');
                        for (let i = 0; i < 29; i++) { //item number non dynamic -> fix to 29
                            $container.find(".SocialCalc-cpadright_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-cpadright_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-cpadright', this);
                            });
                            $container.find(".SocialCalc-cpadright_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-cpadright_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-cpadright', i);
                            });
                        }
                    });

                    $container.find("#SocialCalc-cpadbottom input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-cpadbottom input").on("click", function () {
                        t.Popup.CClick('SocialCalc-cpadbottom');
                        for (let i = 0; i < 29; i++) { //item number non dynamic -> fix to 29
                            $container.find(".SocialCalc-cpadbottom_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-cpadbottom_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-cpadbottom', this);
                            });
                            $container.find(".SocialCalc-cpadbottom_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-cpadbottom_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-cpadbottom', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-cpadleft input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-cpadleft input").on("click", function () {
                        t.Popup.CClick('SocialCalc-cpadleft');
                        for (let i = 0; i < 29; i++) { //item number non dynamic -> fix to 29
                            $container.find(".SocialCalc-cpadleft_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-cpadleft_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-cpadleft', this);
                            });
                            $container.find(".SocialCalc-cpadleft_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-cpadleft_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-cpadleft', i);
                            });
                        }
                    });
                    // For the sheet

                    $container.find("#SocialCalc-settings-savesheet").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-settings-savesheet").on("click", function () {
                        t.SettingsControlSave('sheet');
                    });
                    $container.find(".cancelSheetMod").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-settings-savesheet").on("click", function () {
                        t.SettingsControlSave('cancel');
                    });

                    $container.find("#SocialCalc-fontfamily input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-fontfamily input").on("click", function () {
                        t.Popup.CClick('SocialCalc-fontfamily');
                        for (let i = 0; i < 7; i++) { //item number non dynamic -> fix to 56
                            $container.find(".SocialCalc-fontfamily_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-fontfamily_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-fontfamily', this);
                            });
                            $container.find(".SocialCalc-fontfamily_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-fontfamily_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-fontfamily', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-fontlook input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-fontlook input").on("click", function () {
                        t.Popup.CClick('SocialCalc-fontlook');
                        for (let i = 0; i < 7; i++) { //item number non dynamic -> fix to 56
                            $container.find(".SocialCalc-fontlook_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-fontlook_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-fontlook', this);
                            });
                            $container.find(".SocialCalc-fontlook_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-fontlook_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-fontlook', i);
                            });
                        }

                    });
                    $container.find("#SocialCalc-fontsize input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-fontsize input").on("click", function () {
                        t.Popup.CClick('SocialCalc-fontsize');
                        for (let i = 0; i < 44; i++) { //item number non dynamic -> fix to 56
                            $container.find(".SocialCalc-fontsize_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-fontsize_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-fontsize', this);
                            });
                            $container.find(".SocialCalc-fontsize_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-fontsize_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-fontsize', i);
                            });
                        }

                    });
                    $container.find("#SocialCalc-textalignhoriz input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-textalignhoriz input").on("click", function () {
                        t.Popup.CClick('SocialCalc-textalignhoriz');
                        for (let i = 0; i < 6; i++) { //item number non dynamic -> fix to 56
                            $container.find(".SocialCalc-textalignhoriz_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-textalignhoriz_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-textalignhoriz', this);
                            });
                            $container.find(".SocialCalc-textalignhoriz_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-textalignhoriz_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-textalignhoriz', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-numberalignhoriz input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-numberalignhoriz input").on("click", function () {
                        t.Popup.CClick('SocialCalc-numberalignhoriz');
                        for (let i = 0; i < 6; i++) { //item number non dynamic -> fix to 6
                            $container.find(".SocialCalc-numberalignhoriz_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-numberalignhoriz_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-numberalignhoriz', this);
                            });
                            $container.find(".SocialCalc-numberalignhoriz_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-numberalignhoriz_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-numberalignhoriz', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-alignvert input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-alignvert input").on("click", function () {
                        t.Popup.CClick('SocialCalc-alignvert');
                        for (let i = 0; i < 6; i++) { //item number non dynamic -> fix to 6
                            $container.find(".SocialCalc-alignvert_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-alignvert_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-alignvert', this);
                            });
                            $container.find(".SocialCalc-alignvert_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-alignvert_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-alignvert', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-formatnumber input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-formatnumber input").on("click", function () {
                        t.Popup.CClick('SocialCalc-formatnumber');
                        for (let i = 0; i < 56; i++) { //item number non dynamic -> fix to 56
                            $container.find(".SocialCalc-formatnumber_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-formatnumber_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-formatnumber', this);
                            });
                            $container.find(".SocialCalc-formatnumber_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-formatnumber_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-formatnumber', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-formattext input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-formattext input").on("click", function () {
                        t.Popup.CClick('SocialCalc-formattext');
                        for (let i = 0; i < 12; i++) { //item number non dynamic -> fix to 12
                            $container.find(".SocialCalc-formattext_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-formattext_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-formattext', this);
                            });
                            $container.find(".SocialCalc-formattext_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-formattext_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-formattext', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-padtop input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-padtop input").on("click", function () {
                        t.Popup.CClick('SocialCalc-padtop');
                        for (let i = 0; i < 29; i++) { //item number non dynamic -> fix to 12
                            $container.find(".SocialCalc-padtop_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-padtop_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-padtop', this);
                            });
                            $container.find(".SocialCalc-padtop_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-padtop_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-padtop', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-padright input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-padright input").on("click", function () {
                        t.Popup.CClick('SocialCalc-padright');
                        for (let i = 0; i < 29; i++) { //item number non dynamic -> fix to 12
                            $container.find(".SocialCalc-padright_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-padright_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-padright', this);
                            });
                            $container.find(".SocialCalc-padright_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-padright_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-padright', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-padbottom input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-padbottom input").on("click", function () {
                        t.Popup.CClick('SocialCalc-padbottom');
                        for (let i = 0; i < 29; i++) { //item number non dynamic -> fix to 12
                            $container.find(".SocialCalc-padbottom_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-padbottom_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-padbottom', this);
                            });
                            $container.find(".SocialCalc-padbottom_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-padbottom_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-padbottom', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-padleft input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-padleft input").on("click", function () {
                        t.Popup.CClick('SocialCalc-padleft');
                        for (let i = 0; i < 29; i++) { //item number non dynamic -> fix to 12
                            $container.find(".SocialCalc-padleft_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-padleft_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-padleft', this);
                            });
                            $container.find(".SocialCalc-padleft_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-padleft_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-padleft', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-colwidth input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-colwidth input").on("click", function () {
                        t.Popup.CClick('SocialCalc-colwidth');
                        for (let i = 0; i < 21; i++) { //item number non dynamic -> fix to 21
                            $container.find(".SocialCalc-colwidth_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-colwidth_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-colwidth', this);
                            });
                            $container.find(".SocialCalc-colwidth_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-colwidth_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-colwidth', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-recalc input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-recalc input").on("click", function () {
                        t.Popup.CClick('SocialCalc-recalc');
                        for (let i = 0; i < 4; i++) { //item number non dynamic -> fix to 4
                            $container.find(".SocialCalc-recalc_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-recalc_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-recalc', this);
                            });
                            $container.find(".SocialCalc-recalc_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-recalc_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-recalc', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-usermaxcol input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-usermaxcol input").on("click", function () {
                        t.Popup.CClick('SocialCalc-usermaxcol');
                        for (let i = 0; i < 14; i++) { //item number non dynamic -> fix to 14
                            $container.find(".SocialCalc-usermaxcol_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-usermaxcol_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-usermaxcol', this);
                            });
                            $container.find(".SocialCalc-usermaxcol_" + i).prop("onclick", null).off("click");
                            $container.find(".SocialCalc-usermaxcol_" + i).on("click", function () {
                                t.Popup.Types.List.ItemClicked('SocialCalc-usermaxcol', i);
                            });
                        }
                    });
                    $container.find("#SocialCalc-usermaxrow input").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-usermaxrow input").on("click", function () {
                        t.Popup.CClick('SocialCalc-usermaxrow');
                        for (let i = 0; i < 14; i++) { //item number non dynamic -> fix to 14
                            $container.find(".SocialCalc-usermaxrow_" + i).prop("onmousemove", null).off("mousemove");
                            $container.find(".SocialCalc-usermaxrow_" + i).on("mousemove", function () {
                                t.Popup.Types.List.MouseMove('SocialCalc-usermaxrow', this);
                            });

                        }
                    });

                });
                $container.find('#SocialCalc-sorttab').on("click", function () {
                    t.SetTab(this);
                    $container.find("#SocialCalc-sortlist").prop("onfocus", null).off("focus");
                    $container.find("#SocialCalc-sortlist").on("focus", function () {
                        t.CmdGotFocus(this);
                    });
                    $container.find("#SocialCalc-majorsort").prop("onfocus", null).off("focus");
                    $container.find("#SocialCalc-majorsort").on("focus", function () {
                        t.CmdGotFocus(this);
                    });
                    $container.find("#SocialCalc-minorsort").prop("onfocus", null).off("focus");
                    $container.find("#SocialCalc-minorsort").on("focus", function () {
                        t.CmdGotFocus(this);
                    });
                    $container.find("#SocialCalc-lastsort").prop("onfocus", null).off("focus");
                    $container.find("#SocialCalc-lastsort").on("focus", function () {
                        t.CmdGotFocus(this);
                    });

                    $container.find(".doCmdSort").prop("onclick", null).off("click");
                    $container.find(".doCmdSort").on("click", function () {
                        t.DoCmd(this, 'ok-setsort');
                        $container.find("#SocialCalc-sortbutton").prop("onclick", null).off("click");
                        $container.find("#SocialCalc-sortbutton").on("click", function () {
                            t.DoCmd(this, 'dosort');
                        });
                    });
                    $container.find("#SocialCalc-namesrangeproposal").prop("onclick", null).off("click");
                    $container.find("#SocialCalc-namesrangeproposal").on("click", function () {
                        t.SpreadsheetControlNamesSetValue();
                    });

                });
                $container.find('#SocialCalc-audittab').on("click", function () {
                    t.SetTab(this)
                });
                $container.find('#SocialCalc-commenttab').on("click", function () {
                    t.SetTab(this);

                    $container.find("#SocialCalc-commenttext").prop("onfocus", null).off("focus");
                    $container.find("#SocialCalc-commenttext").on("focus", function () {
                        t.CmdGotFocus(this);
                    });
                    $container.find(".commentButton").on("click", function () {
                        t.SpreadsheetControlCommentSet();
                    });
                });
                $container.find('#SocialCalc-namestab').on("click", function () {
                    t.SetTab(this);
                    $container.find("#SocialCalc-nameslist").prop("onfocus", null).off("focus");
                    $container.find("#SocialCalc-nameslist").on("focus", function () {
                        t.CmdGotFocus(this);
                    });
                    $container.find("#SocialCalc-nameslist").prop("onchange", null).off("change");
                    $container.find("#SocialCalc-nameslist").on("change", function () {
                        t.SpreadsheetControlNamesChangedName();
                    });
                    $container.find("#SocialCalc-namesname").prop("onfocus", null).off("focus");
                    $container.find("#SocialCalc-namesname").on("focus", function () {
                        t.CmdGotFocus(this);
                    });
                    $container.find("#SocialCalc-namesdesc").prop("onfocus", null).off("focus");
                    $container.find("#SocialCalc-namesdesc").on("focus", function () {
                        t.CmdGotFocus(this);
                    });
                    $container.find("#SocialCalc-namesvalue").prop("onfocus", null).off("focus");
                    $container.find("#SocialCalc-namesvalue").on("focus", function () {
                        t.CmdGotFocus(this);
                    });
                    $container.find("#SocialCalc-namesrangeproposal").on("click", function () {
                        t.SpreadsheetControlNamesSetValue();
                    });
                    $container.find(".nameSaver").prop("onclick", null).off("click");
                    $container.find(".nameSaver").on("click", function () {
                        t.SpreadsheetControlNamesSave()
                    });
                    $container.find(".deleteName").prop("onclick", null).off("click");
                    $container.find(".deleteName").on("click", function () {
                        t.SpreadsheetControlNamesDelete();
                    });
                });

                $container.find('#SocialCalc-clipboardtab').on("click", function () {
                    t.SetTab(this)
                    $container.find("#SocialCalc-clipboardtext").prop("onfocus", null).off("focus");
                    $container.find("#SocialCalc-clipboardtext").on("focus", function () {
                        t.CmdGotFocus(this);
                    });
                    $container.find(".fillValues").on("click", function () {
                        t.SpreadsheetControlClipboardLoad();
                    });

                });

                $container.find(".cancelBT2").on("click", function () {
                    t.SettingsControlSave('cancel');
                });
                $container.find(".switchSheet").on("click", function () {
                    t.SpreadsheetControlSettingsSwitch('sheet');
                    return false;
                });
                $container.find(".saveToCell").on("click", function () {
                    t.SettingsControlSave('cell')
                });
                $container.find(".showCellSettings").on("click", function () {
                    t.SpreadsheetControlSettingsSwitch('cell');
                    return false;
                });
                $container.find(".xboxBorder").on("click", function () {
                    t.SettingsControlOnchangeBorder(this)
                });

                var y = $("<input id='searchbarinput' value='' placeholder='" + lang.synt42 + "'>"),
                    C = $("<span id='searchbar'></span>");
                C.append("<div id='searchstatus'></div>"), C.append(y);
                for (h in e.findbuttons) p = document.createElement("img"), p.id = e.idPrefix + h,
                    //p.src = e.imagePrefix + e.findbuttons[h].image, 
                    p.src = assetManager.resolve("EtherCalc/runtime/assets/sc_" + e.findbuttons[h].image),
                    p.style.verticalAlign = "middle",
                    p.style.border = "1px solid #FFF", p.title = m(e.findbuttons[h].tooltip), t.ButtonRegister(e.editor, p, {
                        normalstyle: "border:1px solid #FFF;backgroundColor:#FFF;",
                        hoverstyle: "border:1px solid #CCC;backgroundColor:#FFF;",
                        downstyle: "border:1px solid #000;backgroundColor:#FFF;"
                    }, {
                        MouseDown: e.findbuttons[h].command,
                        Disabled: function () {
                            return !1;
                        }
                    }), C[0].appendChild(p);
                for (y.on("input", t.SpreadsheetControl.FindInSheet), y.on("focus", function () {
                        t.Keyboard.passThru = !0;
                    }), y.on("blur", function () {
                        t.Keyboard.passThru = !1;
                    }), y.keyup(function (e) {
                        13 == e.keyCode && (e.shiftKey ? t.SpreadsheetControl.SearchUp() : t.SpreadsheetControl.SearchDown());
                    }), e.formulabarDiv.appendChild(C[0]), l = 0; l < v.length; l++) v[l].oncreate && v[l].oncreate(e, v[l].name);
                t.CalculateSheetNonViewHeight(e), e.viewheight = e.height - e.nonviewheight, e.editorDiv = e.editor.CreateTableEditor(e.width, e.viewheight);
                var w = document.createElement("div");
                w.id = "te_appView", w.appendChild(e.editorDiv), e.editorDiv = w;
                var x = document.createElement("div");
                x.id = "te_formData", x.style.display = "none", e.editorDiv.appendChild(x), e.spreadsheetDiv.appendChild(e.editorDiv),
                    e.formDataViewer = new t.SpreadsheetViewer("te_FormData-"), e.formDataViewer.InitializeSpreadsheetViewer(x.id, 180, 0, 200),
                    e.formDataViewer.editor.ignoreRender = !0;
                for (c in b) {
                    a = b[c].html;
                    for (d in b[c].replacements) a = a.replace(b[c].replacements[d].regex, b[c].replacements[d].replacement);
                    a = a.replace(/\%s\./g, "SocialCalc."), a = a.replace(/\%id\./g, e.idPrefix), a = a.replace(/\%tbt\./g, e.toolbartext),
                        a = a.replace(/\%img\./g, e.imagePrefix), u = document.createElement("div"), t.setStyles(u, b[c].divStyle),
                        u.style.display = "none", u.style.width = e.width + "px", u.style.height = e.viewheight + "px",
                        u.id = e.idPrefix + b[c].name + "view", a = g(a), u.innerHTML = a, e.spreadsheetDiv.appendChild(u),
                        b[c].element = u, b[c].oncreate && b[c].oncreate(e, b[c]);
                }
                if (b.sheet = {
                        name: "sheet",
                        element: e.editorDiv
                    }, e.statuslineDiv = document.createElement("div"), e.statuslineDiv.style.cssText = e.statuslineCSS,
                    e.statuslineDiv.style.height = e.statuslineheight - (e.statuslineDiv.style.paddingTop.slice(0, -2) - 0) - (e.statuslineDiv.style.paddingBottom.slice(0, -2) - 0) + "px",
                    e.statuslineDiv.id = e.idPrefix + "statusline", e.spreadsheetDiv.appendChild(e.statuslineDiv),
                    e.spreadsheetDiv.addEventListener) e.spreadsheetDiv.addEventListener("mousedown", function () {
                    t.SetSpreadsheetControlObject(e);
                }, !1), e.spreadsheetDiv.addEventListener("mouseover", function () {
                    t.SetSpreadsheetControlObject(e);
                }, !1);
                else {
                    if (!e.spreadsheetDiv.attachEvent) throw t.Constants.s_BrowserNotSupported;
                    e.spreadsheetDiv.attachEvent("onmousedown", function () {
                        t.SetSpreadsheetControlObject(e);
                    }), e.spreadsheetDiv.attachEvent("onmouseover", function () {
                        t.SetSpreadsheetControlObject(e);
                    });
                }
            }, t.CalculateSheetNonViewHeight = function (e) {
                e.nonviewheight = e.statuslineheight;
                for (var t = 0; t < e.spreadsheetDiv.childNodes.length; t++) "SocialCalc-statusline" != e.spreadsheetDiv.childNodes[t].id && (e.nonviewheight += e.spreadsheetDiv.childNodes[t].offsetHeight);
            }, t.LocalizeString = function (e) {
                var o = t.LocalizeStringList[e];
                return o || (o = t.Constants["s_loc_" + e.toLowerCase().replace(/\s/g, "_").replace(/\W/g, "X")] || e,
                    t.LocalizeStringList[e] = o), o;
            }, t.LocalizeStringList = {}, t.LocalizeSubstrings = function (e) {
                var o = t.LocalizeString;
                return e.replace(/%(loc|ssc)!(.*?)!/g, function (e, i, n) {
                    return "ssc" == i ? t.Constants[n] || alert("Missing constant: " + n) : o(n);
                });
            }, t.GetSpreadsheetControlObject = function () {
                var e = null != t.CurrentSpreadsheetControlObject ? t.CurrentSpreadsheetControlObject : t.CurrentSpreadsheetViewerObject;
                return e ? e : void 0;
            }, t.SetSpreadsheetControlObject = function (e) {
                t.CurrentSpreadsheetControlObject = e, t.Keyboard.focusTable && e && (t.Keyboard.focusTable = e.editor);
            }, t.DoOnResize = function (e) {
                
                var t, o = e.views,
                    i = e.SizeSSDiv();
                if (i) {
                    for (vname in o) t = o[vname].element, t.style.width = e.width + "px", t.style.height = e.height - e.nonviewheight + "px";
                    e.editor.ResizeTableEditor(e.width, e.height - e.nonviewheight);
                }
            }, t.SizeSSDiv = function (e) {
                var o, i, n, r, a, s = 10,
                    l = 10;
                return n = !1, o = t.GetViewportInfo(), i = t.GetElementPosition(e.parentNode),
                    i.bottom = 0, i.right = 0, r = e.parentNode.style, r.marginTop && (i.top += r.marginTop.slice(0, -2) - 0),
                    r.marginBottom && (i.bottom += r.marginBottom.slice(0, -2) - 0), r.marginLeft && (i.left += r.marginLeft.slice(0, -2) - 0),
                    r.marginRight && (i.right += r.marginRight.slice(0, -2) - 0), a = e.requestedHeight || o.height - (i.top + i.bottom + l) - (e.requestedSpaceBelow || 0),
                    e.height != a && (e.height = a, e.spreadsheetDiv.style.height = a + "px", n = !0),
                    a = e.requestedWidth || o.width - (i.left + i.right + s) || 700, e.width != a && (e.width = a,
                        e.spreadsheetDiv.style.width = a + "px", n = !0), e.spreadsheetDiv.style.position = "relative",
                    n;
            }, t.SetTab = function (e) {
                
                var o, i, n, r, a, s, l, c = {},
                    u = {},
                    d = t.GetSpreadsheetControlObject(),
                    h = d.tabs,
                    p = d.views;
                if (o = "string" == typeof e ? e : e.id.slice(d.idPrefix.length, -3), d.editor.busy && (!h[d.currentTab].view || "sheet" == h[d.currentTab].view))
                    for (a = 0; a < h.length; a++)
                        if (h[a].name == o && h[a].view && "sheet" != h[a].view) return;
                for (d.tabs[d.currentTab].onunclick && d.tabs[d.currentTab].onunclick(d, d.tabs[d.currentTab].name),
                    a = 0; a < h.length; a++) i = h[a].name, c[i] = document.getElementById(d.idPrefix + i + "tab"),
                    u[i] = document.getElementById(d.idPrefix + i + "tools"), i == o ? (n = a, u[i].style.display = "block",
                        c[i].style.cssText = d.tabselectedCSS) : (u[i].style.display = "none", c[i].style.cssText = d.tabplainCSS);
                d.currentTab = n, h[n].onclick && h[n].onclick(d, o);
                for (s in p) !h[n].view && "sheet" == s || h[n].view == s ? (p[s].element.style.display = "block",
                    r = s) : p[s].element.style.display = "none";
                h[n].onclickFocus ? (l = h[n].onclickFocus, "string" == typeof l && (l = document.getElementById(d.idPrefix + l),
                    l.focus()), t.CmdGotFocus(l)) : t.KeyboardFocus(), p[r].needsresize && p[r].onresize && (p[r].needsresize = !1,
                    p[r].onresize(d, p[r])), "sheet" == r ? (d.statuslineDiv.style.display = "block",
                    d.editor.ScheduleRender()) : d.statuslineDiv.style.display = "none";
            }, t.SpreadsheetControlStatuslineCallback = function (e, t, o, i) {
                var n, r, a = document.getElementById(i.statuslineid);
                
                $container.find(".statusTop").html(lang.synt8 + ": " + e.GetStatuslineString(t, o, i));

                switch (a && (a.innerHTML = e.GetStatuslineString(t, o, i)), t) {
                    case "cmdendnorender":
                    case "calcfinished":
                    case "doneposcalc":
                        if (n = document.getElementById(i.recalcid1), r = document.getElementById(i.recalcid2),
                            !n || !r) break;
                        "yes" == e.context.sheetobj.attribs.needsrecalc ? (n.style.display = "inline", r.style.display = "inline") : (n.style.display = "none",
                            r.style.display = "none");

                }
            }, t.UpdateSortRangeProposal = function (e) {
                var o = document.getElementById(t.GetSpreadsheetControlObject().idPrefix + "sortlist");
                o.options[0].text = e.range.hasrange ? t.crToCoord(e.range.left, e.range.top) + ":" + t.crToCoord(e.range.right, e.range.bottom) : t.LocalizeString("[select range]");
            }, t.LoadColumnChoosers = function (e) {
                var o, i, n, r, a, s, l, c = t.LocalizeString;
                e.sortrange && -1 == e.sortrange.indexOf(":") ? (i = t.Formula.LookupName(e.sheet, e.sortrange || ""),
                    "range" == i.type ? (n = i.value.match(/^(.*)\|(.*)\|$/), o = n[1] + ":" + n[2]) : o = "A1:A1") : o = e.sortrange;
                var u = t.ParseRange(o);
                s = document.getElementById(e.idPrefix + "majorsort"), l = s.selectedIndex, s.options.length = 0,
                    s.options[s.options.length] = new Option(c("[None]"), "");
                for (var r = u.cr1.col; r <= u.cr2.col; r++) a = t.rcColname(r), s.options[s.options.length] = new Option(c("Column ") + a, a);
                s.selectedIndex = l > 1 && l <= u.cr2.col - u.cr1.col + 1 ? l : 1, s = document.getElementById(e.idPrefix + "minorsort"),
                    l = s.selectedIndex, s.options.length = 0, s.options[s.options.length] = new Option(c("[None]"), "");
                for (var r = u.cr1.col; r <= u.cr2.col; r++) a = t.rcColname(r), s.options[s.options.length] = new Option(a, a);
                s.selectedIndex = l > 0 && l <= u.cr2.col - u.cr1.col + 1 ? l : 0, s = document.getElementById(e.idPrefix + "lastsort"),
                    l = s.selectedIndex, s.options.length = 0, s.options[s.options.length] = new Option(c("[None]"), "");
                for (var r = u.cr1.col; r <= u.cr2.col; r++) a = t.rcColname(r), s.options[s.options.length] = new Option(a, a);
                s.selectedIndex = l > 0 && l <= u.cr2.col - u.cr1.col + 1 ? l : 0;
            }, t.CmdGotFocus = function (e) {
                t.Keyboard.passThru = e;
            }, t.DoButtonCmd = function (e, o, i) {
                t.DoCmd(i.element, i.functionobj.command);
            }, t.DoCmd = function (e, o) {
                var i, n, r, a, s, l, c, u, d, h, p, f, m, g, v, b, y, C, w, x, _, S = t.GetSpreadsheetControlObject(),
                    k = S.editor;
                switch (o) {
                    case "undo":
                        S.ExecuteCommand("undo", "");
                        break;

                    case "redo":
                        S.ExecuteCommand("redo", "");
                        break;

                    case "fill-rowcolstuff":
                    case "fill-text":
                        for (r = o.substring(5), s = document.getElementById(S.idPrefix + r + "list"), s.length = 0,
                            a = 0; a < t.SpreadsheetCmdTable[r].length; a++) s.options[a] = new Option(t.SpreadsheetCmdTable[r][a].t);
                        o = "changed-" + r;

                    case "changed-rowcolstuff":
                    case "changed-text":
                        for (r = o.substring(8), s = document.getElementById(S.idPrefix + r + "list"), l = t.SpreadsheetCmdTable.slists[t.SpreadsheetCmdTable[r][s.selectedIndex].s],
                            c = document.getElementById(S.idPrefix + r + "slist"), c.length = 0, a = 0; a < (l.length || 0); a++) c.options[a] = new Option(l[a].t, l[a].s);
                        return;

                    case "ok-rowcolstuff":
                    case "ok-text":
                        r = o.substring(3), s = document.getElementById(S.idPrefix + r + "list"), c = document.getElementById(S.idPrefix + r + "slist"),
                            i = t.SpreadsheetCmdTable[r][s.selectedIndex].c, n = c[c.selectedIndex].value, t.SpreadsheetControlExecuteCommand(e, i, n);
                        break;

                    case "ok-setsort":
                        if (p = document.getElementById(S.idPrefix + "sortlist"), 0 == p.selectedIndex) S.sortrange = k.range.hasrange ? t.crToCoord(k.range.left, k.range.top) + ":" + t.crToCoord(k.range.right, k.range.bottom) : k.ecell.coord + ":" + k.ecell.coord;
                        else {
                            var T = p.options[p.selectedIndex].value;
                            if ("all" == T) {
                                var F = S.sheet.cells,
                                    E = -1,
                                    D = -1,
                                    P = -1,
                                    A = -1;
                                for (var I in F) {
                                    var M = t.coordToCr(I);
                                    (-1 == P || M.row < P) && (P = M.row), (-1 == E || M.col < E) && (E = M.col), (-1 == A || M.row > A) && (A = M.row),
                                    (-1 == D || M.col > D) && (D = M.col);
                                }
                                S.sortrange = t.crToCoord(E, P) + ":" + t.crToCoord(D, A), p.options[p.selectedIndex].text += " (" + S.sortrange + ")";
                            } else S.sortrange = p.options[p.selectedIndex].value;
                        }
                        return f = document.getElementById(S.idPrefix + "sortbutton"), f.value = t.LocalizeString("Sort ") + S.sortrange,
                            f.style.visibility = "visible", t.LoadColumnChoosers(S), e && e.blur && e.blur(),
                            void t.KeyboardFocus();

                    case "dosort":
                        if (S.sortrange && -1 == S.sortrange.indexOf(":")) {
                            if (g = t.Formula.LookupName(S.sheet, S.sortrange || ""), "range" != g.type) return;
                            v = g.value.match(/^(.*)\|(.*)\|$/), m = v[1] + ":" + v[2];
                        } else m = S.sortrange;
                        if ("A1:A1" == m) return;
                        u = "sort " + m + " ", d = document.getElementById(S.idPrefix + "majorsort"), h = document.getElementById(S.idPrefix + "majorsortup"),
                            u += d.options[d.selectedIndex].value + (h.checked ? " up" : " down"), d = document.getElementById(S.idPrefix + "minorsort"),
                            d.selectedIndex > 0 && (h = document.getElementById(S.idPrefix + "minorsortup"),
                                u += " " + d.options[d.selectedIndex].value + (h.checked ? " up" : " down")), d = document.getElementById(S.idPrefix + "lastsort"),
                            d.selectedIndex > 0 && (h = document.getElementById(S.idPrefix + "lastsortup"),
                                u += " " + d.options[d.selectedIndex].value + (h.checked ? " up" : " down")), S.ExecuteCommand(u, "");
                        break;

                    case "merge":
                        i = t.SpreadsheetCmdLookup[o] || "", n = t.SpreadsheetCmdSLookup[o] || "", S.ExecuteCommand(i, n),
                            k.range.hasrange && (k.MoveECell(t.crToCoord(k.range.left, k.range.top)), k.RangeRemove());
                        break;

                    case "movefrom":
                        k.range2.hasrange ? (S.context.cursorsuffix = "", k.Range2Remove(), S.ExecuteCommand("redisplay", "")) : k.range.hasrange ? (k.range2.top = k.range.top,
                                k.range2.right = k.range.right, k.range2.bottom = k.range.bottom, k.range2.left = k.range.left,
                                k.range2.hasrange = !0, k.MoveECell(t.crToCoord(k.range.left, k.range.top))) : (k.range2.top = k.ecell.row,
                                k.range2.right = k.ecell.col, k.range2.bottom = k.ecell.row, k.range2.left = k.ecell.col,
                                k.range2.hasrange = !0), u = k.range2.hasrange ? "" : "off", f = document.getElementById(S.idPrefix + "button_movefrom"),

                            f.src = assetManager.resolve('EtherCalc/runtime/assets/sc_movefrom.gif'),
                            f = document.getElementById(S.idPrefix + "button_movepaste"),
                            f.src = assetManager.resolve('EtherCalc/runtime/assets/sc_movepaste.gif'),
                            f = document.getElementById(S.idPrefix + "button_moveinsert"),
                            f.src = assetManager.resolve('EtherCalc/runtime/assets/sc_moveinsert.gif'),
                            k.range2.hasrange && k.RangeRemove();

                        break;

                    case "movepaste":
                    case "moveinsert":
                        k.range2.hasrange && (S.context.cursorsuffix = "", i = o + " " + t.crToCoord(k.range2.left, k.range2.top) + ":" + t.crToCoord(k.range2.right, k.range2.bottom) + " " + k.ecell.coord,
                            S.ExecuteCommand(i, ""), k.Range2Remove(), f = document.getElementById(S.idPrefix + "button_movefrom"),
                            f.src = assetManager.resolve('EtherCalc/runtime/assets/sc_movefromoff.gif'), f = document.getElementById(S.idPrefix + "button_movepaste"),
                            f.src = assetManager.resolve('EtherCalc/runtime/assets/sc_movepasteoff.gif'), f = document.getElementById(S.idPrefix + "button_moveinsert"),
                            f.src = assetManager.resolve('EtherCalc/runtime/assets/sc_moveinsertoff.gif'));
                        break;

                    case "swapcolors":
                        b = S.sheet, y = b.GetAssuredCell(k.ecell.coord), x = b.attribs.defaultcolor ? b.colors[b.attribs.defaultcolor] : "rgb(0,0,0)",
                            _ = b.attribs.defaultbgcolor ? b.colors[b.attribs.defaultbgcolor] : "rgb(255,255,255)",
                            C = y.color ? b.colors[y.color] : x, C == _ && (C = ""), w = y.bgcolor ? b.colors[y.bgcolor] : _,
                            w == x && (w = ""), S.ExecuteCommand("set %C color " + w + "%Nset %C bgcolor " + C, "");
                        break;

                    default:
                        i = t.SpreadsheetCmdLookup[o] || "", n = t.SpreadsheetCmdSLookup[o] || "", S.ExecuteCommand(i, n);
                }
                e && e.blur && e.blur(), t.KeyboardFocus();
            }, t.SpreadsheetCmdLookup = {
                copy: "copy %C all",
                cut: "cut %C all",
                paste: "paste %C all",
                pasteformats: "paste %C formats",
                lock: "set %C readonly yes",
                unlock: "set %C readonly no",
                "delete": "erase %C formulas",
                filldown: "filldown %C all",
                fillright: "fillright %C all",
                erase: "erase %C all",
                borderon: "set %C bt %S%Nset %C br %S%Nset %C bb %S%Nset %C bl %S",
                borderoff: "set %C bt %S%Nset %C br %S%Nset %C bb %S%Nset %C bl %S",
                merge: "merge %C",
                unmerge: "unmerge %C",
                "align-left": "set %C cellformat left",
                "align-center": "set %C cellformat center",
                "align-right": "set %C cellformat right",
                "align-default": "set %C cellformat",
                insertrow: "insertrow %C",
                insertcol: "insertcol %C",
                deleterow: "deleterow %C",
                deletecol: "deletecol %C",
                hiderow: "set %H hide yes",
                hidecol: "set %W hide yes",
                undo: "undo",
                redo: "redo",
                recalc: "recalc"
            }, t.SpreadsheetCmdSLookup = {
                borderon: "1px solid rgb(0,0,0)",
                borderoff: ""
            }, t.SpreadsheetControlExecuteCommand = function (e, o, i) {
                var n = t.GetSpreadsheetControlObject(),
                    r = n.editor,
                    a = {};
                a.P = "%", a.N = "\n", r.range.hasrange ? (a.R = t.crToCoord(r.range.left, r.range.top) + ":" + t.crToCoord(r.range.right, r.range.bottom),
                        a.C = a.R, a.W = t.rcColname(r.range.left) + ":" + t.rcColname(r.range.right), a.H = r.range.top + ":" + r.range.bottom) : r.ecell ? (a.C = r.ecell.coord,
                        a.R = r.ecell.coord + ":" + r.ecell.coord, a.W = t.rcColname(t.coordToCr(r.ecell.coord).col),
                        a.H = t.coordToCr(r.ecell.coord).row) : (a.C = "A1", a.R = "A1:A1", a.W = t.rcColname(t.coordToCr("A1").col),
                        a.H = t.coordToCr("A1").row), a.S = i, o = o.replace(/%C/g, a.C), o = o.replace(/%R/g, a.R),
                    o = o.replace(/%N/g, a.N), o = o.replace(/%S/g, a.S), o = o.replace(/%W/g, a.W),
                    o = o.replace(/%H/g, a.H), o = o.replace(/%P/g, a.P), r.EditorScheduleSheetCommands(o, !0, !1);
                
                if ($.isArray(config.cellCSS)) {
                    config.cellCSS.push(o);
                }
            }, t.SpreadsheetControlCreateSheetHTML = function (e) {
                var o, i, n, r = "";
                return o = new t.RenderContext(e.sheet), i = document.createElement("div"), n = o.RenderSheet(null, {
                    type: "html"
                }), i.appendChild(n), delete o, r = i.innerHTML, delete n, delete i, r;
            }
            , t.SpreadsheetControlCreateCellHTML = function (e, o, i) {
                var n = "",
                    r = e.sheet.cells[o];
                return r ? (n = void 0 == r.displaystring ? t.FormatValueForDisplay(e.sheet, r.datavalue, o, i || e.context.defaultHTMLlinkstyle) : r.displaystring,
                    "&nbsp;" == n && (n = ""), n) : "";
            }, t.SpreadsheetControlCreateCellHTMLSave = function (e, o, i) {
                var n, r, a, s, l, c, u, d, h = [];
                for (d = o ? t.ParseRange(o) : {
                        cr1: {
                            row: 1,
                            col: 1
                        },
                        cr2: {
                            row: e.sheet.attribs.lastrow,
                            col: e.sheet.attribs.lastcol
                        }
                    }, n = d.cr1, r = d.cr2, h.push("version:1.0"), a = n.row; a <= r.row; a++)
                    for (s = n.col; s <= r.col; s++) l = t.crToCoord(s, a),
                        c = e.sheet.cells[l], c && (u = void 0 == c.displaystring ? t.FormatValueForDisplay(e.sheet, c.datavalue, l, i || e.context.defaultHTMLlinkstyle) : c.displaystring,
                            "&nbsp;" != u && h.push(l + ":" + t.encodeForSave(u)));
                return h.push(""), h.join("\n");
            }, t.SpreadsheetControl.DoFunctionList = function () {
                var e, o, i, n = t.Formula,
                    r = t.Constants,
                    a = r.function_classlist,
                    s = t.GetSpreadsheetControlObject(),
                    l = s.idPrefix + "function";
                if (i = document.getElementById(l + "dialog"), !i) {
                    for (n.FillFunctionInfo(), o = '<table><tr><td><span style="font-size:x-small;font-weight:bold">%loc!Category!</span><br><select class="categoryFct" id="' + l + 'class" size="' + a.length + '" style="width:120px;"',
                        e = 0; e < a.length; e++) o += '<option value="' + a[e] + '"' + (0 == e ? " selected>" : ">") + t.special_chars(n.FunctionClasses[a[e]].name) + "</option>";
                    o += '</select></td><td>&nbsp;&nbsp;</td><td id="' + l + 'list"><span style="font-size:x-small;font-weight:bold">%loc!Functions!</span><br><select class="fctItem" id="' + l + 'name" size="' + a.length + '" style="width:240px;"',
                        o += t.SpreadsheetControl.GetFunctionNamesStr("all"), o += '</td></tr><tr><td colspan="3"><div id="' + l + 'desc" style="width:380px;height:80px;overflow:auto;font-size:x-small;">' + t.SpreadsheetControl.GetFunctionInfoStr(n.FunctionClasses[a[0]].items[0]) + '</div><div style="width:380px;text-align:right;padding-top:6px;font-size:small;"><input class="insertFctBt" type="button" value="%loc!Paste!" style="font-size:smaller;">&nbsp;<input  class="hideFunction" type="button" value="%loc!Cancel!" style="font-size:smaller;"></div></td></tr></table>';
                    var c = document.createElement("div");
                    c.id = l + "dialog", c.style.position = "absolute";
                    var u = t.GetViewportInfo(),
                        d = t.GetElementPositionWithScroll(s.spreadsheetDiv);
                    c.style.top = u.height / 3 - d.top + "px", c.style.left = u.width / 3 - d.left + "px",
                        c.style.zIndex = 100, c.style.backgroundColor = "#FFF", c.style.border = "1px solid black",
                        c.style.width = "400px", o = '<table cellspacing="0" cellpadding="0" style="border-bottom:1px solid black;"><tr><td style="font-size:10px;cursor:default;width:100%;background-color:#999;color:#FFF;">&nbsp;%loc!Function List!</td><td class="closePop" style="font-size:10px;cursor:default;color:#666;">&nbsp;X&nbsp;</td></tr></table><div style="background-color:#DDD;">' + o + "</div>",
                        o = t.LocalizeSubstrings(o), c.innerHTML = o, t.DragRegister(c.firstChild.firstChild.firstChild.firstChild, !0, !0, {
                            MouseDown: t.DragFunctionStart,
                            MouseMove: t.DragFunctionPosition,
                            MouseUp: t.DragFunctionPosition,
                            Disabled: null,
                            positionobj: c
                        }, s.spreadsheetDiv), s.spreadsheetDiv.appendChild(c), i = document.getElementById(l + "name"),
                        i.focus(), t.CmdGotFocus(i);

                    $container.find(".hideFunction").on("click", function () {
                        t.SpreadsheetControl.HideFunctions();
                    });

                    $container.find(".closePop").on("click", function () {
                        t.SpreadsheetControl.HideFunctions();
                    });
                    $container.find(".fctItem").on("change", function () {
                        t.SpreadsheetControl.FunctionChosen(this.options[this.selectedIndex].value);
                    });
                    $container.find(".fctItem").on("dblclick", function () {
                        t.SpreadsheetControl.DoFunctionPaste()
                    });

                    $container.find(".categoryFct").on("change", function () {
                        t.SpreadsheetControl.FunctionClassChosen(this.options[this.selectedIndex].value);
                    });

                    $container.find(".insertFctBt").on("click", function () {
                        t.SpreadsheetControl.DoFunctionPaste();
                    });
                }
            }, t.SpreadsheetControl.GetFunctionNamesStr = function (e) {
                var o, i, n = t.Formula,
                    r = "";
                for (i = n.FunctionClasses[e], o = 0; o < i.items.length; o++) r += '<option value="' + i.items[o] + '"' + (0 == o ? " selected>" : ">") + i.items[o] + "</option>";
                return r;
            }, t.SpreadsheetControl.FillFunctionNames = function (e, o) {
                var i, n, r = t.Formula;
                for (o.length = 0, n = r.FunctionClasses[e], i = 0; i < n.items.length; i++) o.options[i] = new Option(n.items[i], n.items[i]),
                    0 == i && (o.options[i].selected = !0);
            }, t.SpreadsheetControl.GetFunctionInfoStr = function (e) {
                var o = t.Formula,
                    i = o.FunctionList[e],
                    n = t.special_chars,
                    r = "<b>" + e + "(" + n(o.FunctionArgString(e)) + ")</b><br>";
                return r += n(i[3]);
            }, t.SpreadsheetControl.FunctionClassChosen = function (e) {
                var o = t.GetSpreadsheetControlObject(),
                    i = o.idPrefix + "function",
                    n = t.Formula;
                t.SpreadsheetControl.FillFunctionNames(e, document.getElementById(i + "name")),
                    t.SpreadsheetControl.FunctionChosen(n.FunctionClasses[e].items[0]);
            }, t.SpreadsheetControl.FunctionChosen = function (e) {
                var o = t.GetSpreadsheetControlObject(),
                    i = o.idPrefix + "function";
                document.getElementById(i + "desc").innerHTML = t.SpreadsheetControl.GetFunctionInfoStr(e);
            }, t.SpreadsheetControl.HideFunctions = function () {
                var e = t.GetSpreadsheetControlObject(),
                    o = document.getElementById(e.idPrefix + "functiondialog");
                o.innerHTML = "", t.DragUnregister(o), t.KeyboardFocus(), o.parentNode && o.parentNode.removeChild(o);
            }, t.SpreadsheetControl.DoFunctionPaste = function () {
                var e = t.GetSpreadsheetControlObject(),
                    o = e.editor,
                    i = document.getElementById(e.idPrefix + "functionname"),
                    n = document.getElementById(e.idPrefix + "multilinetextarea"),
                    r = i.value + "(";
                t.SpreadsheetControl.HideFunctions(), n ? (n.value += r, n.focus(), t.CmdGotFocus(n)) : o.EditorAddToInput(r, "=");
            }, t.SpreadsheetControl.DoMultiline = function () {
                var e, o, i, n = t.LocalizeSubstrings,
                    r = (t.Constants, t.GetSpreadsheetControlObject()),
                    a = r.editor,
                    s = a.workingvalues,
                    r = t.GetSpreadsheetControlObject(),
                    l = r.idPrefix + "multiline";
                if (o = document.getElementById(l + "dialog"), !o) {
                    switch (a.state) {
                        case "start":
                            s.ecoord = a.ecell.coord, s.erow = a.ecell.row, s.ecol = a.ecell.col, a.RangeRemove(),
                                i = t.GetCellContents(a.context.sheetobj, s.ecoord);
                            break;

                        case "input":
                        case "inputboxdirect":
                            i = a.inputBox.GetText();
                    }
                    a.inputBox.element.disabled = !0, i = t.special_chars(i), e = '<textarea id="' + l + 'textarea" style="width:380px;height:120px;margin:10px 0px 0px 6px;">' + i + '</textarea><div style="width:380px;text-align:right;padding:6px 0px 4px 6px;font-size:small;">' + n('<input class="setCellContent" type="button" value="%loc!Set Cell Contents!" style="font-size:smaller;" >&nbsp;<input class="clearTextArea" type="button" value="%loc!Clear!" style="font-size:smaller;">&nbsp;<input class="closePopMulti2" type="button" value="%loc!Cancel!" style="font-size:smaller;" ></div></div>');
                    var c = document.createElement("div");
                    c.id = l + "dialog", c.style.position = "absolute";
                    var u = t.GetViewportInfo(),
                        d = t.GetElementPositionWithScroll(r.spreadsheetDiv);
                    c.style.top = u.height / 3 - d.top + "px", c.style.left = u.width / 3 - d.left + "px",
                        c.style.zIndex = 100, c.style.backgroundColor = "#FFF", c.style.border = "1px solid black",
                        c.style.width = "400px", c.innerHTML = '<table cellspacing="0" cellpadding="0" style="border-bottom:1px solid black;"><tr><td style="font-size:10px;cursor:default;width:100%;background-color:#999;color:#FFF;">' + n("&nbsp;%loc!Multi-line Input Box!") + '</td><td class="closePopMulti2" style="font-size:10px;cursor:default;color:#666;">&nbsp;X&nbsp;</td></tr></table><div style="background-color:#DDD;">' + e + "</div>",
                        t.DragRegister(c.firstChild.firstChild.firstChild.firstChild, !0, !0, {
                            MouseDown: t.DragFunctionStart,
                            MouseMove: t.DragFunctionPosition,
                            MouseUp: t.DragFunctionPosition,
                            Disabled: null,
                            positionobj: c
                        }, r.spreadsheetDiv), r.spreadsheetDiv.appendChild(c), o = document.getElementById(l + "textarea"),
                        o.focus(), t.CmdGotFocus(o);
                }

                $container.find(".closePopMulti2").on("click", function () {
                    t.SpreadsheetControl.HideMultiline();
                });
                $container.find(".clearTextArea").on("click", function () {
                    t.SpreadsheetControl.DoMultilineClear();
                })
                $container.find(".setCellContent").on("click", function () {
                    t.SpreadsheetControl.DoMultilinePaste();
                })


            }, t.SpreadsheetControl.HideMultiline = function () {
                var e = (t.Constants, t.GetSpreadsheetControlObject()),
                    o = e.editor,
                    i = document.getElementById(e.idPrefix + "multilinedialog");
                switch (i.innerHTML = "", t.DragUnregister(i), t.KeyboardFocus(), i.parentNode && i.parentNode.removeChild(i),
                    o.state) {
                    case "start":
                        o.inputBox.DisplayCellContents(null);
                        break;

                    case "input":
                    case "inputboxdirect":
                        o.inputBox.element.disabled = !1, o.inputBox.Focus();
                }
            }, t.SpreadsheetControl.DoMultilineClear = function () {
                var e = t.GetSpreadsheetControlObject(),
                    o = document.getElementById(e.idPrefix + "multilinetextarea");
                o.value = "", o.focus();
            }, t.SpreadsheetControl.DoMultilinePaste = function () {
                var e = t.GetSpreadsheetControlObject(),
                    o = e.editor,
                    i = o.workingvalues,
                    n = document.getElementById(e.idPrefix + "multilinetextarea"),
                    r = n.value;
                switch (t.SpreadsheetControl.HideMultiline(), o.state) {
                    case "start":
                        i.partialexpr = "", i.ecoord = o.ecell.coord, i.erow = o.ecell.row, i.ecol = o.ecell.col;
                        break;

                    case "input":
                    case "inputboxdirect":
                        o.inputBox.Blur(), o.inputBox.ShowInputBox(!1), o.state = "start";
                }
                o.EditorSaveEdit(r);
                
            }, t.SpreadsheetControl.DoLink = function () {
                var e, o, i, n, r, a, s = t.LocalizeString,
                    l = (t.Constants, t.GetSpreadsheetControlObject()),
                    c = l.editor,
                    u = c.workingvalues,
                    l = t.GetSpreadsheetControlObject(),
                    d = l.idPrefix + "link";
                if (o = document.getElementById(d + "dialog"), !o) {
                    switch (c.state) {
                        case "start":
                            u.ecoord = c.ecell.coord, u.erow = c.ecell.row, u.ecol = c.ecell.col, c.RangeRemove(),
                                i = t.GetCellContents(c.context.sheetobj, u.ecoord);
                            break;

                        case "input":
                        case "inputboxdirect":
                            i = c.inputBox.GetText();
                    }
                    c.inputBox.element.disabled = !0, "'" == i.charAt(0) && (i = i.slice(1));
                    var h = t.ParseCellLinkText(i);
                    i = t.special_chars(i), n = l.sheet.cells[c.ecell.coord], r = n && n.textvalueformat ? "" : " checked",
                        a = h.newwin ? " checked" : "", e = '<div style="padding:6px 0px 4px 6px;"><span style="font-size:smaller;">' + s("Description") + '</span><br><input type="text" id="' + d + 'desc" style="width:380px;" value="' + t.special_chars(h.desc) + '"><br><span style="font-size:smaller;">' + s("URL") + '</span><br><input type="text" id="' + d + 'url" style="width:380px;" value="' + t.special_chars(h.url) + '"><br>',
                        t.Callbacks.MakePageLink && (e += '<span style="font-size:smaller;">' + s("Page Name") + '</span><br><input type="text" id="' + d + 'pagename" style="width:380px;" value="' + t.special_chars(h.pagename) + '"><br><span style="font-size:smaller;">' + s("Workspace") + '</span><br><input type="text" id="' + d + 'workspace" style="width:380px;" value="' + t.special_chars(h.workspace) + '"><br>'),
                        e += t.LocalizeSubstrings('<input type="checkbox" id="' + d + 'format"' + r + '>&nbsp;<span style="font-size:smaller;">%loc!Set to Link format!</span><br><input type="checkbox" id="' + d + 'popup"' + a + '>&nbsp;<span style="font-size:smaller;">%loc!Show in new browser window!</span></div><div style="width:380px;text-align:right;padding:6px 0px 4px 6px;font-size:small;"><input class="setLinkContent" type="button" value="%loc!Set Cell Contents!" style="font-size:smaller;" >&nbsp;<input class="clearLink" type="button" value="%loc!Clear!" style="font-size:smaller;">&nbsp;<input class="closeLinkPop" type="button" value="%loc!Cancel!" style="font-size:smaller;" ></div></div>');
                    var p = document.createElement("div");
                    p.id = d + "dialog", p.style.position = "absolute";
                    var f = t.GetViewportInfo(),
                        m = t.GetElementPositionWithScroll(l.spreadsheetDiv);
                    p.style.top = f.height / 3 - m.top + "px", p.style.left = f.width / 3 - m.left + "px",
                        p.style.zIndex = 100, p.style.backgroundColor = "#FFF", p.style.border = "1px solid black",
                        p.style.width = "400px", p.innerHTML = '<table cellspacing="0" cellpadding="0" style="border-bottom:1px solid black;"><tr><td style="font-size:10px;cursor:default;width:100%;background-color:#999;color:#FFF;">&nbsp;' + s("Link Input Box") + '</td><td class="closeLinkPop" style="font-size:10px;cursor:default;color:#666;">&nbsp;X&nbsp;</td></tr></table><div style="background-color:#DDD;">' + e + "</div>",
                        t.DragRegister(p.firstChild.firstChild.firstChild.firstChild, !0, !0, {
                            MouseDown: t.DragFunctionStart,
                            MouseMove: t.DragFunctionPosition,
                            MouseUp: t.DragFunctionPosition,
                            Disabled: null,
                            positionobj: p
                        }, l.spreadsheetDiv), l.spreadsheetDiv.appendChild(p), o = document.getElementById(d + "url"),
                        o.focus(), t.CmdGotFocus(o);

                    $container.find(".closeLinkPop").on("click", function linkCloser() {
                        t.SpreadsheetControl.HideLink();
                    });
                    $container.find(".clearLink").on("click", function () {
                        t.SpreadsheetControl.DoLinkClear();
                    });
                    $container.find(".setLinkContent").on("click", function () {
                        t.SpreadsheetControl.DoLinkPaste();
                    });


                }
            }, t.SpreadsheetControl.HideLink = function () {
                var e = (t.Constants, t.GetSpreadsheetControlObject()),
                    o = e.editor,
                    i = document.getElementById(e.idPrefix + "linkdialog");
                switch (i.innerHTML = "", t.DragUnregister(i), t.KeyboardFocus(), i.parentNode && i.parentNode.removeChild(i),
                    o.state) {
                    case "start":
                        o.inputBox.DisplayCellContents(null);
                        break;

                    case "input":
                    case "inputboxdirect":
                        o.inputBox.element.disabled = !1, o.inputBox.Focus();
                }
            }, t.SpreadsheetControl.DoLinkClear = function () {
                var e = t.GetSpreadsheetControlObject();
                document.getElementById(e.idPrefix + "linkdesc").value = "", document.getElementById(e.idPrefix + "linkpagename").value = "",
                    document.getElementById(e.idPrefix + "linkworkspace").value = "";
                var o = document.getElementById(e.idPrefix + "linkurl");
                o.value = "", o.focus();
            }, t.SpreadsheetControl.DoLinkPaste = function () {
                var e, o, i, n, r = t.GetSpreadsheetControlObject(),
                    a = r.editor,
                    s = a.workingvalues,
                    l = document.getElementById(r.idPrefix + "linkdesc"),
                    c = document.getElementById(r.idPrefix + "linkurl"),
                    u = document.getElementById(r.idPrefix + "linkpagename"),
                    d = document.getElementById(r.idPrefix + "linkworkspace"),
                    h = document.getElementById(r.idPrefix + "linkformat"),
                    p = document.getElementById(r.idPrefix + "linkpopup"),
                    f = "";
                switch (p.checked ? (e = "<<", o = ">>", i = "[[", n = "]]") : (e = "<", o = ">",
                        i = "[", n = "]"), f = u && u.value ? d.value ? l.value + "{" + d.value + i + u.value + n + "}" : l.value + i + u.value + n : l.value + e + c.value + o,
                    t.SpreadsheetControl.HideLink(), a.state) {
                    case "start":
                        s.partialexpr = "", s.ecoord = a.ecell.coord, s.erow = a.ecell.row, s.ecol = a.ecell.col;
                        break;

                    case "input":
                    case "inputboxdirect":
                        a.inputBox.Blur(), a.inputBox.ShowInputBox(!1), a.state = "start";
                }
                h.checked && t.SpreadsheetControlExecuteCommand(null, "set %C textvalueformat text-link", ""),
                    a.EditorSaveEdit(f);
                
            }, t.SpreadsheetControl.DoSum = function () {
                var e, o, i, n, r, a, s, l = t.GetSpreadsheetControlObject(),
                    c = l.editor,
                    u = c.context.sheetobj;
                if (c.range.hasrange) r = t.crToCoord(c.range.left, c.range.top) + ":" + t.crToCoord(c.range.right, c.range.bottom),
                    e = "set " + t.crToCoord(c.range.right, c.range.bottom + 1) + " formula sum(" + r + ")";
                else if (i = c.ecell.row - 1,
                    n = c.ecell.col, 1 >= i) e = "set " + c.ecell.coord + " constant e#REF! 0 #REF!";
                else {
                    for (s = !1; i > 0;) {
                        if (a = t.crToCoord(n, i), o = u.GetAssuredCell(a), o.datatype && "t" != o.datatype) s = !0;
                        else if (s) {
                            i++;
                            break;
                        }
                        i--;
                    }
                    e = "set " + c.ecell.coord + " formula sum(" + t.crToCoord(n, i) + ":" + t.crToCoord(n, c.ecell.row - 1) + ")";
                    if ($.isArray(config.cells)) {
                        config.cells.push(e);
                    } // JP MOD
                }
                c.EditorScheduleSheetCommands(e, !0, !1);
            }, t.SpreadsheetControl.FindInSheet = function () {
                var e = $container.find("#searchstatus"),
                    o = t.GetSpreadsheetControlObject();
                if (!this.value.length) return e.text(""), o.sheet.search_cells = [], void(o.sheet.selected_search_cell = void 0);
                var i, n, r = o.sheet.cells,
                    a = new RegExp(this.value, "im"),
                    s = [];
                for (var l in r) {
                    i = r[l];
                    var c = t.coordToCr(l);
                    "yes" !== o.sheet.rowattribs.hide[c.row] && "yes" !== o.sheet.colattribs.hide[t.rcColname(c.col)] && (n = "c" === i.datatype ? i.displaystring : String(i.datavalue),
                        void 0 !== n && n.match(a) && s.push(l));
                }
                o.sheet.search_cells = s, s.length ? (o.sheet.selected_search_cell = 0, o.editor.MoveECell(s[0]),
                    e.text("1 of " + s.length)) : (o.sheet.selected_search_cell = void 0, e.text("No Matches"));
            }, t.SpreadsheetControl.SearchSheet = function (e) {
                var o = t.GetSpreadsheetControlObject(),
                    i = o.sheet,
                    n = i.search_cells;
                if (n.length) {
                    var r = i.selected_search_cell;
                    r === (0 === e ? 0 : n.length - 1) ? r = 0 === e ? n.length - 1 : 0 : r += 0 === e ? -1 : 1;
                    var a = n[r];
                    i.selected_search_cell = r, o.editor.MoveECell(a), document.getElementById("searchstatus").textContent = String(r + 1) + " of " + n.length;
                }
            }, t.SpreadsheetControl.SearchUp = function () {
                t.SpreadsheetControl.SearchSheet(0);
            }, t.SpreadsheetControl.SearchDown = function () {
                t.SpreadsheetControl.SearchSheet(1);
            }, t.SpreadsheetControlSortOnclick = function (e) {
                var o, i, n = [],
                    r = document.getElementById(e.idPrefix + "sortlist");
                t.LoadColumnChoosers(e), e.editor.RangeChangeCallback.sort = t.UpdateSortRangeProposal;
                for (o in e.sheet.names) n.push(o);
                for (n.sort(), r.length = 0, r.options[0] = new Option(t.LocalizeString("[select range]")),
                    r.options[1] = new Option(t.LocalizeString("Sort All"), "all"), n_options = r.options.length,
                    i = 0; i < n.length; i++) o = n[i], r.options[i + n_options] = new Option(o, o),
                    o == e.sortrange && (r.options[i + n_options].selected = !0);
                "" == e.sortrange && (r.options[0].selected = !0), t.UpdateSortRangeProposal(e.editor),
                    t.KeyboardFocus();
            }, t.SpreadsheetControlSortSave = function () {
                var e, o, i, n = t.GetSpreadsheetControlObject();
                return e = "sort:" + t.encodeForSave(n.sortrange) + ":", o = document.getElementById(n.idPrefix + "majorsort"),
                    i = document.getElementById(n.idPrefix + "majorsortup"), e += o.selectedIndex + (i.checked ? ":up" : ":down"),
                    o = document.getElementById(n.idPrefix + "minorsort"), o.selectedIndex > 0 ? (i = document.getElementById(n.idPrefix + "minorsortup"),
                        e += ":" + o.selectedIndex + (i.checked ? ":up" : ":down")) : e += "::", o = document.getElementById(n.idPrefix + "lastsort"),
                    o.selectedIndex > 0 ? (i = document.getElementById(n.idPrefix + "lastsortup"), e += ":" + o.selectedIndex + (i.checked ? ":up" : ":down")) : e += "::",
                    e + "\n";
            }, t.SpreadsheetControlSortLoad = function (e, o, i) {
                var n, r, a = t.GetSpreadsheetControlObject();
                return n = i.split(":"), a.sortrange = t.decodeFromSave(n[1]), r = document.getElementById(a.idPrefix + "sortbutton"),
                    a.sortrange ? (r.value = t.LocalizeString("Sort ") + a.sortrange, r.style.visibility = "visible") : r.style.visibility = "hidden",
                    t.LoadColumnChoosers(a), sele = document.getElementById(a.idPrefix + "majorsort"),
                    sele.selectedIndex = n[2] - 0, document.getElementById(a.idPrefix + "majorsort" + n[3]).checked = !0,
                    sele = document.getElementById(a.idPrefix + "minorsort"), n[4] ? (sele.selectedIndex = n[4] - 0,
                        document.getElementById(a.idPrefix + "minorsort" + n[5]).checked = !0) : (sele.selectedIndex = 0,
                        document.getElementById(a.idPrefix + "minorsortup").checked = !0), sele = document.getElementById(a.idPrefix + "lastsort"),
                    n[6] ? (sele.selectedIndex = n[6] - 0, document.getElementById(a.idPrefix + "lastsort" + n[7]).checked = !0) : (sele.selectedIndex = 0,
                        document.getElementById(a.idPrefix + "lastsortup").checked = !0), !0;
            }, t.SpreadsheetControlCommentOnclick = function (e, o) {
                e.editor.MoveECellCallback.comment = t.SpreadsheetControlCommentMoveECell, t.SpreadsheetControlCommentDisplay(e, o),
                    t.KeyboardFocus();
            }, t.SpreadsheetControlCommentDisplay = function (e) {
                var t = "";
                e.editor.ecell && e.editor.ecell.coord && e.sheet.cells[e.editor.ecell.coord] && (t = e.sheet.cells[e.editor.ecell.coord].comment || ""),
                    document.getElementById(e.idPrefix + "commenttext").value = t;
            }, t.SpreadsheetControlCommentMoveECell = function () {
                t.SpreadsheetControlCommentDisplay(t.GetSpreadsheetControlObject(), "comment");
            }, t.SpreadsheetControlCommentSet = function () {
                var e = t.GetSpreadsheetControlObject();
                e.ExecuteCommand("set %C comment " + t.encodeForSave(document.getElementById(e.idPrefix + "commenttext").value));
                var o = t.GetEditorCellElement(e.editor, e.editor.ecell.row, e.editor.ecell.col);
                e.editor.ECellReadonly() || (o.element.title = document.getElementById(e.idPrefix + "commenttext").value,
                    e.editor.UpdateCellCSS(o, e.editor.ecell.row, e.editor.ecell.col)), t.KeyboardFocus();
            }, t.SpreadsheetControlCommentOnunclick = function (e) {
                delete e.editor.MoveECellCallback.comment;
            }, t.SpreadsheetControlNamesOnclick = function (e) {
                document.getElementById(e.idPrefix + "namesname").value = "", document.getElementById(e.idPrefix + "namesdesc").value = "",
                    document.getElementById(e.idPrefix + "namesvalue").value = "", e.editor.RangeChangeCallback.names = t.SpreadsheetControlNamesRangeChange,
                    e.editor.MoveECellCallback.names = t.SpreadsheetControlNamesRangeChange, t.SpreadsheetControlNamesRangeChange(e.editor),
                    t.SpreadsheetControlNamesFillNameList(), t.SpreadsheetControlNamesChangedName();
            }, t.SpreadsheetControlNamesFillNameList = function () {
                var e, o, i = t.LocalizeString,
                    n = [],
                    r = t.GetSpreadsheetControlObject(),
                    a = document.getElementById(r.idPrefix + "nameslist"),
                    s = document.getElementById(r.idPrefix + "namesname").value.toUpperCase().replace(/[^A-Z0-9_\.]/g, "");
                for (e in r.sheet.names) n.push(e);
                for (n.sort(), a.length = 0, a.options[0] = new Option(n.length > 0 ? i("[New]") : i("[None]")),
                    o = 0; o < n.length; o++) e = n[o], a.options[o + 1] = new Option(e, e), e == s && (a.options[o + 1].selected = !0);
                "" == s && (a.options[0].selected = !0);
            }, t.SpreadsheetControlNamesChangedName = function () {
                var e = t.GetSpreadsheetControlObject(),
                    o = document.getElementById(e.idPrefix + "nameslist"),
                    i = o.options[o.selectedIndex].value;
                e.sheet.names[i] ? (document.getElementById(e.idPrefix + "namesname").value = i,
                    document.getElementById(e.idPrefix + "namesdesc").value = e.sheet.names[i].desc || "",
                    document.getElementById(e.idPrefix + "namesvalue").value = e.sheet.names[i].definition || "") : (document.getElementById(e.idPrefix + "namesname").value = "",
                    document.getElementById(e.idPrefix + "namesdesc").value = "", document.getElementById(e.idPrefix + "namesvalue").value = "");
            }, t.SpreadsheetControlNamesRangeChange = function (e) {
                var o = t.GetSpreadsheetControlObject(),
                    i = document.getElementById(o.idPrefix + "namesrangeproposal");
                i.value = e.range.hasrange ? t.crToCoord(e.range.left, e.range.top) + ":" + t.crToCoord(e.range.right, e.range.bottom) : e.ecell.coord;
            }, t.SpreadsheetControlNamesOnunclick = function (e) {
                delete e.editor.RangeChangeCallback.names, delete e.editor.MoveECellCallback.names;
            }, t.SpreadsheetControlNamesSetValue = function () {
                var e = t.GetSpreadsheetControlObject();
                document.getElementById(e.idPrefix + "namesvalue").value = document.getElementById(e.idPrefix + "namesrangeproposal").value,
                    t.KeyboardFocus();
            }, t.SpreadsheetControlNamesSave = function () {
                var e = t.GetSpreadsheetControlObject(),
                    o = document.getElementById(e.idPrefix + "namesname").value;
                t.SetTab(e.tabs[0].name), t.KeyboardFocus(), "" != o && e.ExecuteCommand("name define " + o + " " + document.getElementById(e.idPrefix + "namesvalue").value + "\nname desc " + o + " " + document.getElementById(e.idPrefix + "namesdesc").value);
            }, t.SpreadsheetControlNamesDelete = function () {
                var e = t.GetSpreadsheetControlObject(),
                    o = document.getElementById(e.idPrefix + "namesname").value;
                t.SetTab(e.tabs[0].name), t.KeyboardFocus(), "" != o && e.ExecuteCommand("name delete " + o),
                    t.KeyboardFocus();
            }, t.SpreadsheetControlClipboardOnclick = function (e) {
                var e = t.GetSpreadsheetControlObject();
                clipele = document.getElementById(e.idPrefix + "clipboardtext"), document.getElementById(e.idPrefix + "clipboardformat-tab").checked = !0;
                try {
                    clipele.value = t.ConvertSaveToOtherFormat(t.Clipboard.clipboard, "tab");
                } catch (o) {
                    console.error(o);
                }
            }, t.SpreadsheetControlClipboardFormat = function (e) {
                var o = t.GetSpreadsheetControlObject();
                clipele = document.getElementById(o.idPrefix + "clipboardtext"), clipele.value = t.ConvertSaveToOtherFormat(t.Clipboard.clipboard, e);
            }, t.SpreadsheetControlClipboardLoad = function () {
                var e = t.GetSpreadsheetControlObject(),
                    o = "tab";
                t.SetTab(e.tabs[0].name), t.KeyboardFocus(), document.getElementById(e.idPrefix + "clipboardformat-csv").checked ? o = "csv" : document.getElementById(e.idPrefix + "clipboardformat-scsave").checked && (o = "scsave"),
                    e.editor.pastescclipboard = !0, e.editor.EditorScheduleSheetCommands("loadclipboard " + t.encodeForSave(t.ConvertOtherFormatToSave(document.getElementById(e.idPrefix + "clipboardtext").value, o)), !0, !1);
            }, t.SpreadsheetControlClipboardClear = function () {
                var e = t.GetSpreadsheetControlObject(),
                    o = document.getElementById(e.idPrefix + "clipboardtext");
                o.value = "", e.editor.EditorScheduleSheetCommands("clearclipboard", !0, !1), o.focus();
            }, t.SpreadsheetControlClipboardExport = function () {
                var e = t.GetSpreadsheetControlObject();
                e.ExportCallback && e.ExportCallback(e), t.SetTab(e.tabs[0].name), t.KeyboardFocus();
            }, t.SpreadsheetControlSettingsSwitch = function (e) {
                t.SettingControlReset();
                var o = t.GetSpreadsheetControlObject(),
                    i = document.getElementById(o.idPrefix + "sheetsettingstable"),
                    n = document.getElementById(o.idPrefix + "cellsettingstable"),
                    r = document.getElementById(o.idPrefix + "sheetsettingstoolbar"),
                    a = document.getElementById(o.idPrefix + "cellsettingstoolbar");
                "sheet" == e ? (i.style.display = "block", n.style.display = "none", r.style.display = "block",
                    a.style.display = "none", t.SettingsControlSetCurrentPanel(o.views.settings.values.sheetspanel)) : (i.style.display = "none",
                    n.style.display = "block", r.style.display = "none", a.style.display = "block",
                    t.SettingsControlSetCurrentPanel(o.views.settings.values.cellspanel));
            }, t.SettingsControlSave = function (e) {
                
                var o, i, n = t.GetSpreadsheetControlObject(),
                    r = t.SettingsControls,
                    a = r.CurrentPanel,
                    s = t.SettingsControlUnloadPanel(a);

                t.SetTab(n.tabs[0].name),
                    t.KeyboardFocus(),
                    "sheet" == e ? i = n.sheet.DecodeSheetAttributes(s) :
                    "cell" == e && (n.editor.range.hasrange && (o = t.crToCoord(n.editor.range.left, n.editor.range.top) + ":" + t.crToCoord(n.editor.range.right, n.editor.range.bottom)),
                        i = n.sheet.DecodeCellAttributes(n.editor.ecell.coord, s, o)), //prepare i to command application style - JP Mod
                    i && n.editor.EditorScheduleSheetCommands(i, !0, !1); // Command application style !
                if ($.isArray(config.cellCSS)) {
                    config.cellCSS.push(i);
                }


            }, t.SpreadsheetControlCreateSpreadsheetSave = function (e, t) {
                var o, i, n, r = "",
                    a = "";
                if (t)
                    for (i in t) n = "\n" != t[i].charAt(t[i] - 1) ? "\n" : "", r += "--" + e.multipartBoundary + "\nContent-type: text/plain; charset=UTF-8\n\n" + t[i] + n,
                        a += "part:" + i + "\n";
                return o = "socialcalc:version:1.0\nMIME-Version: 1.0\nContent-Type: multipart/mixed; boundary=" + e.multipartBoundary + "\n--" + e.multipartBoundary + "\nContent-type: text/plain; charset=UTF-8\n\n# SocialCalc Spreadsheet Control Save\nversion:1.0\npart:sheet\npart:edit\npart:audit\n" + a + "--" + e.multipartBoundary + "\nContent-type: text/plain; charset=UTF-8\n\n" + e.CreateSheetSave() + "--" + e.multipartBoundary + "\nContent-type: text/plain; charset=UTF-8\n\n" + e.editor.SaveEditorSettings() + "--" + e.multipartBoundary + "\nContent-type: text/plain; charset=UTF-8\n\n" + e.sheet.CreateAuditString() + r + "--" + e.multipartBoundary + "--\n";
            }, t.SpreadsheetControlDecodeSpreadsheetSave = function (e, t) {
                var o, i, n, r, a, s, l, c, u, d, u, h, p = {},
                    f = [];
                if (o = t.search(/^MIME-Version:\s1\.0/im), 0 > o) return p;
                if (i = /^Content-Type:\s*multipart\/mixed;\s*boundary=(\S+)/gim, i.lastIndex = o,
                    n = i.exec(t), i.lastIndex <= 0) return p;
                if (r = n[1], a = new RegExp("^--" + r + "(?:\r\n|\n)", "mg"), a.lastIndex = i.lastIndex,
                    n = a.exec(t), s = /(?:\r\n|\n)(?:\r\n|\n)/gm, s.lastIndex = a.lastIndex, n = s.exec(t),
                    !n) return p;
                if (l = s.lastIndex, a.lastIndex = l, n = a.exec(t), !n) return p;
                for (c = n.index, u = t.substring(l, c).split(/\r\n|\n/), d = 0; d < u.length; d++) switch (line = u[d],
                    h = line.split(":"), h[0]) {
                    case "version":
                        break;

                    case "part":
                        f.push(h[1]);
                }
                for (pnum = 0; pnum < f.length; pnum++) {
                    if (s.lastIndex = c, n = s.exec(t), !n) return p;
                    if (l = s.lastIndex, pnum == f.length - 1 && (a = new RegExp("^--" + r + "--$", "mg")),
                        a.lastIndex = l, n = a.exec(t), !n) return p;
                    c = n.index, p[f[pnum]] = {
                        start: l,
                        end: c
                    };
                }
                return p;
            }, t.SettingsControls = {
                Controls: {},
                CurrentPanel: null
            }, t.SettingsControlSetCurrentPanel = function (e) {
                t.SettingsControls.CurrentPanel = e, t.SettingsControls.PopupChangeCallback({
                    panelobj: e
                }, "", null);
            }, t.SettingsControlInitializePanel = function (e) {
                var o, i = t.SettingsControls;
                for (o in e) "name" != o && (ctrl = i.Controls[e[o].type], ctrl && ctrl.Initialize && ctrl.Initialize(e, o));
            }, t.SettingsControlLoadPanel = function (e, o) {
                var i, n = t.SettingsControls;
                for (i in e) "name" != i && (ctrl = n.Controls[e[i].type], ctrl && ctrl.SetValue && ctrl.SetValue(e, i, o[e[i].setting]));
            }, t.SettingsControlUnloadPanel = function (e) {
                var o, i = t.SettingsControls,
                    n = {};
                for (o in e) "name" != o && (ctrl = i.Controls[e[o].type], ctrl && ctrl.GetValue && (n[e[o].setting] = ctrl.GetValue(e, o)));
                return n;
            }, t.SettingsControls.PopupChangeCallback = function (e) {
                var o = t.Constants,
                    i = document.getElementById("sample-text");
                if (i && e && e.panelobj) {
                    var n, r, a, s, l, c = t.CurrentSpreadsheetControlObject.idPrefix,
                        u = "cell" == e.panelobj.name ? "c" : "";
                    a = o.defaultCellLayout.match(/^padding.(\S+) (\S+) (\S+) (\S+).vertical.align.(\S+);$/) || [];
                    var d = {
                        color: ["textcolor"],
                        backgroundColor: ["bgcolor", "#FFF"],
                        fontSize: ["fontsize", o.defaultCellFontSize],
                        fontFamily: ["fontfamily"],
                        paddingTop: ["padtop", a[1]],
                        paddingRight: ["padright", a[2]],
                        paddingBottom: ["padbottom", a[3]],
                        paddingLeft: ["padleft", a[4]],
                        verticalAlign: ["alignvert", a[5]]
                    };
                    for (r in d) n = t.Popup.GetValue(c + u + d[r][0]) || d[r][1] || "", i.style[r] = n;
                    if ("c" == u) {
                        d = {
                            borderTop: "cbt",
                            borderRight: "cbr",
                            borderBottom: "cbb",
                            borderLeft: "cbl"
                        };
                        for (r in d) n = t.SettingsControls.BorderSideGetValue(e.panelobj, d[r]), i.style[r] = n ? n.val || "" : "";
                        n = t.Popup.GetValue(c + "calignhoriz"), i.style.textAlign = n || "left", i.childNodes[1].style.textAlign = n || "right";
                    } else i.style.border = "", n = t.Popup.GetValue(c + "textalignhoriz"), i.style.textAlign = n || "left",
                        n = t.Popup.GetValue(c + "numberalignhoriz"), i.childNodes[1].style.textAlign = n || "right";
                    n = t.Popup.GetValue(c + u + "fontlook"), a = n ? n.match(/^(\S+) (\S+)$/) || [] : [],
                        i.style.fontStyle = a[1] || "", i.style.fontWeight = a[2] || "", n = t.Popup.GetValue(c + u + "formatnumber") || "General",
                        s = t.FormatNumber.formatNumberWithFormat(9.8765, n, ""), l = t.FormatNumber.formatNumberWithFormat(-1234.5, n, ""),
                        "??-???-??&nbsp;??:??:??" != l && (s += "<br>" + l), i.childNodes[1].innerHTML = s;
                }
            }, t.SettingsControls.PopupListSetValue = function (e, o, i) {
                if (!i) return void alert(o + " no value");
                var n = t.Popup;
                i.def ? n.SetValue(e[o].id, "") : n.SetValue(e[o].id, i.val);
            }, t.SettingsControls.PopupListGetValue = function (e, o) {
                var i = e[o];
                if (!i) return null;
                var n = t.Popup.GetValue(i.id);
                return n ? {
                    def: !1,
                    val: n
                } : {
                    def: !0,
                    val: 0
                };
            }, t.SettingsControls.PopupListInitialize = function (e, o) {
                var i, n, r, a, s = t.SettingsControls,
                    l = e[o].initialdata || s.Controls[e[o].type].InitialData || "";
                l = t.LocalizeSubstrings(l);
                var c = l.split(/\|/),
                    u = [];
                for (i = 0; i < (c.length || 0); i++) n = c[i], r = n.indexOf(":"), a = n.substring(0, r),
                    -1 != a.indexOf("\\") && (a = a.replace(/\\c/g, ":"), a = a.replace(/\\b/g, "\\")),
                    a = t.special_chars(a), u[i] = "[custom]" == a ? {
                        o: t.Constants.s_PopupListCustom,
                        v: n.substring(r + 1),
                        a: {
                            custom: !0
                        }
                    } : "[cancel]" == a ? {
                        o: t.Constants.s_PopupListCancel,
                        v: "",
                        a: {
                            cancel: !0
                        }
                    } : "[break]" == a ? {
                        o: "-----",
                        v: "",
                        a: {
                            skip: !0
                        }
                    } : "[newcol]" == a ? {
                        o: "",
                        v: "",
                        a: {
                            newcol: !0
                        }
                    } : {
                        o: a,
                        v: n.substring(r + 1)
                    };
                t.Popup.Create("List", e[o].id, {}), t.Popup.Initialize(e[o].id, {
                    options: u,
                    attribs: {
                        changedcallback: t.SettingsControls.PopupChangeCallback,
                        panelobj: e
                    }
                });
            }, t.SettingsControls.PopupListReset = function () {
                t.Popup.Reset("List");
            }, t.SettingsControls.Controls.PopupList = {
                SetValue: t.SettingsControls.PopupListSetValue,
                GetValue: t.SettingsControls.PopupListGetValue,
                Initialize: t.SettingsControls.PopupListInitialize,
                OnReset: t.SettingsControls.PopupListReset,
                ChangedCallback: null
            }, t.SettingsControls.ColorChooserSetValue = function (e, o, i) {
                if (!i) return void alert(o + " no value");
                var n = t.Popup;
                i.def ? n.SetValue(e[o].id, "") : n.SetValue(e[o].id, i.val);
            }, t.SettingsControls.ColorChooserGetValue = function (e, o) {
                var i = t.Popup.GetValue(e[o].id);
                return i ? {
                    def: !1,
                    val: i
                } : {
                    def: !0,
                    val: 0
                };
            }, t.SettingsControls.ColorChooserInitialize = function (e, o) {
                t.SettingsControls;
                t.Popup.Create("ColorChooser", e[o].id, {}), t.Popup.Initialize(e[o].id, {
                    attribs: {
                        title: "&nbsp;",
                        moveable: !0,
                        width: "106px",
                        changedcallback: t.SettingsControls.PopupChangeCallback,
                        panelobj: e
                    }
                });
            }, t.SettingsControls.ColorChooserReset = function () {
                t.Popup.Reset("ColorChooser");
            }, t.SettingsControls.Controls.ColorChooser = {
                SetValue: t.SettingsControls.ColorChooserSetValue,
                GetValue: t.SettingsControls.ColorChooserGetValue,
                Initialize: t.SettingsControls.ColorChooserInitialize,
                OnReset: t.SettingsControls.ColorChooserReset,
                ChangedCallback: null
            }, t.SettingsControls.BorderSideSetValue = function (e, o, i) {
                var n, r, a, s = (t.SettingsControls, e[o].id);
                return i ? (n = document.getElementById(s + "-onoff-bcb"), void(n && (i.val ? (n.checked = !0,
                    n.value = i.val, a = i.val.match(/(\S+)\s+(\S+)\s+(\S.+)/), r = s + "-color", t.Popup.SetValue(r, a[3]),
                    t.Popup.SetDisabled(r, !1)) : (n.checked = !1, n.value = i.val, r = s + "-color",
                    t.Popup.SetValue(r, ""), t.Popup.SetDisabled(r, !0))))) : void alert(o + " no value");
            }, t.SettingsControls.BorderSideGetValue = function (e, o) {
                var i, n, r = (t.SettingsControls, e[o].id);
                return (i = document.getElementById(r + "-onoff-bcb")) ? i.checked ? (n = t.Popup.GetValue(r + "-color"),
                    n = "1px solid " + (n || "rgb(0,0,0)"), {
                        def: !1,
                        val: n
                    }) : {
                    def: !1,
                    val: ""
                } : void 0;
            }, t.SettingsControls.BorderSideInitialize = function (e, o) {
                var i = (t.SettingsControls, e[o].id);
                t.Popup.Create("ColorChooser", i + "-color", {}), t.Popup.Initialize(i + "-color", {
                    attribs: {
                        title: "&nbsp;",
                        width: "106px",
                        moveable: !0,
                        changedcallback: t.SettingsControls.PopupChangeCallback,
                        panelobj: e
                    }
                });
            }, t.SettingsControlOnchangeBorder = function (e) {
                var o = t.SettingsControls,
                    i = o.CurrentPanel,
                    n = e.id.match(/(^.*\-)(\w+)\-(\w+)\-(\w+)$/);
                if (n) {
                    var r = (n[1], n[2]),
                        a = (n[3], n[4]),
                        s = i[r].type;
                    switch (a) {
                        case "bcb":
                            e.checked ? o.Controls[s].SetValue(o.CurrentPanel, r, {
                                def: !1,
                                val: e.value || "1px solid rgb(0,0,0)"
                            }) : o.Controls[s].SetValue(o.CurrentPanel, r, {
                                def: !1,
                                val: ""
                            });
                    }
                }
            }, t.SettingsControls.Controls.BorderSide = {
                SetValue: t.SettingsControls.BorderSideSetValue,
                GetValue: t.SettingsControls.BorderSideGetValue,
                OnClick: t.SettingsControls.ColorComboOnClick,
                Initialize: t.SettingsControls.BorderSideInitialize,
                InitialData: {
                    thickness: "1 pixel:1px",
                    style: "Solid:solid"
                },
                ChangedCallback: null
            }, t.SettingControlReset = function () {
                var e, o = t.SettingsControls;
                for (e in o.Controls) o.Controls[e].OnReset && o.Controls[e].OnReset(e);
            }, t.OtherSaveParts = {}, t.CtrlSEditor = function (e) {
                var o, i;
                if (e.length > 0) o = t.special_chars(t.OtherSaveParts[e] || "");
                else {
                    o = "Listing of Parts\n";
                    for (i in t.OtherSaveParts) o += t.special_chars("\nPart: " + i + "\n=====\n" + t.OtherSaveParts[i] + "\n");
                }
                var n = document.createElement("div");
                n.style.cssText = "position:absolute;z-index:500;width:300px;height:300px;left:100px;top:200px;border:1px solid black;background-color:#EEE;text-align:center;",
                    n.id = "socialcalc-editbox", n.innerHTML = e + '<br><br><textarea id="socialcalc-editbox-textarea" style="width:250px;height:200px;">' + o + "</textarea><br><br><input type=button onclick=\"SocialCalc.CtrlSEditorDone ('socialcalc-editbox', '" + e + '\');" value="OK">',
                    document.body.appendChild(n);
                var r = document.getElementById("socialcalc-editbox-textarea");
                r.focus(), t.CmdGotFocus(r);
            }, t.CtrlSEditorDone = function (e, o) {
                var i = document.getElementById(e + "-textarea"),
                    n = i.value;
                
                o.length > 0 && (n.length > 0 ? t.OtherSaveParts[o] = n : delete t.OtherSaveParts[o]);
                var r = document.getElementById(e);
                t.KeyboardFocus(), r.parentNode.removeChild(r);
            };

        var t;
        return t || (alert("Main SocialCalc code module needed"), t = {}), t.TableEditor || alert("SocialCalc TableEditor code module needed"),
            t.CurrentSpreadsheetViewerObject = null, t.SpreadsheetViewer = function (e) {
                var o = t.Constants;
                this.parentNode = null, this.spreadsheetDiv = null, this.requestedHeight = 0, this.requestedWidth = 0,
                    this.requestedSpaceBelow = 0, this.height = 0, this.width = 0, this.viewheight = 0,
                    this.sheet = null, this.context = null, this.editor = null, this.spreadsheetDiv = null,
                    this.editorDiv = null, this.sortrange = "", this.idPrefix = e || "SocialCalc-",
                    this.imagePrefix = o.defaultImagePrefix, this.statuslineheight = o.SVStatuslineheight,
                    this.statuslineCSS = o.SVStatuslineCSS, this.sheet = new t.Sheet(), this.context = new t.RenderContext(this.sheet),
                    (1 == t._app || 1 == t._view) && (o.defaultImagePrefix = this.imagePrefix = "../" + this.imagePrefix),
                    1 == t._app ? (this.context.showGrid = !1, this.context.showRCHeaders = !1, this.context.highlightTypes.range.style = "",
                        this.context.sheetobj.cells.A1 = new t.Cell("A1"), this.context.sheetobj.cells.A1.displaystring = "Loading ... ") : (this.context.showGrid = !0,
                        this.context.showRCHeaders = !0), this.editor = new t.TableEditor(this.context),
                    this.editor.noEdit = !0, this.editor.StatusCallback.statusline = {
                        func: t.SpreadsheetViewerStatuslineCallback,
                        params: {}
                    }, this.hasStatusLine = !0, this.statuslineHTML = '<table cellspacing="0" cellpadding="0"><tr><td width="100%" style="overflow:hidden;">{status}</td><td>&nbsp;</td></tr></table>',
                    this.statuslineFull = !0, this.noRecalc = !0, this.repeatingMacroTimer = null, this.repeatingMacroInterval = 60,
                    this.repeatingMacroCommands = "", t.CurrentSpreadsheetViewerObject = this;

            }, t.SpreadsheetViewer.prototype.InitializeSpreadsheetViewer = function (e, o, i, n) {
                return t.InitializeSpreadsheetViewer(this, e, o, i, n);
            }, t.SpreadsheetViewer.prototype.LoadSave = function (e) {
                return t.SpreadsheetViewerLoadSave(this, e);
            }, t.SpreadsheetViewer.prototype.DoOnResize = function () {
                
                return t.DoOnResize(this);
            }, t.SpreadsheetViewer.prototype.SizeSSDiv = function () {
                 
                return t.SizeSSDiv(this);
            }, t.SpreadsheetViewer.prototype.DecodeSpreadsheetSave = function (e) {
                return t.SpreadsheetViewerDecodeSpreadsheetSave(this, e);
            }, t.SpreadsheetViewer.prototype.ParseSheetSave = function (e) {
                return this.sheet.ParseSheetSave(e);
            }, t.InitializeSpreadsheetViewer = function (e, o, i, n, r) {
                {
                    var a;
                    t.Constants, t.LocalizeString, t.LocalizeSubstrings, e.tabs, e.views;
                }
            }, t.SpreadsheetViewerLoadSave = function (o, i) {
                var n, r, a, s, l = o.DecodeSpreadsheetSave(i);
                l && (l.sheet && (o.sheet.ResetSheet(), o.sheet.ParseSheetSave(i.substring(l.sheet.start, l.sheet.end))),
                        l.edit && o.editor.LoadEditorSettings(i.substring(l.edit.start, l.edit.end)), l.startupmacro && o.editor.EditorScheduleSheetCommands(i.substring(l.startupmacro.start, l.startupmacro.end), !1, !0),
                        l.repeatingmacro && (n = i.substring(l.repeatingmacro.start, l.repeatingmacro.end),
                            n = n.replace("\r", ""), r = n.indexOf("\n"), r > 0 && (a = n.substring(0, r) - 0,
                                s = a, o.repeatingMacroInterval = a, o.repeatingMacroCommands = n.substring(r + 1),
                                s > 0 && (o.repeatingMacroTimer = e.setTimeout(t.SpreadsheetViewerDoRepeatingMacro, 1e3 * o.repeatingMacroInterval))))),
                    "off" == o.editor.context.sheetobj.attribs.recalc || o.noRecalc ? o.editor.ScheduleRender() : o.editor.EditorScheduleSheetCommands("recalc");

            }, t.SpreadsheetViewerDoRepeatingMacro = function () {
                var e = t.GetSpreadsheetViewerObject(),
                    o = e.editor;
                e.repeatingMacroTimer = null, t.SheetCommandInfo.CmdExtensionCallbacks.repeatmacro = {
                    func: t.SpreadsheetViewerRepeatMacroCommand,
                    data: null
                }, o.EditorScheduleSheetCommands(e.repeatingMacroCommands);
            }, t.SpreadsheetViewerRepeatMacroCommand = function (o, i, n, r) {
                var a = t.GetSpreadsheetViewerObject(),
                    s = r.RestOfString(),
                    l = s - 0;
                l > 0 || (l = a.repeatingMacroInterval), a.repeatingMacroInterval = l, a.repeatingMacroTimer = e.setTimeout(t.SpreadsheetViewerDoRepeatingMacro, 1e3 * a.repeatingMacroInterval);
            }, t.SpreadsheetViewerStopRepeatingMacro = function () {
                var o = t.GetSpreadsheetViewerObject();
                o.repeatingMacroTimer && (e.clearTimeout(o.repeatingMacroTimer), o.repeatingMacroTimer = null);
            }, t.SpreadsheetViewerDoButtonCmd = function (e, o, i) {
                var n = i.element,
                    r = i.functionobj.command,
                    a = t.GetSpreadsheetViewerObject(),
                    s = a.editor;
                switch (r) {
                    case "recalc":
                        s.EditorScheduleSheetCommands("recalc");
                }
                n && n.blur && n.blur(), t.KeyboardFocus();
            }, t.LocalizeString = function (e) {
                var o = t.LocalizeStringList[e];
                return o || (o = t.Constants["s_loc_" + e.toLowerCase().replace(/\s/g, "_").replace(/\W/g, "X")] || e,
                    t.LocalizeStringList[e] = o), o;
            }, t.LocalizeStringList = {}, t.LocalizeSubstrings = function (e) {
                var o = t.LocalizeString;
                return e.replace(/%(loc|ssc)!(.*?)!/g, function (e, i, n) {
                    return "ssc" == i ? t.Constants[n] || alert("Missing constant: " + n) : o(n);
                });
            }, t.GetSpreadsheetViewerObject = function () {
                var e = t.CurrentSpreadsheetViewerObject;
                if (e) return e;
                throw "No current SpreadsheetViewer object.";
            }, t.DoOnResize = function (e) {
                var o, i = e.views,
                    n = e.SizeSSDiv();
                if (n) {
                    for (vname in i) o = i[vname].element, o.style.width = e.width + "px", o.style.height = e.height - e.nonviewheight + "px";
                    t._app || e.editor.ResizeTableEditor(e.width, e.height - e.nonviewheight);
                }
            }, t.SizeSSDiv = function (e) {
                var o, i, n, r, a, s = 10,
                    l = 10;
                return n = !1, o = t.GetViewportInfo(), i = t.GetElementPosition(e.parentNode),
                    i.bottom = 0, i.right = 20, r = e.parentNode.style, r.marginTop && (i.top += r.marginTop.slice(0, -2) - 0),
                    r.marginBottom && (i.bottom += r.marginBottom.slice(0, -2) - 0), r.marginLeft && (i.left += r.marginLeft.slice(0, -2) - 0),
                    r.marginRight && (i.right += r.marginRight.slice(0, -2) - 0), a = e.requestedHeight || o.height - (i.top + i.bottom + l) - (e.requestedSpaceBelow || 0),
                    e.height != a && (e.height = a, e.spreadsheetDiv.style.height = a + "px", n = !0),
                    a = e.requestedWidth || o.width - (i.left + i.right + s) || 700, e.width != a && (e.width = a,
                        e.spreadsheetDiv.style.width = a + "px", n = !0), e.spreadsheetDiv.style.position = "relative",
                    n; //JP MOD :i.right =20.
            }, t.SpreadsheetViewerStatuslineCallback = function (e, t, o, i) {
                var n = i.spreadsheetobj,
                    r = "";
                switch (n && n.statuslineDiv && (r = n.statuslineFull ? e.GetStatuslineString(t, o, i) : e.ecell.coord,
                    r = n.statuslineHTML.replace(/\{status\}/, r), n.statuslineDiv.innerHTML = r), t) {
                    case "cmdendnorender":
                    case "calcfinished":
                    case "doneposcalc":
                }
            }, t.CmdGotFocus = function (e) {
                t.Keyboard.passThru = e;
            }, t.SpreadsheetViewerCreateSheetHTML = function (e) {
                var o, i, n, r = "";
                return o = new t.RenderContext(e.sheet), i = document.createElement("div"), n = o.RenderSheet(null, {
                    type: "html"
                }), i.appendChild(n), delete o, r = i.innerHTML, delete n, delete i, r;
            }, t.SpreadsheetViewerDecodeSpreadsheetSave = function (e, t) {
                var o, i, n, r, a, s, l, c, u, d, u, h, p = {},
                    f = [],
                    m = /[^\n]\r[^\n]/;
                if (m.test(t) && (t = t.replace(/([^\n])\r([^\n])/g, "$1\r\n$2")), o = t.search(/^MIME-Version:\s1\.0/im),
                    0 > o) return p;
                if (i = /^Content-Type:\s*multipart\/mixed;\s*boundary=(\S+)/gim, i.lastIndex = o,
                    n = i.exec(t), i.lastIndex <= 0) return p;
                if (r = n[1], a = new RegExp("^--" + r + "(?:\r\n|\n)", "mg"), a.lastIndex = i.lastIndex,
                    n = a.exec(t), s = /(?:\r\n|\n)(?:\r\n|\n)/gm, s.lastIndex = a.lastIndex, n = s.exec(t),
                    !n) return p;
                if (l = s.lastIndex, a.lastIndex = l, n = a.exec(t), !n) return p;
                for (c = n.index, u = t.substring(l, c).split(/\r\n|\n/), d = 0; d < u.length; d++) switch (line = u[d],
                    h = line.split(":"), h[0]) {
                    case "version":
                        break;

                    case "part":
                        f.push(h[1]);
                }
                for (pnum = 0; pnum < f.length; pnum++) {
                    if (s.lastIndex = c, n = s.exec(t), !n) return p;
                    if (l = s.lastIndex, pnum == f.length - 1 && (a = new RegExp("^--" + r + "--$", "mg")),
                        a.lastIndex = l, n = a.exec(t), !n) return p;
                    c = n.index, p[f[pnum]] = {
                        start: l,
                        end: c
                    };
                }
                return p;
            }, "undefined" == typeof document && (t.GetEditorCellElement = function () {}, t.ReplaceCell = function () {},
                t.EditorRenderSheet = function () {}, t.SpreadsheetControlSortSave = function () {
                    return "";
                }, t.SpreadsheetControlStatuslineCallback = function () {}, t.DoPositionCalculations = function (e) {
                    t.EditorSheetStatusCallback(null, "doneposcalc", null, e);
                }), "undefined" != typeof self && self.thread && (e.setTimeout = function (e, t) {
                    1 >= t && self.thread.nextTick(e);
                },
                e.clearTimeout = function () {}), t;
    }

    return {
        render: function (id, $container, config, assetManager) {
            return EtherInit(id, $container, config, assetManager);
        }
    }
});